      SUBROUTINE MPICM0(RANG  ,NBPROC)
!           CONFIGURATION MANAGEMENT OF EDF VERSION
!& MODIF MPICM0 UTILITAI  DATE 12/12/2011   AUTEUR DESOZA T.DESOZA 
! ==================================================================
! COPYRIGHT (C) 1991 - 2011  EDF R&D              WWW.CODE-ASTER.ORG
!
! THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR
! MODIFY IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS
! PUBLISHED BY THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE
! LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.
! THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,
! BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
! MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
! GENERAL PUBLIC LICENSE FOR MORE DETAILS.
!
! YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
! ALONG WITH THIS PROGRAM; IF NOT, WRITE TO : EDF R&D CODE_ASTER,
!    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
! ==================================================================
!-----------------------------------------------------------------------
!    - FONCTION REALISEE : SUR-COUCHE MPI
!
!      RETOURNE LE RANG DU PROCESSEUR ET LE NOMBRE TOTAL DE PROCESSEURS
!
! ARGUMENTS D'APPELS
! OUT RANG   : RANG DU PROCESSEUR
! OUT NBPROC : NOMBRE DE PROCESSEURS
!----------------------------------------------------------------------
! RESPONSABLE PELLET J.PELLET
      IMPLICIT NONE
! DECLARATION PARAMETRES D'APPELS
      INTEGER      RANG,NBPROC

#ifdef _USE_MPI
      INCLUDE   'mpif.h'
! DECLARATION VARIABLES LOCALES
      INTEGER*4 RANG4,NBPRO4,IERMPI
      LOGICAL   FIRST
      SAVE      FIRST
      DATA      FIRST /.TRUE./
! ---------------------------------------------------------------------
!
!     -- INITIALISATIONS :
!     --------------------
      IF (FIRST) THEN
!       -- POUR LA GESTION DES ERREURS :
        CALL MPI_ERRHANDLER_SET(MPI_COMM_WORLD,MPI_ERRORS_RETURN,IERMPI)
        CALL MPIERR(IERMPI)
        FIRST= .FALSE.
      ENDIF

      CALL MPI_COMM_RANK(MPI_COMM_WORLD,RANG4,IERMPI)
      CALL MPIERR(IERMPI)
      RANG=RANG4

      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NBPRO4,IERMPI)
      CALL MPIERR(IERMPI)
      NBPROC=NBPRO4

#else
!----------------------------------------------------------------------
      RANG=0
      NBPROC=1
#endif

      END
