      SUBROUTINE MPICMW( IEXC )
!           CONFIGURATION MANAGEMENT OF EDF VERSION                  
!& MODIF MPICMW UTILITAI  DATE 19/11/2012   AUTEUR COURTOIS M.COURTOIS 
! ================================================================== 
! COPYRIGHT (C) 1991 - 2012  EDF R&D              WWW.CODE-ASTER.ORG 
!                                                                    
! THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR      
! MODIFY IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS     
! PUBLISHED BY THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE 
! LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.                    
! THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,    
! BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF     
! MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU   
! GENERAL PUBLIC LICENSE FOR MORE DETAILS.                           
!                                                                    
! YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE  
! ALONG WITH THIS PROGRAM; IF NOT, WRITE TO : EDF R&D CODE_ASTER,    
!    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.     
! ================================================================== 
C RESPONSABLE COURTOIS M.COURTOIS
      IMPLICIT NONE
      INTEGER  IEXC
!-----------------------------------------------------------------------
!     FONCTION REALISEE : MPI COMM WARN
!       UN PROCESSEUR A RENCONTRE UNE ERREUR, IL EMET SON MESSAGE
!       ET ENVOIE L'INFO AU PROC #0.
!-----------------------------------------------------------------------
#if defined(_USE_MPI) && !defined(ASTER_DISABLE_MPI_CHECK)
!
      INCLUDE 'mpif.h'
      INCLUDE 'aster_constant.h'
!
      LOGICAL   GTSTAT
      INTEGER*4 IERMPI, RANK, NBPRO4
      INTEGER   IRET
!
      CALL MPI_COMM_RANK(MPI_COMM_WORLD, RANK, IERMPI)
      CALL MPIERR(IERMPI)
      CALL MPI_COMM_SIZE(MPI_COMM_WORLD, NBPRO4, IERMPI)
      CALL MPIERR(IERMPI)
!
!     SI PAS 'ST_OK', IL NE FAUT PAS COMMUNIQUER ENCORE UNE FOIS
      IF ( NBPRO4 .LE. 1 .OR. .NOT. GTSTAT(ST_OK) ) THEN
        GOTO 9999
      ENDIF
!
!     SUR LES PROCESSEURS AUTRES QUE #0
      IF ( RANK .NE. 0 ) THEN
        CALL STSTAT(ST_ER_OTH)
        IF ( IEXC .EQ. 0 ) THEN
          CALL U2MESS('I', 'APPELMPI_82')
        ELSE
          CALL U2MESS('I', 'APPELMPI_92')
          CALL STSTAT(ST_EXCEPT)
        ENDIF
        CALL MPISST(ST_ER, IRET)
!
!     SUR LE PROCESSEUR #0
      ELSE
        CALL STSTAT(ST_ER_PR0)
        IF ( IEXC .EQ. 1 ) THEN
          CALL STSTAT(ST_EXCEPT)
        ENDIF
        CALL MPICHK(NBPRO4, IRET)
      ENDIF
!     INUTILE DE TESTER IRET, ON SAIT QU'IL Y A UNE ERREUR
!
 9999 CONTINUE
#endif
      END
