      SUBROUTINE MCMULT(CUMUL,LMAT,VECT,XSOL,NBVECT,PREPOS)
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*(*) CUMUL
      INTEGER LMAT,NBVECT
      COMPLEX*16 VECT(*),XSOL(*)
      LOGICAL       PREPOS,PREPO2
C     ------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGELINE  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C TOLE CRP_4
C     ------------------------------------------------------------------
C     EFFECTUE LE PRODUIT D'UNE MATRICE PAR N VECTEURS COMPLEXES.
C     LE RESULTAT EST STOCKE DANS N VECTEURS COMPLEXES
C     ATTENTION:
C       - MATRICE SYMETRIQUE OU NON, REELLE OU COMPLEXE
C       - VECTEURS INPUT ET OUTPUT COMPLEXES ET DISTINCTS
C       - POUR LES DDLS ELIMINES PAR AFFE_CHAR_CINE, ON NE PEUT PAS
C         CALCULER XSOL. CES DDLS SONT MIS A ZERO.
C     ------------------------------------------------------------------
C IN  CUMUL  : K4 :
C              / 'ZERO' : XSOL =        MAT*VECT
C              / 'CUMU' : XSOL = XSOL + MAT*VECT

C IN  LMAT  : I : DESCRIPTEUR DE LA MATRICE
C IN  VECT  :R/C: VECTEURS A MULTIPLIER PAR LA MATRICE
C VAR XSOL  :R/C: VECTEUR(S) SOLUTION(S)
C               SI CUMUL = 'ZERO' ALORS XSOL EST EN MODE OUT
C IN  NBVECT: I : NOMBRE DE VECTEURS A MULTIPLIER (ET DONC DE SOLUTIONS)
C     ------------------------------------------------------------------
      CHARACTER*3 KMPIC
      CHARACTER*19 MATAS
      INTEGER IBID,JREFA,JSMDI,JSMHC,JVTEMP,NEQ

      CALL JEMARQ()
      PREPO2=PREPOS
      MATAS=ZK24(ZI(LMAT+1))(1:19)
      CALL JEVEUO(MATAS//'.REFA','L',JREFA)
      IF (ZK24(JREFA-1+3).EQ.'ELIMF') CALL MTMCHC(MATAS,'ELIML')

      CALL DISMOI('F','MPI_COMPLET',MATAS,'MATR_ASSE',IBID,KMPIC,IBID)
      IF (KMPIC.NE.'OUI') CALL U2MESS('F','CALCULEL6_54')

      CALL JEVEUO(ZK24(JREFA-1+2)(1:14)//'.SMOS.SMHC','L',JSMHC)
      NEQ=ZI(LMAT+2)
      CALL WKVECT('&&MCMULT.VECTMP','V V C',NEQ,JVTEMP)


C     SELON REEL OU COMPLEXE :
      GOTO (10,20)ZI(LMAT+3)

      CALL U2MESS('F','ALGELINE_66')


   10 CONTINUE
C     MATRICE REELLE
      CALL MTDSC2(ZK24(ZI(LMAT+1)),'SMDI','L',JSMDI)
      CALL MCMMVR(CUMUL,LMAT,ZI(JSMDI),ZI4(JSMHC),NEQ,VECT,XSOL,NBVECT,
     &            ZC(JVTEMP),PREPO2)
      GOTO 30


   20 CONTINUE
C     MATRICE COMPLEXE
      CALL MTDSC2(ZK24(ZI(LMAT+1)),'SMDI','L',JSMDI)
      CALL MCMMVC(CUMUL,LMAT,ZI(JSMDI),ZI4(JSMHC),NEQ,VECT,XSOL,NBVECT,
     &            ZC(JVTEMP),PREPO2)


   30 CONTINUE
      CALL JEDETR('&&MCMULT.VECTMP')
      CALL JEDEMA()
      END
