      SUBROUTINE OP0156()
      IMPLICIT  NONE
C     ------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGELINE  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C     ------------------------------------------------------------------

C     OPERATEUR :   PROD_MATR_CHAM

C     ------------------------------------------------------------------

      INCLUDE 'jeveux.h'
      INTEGER IBID,N1,IRET,NEQ,IER
      INTEGER LMAT,JCHIN,JCHOUT
      CHARACTER*1 TYPMAT,TYPRES
      CHARACTER*24 VALK(2)
      CHARACTER*14 NUMEM
      CHARACTER*19 PFCHN1,PFCHN2
      CHARACTER*16 TYPE,NOMCMD
      CHARACTER*19 MASSE,RESU,CHAMNO,CHAMN2
      INTEGER IARG
      LOGICAL IDENSD
C     ------------------------------------------------------------------
      CALL JEMARQ()
      CALL INFMAJ()

C     --- RECUPERATION DES ARGUMENTS DE LA COMMANDE ---
      RESU=' '
      CALL GETRES(RESU,TYPE,NOMCMD)

C     0. MATRICE :
C     -------------
      CALL GETVID(' ','MATR_ASSE',0,IARG,1,MASSE,N1)
      CALL MTDSCR(MASSE)
      CALL JEVEUO(MASSE(1:19)//'.&INT','E',LMAT)
      IF (ZI(LMAT+3).EQ.1) THEN
        TYPMAT='R'
      ELSEIF (ZI(LMAT+3).EQ.2) THEN
        TYPMAT='C'
      ELSE
        CALL U2MESS('F','ALGELINE2_86')
      ENDIF
      CALL DISMOI('F','NOM_NUME_DDL',MASSE,'MATR_ASSE',IBID,NUMEM,IRET)
      CALL DISMOI('F','PROF_CHNO',MASSE,'MATR_ASSE',IBID,PFCHN1,IRET)


C     1. CHAM_NO  :
C     -------------
      CALL GETVID(' ','CHAM_NO',0,IARG,1,CHAMNO,N1)
      CALL CHPVER('F',CHAMNO,'NOEU','*',IER)
      CALL JELIRA(CHAMNO//'.VALE','TYPE',IBID,TYPRES)
      IF (TYPMAT.NE.TYPRES) THEN
        VALK(1)=TYPMAT
        VALK(2)=TYPRES
        CALL U2MESK('F','ALGELINE4_42',2,VALK)
      ENDIF

      CALL DISMOI('F','PROF_CHNO',CHAMNO,'CHAM_NO',IBID,PFCHN2,IRET)
C     -- SI LA NUMEROTATION DE CHAM_NO N'EST PAS LA MEME QUE CELLE DE
C        LA MATRICE, ON CHANGE LA NUMEROTATION DE CHAM_NO.
C        EN APPELANT VTCOPY, ON PERD LA VALEUR DES LAGRANGES
      IF (.NOT.IDENSD('PROF_CHNO',PFCHN1,PFCHN2)) THEN
        VALK(1)=PFCHN1
        VALK(2)=PFCHN2
        CALL U2MESK('A','CALCULEL3_46',2,VALK)
        CHAMN2='&&OP0156.CHAM_NO'
        CALL VTCREB(CHAMN2,NUMEM,'V',TYPRES,NEQ)
        CALL VTCOPY(CHAMNO,CHAMN2)
        CHAMNO=CHAMN2
      ENDIF
      CALL JEVEUO(CHAMNO//'.VALE','L',JCHIN)


C     3. ALLOCATION DU CHAM_NO RESULTAT :
C     ----------------------------------
      CALL JEEXIN(RESU//'.VALE',IRET)
      IF (IRET.NE.0) THEN
        CALL U2MESK('F','ALGELINE2_87',1,RESU(1:8))
      ENDIF
      CALL VTCREB(RESU,NUMEM,'G',TYPRES,NEQ)
      CALL JEVEUO(RESU//'.VALE','E',JCHOUT)


C     4. PRODUIT MATRICE X VECTEUR :
C     ----------------------------------
      IF (TYPRES.EQ.'R') THEN
        CALL MRMULT('ZERO',LMAT,ZR(JCHIN),ZR(JCHOUT),1,.TRUE.)
      ELSEIF (TYPRES.EQ.'C') THEN
        CALL MCMULT('ZERO',LMAT,ZC(JCHIN),ZC(JCHOUT),1,.TRUE.)
      ENDIF


      CALL TITRE()

      CALL JEDEMA()
      END
