      SUBROUTINE CA2MAM(MOINT,INCR,LIGRMO,LCHIN,LPAIN,LPAOUT,NUM,MADE)
C--------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 18/09/2012   AUTEUR LADIER A.LADIER 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C--------------------------------------------------------------------
      IMPLICIT NONE

C ROUTINE CALCULANT LES MATRICES DES DERIVEES
C DE FONCTIONS DE FORME SUR LE MODELE INTERFACE

C IN : MOINT : MODELE INTERFACE
C IN : MATE : MATERIAU CODE
C IN : LIGRMO : LIGREL DU MODELE
C IN: LCHIN,LPAIN,LPAOUT : PARAMETRES DU CALCUL ELEMENTAIRE
C IN : NUM : NUMEROTATION DES DDLS THERMIQUES D INTERFACE

C OUT : MADE : MATRICE DES DERIVEES

C---------------------------------------------------------------------

      INCLUDE 'jeveux.h'
      CHARACTER*(*) MOINT
      CHARACTER*3 INCR
      CHARACTER*8 K8BID,LPAIN(2),LPAOUT(1)
      CHARACTER*14 NUM
      CHARACTER*16 OPTION
      CHARACTER*19 MATEL,NU19
      CHARACTER*24 LCHOUT(1),LCHIN(2),LIGRMO
      CHARACTER*24 MADE,MADEEL

C ----- CREATION DE LA MATR_ELEM DES DERIVEES DES DN(I)*DN(J)
C--------------SUR LE MODELE THERMIQUE------------------------------
C--------------------D'INTERFACE -----------------------------------

C-----------------------------------------------------------------------
      INTEGER JLVA 
C-----------------------------------------------------------------------
      CALL JEMARQ()
      OPTION = 'AMOR_AJOU'
      LPAOUT(1) = 'PMATTTR'
      MATEL = '&&B'//INCR(1:3)
      MADEEL = MATEL//'.RELR'
      CALL MEMARE('V',MATEL,MOINT(1:8),' ',' ','AMOR_AJOU ')
      CALL WKVECT(MADEEL,'V V K24',1,JLVA)

      LCHOUT(1) = MATEL(1:8)//'.ME000'
      CALL CODENT(1,'D0',LCHOUT(1) (12:14))
      CALL CALCUL('S',OPTION,LIGRMO,2,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V',
     &               'OUI')
      ZK24(JLVA) = LCHOUT(1)
      CALL JEECRA(MADEEL,'LONUTI',1,K8BID)


C-------------------- NUMEROTATION ----------------------------------

      NUM = 'NUM'//INCR
      CALL NUMDDL(NUM,'VV',1,MATEL,'RCMK')
      CALL PROMOR(NUM,'V')
      CALL CRNSLV(NUM,'MULT_FRONT','METIS','V')

C---------------ASSEMBLAGE DES MATRICES  DES DN(I)DN(J)--------------

      MADE = 'MA'//INCR

      CALL ASSMAM('V',MADE,1,MATEL,1.D0,NUM,'ZERO',1)


      NU19=NUM
C
C --- MENAGE
C
      CALL JEDETR(NU19//'.ADLI')
      CALL JEDETR(NU19//'.ADNE')
      CALL DETRSD('MATR_ELEM',MATEL)
      CALL DETRSD('CHAMP_GD',LCHOUT(1))

      CALL JEDEMA()
      END
