      SUBROUTINE CALALP (KPG,IMATE,COMPOR,ALPHA)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE PELLET J.PELLET
      IMPLICIT NONE


      INCLUDE 'jeveux.h'
      CHARACTER*16 COMPOR(4)

C......................................................................
C     BUT:  CALCUL DE L'INVERSE DE KAPPA
C IN  KPG    : NUMERO DU POINT DE GAUSS
C IN  IMATE  : NUMERO DU MATERIAU
C IN  COMPOR : NOM DU COMPORTEMENT
C OUT ALPHA  : INVERSE DE KAPPA
C......................................................................

      INTEGER IMATE,KPG,ICODRE(2),ITEMPS,IRET
      REAL*8  E,NU,VALRES(2)
      REAL*8  ALPHA,VALPAR
      CHARACTER*8 NOMRES(2),NOMPAR

C INITIALISATION
      NOMPAR = 'INST'

      IF (.NOT.( COMPOR(1)(1:4) .EQ. 'ELAS'.OR.
     &     COMPOR(1)(1:9) .EQ. 'VMIS_ISOT' )) THEN
            CALL U2MESK('F','ALGORITH4_50',1,COMPOR(1))
      ENDIF

C - RECUPERATION DE L INSTANT
      CALL TECACH('NNN','PTEMPSR',1,ITEMPS,IRET)
      IF (ITEMPS.NE.0) THEN
        VALPAR = ZR(ITEMPS)
      ELSE
        VALPAR = 0.D0
      ENDIF

C - RECUPERATION DE E ET NU DANS LE FICHIER PYTHON
      NOMRES(1)='E'
      NOMRES(2)='NU'
      CALL RCVALB('RIGI',KPG,1,'+',IMATE,' ','ELAS',1,NOMPAR,VALPAR,2,
     &            NOMRES,VALRES,ICODRE,1)
      E  = VALRES(1)
      NU = VALRES(2)
      ALPHA=(3.D0*(1.D0-2.D0*NU))/E

      END
