      SUBROUTINE CALCIN(OPTION,MAX,MAY,MAZ,MODEL,VEPRJ,MODX,
     &                  MODY,MODZ,I,J,MIJ)
C-------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 18/09/2012   AUTEUR LADIER A.LADIER 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C-------------------------------------------------------------------
      IMPLICIT NONE
C
C ROUTINE CALCULANT LA MASSE AJOUTEE SUR LE MODELE THERMIQUE
C  D INTERFACE AINSI QUE LE PREMIER COEFFICIENT D AMORTISSEMENT
C  AJOUTE
C IN :MAX,MAY,MAZ : MATRICES AX ET AY ET AZ
C IN: VEPRJ: PRESSION PROJETEE DUE AU MODE OU CHAMNO J
C IN: MODEL: K2 : CHAINE DISTINGUANT LE TYPE DE MODELISATION
C IN: MODX,MODY,MODZ : DEPLACEMENTS PROJETES
C OUT : MIJ : MASSE AJOUTEE
C-------------------------------------------------------------------
      INCLUDE 'jeveux.h'
      INTEGER       IPRES,I,J
      REAL*8        MIJ
      CHARACTER*(*) MODEL,OPTION
      CHARACTER*19  MODX,MODY,MODZ,VEPRJ,MAX,MAY,MAZ
      CHARACTER*1 K1BID
C--------------------------------------------------------------------

C-----------------------------------------------------------------------
      INTEGER IMATX ,IMATY ,IMATZ ,IMODX ,IMODY ,IMODZ ,IVECX
      INTEGER IVECY ,IVECZ ,NBPRES
      REAL*8 RX ,RY ,RZ,DDOT
C-----------------------------------------------------------------------
      CALL JEMARQ()
           CALL JEVEUO(MODX//'.VALE','L',IMODX)
           CALL JEVEUO(MODY//'.VALE','L',IMODY)

           CALL JEVEUO(VEPRJ//'.VALE','L',IPRES)
           CALL JELIRA(VEPRJ//'.VALE','LONMAX',NBPRES,K1BID)

           CALL WKVECT('&&CALCIN.VECTX','V V R',NBPRES,IVECX)
           CALL WKVECT('&&CALCIN.VECTY','V V R',NBPRES,IVECY)

C --- RECUPERATION DES DESCRIPTEURS DE MATRICES ASSEMBLEES MAX ET MAY

           CALL MTDSCR(MAX)
           CALL JEVEUO(MAX(1:19)//'.&INT','E',IMATX)
           CALL MTDSCR(MAY)
           CALL JEVEUO(MAY(1:19)//'.&INT','E',IMATY)

C------MULTIPLICATIONS MATRICE MAX * CHAMNO MODX---------------------
C----------ET MATRICE MAY * CHAMNO MODY------------------------------

           CALL MRMULT('ZERO',IMATX,ZR(IMODX),ZR(IVECX),1,.TRUE.)
           CALL MRMULT('ZERO',IMATY,ZR(IMODY),ZR(IVECY),1,.TRUE.)

C--PRODUITS SCALAIRES VECTEURS PRESSION PAR MAX*MODX ET MAY*MODY

           RX= DDOT(NBPRES,ZR(IPRES), 1,ZR(IVECX),1)
           RY= DDOT(NBPRES,ZR(IPRES), 1,ZR(IVECY),1)

C
C---------------- MENAGE SUR LA VOLATILE ---------------------------
C

           CALL JEDETR('&&CALCIN.VECTX')
           CALL JEDETR('&&CALCIN.VECTY')

           CALL DETRSD('CHAM_NO',MODX)
           CALL DETRSD('CHAM_NO',MODY)





C------ MASSE AJOUTEE = PRESSION*MAX*MODX + PRESSION*MAY*MODY-------
C--------------------------+ PRESSION*MAZ*MODZ  EN 3D---------------
           IF (MODEL.EQ.'3D') THEN

             CALL JEVEUO(MODZ//'.VALE','L',IMODZ)
             CALL WKVECT('&&CALCIN.VECTZ','V V R',NBPRES,IVECZ)
             CALL MTDSCR(MAZ)
             CALL JEVEUO(MAZ(1:19)//'.&INT','E',IMATZ)
             CALL MRMULT('ZERO',IMATZ,ZR(IMODZ),ZR(IVECZ),1,.TRUE.)
             RZ= DDOT(NBPRES,ZR(IPRES), 1,ZR(IVECZ),1)
             CALL JEDETR('&&CALCIN.VECTZ')
             CALL DETRSD('CHAM_NO',MODZ)
             MIJ = RX+RY+RZ

           ELSE
             MIJ = RX+RY
           ENDIF

        IF ((I.EQ.J).AND.(MIJ.LT.0).AND.(OPTION.EQ.'MASS_AJOU')) THEN
       CALL U2MESS('A','ALGORITH_60')
        ENDIF
        IF ((I.EQ.J).AND.(MIJ.LT.0).AND.(OPTION.EQ.'AMOR_AJOU')) THEN
       CALL U2MESS('A','ALGORITH_61')
        ENDIF

        CALL DETRSD('CHAM_NO',VEPRJ)

C-----------------------------------------------------------------
      CALL JEDEMA()
           END
