      SUBROUTINE CALDIS ( FREMAX, FREMIN, PAS, FREXCI, NBPTMD, NBMODE,
     &                 LISMOD, FREMOD, AMOMOD, NINDEX, NPDSC3, FREFIN )
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      INTEGER             NBPTMD, NBMODE, NINDEX, NPDSC3, LISMOD(*)
      REAL*8              FREMAX, FREMIN, PAS, FREMOD(*), AMOMOD(*),
     +                    FREFIN
      CHARACTER*4         FREXCI
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 12/11/2012   AUTEUR SELLENET N.SELLENET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C 
C  BUT: CALCUL DE LA DISCRETISATION FREQUENTIELLE POUR
C                 LE CALCUL DYNAMIQUE ALEATOIRE
C
C IN  : FREMAX : FREQ MAX DE LA DISCRETISATION
C IN  : FREMIN : FREQ MIN DE LA DISCRETISATION
C IN  : PAS    : PAS DE LA DISCRETISATION
C IN  : FREXCI : FREQUENCES EXCITATION: AVEC OU SANS
C IN  : NBPTMD : NOMBRE DE POINTS PAR PICS
C IN  : NBMODE : NOMBRE DE MODES DYNAMIQUES
C IN  : LISMOD : LISTE DES NUMEROS D'ORDRE DES MODES
C IN  : FREMOD : FREQUENCE DU MODE MECA
C IN  : AMOMOD : AMORTISSEMENTS MODAUX
C IN  : NINDEX : NOMBRE  D INDICES RECUPERES DANS L INTERPECTRE EXC
C OUT : NPDSC3 : NOMBRE DE VALEURS DE FREQUENCE
C OUT : FREFIN : DERNIERE FREQUENCE ( LA PLUS GRANDE)
C-----------------------------------------------------------------------
C
      REAL*8          FREMA1,FREDEB
C     ------------------------------------------------------------------
C-----------------------------------------------------------------------
      INTEGER I1 ,I2 ,IADII1 ,IADR1 ,IADSC1 ,IADSC2 ,IADSC3 
      INTEGER IBID1 ,ICONT1 ,IFREQ1 ,IGEX1 ,ILFEX ,ILLEX ,ILONG1 
      INTEGER IMODE ,INAJOU ,NBMAX ,NPDSC0 ,NPDSC2 ,MXVAL
      REAL*8 AMOR ,F0 ,F1 ,F2 ,FREQ 
      REAL*8 PASMIN ,R8ECAR
C-----------------------------------------------------------------------
      CALL JEMARQ()
C
C---------CAS D UNE DISCRETISATION DEMANDEE PAR L UTILISATEUR
C
      CALL JEVEUO('&&OP0131.LIADRFEX1','E',ILFEX)
      CALL JEVEUO('&&OP0131.LIADRLEX1','E',ILLEX)

      IF ( (FREMIN.NE.-1.D0) .AND. (FREMAX.NE.-1.D0) )THEN
         IF ( PAS .EQ.-1.D0 ) THEN
            PAS = ( FREMAX - FREMIN ) / 100.D0
         ENDIF
         NPDSC3 = INT( (FREMAX-FREMIN) / PAS +1.D-6) + 1
         CALL WKVECT( '&&OP0131.DISCR3', 'V V R8', NPDSC3, IADSC3 )
         DO 331,I1=1,NPDSC3-1
            ZR(IADSC3-1+I1) = FREMIN + (I1-1)*PAS
 331     CONTINUE
         ZR(IADSC3-1+NPDSC3) = FREMAX
         FREDEB = FREMIN
         FREFIN = FREMAX
         GOTO 332
      ENDIF
C
C---------CALCUL DE LA DISCRETISATION MINI IMPOSEE PAR LES FREQUENCES
C         PROPRES
C
C---------ON ALLOUE UN TABLEAU DE TRAVAIL POUR STOCKER TOUTES LES
C         DISCRETISATIONS
C
      ILONG1=0
      IF (FREXCI.EQ.'AVEC') THEN
        DO 329,IGEX1=1,NINDEX*(NINDEX+1)/2
          ILONG1=ILONG1+ZI(ILLEX)
 329    CONTINUE
      ENDIF
      CALL WKVECT('&&OP0131.DISCR1','V V R8',NBMODE*NBPTMD+ILONG1
     &     +NBMODE,    IADSC1)
      FREMA1=0.D0
      DO 301,I1=1,NBMODE
        IMODE = LISMOD(I1)
        F0    = FREMOD(IMODE)
        IF ( F0 .GT. FREMA1 ) FREMA1 = F0          
        AMOR   = AMOMOD(I1)
        FREDEB = 0.D0
        FREFIN = 2.D0*F0
        CALL DISCRT(F0,FREDEB,FREFIN,NBPTMD,AMOR,ZR(IADSC1+
     &              (I1-1)*NBPTMD))
 301  CONTINUE
      ICONT1=0
      MXVAL = NINDEX*(NINDEX+1)/2
      IF(FREXCI.EQ.'AVEC')THEN
        DO 330,IGEX1=1,NINDEX*(NINDEX+1)/2
          IADR1=ZI(ILLEX+MXVAL+1)
          DO 316,I2=1,ZI(ILLEX)
            ICONT1=ICONT1+1 
            ZR(IADSC1+NBMODE*NBPTMD-1+ICONT1)=ZR(IADR1-1+I2)
 316      CONTINUE
 330    CONTINUE
      ENDIF

C
C----AJOUT DES FREQUENCES PROPRES DANS LE CAS D AMORTISSEMENT NON NUL
C
      DO 327,I2 = 1,NBMODE
         IMODE = LISMOD(I2)
         AMOR  = AMOMOD(I2)
         FREQ  = FREMOD(IMODE)
         IF ( AMOR .NE. 0.D0 )THEN
            ZR(IADSC1+NBMODE*NBPTMD-1+ILONG1+I2) = FREQ
         ENDIF
 327  CONTINUE
      NPDSC0 = ILONG1+NBMODE
C
C---------TRI DES FREQUENCES OBTENUES-RANGEMENT DANS &&..DISCR2
C
      CALL WKVECT('&&OP0131.DISCI1','V V I',NBMODE*NBPTMD+NPDSC0,
     &IADII1)
      CALL ORDR8(ZR(IADSC1),NBMODE*NBPTMD+NPDSC0,ZI(IADII1))
      CALL WKVECT('&&OP0131.DISCR2','V V R8',NBMODE*NBPTMD+NPDSC0
     &+50,IADSC2)
      ZR(IADSC2)=ZR(IADSC1-1+ZI(IADII1))
      I2=1
      DO 302,I1=2,NBMODE*NBPTMD+NPDSC0
        IF(ZR(IADSC1-1+ZI(IADII1+I1-1)).GT.ZR(IADSC1-1
     &       +ZI(IADII1+I1-2)))THEN
          I2=I2+1
          ZR(IADSC2+I2-1)=ZR(IADSC1-1+ZI(IADII1+I1-1))
        ENDIF
 302  CONTINUE
      NPDSC2=I2
C
C---------PRISE EN COMPTE DU PAS MINI
C
C  - ON TIENT COMPTE D'UN PAS MINI EXPRIME OU NON PAR L UTILISATEUR
C  --- IL EST PAR DEFAUT EGAL A (FREFIN -FREDEB)/100
C
      IF((FREMIN.EQ.-1.D0).AND.(FREMAX.EQ.-1.D0))THEN
        FREDEB=0.D0
        FREFIN=2.0D0*FREMA1
      ELSE
        FREDEB=FREMIN
        FREFIN=FREMAX
      ENDIF
      IF(PAS.EQ.-1.D0)THEN
        PASMIN=(FREFIN-FREDEB)/100.0D0
      ELSE
        PASMIN=PAS
      ENDIF
      NBMAX=INT((FREFIN-FREDEB)/PASMIN)
      CALL WKVECT('&&OP0131.DISCR3','V V R8',NPDSC2+NBMAX,IADSC3)
      NPDSC3=NPDSC2
      INAJOU=0
      ZR(IADSC3)=ZR(IADSC2)
      DO 304,IFREQ1=2,NPDSC2
        F2=ZR(IADSC2-1+IFREQ1)
        F1=ZR(IADSC2-1+IFREQ1-1)
        R8ECAR=F2-F1
        IF((R8ECAR.GT.PASMIN).AND.(F2.LE.FREFIN))THEN
          INAJOU=INT(R8ECAR/PASMIN)
          DO 305,IBID1=1,INAJOU
            ZR(IADSC3-1+IFREQ1-1+NPDSC3-NPDSC2+IBID1)=
     &      ZR(IADSC2+IFREQ1-2)+IBID1*PASMIN
 305      CONTINUE
        ENDIF
        NPDSC3=NPDSC3+INAJOU
        INAJOU=0
        ZR(IADSC3-1+IFREQ1+NPDSC3-NPDSC2)=ZR(IADSC2-1+IFREQ1)
 304  CONTINUE
 332  CONTINUE
C
C------CALCUL DES DSP EXCITS DANS LA DISCRETISATION REPONSE
C
      CALL DISEXC(NINDEX,ILFEX,ILLEX,NPDSC3,IADSC3)
      CALL JEDEMA()
      END
