      SUBROUTINE CALMAA(MOINT,MATE,DIR,LIGRMO,LCHIN,LPAIN,LPAOUT,NUM,
     &                  MAA)
C--------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 03/07/2012   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C--------------------------------------------------------------------
      IMPLICIT NONE

C ROUTINE CALCULANT LES MATRICES AX ET AY SUR LE MODELE INTERFACE
C G. ROUSSEAU
C IN : MOINT : MODELE INTERFACE
C IN : MATE : MATERIAU CODE
C IN : DIR : DIRECTION X OU Y
C IN : LIGRMO : LIGREL DU MODELE
C IN: LCHIN,LPAIN,LPAOUT : PARAMETRES DU CALCUL ELEMENTAIRE
C IN : NUM : NUMEROTATION DES DDLS THERMIQUES D INTERFACE

C OUT : MAA : MATRICE AX OU AY
C---------------------------------------------------------------------

      INCLUDE 'jeveux.h'
      CHARACTER*(*) MOINT,MATE
      CHARACTER*1 DIR
      CHARACTER*8 K8BID,LPAIN(1),LPAOUT(1)
      CHARACTER*14 NUM
      CHARACTER*16 OPTION
      CHARACTER*19 MATEL,MAA
      CHARACTER*24 LCHOUT(1),LCHIN(1),LIGRMO,MAA2



C ----- CREATION DE LA MATR_ELEM AX OU AY DES N(I)*N(J)*NX OU NY----
C--------------SUR LE MODELE THERMIQUE------------------------------
C--------------------D'INTERFACE -----------------------------------

C-----------------------------------------------------------------------
      INTEGER JLVA 
C-----------------------------------------------------------------------
      CALL JEMARQ()
      OPTION = 'FLUX_FLUI_'//DIR
      MATEL = '&&CA.MA'//DIR
      MAA2 = MATEL//'.RELR'
      CALL MEMARE('V',MATEL,MOINT(1:8),MATE,' ','FLUX_FLUI_ '//DIR)
      CALL WKVECT(MAA2,'V V K24',1,JLVA)
      LCHOUT(1) = MATEL(1:8)//'.ME000'
      CALL CODENT(1,'D0',LCHOUT(1) (12:14))
      CALL CALCUL('S',OPTION,LIGRMO,1,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V',
     &               'OUI')
      ZK24(JLVA) = LCHOUT(1)
      CALL JEECRA(MAA2,'LONUTI',1,K8BID)


C-------------------- NUMEROTATION ----------------------------------

      NUM = '&&CALMAA.NUM'//DIR
      CALL NUMDDL(NUM,'VV',1,MATEL,'RCMK')
      CALL PROMOR(NUM,'V')
      CALL CRNSLV(NUM,'MULT_FRONT','METIS','V')

C---------------ASSEMBLAGE DES MATRICES AX OU AY DES N(I)N(J)NX OU NY

      MAA = '&&CA.AA'//DIR

      CALL ASSMAM('V',MAA,1,MATEL,1.D0,NUM,'ZERO',1)

      CALL JEDEMA()
      END
