      SUBROUTINE CFADDM(RESOCO,LCTFD ,LCTF3D,POSNOE,ILIAI ,
     &                  NDIMG ,NBNOM ,POSNSM,COEFNO,TAU1  ,
     &                  TAU2  ,NORM  ,JEU   ,COORNP)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*24 RESOCO
      INTEGER      POSNOE,ILIAI
      INTEGER      NBNOM,NDIMG
      INTEGER      POSNSM(9)
      REAL*8       COEFNO(9)
      REAL*8       JEU,COORNP(3)
      REAL*8       NORM(3),TAU1(3),TAU2(3)
      LOGICAL      LCTFD ,LCTF3D
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES DISCRETES - APPARIEMENT)
C
C ON AJOUTE UNE LIAISON MAITRE/ESCLAVE OU NODALE
C
C ----------------------------------------------------------------------
C
C
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  LCTFD  : FROTTEMENT
C IN  LCTF3D : FROTTEMENT EN 3D
C IN  POSNOE : INDICE DANS CONTNO DU NOEUD ESCLAVE
C IN  ILIAI  : INDICE DE LA LIAISON COURANTE
C IN  NDIMG  : DIMENSION DE L'ESPACE
C IN  NBNOM  : NOMBRE DE NOEUDS MAITRES CONCERNES (MAX: 9)
C IN  POSNSM : INDICES DANS CONTNO DES NOEUDS MAITRES
C IN  COEFNO : VALEURS EN M DES FONCTIONS DE FORME ASSOCIEES AUX NOEUDS
C               MAITRES
C IN  TAU1   : TANGENTE LOCALE DIRECTION 1
C IN  TAU2   : TANGENTE LOCALE DIRECTION 2
C IN  NORM   : NORMALE LOCALE
C IN  JEU    : JEU DANS LA DIRECTION DE LA NORMALE CHOISIE (PM.NORM)
C IN  COORNP : COORDONNNES DE LA PROJECTION DU NOEUD ESCLAVE
C
C
C
C
      CHARACTER*24 TANGCO,APPROJ
      INTEGER      JTANGO,JAPPRO
      CHARACTER*24 JEUITE
      INTEGER      JJEUIT
      REAL*8       COEF(30),COFX(30),COFY(30)
      INTEGER      NBDDLT
      INTEGER      DDL(30)
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- LECTURE DES STRUCTURES DE DONNEES DE CONTACT
C
      TANGCO = RESOCO(1:14)//'.TANGCO'
      JEUITE = RESOCO(1:14)//'.JEUITE'
      APPROJ = RESOCO(1:14)//'.APPROJ'
      CALL JEVEUO(TANGCO,'E',JTANGO)
      CALL JEVEUO(JEUITE,'E',JJEUIT)
      CALL JEVEUO(APPROJ,'E',JAPPRO)
C
C --- CALCUL DES COEFFICIENTS DES RELATIONS LINEAIRES
C
      CALL CFCOEF(NDIMG ,RESOCO,NBNOM ,POSNSM,COEFNO,
     &            POSNOE,NORM  ,TAU1  ,TAU2  ,COEF  ,
     &            COFX  ,COFY  ,NBDDLT,DDL   )
C
C --- MISE A JOUR DU JEU POUR LE CONTACT
C
      ZR(JJEUIT+3*(ILIAI-1)+1-1) = JEU
C
C --- INITIALISATIONS JEUX FROTTEMENT EN 3D
C
      IF (LCTF3D) THEN
        ZR(JJEUIT+3*(ILIAI-1)+2-1) = 0.D0
        ZR(JJEUIT+3*(ILIAI-1)+3-1) = 0.D0
      ENDIF
C
C --- SAUVEGARDE TANGENTES
C
      ZR(JTANGO+6*(ILIAI-1)+1-1) = TAU1(1)
      ZR(JTANGO+6*(ILIAI-1)+2-1) = TAU1(2)
      ZR(JTANGO+6*(ILIAI-1)+3-1) = TAU1(3)
      ZR(JTANGO+6*(ILIAI-1)+4-1) = TAU2(1)
      ZR(JTANGO+6*(ILIAI-1)+5-1) = TAU2(2)
      ZR(JTANGO+6*(ILIAI-1)+6-1) = TAU2(3)
C
C --- SAUVEGARDE COORDONNEES DE LA PROJECTION
C
      ZR(JAPPRO+3*(ILIAI-1)+1-1) = COORNP(1)
      ZR(JAPPRO+3*(ILIAI-1)+2-1) = COORNP(2)
      ZR(JAPPRO+3*(ILIAI-1)+3-1) = COORNP(3)
C
C --- COEFFICIENTS RELATIONS LINEAIRES APPARIEMENT
C
      CALL CFCOEM(RESOCO,LCTFD ,LCTF3D,POSNOE,ILIAI ,
     &            NBDDLT,NBNOM ,POSNSM,DDL   ,COEF  ,
     &            COFX  ,COFY)
C
      CALL JEDEMA()
      END
