      SUBROUTINE CFCGLT(RESOCO,ILIAI ,GLIS  )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'

      CHARACTER*24 RESOCO
      INTEGER      ILIAI
      REAL*8       GLIS
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (RESOLUTION)
C
C CALCUL DU GLISSEMENT - CAS PENALISE: JEU TOTAL
C
C ----------------------------------------------------------------------
C
C
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  ILIAI  : INDICE DE LA LIAISON COURANTE
C OUT GLIS   : GLISSEMENT TANGENT
C
C
C
C
      CHARACTER*24 JEUITE,JEUX
      INTEGER      JJEUIT,JJEUX
      REAL*8       JEXOLD,JEYOLD,JEXINI,JEYINI,JEXNEW,JEYNEW
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- LECTURE DES STRUCTURES DE DONNEES DE CONTACT
C
      JEUITE = RESOCO(1:14)//'.JEUITE'
      JEUX   = RESOCO(1:14)//'.JEUX'
      CALL JEVEUO(JEUITE,'L',JJEUIT)
      CALL JEVEUO(JEUX  ,'L',JJEUX )
C
C --- JEUX TANGENTS AVANT ITERATION DE NEWTON
C
      JEXOLD = ZR(JJEUIT+3*(ILIAI-1)+2-1)
      JEYOLD = ZR(JJEUIT+3*(ILIAI-1)+3-1)
C
C --- INCR. JEUX TANGENTS DEPUIS LE DEBUT DU PAS DE TEMPS SANS CORR.
C
      JEXINI = ZR(JJEUX+3*(ILIAI-1)+2-1)
      JEYINI = ZR(JJEUX+3*(ILIAI-1)+3-1)
C
C --- JEU TANGENT RESULTANT
C
      JEXNEW = JEXOLD - JEXINI
      JEYNEW = JEYOLD - JEYINI
      GLIS   = SQRT(JEXNEW**2+JEYNEW**2)
C
      CALL JEDEMA()
C
      END
