      SUBROUTINE CFCONV(NOMA  ,SDSTAT,SDIMPR,SDERRO,DEFICO,
     &                  RESOCO,SOLALG)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 18/09/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*8  NOMA
      CHARACTER*24 DEFICO,RESOCO,SDIMPR,SDERRO,SDSTAT
      CHARACTER*19 SOLALG(*)
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES DISCRETES)
C
C CONVERGENCE LIEE AU CONTACT DISCRET
C
C ----------------------------------------------------------------------
C
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  SDIMPR : SD AFFICHAGE
C IN  SDSTAT : SD STATISTIQUES
C IN  SDERRO : GESTION DES ERREURS
C IN  DEFICO : SD POUR LA DEFINITION DE CONTACT
C IN  RESOCO : SD POUR LA RESOLUTION DE CONTACT
C IN  SOLALG : VARIABLE CHAPEAU POUR INCREMENTS SOLUTIONS
C
C ----------------------------------------------------------------------
C
      LOGICAL      CFDISL,LALLV,LREAG
      CHARACTER*24 CLREAC
      INTEGER      JCLREA
      REAL*8       R8VIDE
      CHARACTER*16 GEONOE,K16BLA
      REAL*8       GEOVAL,R8BID
      LOGICAL      CTDERG,CVRESI
      LOGICAL      DVPFIX,DVFIXG
      INTEGER      CTCITE
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      DVPFIX = .FALSE.
      DVFIXG = .FALSE.
      CTDERG = .FALSE.
      LREAG  = .FALSE.
      K16BLA = ' '
      GEONOE = ' '
      GEOVAL = R8VIDE()
      CALL NMRVAI(SDSTAT,'CTCD_ALGO_ITER','N',CTCITE)
C
C --- VALEURS NON AFFECTEES DANS LE TABLEAU
C
      CALL NMIMCK(SDIMPR,'BOUC_NOEU',K16BLA,.FALSE.)
      CALL NMIMCR(SDIMPR,'BOUC_VALE',R8BID ,.FALSE.)
C
C --- CONVERGENCE DES RESIDUS D'EQUILIBRE ?
C
      CALL NMLECV(SDERRO,'RESI',CVRESI)
C
C --- ACCES SD CONTACT
C
      CLREAC = RESOCO(1:14)//'.REAL'
C
C --- FONCTIONNALISTES ACTIVEES
C
      LALLV  = CFDISL(DEFICO,'ALL_VERIF')
C
C --- CONVERGENCE
C
      IF (.NOT.LALLV) THEN
C
        CALL JEVEUO(CLREAC,'E',JCLREA)
C
C ----- ATTENTE POINT FIXE ?
C
        DVPFIX = ZL(JCLREA+2-1)
        LREAG  = .FALSE.
C
C ----- EVALUATION DE LA REACUALISATION GEOMETRIQUE POUR CONTACT DISCRET
C
        IF (CVRESI) THEN
          IF (.NOT.DVPFIX) THEN
            CALL CFCGEO(NOMA  ,DEFICO,RESOCO,SOLALG,DVFIXG,
     &                  CTDERG,GEONOE,GEOVAL)
            ZL(JCLREA+1-1) = DVFIXG
            ZL(JCLREA+4-1) = CTDERG
            LREAG          = .TRUE.
          ENDIF
        ENDIF
      ENDIF
C
C --- ENREGISTREMENT DES VALEURS POUR AFFICHAGE
C
      IF (LREAG) THEN
        CALL NMIMCK(SDIMPR,'BOUC_NOEU',GEONOE,.TRUE.)
        CALL NMIMCR(SDIMPR,'BOUC_VALE',GEOVAL,.TRUE.)
      ENDIF
      CALL NMIMCI(SDIMPR,'CTCD_NBIT',CTCITE,.TRUE.)
C
C --- ENREGISTREMENT DES EVENEMENTS - DIVERGENCES
C
      CALL NMCREL(SDERRO,'DIVE_PFIX',DVPFIX)
C
      CALL JEDEMA()
      END
