      SUBROUTINE CFCPES(RESOCO,JSECMB)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*24 RESOCO
      INTEGER      JSECMB
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (RESOLUTION - PENALISATION)
C
C CALCUL DU SECOND MEMBRE POUR LE CONTACT -E_N.[Ac]T.{JEU}
C
C ----------------------------------------------------------------------
C 
C
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  JSECMB : ADRESSE VERS LE SECOND MEMBRE
C
C
C
C
      REAL*8       JEUINI,COEFPN,LAMBDC,R8PREM
      INTEGER      ILIAI,ILIAC
      CHARACTER*19 MU
      INTEGER      JMU
      CHARACTER*24 APCOEF,APDDL,APPOIN
      INTEGER      JAPCOE,JAPDDL,JAPPTR
      CHARACTER*24 TACFIN
      INTEGER      JTACF
      CHARACTER*24 JEUX
      INTEGER      JJEUX
      INTEGER      CFMMVD,ZTACF
      INTEGER      CFDISD,NBLIAI,NEQ
      INTEGER      NBDDL,JDECAL
C 
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATION DES VARIABLES
C
      NBLIAI = CFDISD(RESOCO,'NBLIAI')
      NEQ    = CFDISD(RESOCO,'NEQ'   )
C
C --- LECTURE DES STRUCTURES DE DONNEES DE CONTACT
C
      APPOIN = RESOCO(1:14)//'.APPOIN'
      APDDL  = RESOCO(1:14)//'.APDDL'
      APCOEF = RESOCO(1:14)//'.APCOEF'
      JEUX   = RESOCO(1:14)//'.JEUX'
      TACFIN = RESOCO(1:14)//'.TACFIN'
      MU     = RESOCO(1:14)//'.MU'
      CALL JEVEUO(APPOIN,'L',JAPPTR)
      CALL JEVEUO(APDDL ,'L',JAPDDL)
      CALL JEVEUO(APCOEF,'L',JAPCOE)
      CALL JEVEUO(JEUX  ,'L',JJEUX )
      CALL JEVEUO(TACFIN,'L',JTACF )
      CALL JEVEUO(MU,    'E',JMU   )
      ZTACF  = CFMMVD('ZTACF')
C
C --- INITIALISATION DES MU
C
      DO 10 ILIAI = 1,NBLIAI
        ZR(JMU         +ILIAI-1) = 0.D0
        ZR(JMU+3*NBLIAI+ILIAI-1) = 0.D0
 10   CONTINUE
C
C --- CALCUL DES FORCES DE CONTACT
C
      ILIAC = 1
      DO 50 ILIAI = 1,NBLIAI
        JEUINI = ZR(JJEUX+3*(ILIAI-1)+1-1)
        COEFPN = ZR(JTACF+ZTACF*(ILIAI-1)+1)
        IF (JEUINI.LT.R8PREM()) THEN
          JDECAL = ZI(JAPPTR+ILIAI-1)
          NBDDL  = ZI(JAPPTR+ILIAI) - ZI(JAPPTR+ILIAI-1)
          LAMBDC          = -JEUINI*COEFPN
          ZR(JMU+ILIAC-1) = LAMBDC
          CALL CALATM(NEQ,NBDDL,LAMBDC,ZR(JAPCOE+JDECAL),
     &                ZI(JAPDDL+JDECAL),ZR(JSECMB))
          ILIAC           = ILIAC + 1
        ENDIF
 50   CONTINUE
C
      CALL JEDEMA()
C
      END
