      SUBROUTINE CFCRJE(DEFICO,RESOCO)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*24 DEFICO,RESOCO
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES DISCRETES - JEUX)
C
C CREATION DES SD POUR LES JEUX
C
C ----------------------------------------------------------------------
C
C
C IN  DEFICO : SD POUR LA DEFINITION DE CONTACT
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C
C
C
C
      INTEGER      IFM,NIV
      INTEGER      CFDISI,NTPC
      CHARACTER*24 JEUITE,JEUSAV,JEUX
      INTEGER      JJEUIT,JJEUSA,JJEUX
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('CONTACT',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<CONTACT> ...... CREATION DES SD POUR LES'//
     &                ' JEUX'
      ENDIF
C
C --- INFORMATIONS
C
      NTPC   = CFDISI(DEFICO,'NTPC'  )
C
C --- JEUX ACTUALISES AU COURS DES ITERATIONS
C
      JEUITE = RESOCO(1:14)//'.JEUITE'
      CALL WKVECT(JEUITE,'V V R',3*NTPC ,JJEUIT)
C
C --- JEUX AU DEBUT DU PAS DE TEMPS (SI REDECOUPAGE CF CFDECO/REAJEU)
C
      JEUSAV = RESOCO(1:14)//'.JEUSAV'
      CALL WKVECT(JEUSAV,'V V R',3*NTPC ,JJEUSA)
C
C --- JEUX
C     1: JEU NORMAL SANS CORRECTION DU CONTACT
C     2: JEU TANGENT 1 DEPUIS LE DEBUT DU PAS DE TEMPS
C     3: JEU TANGENT 2 DEPUIS LE DEBUT DU PAS DE TEMPS
C
      JEUX   = RESOCO(1:14)//'.JEUX'
      CALL WKVECT(JEUX  ,'V V R',3*NTPC ,JJEUX )
C
      CALL JEDEMA()
      END
