      INTEGER FUNCTION CFDISD(RESOCO,QUESTZ)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS

      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*24  RESOCO
      CHARACTER*(*) QUESTZ
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (TOUTES METHODES - UTILITAIRE)
C
C LECTURE INFORMATIONS SUR L'ETAT DU CONTACT ACTUEL
C
C ----------------------------------------------------------------------
C
C 
C IN  RESOCO  : SD DE RESOLUTION DU CONTACT
C IN  QUESTI  : VALEUR A LIRE/ECRIRE
C   NDIM   : DIMENSION DE L'ESPACE
C   NBLIAC : NOMBRE DE LIAISON DE CONTACT ACTIVES
C   LLF    : NOMBRE DE LIAISON DE FROTTEMENT (DEUX DIRECTIONS) 
C   LLF1   : NOMBRE DE LIAISON DE FROTTEMENT (1ERE DIRECTION ) 
C   LLF2   : NOMBRE DE LIAISON DE FROTTEMENT (2EME DIRECTION ) 
C   NBLIAI : NOMBRE DE LIAISONS (NOEUDS ESCLAVES APPARIES)
C   NEQ    : NOMBRE D'EQUATIONS DU SYSTEME
C   NESMAX : NOMBRE MAXI DE NOEUDS ESCLAVES (POUR DECALAGES)
C
C
C
C
      CHARACTER*24 QUESTI
      CHARACTER*24 COCO  
      INTEGER      JCOCO  
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      QUESTI = QUESTZ  
C 
C --- LECTURE DES STRUCTURES DE DONNEES DE CONTACT
C     
      COCO   = RESOCO(1:14)//'.COCO'
      CALL JEVEUO(COCO  ,'L',JCOCO)
C     
      IF (QUESTI.EQ.'NDIM') THEN  
        CFDISD = ZI(JCOCO+1-1)
      ELSEIF (QUESTI.EQ.'NEQ') THEN
        CFDISD = ZI(JCOCO+2-1)
      ELSEIF (QUESTI.EQ.'NBLIAC') THEN
        CFDISD = ZI(JCOCO+3-1)        
      ELSEIF (QUESTI.EQ.'LLF') THEN
        CFDISD = ZI(JCOCO+4-1)  
      ELSEIF (QUESTI.EQ.'LLF1') THEN
        CFDISD = ZI(JCOCO+5-1)  
      ELSEIF (QUESTI.EQ.'LLF2') THEN
        CFDISD = ZI(JCOCO+6-1)
      ELSEIF (QUESTI.EQ.'NESMAX') THEN
        CFDISD = ZI(JCOCO+7-1)         
      ELSEIF (QUESTI.EQ.'NBLIAI') THEN
        CFDISD = ZI(JCOCO+8-1)
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF 
C
      CALL JEDEMA()
      END
