      SUBROUTINE CFFACT(LDSCON,NDIM  ,ISTO  ,NBLIAC,LLF   ,
     &                  LLF1  ,LLF2  ,INDFAC,LECHEC)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      INTEGER      NDIM
      INTEGER      NBLIAC,LLF,LLF1,LLF2,INDFAC
      INTEGER      LDSCON
      INTEGER      ISTO
      LOGICAL      LECHEC
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES DISCRETES - RESOLUTION)
C
C FACTORISATION LDLT DE [-A.C-1.AT]
C
C ----------------------------------------------------------------------
C
C ATTENTION : SI ON RAJOUTE DES LIAISONS ON NE FACTORISE QUE
C LA PARTIE RAJOUTEE (LE RESTE EST ENCORE VALABLE, CF. PROPRIETES
C MAGIQUES DES FACTORISATIONS).
C SI ON ENLEVE LA DERNIERE LIAISON (IDEBUT > NBLIAC),PAS BESOIN DE
C REFACTORISER : L'INSTRUCTION ZI(LDSCON+2) = NBLIAC ECRITE PLUS
C LOIN FERA QUE RLDLGG PRENDRA LA BONNE TAILLE DE MATRICE, QUI
C EST DEJA FACTORISEE (SI ON REFACTORISAIT A PARTIR DE 1, ON
C FACTORISERAIT LA FACTORISEE, CE QUI EST GENANT, CAR
C FACTORISATION EN PLACE)
C
C IN  LDSCON : DESCRIPTEUR DE LA MATRICE DE CONTACT
C IN  NDIM   : DIMENSION DU PROBLEME
C IN  ISTO   : INDICATEUR D'ARRET EN CAS DE PIVOT NUL
C IN  NBLIAC : NOMBRE DE LIAISONS ACTIVES
C IN  LLF    : NOMBRE DE LIAISONS DE FROTTEMENT (EN 2D)
C              NOMBRE DE LIAISONS DE FROTTEMENT SUIVANT LES DEUX
C               DIRECTIONS SIMULTANEES (EN 3D)
C IN  LLF1   : NOMBRE DE LIAISONS DE FROTTEMENT SUIVANT LA
C               PREMIERE DIRECTION (EN 3D)
C IN  LLF2   : NOMBRE DE LIAISONS DE FROTTEMENT SUIVANT LA
C               SECONDE DIRECTION (EN 3D)
C I/O INDFAC : INDICE DE DEBUT DE LA FACTORISATION
C OUT LECHEC : .TRUE. SI LA FACTORISATION A ECHOUE (MATRICE SINGULIERE)
C
C
C
C
      INTEGER IFM,NIV
      INTEGER ILIDEB,ILIFIN,IER
      INTEGER NDECI,ISINGU,NPVNEG
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('CONTACT',IFM,NIV) 
C
C --- INITIALISATION
C
      LECHEC = .FALSE.
C
C --- FACTORISATION
C
      IF (INDFAC.LE.(NBLIAC+(NDIM-1)*LLF+LLF1+LLF2)) THEN
        IF (NIV.GE.2) THEN
          WRITE(IFM,*)'<CONTACT><CALC> FACTORISATION MATRICE CONTACT '
        ENDIF
        ILIDEB = INDFAC
        ILIFIN = NBLIAC+(NDIM-1)*LLF+LLF1+LLF2
        CALL TLDLGG(2     ,LDSCON,ILIDEB,ILIFIN,0     ,
     &              NDECI ,ISINGU,NPVNEG,IER   )
        INDFAC = ILIFIN + 1
        IF (IER.GT.ISTO) THEN
          LECHEC = .TRUE.
        ENDIF
      ENDIF
C 
      CALL JEDEMA() 
C
      END 
