      SUBROUTINE CFGCAC(RESOCO,TOLE  ,NEQ   ,NBLIAI,NBLIAC)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*24 RESOCO
      INTEGER      NEQ,NBLIAI,NBLIAC
      REAL*8       TOLE
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (RESOLUTION - GCP)
C
C ACTIVATION DES LIAISONS ET CALCUL DE LA FORCE DE CONTACT
C
C ----------------------------------------------------------------------
C 
C
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  NBLIAI : NOMBRE DE LIAISONS DE CONTACT
C IN  NEQ    : NOMBRE D'EQUATIONS
C IN  TOLE   : TOLERANCE POUR DETECTER PRESSION NULLE
C OUT NBLIAC : NOMBRE DE LIAISONS ACTIVES
C
C
C
C
      INTEGER      IFM,NIV
      INTEGER      ILIAI,JDECAL,NBDDL
      CHARACTER*24 APCOEF,APDDL,APPOIN
      INTEGER      JAPCOE,JAPDDL,JAPPTR
      CHARACTER*19 MU ,ATMU,LIAC
      INTEGER      JMU,JATMU,JLIAC
C 
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('CONTACT',IFM,NIV)
C
C --- LECTURE DES STRUCTURES DE DONNEES DE CONTACT
C
      APPOIN = RESOCO(1:14)//'.APPOIN'
      APCOEF = RESOCO(1:14)//'.APCOEF'
      APDDL  = RESOCO(1:14)//'.APDDL'
      MU     = RESOCO(1:14)//'.MU'  
      ATMU   = RESOCO(1:14)//'.ATMU'
      LIAC   = RESOCO(1:14)//'.LIAC'  
C
      CALL JEVEUO(APPOIN,'L',JAPPTR)
      CALL JEVEUO(APCOEF,'L',JAPCOE)
      CALL JEVEUO(APDDL ,'L',JAPDDL)     
      CALL JEVEUO(MU    ,'L',JMU   ) 
      CALL JEVEUO(ATMU,  'E',JATMU )
      CALL JEVEUO(LIAC,  'E',JLIAC )
C
C --- CALCUL DE ATMU SUR TOUTES LES LIAISONS
C
      CALL R8INIR(NEQ,0.D0,ZR(JATMU),1)
      DO 120 ILIAI = 1,NBLIAI
        JDECAL = ZI(JAPPTR+ILIAI-1)
        NBDDL  = ZI(JAPPTR+ILIAI) - ZI(JAPPTR+ILIAI-1)
        CALL CALATM(NEQ,NBDDL,ZR(JMU+ILIAI-1),ZR(JAPCOE+JDECAL),
     &              ZI(JAPDDL+JDECAL),ZR(JATMU))
  120 CONTINUE
C
C --- COMPTE DES LIAISONS ACTIVES ET ACTIVATION
C
      NBLIAC = 0
      DO 130 ILIAI = 1,NBLIAI
        IF (ZR(JMU+ILIAI-1).GT.TOLE) THEN
          NBLIAC = NBLIAC + 1
          ZI(JLIAC+NBLIAC-1) = ILIAI
        END IF
  130 CONTINUE 
C
      CALL JEDEMA()
C
      END
