      SUBROUTINE CFGCPC(RESOCO,MATASS,SOLVEU,NEQ   ,NBLIAI,
     &                  PRECON,TOLE  ,PREMAX,EPSI  )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*24 RESOCO
      CHARACTER*16 PRECON
      INTEGER      NEQ,NBLIAI
      CHARACTER*19 MATASS,SOLVEU
      INTEGER      PREMAX
      REAL*8       TOLE,EPSI
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (RESOLUTION - GCP)
C
C PRECONDITIONNEMENT
C
C ----------------------------------------------------------------------
C
C
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  SOLVEU : SD SOLVEUR
C IN  MATASS : NOM DE LA MATRICE DU PREMIER MEMBRE ASSEMBLEE
C IN  NBLIAI : NOMBRE DE LIAISONS DE CONTACT
C IN  NEQ    : NOMBRE D'EQUATIONS
C IN  PRECON : TYPE DE PRECONDITIONNEMENT
C              'DIRICHLET'
C              'SANS'
C IN  TOLE   : TOLERANCE POUR DETECTER PRESSION NULLE
C IN  PREMAX : NOMBRE MAXI D'ITERATIONS DU SOLVEUR ITERATIF
C IN  EPSI   : RESI_ABSO
C
C
C
C
      CHARACTER*19 SGRADP,SGRPRP
      INTEGER      JSGRAP,JSGPRP
      CHARACTER*24 APCOEF,APDDL,APPOIN
      INTEGER      JAPCOE,JAPDDL,JAPPTR
      CHARACTER*19 MU ,LIAC
      INTEGER      JMU,JLIAC
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- LECTURE DES STRUCTURES DE DONNEES DE CONTACT
C
      APPOIN = RESOCO(1:14)//'.APPOIN'
      APCOEF = RESOCO(1:14)//'.APCOEF'
      APDDL  = RESOCO(1:14)//'.APDDL'
      MU     = RESOCO(1:14)//'.MU'
      SGRADP = RESOCO(1:14)//'.SGDP'
      LIAC   = RESOCO(1:14)//'.LIAC'
      SGRPRP = RESOCO(1:14)//'.SGPP'
      CALL JEVEUO(APPOIN,'L',JAPPTR)
      CALL JEVEUO(APCOEF,'L',JAPCOE)
      CALL JEVEUO(APDDL ,'L',JAPDDL)
      CALL JEVEUO(MU    ,'L',JMU   )
      CALL JEVEUO(SGRADP,'L',JSGRAP)
      CALL JEVEUO(LIAC  ,'E',JLIAC )
      CALL JEVEUO(SGRPRP,'E',JSGPRP)
C
C --- INITIALISATION DU PRECONDITIONNEUR
C
      CALL R8INIR(NBLIAI,0.D0,ZR(JSGPRP),1)
C
C --- PRECONDITIONNEMENT (OU PAS)
C
      IF (PRECON.EQ.'DIRICHLET') THEN
        CALL CFPCDI(RESOCO ,NEQ       ,NBLIAI    ,TOLE      ,EPSI      ,
     &              ZR(JMU),ZR(JAPCOE),ZI(JAPDDL),ZI(JAPPTR),ZI(JLIAC) ,
     &              MATASS ,SOLVEU    ,PREMAX    ,ZR(JSGRAP),ZR(JSGPRP))
      ELSEIF (PRECON.EQ.'SANS') THEN
        CALL DCOPY(NBLIAI,ZR(JSGRAP),1,ZR(JSGPRP),1)
      ELSE
        CALL ASSERT(.FALSE.)
      END IF
C
      CALL JEDEMA()
C
      END
