      SUBROUTINE CFGCSG(RESOCO,NEQ   ,NBLIAI,TOLE ,NINF  )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*24 RESOCO
      INTEGER      NEQ,NBLIAI
      REAL*8       TOLE
      REAL*8       NINF
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (RESOLUTION - GCP)
C
C CALCUL DU SOUS-GRADIENT
C
C ----------------------------------------------------------------------
C
C
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  NBLIAI : NOMBRE DE LIAISONS DE CONTACT
C IN  NEQ    : NOMBRE D'EQUATIONS
C IN  TOLE   : TOLERANCE POUR DETECTER PRESSION NULLE
C OUT NINF   : NORME INFINIE DU RESIDU
C
C
C
C
      INTEGER      ILIAI,NBDDL,JDECAL
      REAL*8       JEUINC,JEUOLD,JEUNEW,SSGRAD
      CHARACTER*19 MU
      INTEGER      JMU
      CHARACTER*19 SGRADP
      INTEGER      JSGRAP
      CHARACTER*24 APCOEF,APDDL,APPOIN
      INTEGER      JAPCOE,JAPDDL,JAPPTR
      CHARACTER*24 JEUITE
      INTEGER      JJEUIT
      CHARACTER*19 DDEPLC
      INTEGER      JDDEPC
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- ACCES STRUCTURES DE DONNEES DE CONTACT
C
      MU     = RESOCO(1:14)//'.MU'
      APPOIN = RESOCO(1:14)//'.APPOIN'
      APCOEF = RESOCO(1:14)//'.APCOEF'
      APDDL  = RESOCO(1:14)//'.APDDL'
      JEUITE = RESOCO(1:14)//'.JEUITE'
      SGRADP = RESOCO(1:14)//'.SGDP'
      CALL JEVEUO(MU    ,'L',JMU   )
      CALL JEVEUO(APPOIN,'L',JAPPTR)
      CALL JEVEUO(APCOEF,'L',JAPCOE)
      CALL JEVEUO(APDDL ,'L',JAPDDL)
      CALL JEVEUO(JEUITE,'L',JJEUIT)
      CALL JEVEUO(SGRADP,'E',JSGRAP)
C
C --- ACCES AUX CHAMPS DE TRAVAIL
C --- DDEPLC: INCREMENT DE SOLUTION APRES CORRECTION DU CONTACT
C
      DDEPLC = RESOCO(1:14)//'.DELC'
      CALL JEVEUO(DDEPLC(1:19)//'.VALE','L',JDDEPC)
C
C --- CALCUL DU SOUS-GRADIENT
C
      DO 10 ILIAI = 1,NBLIAI
        JDECAL = ZI(JAPPTR+ILIAI-1)
        NBDDL  = ZI(JAPPTR+ILIAI) - ZI(JAPPTR+ILIAI-1)
        JEUOLD = ZR(JJEUIT+3*(ILIAI-1)+1-1)
        CALL CALADU(NEQ,NBDDL,ZR(JAPCOE+JDECAL),ZI(JAPDDL+JDECAL),
     &              ZR(JDDEPC),JEUINC)
        JEUNEW = JEUOLD - JEUINC
        SSGRAD = -JEUNEW
        ZR(JSGRAP-1+ILIAI) = SSGRAD
   10 CONTINUE
C
C --- PROJECTION DU SOUS-GRADIENT
C
      DO 15 ILIAI = 1,NBLIAI
        SSGRAD = ZR(JSGRAP-1+ILIAI)
        IF (ZR(JMU+ILIAI-1).LE.TOLE) THEN
          ZR(JSGRAP-1+ILIAI) = MAX(SSGRAD,0.D0)
        ENDIF
   15 CONTINUE
C
C --- NORME INFINIE DU RESIDU
C
      NINF = 0.D0
      DO 20 ILIAI = 1,NBLIAI
        NINF = MAX(ABS(ZR(JSGRAP-1+ILIAI)),NINF)
   20 CONTINUE
C
      CALL JEDEMA()
C
      END
