      SUBROUTINE CFGEOM(REAGEO,ITERAT,NOMA  ,SDTIME,SDSTAT,
     &                  DEFICO,RESOCO,DEPPLU)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      INTEGER      ITERAT
      LOGICAL      REAGEO
      CHARACTER*8  NOMA
      CHARACTER*24 DEFICO,RESOCO,SDTIME,SDSTAT
      CHARACTER*19 DEPPLU
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES DISCRETES - APPARIEMENT)
C
C ROUTINE D'AIGUILLAGE POUR L'ACTUALISATION GEOMETRIQUE DU CONTACT:
C  APPARIEMENT, PROJECTION, JEUX
C
C ----------------------------------------------------------------------
C
C
C IN  REAGEO : VAUT .TRUE. SI REACTUALISATION GEOMETRIQUE
C IN  ITERAT : NUMERO DE L'ITERATION DE NEWTON COURANTE
C IN  NOMA   : NOM DU MAILLAGE
C IN  SDTIME : SD TIMER
C IN  SDSTAT : SD STATISTIQUES
C IN  DEFICO : SD DE DEFINITION DU CONTACT
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  DEPPLU : CHAMP DE DEPLACEMENTS DEPUIS L'INSTANT INITIAL
C
C
C
C
      INTEGER      IFM,NIV
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('CONTACT',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        IF (REAGEO) THEN
          WRITE (IFM,*) '<CONTACT> ... REACTUALISATION DE '//
     &                  'L''APPARIEMENT'
        ELSE
          WRITE (IFM,*) '<CONTACT> ... PAS DE REACTUALISATION DE '//
     &                  'L''APPARIEMENT'
        ENDIF
      ENDIF
C
C --- APPARIEMENT (OU PAS)
C
      IF (REAGEO) THEN
        CALL NMTIME(SDTIME,'INI','CONT_GEOM')
        CALL NMTIME(SDTIME,'RUN','CONT_GEOM')
C
C ----- REACTUALISATION DE LA GEOMETRIE
C
        CALL GEOMCO(NOMA  ,RESOCO,DEPPLU)
C
C ----- APPARIEMENT
C
        CALL CFAPPA(NOMA  ,DEFICO,RESOCO)
        CALL NMTIME(SDTIME,'END','CONT_GEOM')
        CALL NMRINC(SDSTAT,'CONT_GEOM')
C
      ELSE
C
C --- REACTUALISATION DU JEU NECESSAIRE EN DEBUT DE PAS
C --- DE TEMPS AU CAS OU IL Y AURAIT EU REDECOUPAGE
C
         IF (ITERAT.EQ.0) THEN
           CALL REAJEU(RESOCO)
         ENDIF
      ENDIF
C
C --- IMPRESSIONS POUR LES DEVELOPPEURS
C
      IF (NIV.GE.2) THEN
        CALL CFIMP4(DEFICO,RESOCO,NOMA,IFM)
      ENDIF
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        IF (REAGEO) THEN
          WRITE (IFM,*) '<CONTACT> ... FIN DE REACTUALISATION DE '//
     &                  'L''APPARIEMENT'
        ENDIF
      ENDIF
C
      CALL JEDEMA()
      END
