      SUBROUTINE CFINNL(DEFICO,RESOCO,REAGEO,NBLIAC,LLF   ,
     &                  LLF1  ,LLF2  )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*24 DEFICO,RESOCO
      INTEGER      NBLIAC,LLF,LLF1,LLF2
      LOGICAL      REAGEO
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE DISCRETE - ALGORITHME)
C
C NOMBRE DE LIAISONS INITIALES
C
C ----------------------------------------------------------------------
C
C
C IN  DEFICO : SD DE DEFINITION DU CONTACT
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  REAGEO : .TRUE. SI ON VIENT DE FAIRE UN NOUVEL APPARIEMENT
C OUT NBLIAC : NOMBRE DE LIAISONS ACTIVES
C OUT LLF    : NOMBRE DE LIAISON DE FROTTEMENT (DEUX DIRECTIONS)
C OUT LLF1   : NOMBRE DE LIAISON DE FROTTEMENT (1ERE DIRECTION ) 
C OUT LLF2   : NOMBRE DE LIAISON DE FROTTEMENT (2EME DIRECTION ) 
C
C
C
C
      INTEGER CFDISD
      LOGICAL CFDISL,LPENAF,LLAGRC
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- PARAMETRES
C
      LPENAF = CFDISL(DEFICO,'FROT_PENA')
      LLAGRC = CFDISL(DEFICO,'CONT_LAGR')
C
C --- NOMBRE DE LIAISONS INITIALES
C --- POUR LES METHODES PUREMENT LAGRANGIENNES, ON GARDE
C --- LA MEMOIRE DES LIAISONS PRECEDEMMENT ACTIVES
C
      IF (LLAGRC) THEN
        IF (REAGEO) THEN
          NBLIAC = 0
          LLF    = 0
          LLF1   = 0
          LLF2   = 0
        ELSE
          NBLIAC = CFDISD(RESOCO,'NBLIAC'  )
          IF (LPENAF) THEN
            LLF    = 0
            LLF1   = 0
            LLF2   = 0
          ELSE
            LLF    = CFDISD(RESOCO,'LLF'     )
            LLF1   = CFDISD(RESOCO,'LLF1'    )
            LLF2   = CFDISD(RESOCO,'LLF2'    )
          ENDIF
        ENDIF
      ELSE
        NBLIAC = 0
        LLF    = 0
        LLF1   = 0
        LLF2   = 0
      ENDIF
C
      CALL JEDEMA()
C
      END
