      SUBROUTINE CFLLAF(NOMA  ,DEFICO,RESOCO,ILIAI ,NBLIAI,
     &                  NBLIAC,LLF   ,LLF1  ,LLF2  ,INDIC ,
     &                  AJLIAI,SPLIAI)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*8  NOMA
      CHARACTER*24 DEFICO,RESOCO
      INTEGER      ILIAI
      INTEGER      NBLIAI,NBLIAC,LLF,LLF1,LLF2
      INTEGER      INDIC,SPLIAI,AJLIAI
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES DISCRETES - RESOLUTION)
C
C ON AJOUTE UNE LIAISON DE FROTTEMENT
C
C ----------------------------------------------------------------------
C
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  DEFICO : SD DE DEFINITION DU CONTACT
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  ILIAI  : NUMERO DE LA LIAISON A AJOUTER
C IN  NBLIAI : NOMBRE DE LIAISONS
C OUT INDIC  :+1 ON A RAJOUTE UNE LIAISON
C             -1 ON A ENLEVE UNE LIAISON
C I/O NBLIAC : NOMBRE DE LIAISONS ACTIVES
C I/O AJLIAI : INDICE DANS LA LISTE DES LIAISONS ACTIVES DE LA DERNIERE
C              LIAISON CORRECTE DU CALCUL
C              DE LA MATRICE DE CONTACT ACM1AT
C I/O SPLIAI : INDICE DANS LA LISTE DES LIAISONS ACTIVES DE LA DERNIERE
C              LIAISON AYANT ETE CALCULEE POUR LE VECTEUR CM1A
C I/O LLF    : NOMBRE DE LIAISONS DE FROTTEMENT (EN 2D)
C              NOMBRE DE LIAISONS DE FROTTEMENT SUIVANT LES DEUX
C               DIRECTIONS SIMULTANEES (EN 3D)
C I/O LLF1   : NOMBRE DE LIAISONS DE FROTTEMENT SUIVANT LA
C               PREMIERE DIRECTION (EN 3D)
C I/O LLF2   : NOMBRE DE LIAISONS DE FROTTEMENT SUIVANT LA
C               SECONDE DIRECTION (EN 3D)
C
C
C
C
      INTEGER      POSIT
      LOGICAL      LELPIV,LELPI1,LELPI2
      CHARACTER*1  TYPEAJ
      CHARACTER*2  TYPEF0,TYPEF1,TYPEF2
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      TYPEAJ = 'A'
      TYPEF0 = 'F0'
      TYPEF1 = 'F1'
      TYPEF2 = 'F2'
      POSIT  = NBLIAC + LLF + LLF1 + LLF2 + 1
C
C --- LIAISON PROVOQUANT UN PIVOT NUL ?
C
      CALL CFELPV(ILIAI ,TYPEF0,RESOCO,NBLIAI,LELPIV)
      CALL CFELPV(ILIAI ,TYPEF1,RESOCO,NBLIAI,LELPI1)
      CALL CFELPV(ILIAI ,TYPEF2,RESOCO,NBLIAI,LELPI2)
C
C --- ON NE PREND PAS EN COMPTE UNE LIAISON A PIVOT NUL
C
      IF (.NOT.LELPIV) THEN
        IF (LELPI1) THEN
          CALL CFTABL(INDIC ,NBLIAC,AJLIAI,SPLIAI,LLF   ,
     &                LLF1  ,LLF2  ,RESOCO,TYPEAJ,POSIT ,
     &                ILIAI ,TYPEF2)
          CALL CFIMP2(DEFICO,RESOCO,NOMA  ,ILIAI ,TYPEF2,
     &                'ACT' )
        ELSE
          IF (LELPI2) THEN
            CALL CFTABL(INDIC ,NBLIAC,AJLIAI,SPLIAI,LLF   ,
     &                  LLF1  ,LLF2  ,RESOCO,TYPEAJ,POSIT ,
     &                  ILIAI ,TYPEF1)
            CALL CFIMP2(DEFICO,RESOCO,NOMA  ,ILIAI ,TYPEF1,
     &                  'ACT' )
          ELSE
            CALL CFTABL(INDIC ,NBLIAC,AJLIAI,SPLIAI,LLF   ,
     &                  LLF1  ,LLF2  ,RESOCO,TYPEAJ,POSIT ,
     &                  ILIAI ,TYPEF0)
            CALL CFIMP2(DEFICO,RESOCO,NOMA  ,ILIAI ,TYPEF0,
     &                  'ACT' )
          ENDIF
        ENDIF
      ENDIF
C 
      CALL JEDEMA() 
C
      END 
