      SUBROUTINE CFMAJM(RESOCO,NDIM  ,NBLIAC,LLF   ,LLF1  ,
     &                  LLF2  )
C 
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C 
       IMPLICIT      NONE
      INCLUDE 'jeveux.h'
       INTEGER       NDIM, NBLIAC, LLF, LLF1, LLF2
       CHARACTER*24  RESOCO
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES DISCRETES - RESOLUTION)
C
C RE-ORDONNE LE VECTEUR MU
C
C ----------------------------------------------------------------------
C
C
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  NEQ    : NOMBRE D'EQUATIONS
C IN  NDIM   : DIMENSION DU PROBLEME
C IN  NBLIAC : NOMBRE DE LIAISONS ACTIVES
C IN  LLF    : NOMBRE DE LIAISONS DE FROTTEMENT (EN 2D)
C              NOMBRE DE LIAISONS DE FROTTEMENT SUIVANT LES DEUX 
C               DIRECTIONS SIMULTANEES (EN 3D)
C IN  LLF1   : NOMBRE DE LIAISONS DE FROTTEMENT SUIVANT LA 
C               PREMIERE DIRECTION (EN 3D)
C IN  LLF2   : NOMBRE DE LIAISONS DE FROTTEMENT SUIVANT LA 
C               SECONDE DIRECTION (EN 3D)
C
C
C
C
C
      INTEGER       JMU, ILIAC, POSIT, POSMU, JMAJMU, DIMMAJ
      INTEGER       POSNBL, POSLF0, POSLF1, POSLF2
      CHARACTER*19  MU
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ() 
C
C --- INITIALISATIONS
C
      POSMU  = 0
      POSNBL = 0
      POSLF0 = NBLIAC
      POSLF1 = NBLIAC + (NDIM-1)*LLF
      POSLF2 = NBLIAC + (NDIM-1)*LLF + LLF1
      DIMMAJ = NBLIAC + (NDIM-1)*LLF + LLF1 + LLF2
C
C --- ACCES STRUCTURES DE DONNEES DE CONTACT
C
      MU       = RESOCO(1:14)//'.MU'
      CALL JEVEUO(MU,    'E', JMU   )
C
C --- RECOPIE DES VALEURS DANS UN VECTEUR TEMPORAITE
C
      CALL WKVECT('&&CFMAJM.ORDO','V V R',DIMMAJ,JMAJMU)
      DO 20 ILIAC = 1, DIMMAJ
        ZR(JMAJMU-1+ILIAC) = ZR(JMU-1+ILIAC)
 20   CONTINUE
C
C --- ECRIT LES LIAISONS DANS L'ORDRE: NBLIAC, LLF, LLF1, LLF2
C
      DO 10 ILIAC = 1, NBLIAC + LLF + LLF1 + LLF2
        POSMU  = POSMU + 1
        CALL CFTYLI(RESOCO,ILIAC,POSIT)
        GOTO (1000,2000,3000,4000) POSIT
C 
C ----- LIAISON DE CONTACT 
C
 1000   CONTINUE
          POSNBL = POSNBL + 1
          ZR(JMU-1+POSNBL) = ZR(JMAJMU-1+POSMU)
          GOTO 10
C 
C ----- LIAISON DE FROTTEMENT - 2D OU 3D DANS LES DEUX DIRECTIONS
C 
 2000   CONTINUE
          POSLF0 = POSLF0 + 1
          ZR(JMU-1+POSLF0) = ZR(JMAJMU-1+POSMU)
          IF (NDIM.EQ.3) THEN
             POSMU = POSMU + 1
             ZR(JMU-1+POSLF0+LLF) = ZR(JMAJMU-1+POSMU)
          ENDIF
          GOTO 10
C 
C ----- LIAISON DE FROTTEMENT - 3D PREMIERE DIRECTION
C
 3000   CONTINUE
          POSLF1 = POSLF1 + 1
          ZR(JMU-1+POSLF1) = ZR(JMAJMU-1+POSMU)
          GOTO 10
C 
C ----- LIAISON DE FROTTEMENT - 3D SECONDE DIRECTION 
C
 4000   CONTINUE
          POSLF2 = POSLF2 + 1
          ZR(JMU-1+POSLF2) = ZR(JMAJMU-1+POSMU)
 10   CONTINUE
C 
      CALL JEDETR('&&CFMAJM.ORDO')
      CALL JEDEMA()
C
      END
