      SUBROUTINE CFMATA(RESOCO,NEQ   ,NBLIAI,NMULT ,NUMEDZ,
     &                  MATELZ,NUMECZ,MATRIZ)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT      NONE
      INCLUDE 'jeveux.h'
      CHARACTER*24  RESOCO
      CHARACTER*(*) NUMEDZ,NUMECZ,MATRIZ,MATELZ
      INTEGER       NEQ,NBLIAI,NMULT
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (RESOLUTION - UTILITAIRE)
C
C CALCUL DE LA MATRICE AT*A
C
C ----------------------------------------------------------------------
C 
C
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  NBLIAI : NOMBRE DE LIAISONS DE CONTACT
C IN  NEQ    : NOMBRE D'EQUATIONS
C IN  NUMEDD : NOM DU NUME_DDL GLOBAL
C IN  NUMECF : NOM DU NUME_DDL A CREER POUR LA MATRICE
C IN  MATELE : NOM DE LA COLLECTION DES VECTEURS
C              LIGNES (I.E. MATRICE RECTANGULAIRE POUR LAQUELLE ON VA
C                      CALCULER LE PRODUIT).
C OUT MATRIX : MATRICE RESULTANTE
C
C
C
C
      CHARACTER*24 APPOIN,APDDL
      INTEGER      JAPPTR,JAPDDL
      CHARACTER*14 NUMEDD,NUMECF
      CHARACTER*19 MATRIX
      CHARACTER*24 MATELE
C 
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      NUMEDD = NUMEDZ
      NUMECF = NUMECZ
      MATRIX = MATRIZ
      MATELE = MATELZ
C
C --- LECTURE DES STRUCTURES DE DONNEES DE CONTACT
C
      APPOIN = RESOCO(1:14)//'.APPOIN'
      APDDL  = RESOCO(1:14)//'.APDDL'
      CALL JEVEUO(APPOIN,'L',JAPPTR)
      CALL JEVEUO(APDDL, 'L',JAPDDL)
C
C --- CONSTRUCTION NOUVELLE MATRICE
C
      CALL ATASMO(NEQ   ,MATELE,ZI(JAPDDL),ZI(JAPPTR),NUMEDD,
     &            MATRIX,'V'   ,NBLIAI    ,NMULT     ,NUMECF)
C
      CALL JEDEMA()
C
      END
