      SUBROUTINE CFMMCI(DEFICO,RESOCO)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT      NONE
      INCLUDE 'jeveux.h'
      CHARACTER*24  DEFICO,RESOCO
C      
C ----------------------------------------------------------------------
C
C ROUTINE UTILITAIRE POUR LE CONTACT (TOUTES METHODES)
C
C INITIALISE LES COEFFICIENTS VARIABLES 
C
C ----------------------------------------------------------------------
C
C IN  DEFICO : SD POUR LA DEFINITION DE CONTACT
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT  
C
C
C
C 
      INTEGER      CFDISI,NZOCO,IZONE
      LOGICAL      CFDISL,LCTCD,LCTCC,LXFCM
      REAL*8       MMINFR,COEFAC,COEFAF
      REAL*8       COEFPN,COEFPT
      REAL*8       COEFCR,COEFFR,COEFCP,COEFFP,COEFCS,COEFFS
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- FONCTIONNALITES ACTIVEES
C
      LXFCM  = CFDISL(DEFICO,'FORMUL_XFEM')
      LCTCC  = CFDISL(DEFICO,'FORMUL_CONTINUE')
      LCTCD  = CFDISL(DEFICO,'FORMUL_DISCRETE')
C
C --- INITIALISATIONS
C
      NZOCO  = CFDISI(DEFICO,'NZOCO')
C
C --- REMPLISSAGE INITIAL
C
      DO 10 IZONE = 1,NZOCO
        IF (LXFCM) THEN
          COEFCR = MMINFR(DEFICO,'COEF_REGU_CONT'   ,IZONE )
          COEFFR = MMINFR(DEFICO,'COEF_REGU_FROT'   ,IZONE )
          COEFCP = MMINFR(DEFICO,'COEF_PENA_CONT'   ,IZONE )
          COEFFP = MMINFR(DEFICO,'COEF_PENA_FROT'   ,IZONE )
          COEFCS = MMINFR(DEFICO,'COEF_STAB_CONT'   ,IZONE )
          COEFFS = MMINFR(DEFICO,'COEF_STAB_FROT'   ,IZONE )
          CALL CFMMCO(DEFICO,RESOCO,IZONE,'COEF_REGU_CONT','E',
     &                COEFCR)
          CALL CFMMCO(DEFICO,RESOCO,IZONE,'COEF_REGU_FROT','E',
     &                COEFFR)     
          CALL CFMMCO(DEFICO,RESOCO,IZONE,'COEF_PENA_CONT','E',
     &                COEFCP)
          CALL CFMMCO(DEFICO,RESOCO,IZONE,'COEF_PENA_FROT','E',
     &                COEFFP)  
          CALL CFMMCO(DEFICO,RESOCO,IZONE,'COEF_STAB_CONT','E',
     &                COEFCS)
          CALL CFMMCO(DEFICO,RESOCO,IZONE,'COEF_STAB_FROT','E',
     &                COEFFS)        
        
        ELSEIF (LCTCC) THEN
          COEFAC = MMINFR(DEFICO,'COEF_AUGM_CONT'   ,IZONE )
          COEFAF = MMINFR(DEFICO,'COEF_AUGM_FROT'   ,IZONE )
          CALL CFMMCO(DEFICO,RESOCO,IZONE,'COEF_AUGM_CONT','E',
     &                COEFAC)
          CALL CFMMCO(DEFICO,RESOCO,IZONE,'COEF_AUGM_FROT','E',
     &                COEFAF)         
        ELSEIF (LCTCD) THEN
          COEFPN = MMINFR(DEFICO,'E_N'              ,IZONE )
          COEFPT = MMINFR(DEFICO,'E_T'              ,IZONE )
          CALL CFMMCO(DEFICO,RESOCO,IZONE,'E_N','E',
     &                COEFPN)
          CALL CFMMCO(DEFICO,RESOCO,IZONE,'E_T','E',
     &                COEFPT)         
        ELSE
          CALL ASSERT(.FALSE.)
        ENDIF       
 10   CONTINUE
C
      CALL JEDEMA()
      END
