      SUBROUTINE CFMMCV(NOMA  ,MODELE,NUMEDD,FONACT,SDDYNA,
     &                  SDIMPR,SDSTAT,SDDISC,SDTIME,SDERRO,
     &                  NUMINS,ITERAT,DEFICO,RESOCO,VALINC,
     &                  SOLALG)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 22/10/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE      'jeveux.h'
      INTEGER      FONACT(*)
      INTEGER      ITERAT,NUMINS
      CHARACTER*19 SDDISC,SDDYNA
      CHARACTER*8  NOMA
      CHARACTER*24 NUMEDD,MODELE
      CHARACTER*24 DEFICO,RESOCO
      CHARACTER*24 SDIMPR,SDERRO,SDSTAT,SDTIME
      CHARACTER*19 SOLALG(*),VALINC(*)
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C CRITERES DE CONVERGENCE POUR LE CONTACT
C
C ----------------------------------------------------------------------
C
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  MODELE : NOM DU MODELE
C IN  NUMEDD : NUMEROTATION NUME_DDL
C IN  FONACT : FONCTIONNALITES ACTIVEES (VOIR NMFONC)
C IN  SDDYNA : SD DYNAMIQUE
C IN  SDIMPR : SD AFFICHAGE
C IN  SDSTAT : SD STATISTIQUES
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  SDTIME : SD TIMER
C IN  SDERRO : GESTION DES ERREURS
C IN  ITERAT : NUMERO D'ITERATION
C IN  NUMINS : NUMERO D'INSTANT
C IN  DEFICO : SD POUR LA DEFINITION DU CONTACT
C IN  RESOCO : SD POUR LA RESOLUTION DU CONTACT
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C IN  SOLALG : VARIABLE CHAPEAU POUR INCREMENTS SOLUTIONS
C
C ----------------------------------------------------------------------
C
      LOGICAL      ISFONC,LCTCD,LNEWTC
      LOGICAL      MMCVCA
      CHARACTER*8  NOMO
      CHARACTER*16 K16BLA
      REAL*8       R8BID
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C  
      MMCVCA = .FALSE. 
      NOMO   = MODELE(1:8)
      K16BLA = ' '
C
C --- FONCTIONNALITES ACTIVEES
C
      LCTCD  = ISFONC(FONACT,'CONT_DISCRET')
      LNEWTC = ISFONC(FONACT,'CONT_NEWTON')
C
C --- VALEURS NON AFFECTEES DANS LE TABLEAU
C
      CALL NMIMCK(SDIMPR,'BOUC_NOEU',K16BLA,.FALSE.)
      CALL NMIMCR(SDIMPR,'BOUC_VALE',R8BID ,.FALSE.)
C
C --- CONVERGENCE ADAPTEE AU CONTACT DISCRET
C
      IF (LCTCD) THEN
        CALL CFCONV(NOMA  ,SDSTAT,SDIMPR,SDERRO,DEFICO,
     &              RESOCO,SOLALG)
      ENDIF
C
C --- CONVERGENCE ADAPTEE AU CONTACT CONTINU
C
      IF (LNEWTC) THEN
        CALL MMBCLC(NOMA  ,NOMO  ,NUMEDD,ITERAT,NUMINS,
     &              SDDISC,SDDYNA,SDIMPR,DEFICO,RESOCO,
     &              VALINC,SOLALG,SDTIME,SDSTAT,MMCVCA)
        IF (MMCVCA) THEN
          CALL NMCREL(SDERRO,'DIVE_CTCC',.FALSE.)
        ELSE
          CALL NMCREL(SDERRO,'DIVE_CTCC',.TRUE. )
        ENDIF
      ENDIF
C
      CALL JEDEMA()
      END
