      SUBROUTINE CFMMMA(DEFICO,RESOCO)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*24 DEFICO,RESOCO
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES MAILLEES)
C
C CREATION SD DE RESOLUTION
C
C ----------------------------------------------------------------------
C
C
C IN  DEFICO : SD POUR LA DEFINITION DE CONTACT
C IN  RESOCO : SD POUR LA RESOLUTION DE CONTACT
C
C
C
C
      INTEGER      IFM,NIV
      INTEGER      CFDISI,NTPC,NTNOEC,NZOCO
      CHARACTER*24 JEUSUP,CTEVCO,CTEVPE
      INTEGER      JJSUP,JCTEVC,JCTEVP
      INTEGER      CFMMVD,ZEVEN
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('CONTACT',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<CONTACT> ... CREATION DES SD POUR LES '//
     &                ' FORMULATIONS MAILLEES'
      ENDIF
C
C --- INITIALISATIONS
C
      NTPC   = CFDISI(DEFICO,'NTPC'  )
      NTNOEC = CFDISI(DEFICO,'NTNOEC')
      NZOCO  = CFDISI(DEFICO,'NZOCO' )
      ZEVEN  = CFMMVD('ZEVEN')
C
C --- JEU SUPPLEMENTAIRE (DIST_*)
C
      JEUSUP = RESOCO(1:14)//'.JSUPCO'
      CALL WKVECT(JEUSUP,'V V R',NTPC ,JJSUP )
C
C --- INFORMATIONS POUR L'EVENT-DRIVEN - COLLISION
C
      CTEVCO = RESOCO(1:14)//'.EVENCO'
      CALL WKVECT(CTEVCO,'V V R',ZEVEN*NTPC,JCTEVC)
C
C --- INFORMATIONS POUR L'EVENT-DRIVEN - INTERPENETRATION
C
      CTEVPE = RESOCO(1:14)//'.EVENPE'
      CALL WKVECT(CTEVPE,'V V R',3*NZOCO,JCTEVP)
C
C --- AFFICHAGE
C
      CALL U2MESI('I','MECANONLINE6_5',1,NTNOEC)
C
      CALL JEDEMA()
      END
