      SUBROUTINE CFMXRE(NOMA  ,NOMO  ,SDSTAT,DEFICO,RESOCO,
     &                  NUMINS,SDDISC,SOLALG,VALINC,VEASSE)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT      NONE
      INCLUDE 'jeveux.h'
      CHARACTER*24  RESOCO,DEFICO,SDSTAT
      CHARACTER*8   NOMA,NOMO
      CHARACTER*19  SDDISC
      CHARACTER*19  SOLALG(*),VEASSE(*),VALINC(*)
      INTEGER       NUMINS
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (POST_TRAITEMENT)
C
C REMPLIR LE VALE_CONT POUR L'ARCHIVAGE DU CONTACT
C
C ----------------------------------------------------------------------
C
C
C IN  SDSTAT : SD STATISTIQUES
C IN  DEFICO : SD DE DEFINITION DU CONTACT
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  NOMO   : NOM DU MODELE
C IN  NOMA   : NOM DU MAILLAGE
C IN  NUMINS : NUMERO DU PAS DE CHARGE
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  SOLALG : VARIABLE CHAPEAU POUR INCREMENTS SOLUTIONS
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C IN  VEASSE : VARIABLE CHAPEAU POUR NOM DES VECT_ASSE
C
C
C
C
      INTEGER      IFM,NIV
      LOGICAL      CFDISL,LCTCC,LCTCD,LXFCM,LEXIV,LALLV
      CHARACTER*19 DDEPLA,DEPDEL,DEPPLU
      REAL*8       DIINST,INST(2)
      CHARACTER*19 PRNO
      CHARACTER*24 NOCHCO
      INTEGER      JNOCHC
      CHARACTER*19 CNSINR,CNSPER,CNOINR
      INTEGER      IBID,IRET
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFNIV(IFM,NIV)
C
C --- TYPE DE CONTACT
C
      LCTCC  = CFDISL(DEFICO,'FORMUL_CONTINUE')
      LCTCD  = CFDISL(DEFICO,'FORMUL_DISCRETE')
      LXFCM  = CFDISL(DEFICO,'FORMUL_XFEM')
      LEXIV  = CFDISL(DEFICO,'EXIS_VERIF')
      LALLV  = CFDISL(DEFICO,'ALL_VERIF')
C
C --- NOM DES CHAM_NO
C
      NOCHCO = RESOCO(1:14)//'.NOCHCO'
      CALL JEVEUO(NOCHCO,'L',JNOCHC)
      CNSINR = ZK24(JNOCHC+1-1)(1:19)
      CNOINR = ZK24(JNOCHC+2-1)(1:19)
      CNSPER = ZK24(JNOCHC+3-1)(1:19)
C
C --- TOUT VERIF -> ON SAUTE
C
      IF (LALLV) THEN
        GOTO 50
      ENDIF
C
C --- INSTANT
C
      INST(1) = DIINST(SDDISC,NUMINS)
      INST(2) = INST(1) - DIINST(SDDISC,NUMINS-1)
C
C --- DECOMPACTION DES VARIABLES CHAPEAUX
C
      CALL NMCHEX(SOLALG,'SOLALG','DDEPLA',DDEPLA)
      CALL NMCHEX(SOLALG,'SOLALG','DEPDEL',DEPDEL)
      CALL NMCHEX(VALINC,'VALINC','DEPPLU',DEPPLU)
C
C --- POST-TRAITEMENT
C
      IF (LXFCM) THEN
        CALL XMMRES(DEPDEL,NOMO  ,VEASSE,CNSINR)
      ELSEIF (LCTCC) THEN
        CALL MMMRES(NOMA  ,INST  ,DEFICO,RESOCO,DEPPLU,
     &              DEPDEL,SDDISC,VEASSE,CNSINR,CNSPER)
      ELSEIF (LCTCD) THEN
        CALL CFRESU(NOMA  ,NUMINS,INST  ,SDDISC,DEFICO,
     &              RESOCO,DEPPLU,DEPDEL,DDEPLA,CNSINR,
     &              CNSPER)
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF
C
C --- DECOMPTE NOMBRE DE LIAISONS
C
      IF (LCTCC) THEN
        CALL MMMCPT(NOMA  ,SDSTAT,DEFICO,RESOCO,CNSINR)
      ENDIF
C
C --- METHODE VERIF
C
  50  CONTINUE
C
      IF (LEXIV) THEN
        CALL CFMMVE(NOMA  ,DEFICO,RESOCO,VALINC)
      ENDIF
C
C --- TRANSFO DU CHAM_NO_S EN CHAM_NO (AVEC UN PROF_CHNO CONSTANT !)
C
      CALL DISMOI('C','PROF_CHNO',CNOINR,'CHAM_NO' ,
     &            IBID,PRNO,IRET)
      CALL CNSCNO(CNSINR,PRNO  ,'NON','V',CNOINR,'F',IBID)
C
      CALL JEDEMA()
      END
