      SUBROUTINE CFPARZ(RESOCO,ILIAI ,COEFFF,COEFPN,COEFPT,
     &                  COEFTE,DISSUP,IZONE ,IP    ,NUMNOE,
     &                  POSNOE)
C     
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*24 RESOCO
      REAL*8       COEFFF,COEFPN,COEFPT,COEFTE,DISSUP
      INTEGER      ILIAI,IP,IZONE,NUMNOE,POSNOE
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES DISCRETES - APPARIEMENT)
C
C CARACTERISTIQUES DES LIAISONS POUR LA ZONE
C
C ----------------------------------------------------------------------
C
C
C IN  ILIAI  : INDICE DE LA LIAISON COURANTE
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  DISSUP : JEU FICTIF DE LA ZONE
C IN  COEFPN : COEFFICIENT DE PENALISATION DE CONTACT
C IN  COEFPT : COEFFICIENT DE PENALISATION DE FROTTEMENT      
C IN  COEFFF : COEFFICIENT DE FROTTEMENT
C IN  COEFTE : COEFFICIENT THETA POUR FROTTEMENT
C IN  POSNOE : INDICES DANS CONTNO DU NOEUD ESCLAVE
C IN  NUMNOE : NUMERO ABSOLU DU NOEUD ESCLAVE
C IN  IP     : INDICE DU POINT DANS LA SD APPARIEMENT
C IN  IZONE  : NUMERO DE LA ZONE DE CONTACT
C
C
C
C
      INTEGER      IFM,NIV
      INTEGER      CFMMVD,ZTACF
      CHARACTER*24 TACFIN,JEUSUP
      INTEGER      JTACF,JJSUP
      CHARACTER*24 JEUITE,NUMLIA
      INTEGER      JJEUIT,JNUMLI
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()      
      CALL INFDBG('CONTACT',IFM,NIV)
C
C --- LECTURE DES STRUCTURES DE DONNEES DE CONTACT
C
      JEUITE = RESOCO(1:14)//'.JEUITE'
      TACFIN = RESOCO(1:14)//'.TACFIN' 
      JEUSUP = RESOCO(1:14)//'.JSUPCO'
      NUMLIA = RESOCO(1:14)//'.NUMLIA'
C
      CALL JEVEUO(JEUITE,'E',JJEUIT)
      CALL JEVEUO(TACFIN,'E',JTACF )
      CALL JEVEUO(JEUSUP,'E',JJSUP )
      CALL JEVEUO(NUMLIA,'E',JNUMLI)      
C
      ZTACF  = CFMMVD('ZTACF')  
C
C --- JEU FICTIF DE LA ZONE
C    
      ZR(JJSUP+ILIAI-1)  = DISSUP
C
C --- ADDITION DU JEU FICTIF DE LA ZONE
C
      ZR(JJEUIT+3*(ILIAI-1)+1-1)  = ZR(JJEUIT+3*(ILIAI-1)+1-1) - DISSUP
C
C --- RECOPIE CARACTERISTIQUES ZONE -> NOEUDS ESCLAVES
C           
      ZR(JTACF+ZTACF*(ILIAI-1)+0) = COEFFF
      ZR(JTACF+ZTACF*(ILIAI-1)+1) = COEFPN
      ZR(JTACF+ZTACF*(ILIAI-1)+2) = COEFPT
      ZR(JTACF+ZTACF*(ILIAI-1)+3) = COEFTE
C
C --- SAUVEGARDE DANS LA SD APPARIEMENT
C
      ZI(JNUMLI+4*(ILIAI-1)+1-1) = IP
      ZI(JNUMLI+4*(ILIAI-1)+2-1) = POSNOE
      ZI(JNUMLI+4*(ILIAI-1)+3-1) = NUMNOE
      ZI(JNUMLI+4*(ILIAI-1)+4-1) = IZONE
      
C
      CALL JEDEMA
      END
