      SUBROUTINE CFPOST(NOMA  ,DEFICO,RESOCO,DDEPLA,CTCCVG)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*8  NOMA
      CHARACTER*24 DEFICO,RESOCO
      CHARACTER*19 DDEPLA
      INTEGER      CTCCVG
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE DISCRETE - ALGORITHME)
C
C POST-TRAITEMENT ALGORITHMES
C
C ----------------------------------------------------------------------
C
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  DEFICO : SD DE DEFINITION DU CONTACT
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  DDEPLA : INCREMENT DE DEPLACEMENT
C OUT CTCCVG : CODE RETOUR CONTACT DISCRET
C                -1 : PAS DE CALCUL DU CONTACT DISCRET
C                 0 : CAS DU FONCTIONNEMENT NORMAL
C                 1 : NOMBRE MAXI D'ITERATIONS
C                 2 : MATRICE SINGULIERE
C
C
C
C
      INTEGER      IFM,NIV
      CHARACTER*19 DDEPLC
      INTEGER      JDDEPC
      LOGICAL      CFDISL,LPENAC,LGCP
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('CONTACT',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<CONTACT> ...... POST-TRAITEMENT DU CALCUL'
      ENDIF
C
C --- PARAMETRES
C
      LPENAC = CFDISL(DEFICO,'CONT_PENA')
      LGCP   = CFDISL(DEFICO,'CONT_GCP' )
C
C --- SORTIE EN ERREUR
C
      IF (CTCCVG.NE.0) THEN
        IF (.NOT.LGCP) THEN
          IF (NIV.GE.2) THEN
            WRITE (IFM,*) '<CONTACT> ...... SORTIE DIRECTE CAR ERREUR'
          ENDIF
          GOTO 999
        ENDIF
      ENDIF
C
C --- ACCES AUX CHAMPS DE TRAVAIL
C --- DDEPLC: INCREMENT DE SOLUTION APRES CORRECTION DU CONTACT
C
      DDEPLC = RESOCO(1:14)//'.DELC'
      CALL JEVEUO(DDEPLC(1:19)//'.VALE','L',JDDEPC)
C
C --- RECOPIE CHAMP DE DEPLACEMENT SOLUTION
C
      IF ((.NOT.LPENAC).AND.(CTCCVG.EQ.0)) THEN
        CALL COPISD('CHAMP_GD','V',DDEPLC,DDEPLA)
      ENDIF
C
C --- CALCUL DES JEUX FINAUX
C
      CALL CFJEFI(NOMA  ,DEFICO,RESOCO,DDEPLA)
C
 999  CONTINUE
C
      CALL JEDEMA()
C
      END
