      SUBROUTINE CFSVMU(DEFICO,RESOCO,LCONV )
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*24 DEFICO,RESOCO
      LOGICAL      LCONV
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES DISCRETES)
C
C SAUVEGARDE DU LAGRANGE DE CONTACT POUR PERMETTRE LE TRANSPORT
C D'UN APPARIEMENT A UN AUTRE
C
C ----------------------------------------------------------------------
C
C IN  DEFICO : SD DE DEFINITION DU CONTACT
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  LCONV  : SAUVEGARDE T-ON UN ETAT CONVERGE ?
C
C
C
C
      INTEGER      IFM,NIV
      LOGICAL      CFDISL
      INTEGER      CFDISI,CFDISD,NNOCO
      INTEGER      ILIAI,POSNOE
      INTEGER      NBLIAI
      CHARACTER*19 SVMU  ,MU
      INTEGER      JSVMU ,JMU
      CHARACTER*24 NUMLIA
      INTEGER      JNUMLI
      LOGICAL      LGCP
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('CONTACT',IFM,NIV)
C
C --- LE LAGRANGE DE CONTACT N'EST SAUVEGARDE QU'EN GCP
C
      LGCP = CFDISL(DEFICO,'CONT_GCP')
C
      IF (.NOT.LGCP) THEN
        GOTO 999
      ENDIF
C
C --- ACCES OBJETS
C
      IF (LCONV) THEN
        SVMU = RESOCO(1:14)//'.SVM0'
      ELSE
        SVMU = RESOCO(1:14)//'.SVMU'
      ENDIF
      CALL JEVEUO(SVMU,'E',JSVMU)
      MU   = RESOCO(1:14)//'.MU'
      CALL JEVEUO(MU,'L',JMU )
      NUMLIA = RESOCO(1:14)//'.NUMLIA'
      CALL JEVEUO(NUMLIA,'L',JNUMLI)
C
C --- INITIALISATIONS
C
      NNOCO = CFDISI(DEFICO,'NNOCO')
      CALL JERAZO(SVMU,NNOCO,1)
C
C --- INFORMATIONS
C
      NBLIAI = CFDISD(RESOCO,'NBLIAI')
C
C --- SAUVEGARDE DU STATUT DE FROTTEMENT
C
      DO 10 ILIAI = 1,NBLIAI
        POSNOE =  ZI(JNUMLI-1+4*(ILIAI-1)+2)
        CALL ASSERT(POSNOE.LE.NNOCO)
        CALL ASSERT(ZR(JSVMU-1+POSNOE).EQ.0.D0)
        ZR(JSVMU-1+POSNOE) = ZR(JMU-1+ILIAI)
  10  CONTINUE
C
 999  CONTINUE
C
      CALL JEDEMA()
      END
