        SUBROUTINE COEFFT(COTHE,COEFF,DCOTHE,DCOEFF,X,DTIME,COEFT,NMAT,
     &                    COEL)
        IMPLICIT NONE
C       ===============================================================
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 18/06/2012   AUTEUR PROIX J-M.PROIX 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C       ---------------------------------------------------------------
C       INTEGRATION DE LOIS DE COMPORTEMENT ELASTO-VISCOPLASTIQUE PAR
C       UNE METHODE DE RUNGE KUTTA AVEC REDECOUPAGE AUTOMATIQUE DU PAS
C       DE TEMPS : CALCUL DES PARAMETRES MATERIAU A UN INSTANT DONNE
C       ---------------------------------------------------------------
C       IN  COTHE  :  COEFFICIENTS MATERIAU ELASTIQUE A T
C           COEFF  :  COEFFICIENTS MATERIAU INELASTIQUE A T
C           DCOTHE :  INTERVALLE COEFFICIENTS MATERIAU ELAST POUR DT
C           DCOEFF :  INTERVALLE COEFFICIENTS MATERIAU INELAST POUR DT
C           X      :  INSTANT COURANT
C           DTIME  :  INTERVALLE DE TEMPS
C           NMAT   :  NOMNRE MAXI DE COEF MATERIAU
C       OUT COEFT  :  COEFFICIENTS MATERIAU INELASTIQUE A T+DT
CC          COEL   :  COEFFICIENTS  ELASTIQUES ELASTIQUE A T+DT
C       ---------------------------------------------------------------
        INTEGER NMAT,I,NCOE,NCOEL
        REAL*8 COTHE(NMAT),DCOTHE(NMAT),COEL(NMAT)
        REAL*8 HSDT,DTIME,X
        REAL*8 COEFF(NMAT),DCOEFF(NMAT),COEFT(NMAT)
C
        HSDT=X/DTIME

        CALL R8INIR(NMAT, 0.D0, COEL, 1)

        IF (COTHE(NMAT).EQ.0) THEN
           DO 12 I=1,3
              COEL(I)=COTHE(I)+HSDT*DCOTHE(I)
   12      CONTINUE
           COEL(NMAT)=0.D0
        ELSEIF (COTHE(NMAT).EQ.1) THEN
C          MATERIAU ISOTROPE, OU ANISOTROPE, MATRICE DE HOOKE    
           COEL(NMAT)=1.D0
           NCOEL=75
           DO 11 I=1,NCOEL
              COEL(I)=COTHE(I)+HSDT*DCOTHE(I)
   11      CONTINUE
        ENDIF

C       POUR GAGNER DU TEMPS CPU
        IF (COEFF(NMAT).EQ.0) THEN
           NCOE=NMAT
        ELSE
           NCOE=NINT(COEFF(NMAT))
        ENDIF

        DO 10 I=1,NCOE
          COEFT(I)=COEFF(I)+HSDT*DCOEFF(I)
   10   CONTINUE
   
        END
