      SUBROUTINE CRVRC1()
      IMPLICIT  NONE
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 30/07/2012   AUTEUR LEFEBVRE J-P.LEFEBVRE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
C     COMMANDE:  CREA_RESU
C     CREE UNE STRUCTURE DE DONNEE DE TYPE "EVOL_THER"  CONTENANT
C     LA TEMPERATURE SUR LES COUCHES DES COQUES MULTICOUCHE A PARTIR
C     D'UN CHAMP DE FONCTIONS (INST,EPAIS)
C


      INCLUDE 'jeveux.h'
      INTEGER IBID,NBFAC,N1,NBINST,KINST,JINST,JLINST
      INTEGER NBIN,IRET,IEXI,JTEMP
      REAL*8 RBID,VINST
      COMPLEX*16 CBID
      CHARACTER*8 KBID,RESU,CARELE,PAOUT,LPAIN(10),TEMPEF
      CHARACTER*8 MODEL2,MODELE
      CHARACTER*16 TYPE,OPER
      CHARACTER*19 LIGRMO,CHOUT,CHINST
      CHARACTER*24 CHCARA(18),LCHIN(10)
      LOGICAL EXICAR
      INTEGER      IARG

C----------------------------------------------------------------------
      CALL JEMARQ()

      CALL GETFAC('PREP_VRC1',NBFAC)
      IF (NBFAC.EQ.0) GOTO 20
      CALL ASSERT(NBFAC.EQ.1)


      CALL GETRES(RESU,TYPE,OPER)
      CALL GETVID('PREP_VRC1','MODELE',1,IARG,1,MODELE,N1)
      CALL GETVID('PREP_VRC1','CARA_ELEM',1,IARG,1,CARELE,N1)
      CALL GETVID('PREP_VRC1','CHAM_GD',1,IARG,1,TEMPEF,N1)

C     -- ON VERIFIE QUE LE CARA_ELEM S'APPUIE BIEN SUR LE MODELE
      CALL JEEXIN(CARELE//'.CANBSP    .CELK',IEXI)
      IF (IEXI.EQ.0) CALL U2MESK('F','CALCULEL4_14',1,CARELE)
      CALL JEVEUO(CARELE//'.CANBSP    .CELK','L',JTEMP)
      MODEL2=ZK24(JTEMP-1+1)(1:8)
      IF (MODEL2.NE.MODELE) CALL U2MESK('F','CALCULEL4_15',1,CARELE)



C     -- INSTANTS DE L'EVOL_THER :
      CALL GETVR8('PREP_VRC1','INST',1,IARG,0,RBID,N1)
      CALL ASSERT(N1.LT.0)
      NBINST = -N1
      CALL WKVECT('&&CRVRC1.LINST','V V R',NBINST,JLINST)
      CALL GETVR8('PREP_VRC1','INST',1,IARG,NBINST,ZR(JLINST),N1)

      CALL JEEXIN(RESU//'           .DESC',IRET)
      IF (IRET.NE.0) THEN
        CALL U2MESK('F','CALCULEL7_6',1,RESU)
      ELSE
        CALL RSCRSD('G',RESU,'EVOL_THER',NBINST)
      ENDIF

      LIGRMO = MODELE//'.MODELE'
      PAOUT = 'PTEMPCR'
      CHINST = '&&CRVRC1.CHINST'
      CALL MECARA(CARELE,EXICAR,CHCARA)

      LPAIN(1) = 'PNBSP_I'
      LCHIN(1) = CHCARA(1) (1:8)//'.CANBSP'
      LPAIN(2) = 'PTEMPEF'
      LCHIN(2) = TEMPEF
      LPAIN(3) = 'PINST_R'
      LCHIN(3) = CHINST
      LPAIN(4) = 'PCACOQU'
      LCHIN(4) = CHCARA(7)
      NBIN = 4

C     -- BOUCLE SUR LES INSTANTS :
C     --------------------------------
      DO 10,KINST = 1,NBINST
        VINST = ZR(JLINST-1+KINST)
        CALL MECACT('V',CHINST,'MODELE',LIGRMO,'INST_R',1,'INST',IBID,
     &              VINST,CBID,KBID)
        CALL RSEXCH(' ',RESU,'TEMP',KINST,CHOUT,IRET)

        CALL CESVAR(CARELE,' ',LIGRMO,CHOUT)
        CALL CALCUL('S','PREP_VRC',LIGRMO,NBIN,LCHIN,LPAIN,1,CHOUT,
     &              PAOUT,'G','OUI')
        CALL DETRSD('CHAM_ELEM_S',CHOUT)
        CALL RSNOCH(RESU,'TEMP',KINST)
        CALL RSADPA(RESU,'E',1,'INST',KINST,0,JINST,KBID)
        ZR(JINST) = VINST
        CALL DETRSD('CHAMP',CHINST)
   10 CONTINUE


      CALL JEDETR('&&CRVRC1.LINST')


   20 CONTINUE
      CALL JEDEMA()
      END
