      SUBROUTINE DFLLAC(MCFACT,IECHEC,DTMIN ,EVEN  ,ACTION,
     &                  SUBMET,SUBAUT,PASMIN,NBRPAS,NIVEAU,
     &                  PCPLUS,CMMAXI,PRCOLL,DUCOLL)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 02/10/2012   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
      IMPLICIT NONE
      CHARACTER*16 MCFACT,EVEN
      INTEGER      IECHEC
      REAL*8       PASMIN,DTMIN
      CHARACTER*16 SUBMET,ACTION,SUBAUT
      INTEGER      NBRPAS,NIVEAU
      REAL*8       PCPLUS,CMMAXI,PRCOLL,DUCOLL
C
C ----------------------------------------------------------------------
C
C OPERATEUR DEFI_LIST_INST
C
C LECTURE DES PARAMETRES DE L'ACTION
C
C ----------------------------------------------------------------------
C
C IN  MCFACT : MOT-CLEF FACTEUR POUR LIRE L'ECHEC
C IN  IECHEC : NUMERO OCCURRENCE ECHEC
C IN  EVEN   : NOM DE L'EVENEMENT
C IN  DTMIN  : INCREMENT MINIMUM DANS LA LISTE D'INSTANT
C OUT ACTION : ACTION
C OUT SUBMET : TYPE DE SUBDIVISION
C OUT SUBAUT : TYPE DE SUBDIVISION AUTOMATIQUE
C OUT PASMIN : VALEUR DE SUBD_PAS_MINI
C OUT NBRPAS : VALEUR DE SUBD_PAS
C OUT NIVEAU : VALEUR DE SUBD_NIVEAU
C OUT PCPLUS : VALEUR DE PCENT_ITER_PLUS
C OUT CMMAXI : VALEUR DE COEF_MULT_MAXI
C OUT PRCOLL : VALEUR DE PREC_COLLISION
C OUT DUCOLL : VALEUR DE DUREE_COLLISION
C
C ----------------------------------------------------------------------
C
      INTEGER IRET
      INTEGER      IARG
C
C ----------------------------------------------------------------------
C
      ACTION = ' '
C
C --- ACTION
C
      CALL GETVTX(MCFACT,'ACTION',IECHEC,IARG,1,ACTION,IRET  )
      IF (ACTION.EQ.'ARRET') THEN
C ----- PAS D'OPTIONS
      ELSEIF (ACTION.EQ.'REAC_PRECOND') THEN
        CALL DFLLDC(MCFACT,IECHEC,DTMIN ,EVEN  ,SUBMET,
     &              SUBAUT,PASMIN,NBRPAS,NIVEAU,PRCOLL,
     &              DUCOLL)
      ELSEIF (ACTION.EQ.'DECOUPE') THEN
        CALL DFLLDC(MCFACT,IECHEC,DTMIN ,EVEN  ,SUBMET,
     &              SUBAUT,PASMIN,NBRPAS,NIVEAU,PRCOLL,
     &              DUCOLL)
      ELSEIF (ACTION.EQ.'ITER_SUPPL') THEN
        CALL DFLLAE(MCFACT,IECHEC,PCPLUS)
        CALL DFLLDC(MCFACT,IECHEC,DTMIN ,EVEN  ,SUBMET,
     &              SUBAUT,PASMIN,NBRPAS,NIVEAU,PRCOLL,
     &              DUCOLL)
      ELSEIF (ACTION.EQ.'ADAPT_COEF_PENA') THEN
        CALL DFLLIN(MCFACT,IECHEC,CMMAXI)
      ELSEIF (ACTION.EQ.'AUTRE_PILOTAGE') THEN
        CALL DFLLDC(MCFACT,IECHEC,DTMIN ,EVEN  ,SUBMET,
     &              SUBAUT,PASMIN,NBRPAS,NIVEAU,PRCOLL,
     &              DUCOLL)
      ELSEIF (ACTION.EQ.'CONTINUE') THEN
C ----- PAS D'OPTIONS
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF
C
      END
