      SUBROUTINE DFLLDC(MCFACT,IECHEC,DTMIN ,EVEN  ,SUBMET,
     &                  SUBAUT,PASMIN,NBRPAS,NIVEAU,SUBINS,
     &                  SUBDUR)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 16/04/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
      IMPLICIT NONE
      CHARACTER*16 MCFACT,EVEN
      INTEGER      IECHEC
      REAL*8       PASMIN,DTMIN,SUBINS,SUBDUR
      CHARACTER*16 SUBMET,SUBAUT
      INTEGER      NBRPAS,NIVEAU
C
C ----------------------------------------------------------------------
C
C OPERATEUR DEFI_LIST_INST
C
C LECTURE DES PARAMETRES DE L'ACTION DE TYPE DECOUPE DU PAS DE TEMPS
C
C ----------------------------------------------------------------------
C
C
C IN  MCFACT : MOT-CLEF FACTEUR POUR LIRE L'ECHEC
C IN  IECHEC : NUMERO OCCURRENCE ECHEC
C IN  EVEN   : NOM DE L'EVENEMENT
C IN  DTMIN  : INCREMENT MINIMUM DANS LA LISTE D'INSTANT
C OUT SUBMET : TYPE DE SUBDIVISION
C OUT SUBAUT : TYPE DE SUBDIVISION AUTOMATIQUE
C OUT PASMIN : VALEUR DE SUBD_PAS_MINI
C OUT NBRPAS : VALEUR DE SUBD_PAS
C OUT NIVEAU : VALEUR DE SUBD_NIVEAU
C OUT SUBINS : VALEUR DE SUBD_INST
C OUT SUBDUR : VALEUR DE SUBD_DUREE
C
C ----------------------------------------------------------------------
C
      INTEGER      IRET
      INTEGER      IARG
C
C ----------------------------------------------------------------------
C

C
C --- INITIALISATIONS
C
      SUBMET = ' '
      SUBAUT = ' '
      NIVEAU = 0
      NBRPAS = 4
      PASMIN = 0.D0
      SUBINS = 0.D0
      SUBDUR = 0.D0
C
C --- TYPE DE LA DECOUPE
C
      CALL GETVTX(MCFACT,'SUBD_METHODE',IECHEC,IARG,1,SUBMET,IRET)
C
C --- OPTIONS
C
      CALL GETVR8(MCFACT,'SUBD_PAS_MINI',IECHEC,IARG,1,PASMIN,IRET)
      IF (PASMIN.GT.DTMIN) CALL U2MESS('F','DISCRETISATION_2')
      IF (SUBMET.EQ.'MANUEL') THEN
        CALL GETVIS(MCFACT,'SUBD_NIVEAU' ,IECHEC,IARG,1,NIVEAU,IRET)
        CALL GETVIS(MCFACT,'SUBD_PAS'     ,IECHEC,IARG,1,NBRPAS,IRET)
        IF (NBRPAS .LT. 2) CALL ASSERT(.FALSE.)
      ELSEIF (SUBMET.EQ.'AUTO') THEN
        IF (EVEN.EQ.'COLLISION') THEN
          CALL GETVR8(MCFACT,'SUBD_INST',IECHEC,IARG,1,
     &                SUBINS,IRET)
          CALL GETVR8(MCFACT,'SUBD_DUREE'   ,IECHEC,IARG,1,
     &                SUBDUR,IRET)
          SUBAUT = 'COLLISION'
        ELSE
          SUBAUT = 'EXTRAPOLE'
        ENDIF
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF
C
      END
