      SUBROUTINE DFLLLI(LISINS,DTMIN ,NBINST)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*19 LISINS
      REAL*8       DTMIN
      INTEGER      NBINST
C      
C ----------------------------------------------------------------------
C
C ROUTINE GESTION LISTE INSTANTS
C
C VERIFICATIONS LISTE D'INSTANTS
C
C ----------------------------------------------------------------------
C
C
C IN  LISINS : NOM DE LA SD LISTE
C OUT DTMIN  : PAS DE TEMPS MINIMUM DE LA LISTE
C OUT NBINST : NOMBRE D'INSTANTS
C
C
C
C 
      INTEGER      I
      INTEGER      JINST
      REAL*8       DELTAT,R8MAEM
      CHARACTER*8  K8BID 
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      DTMIN  = R8MAEM()
C
C --- RECUPERATION DE LA LISTE D'INSTANTS FOURNIE
C
      CALL JEVEUO(LISINS//'.VALE','L',JINST)
      CALL JELIRA(LISINS//'.VALE','LONMAX',NBINST,K8BID) 
C
C --- VERIFICATION IL Y A AU MOINS UN INSTANT DE CALCUL
C
      IF (NBINST.LT.2) CALL U2MESS('F','DISCRETISATION_86')
C
C --- INTERVALLE DE TEMPS MINIMAL : DTMIN
C
      DO 30 I = 1,NBINST-1
        DELTAT = ZR(JINST+I) - ZR(JINST+I-1)
        DTMIN  = MIN(DELTAT,DTMIN)
30    CONTINUE
C
C --- VERIFICATION DE LA STRICTE CROISSANCE DE LA LISTE D'INSTANTS
C
      IF (DTMIN.LE.0.D0) CALL U2MESS('F','DISCRETISATION_87') 
C
      CALL JEDEMA()
      END
