      SUBROUTINE DINUAR(SDDISC,NUMINS,FORCE ,NUMARC,NUMREU)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 05/11/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*19 SDDISC
      INTEGER      NUMINS,NUMARC,NUMREU
      LOGICAL      FORCE
C
C ----------------------------------------------------------------------
C
C ARCHIVAGE - UTILITAIRE
C
C NUMERO D'ARCHIVAGE
C
C ----------------------------------------------------------------------
C
C
C IN  SDDISC : SD DISCRETISATION
C IN  NUMINS : NUMERO INSTANT COURANT
C IN  FORCE  : VRAI SI ON SOUHAITE FORCER L'ARCHIVAGE DE TOUS LES CHAMPS
C OUT NUMARC : NUMERO D'ARCHIVAGE
C OUT NUMREU : NUMERO DE REUSE
C
C ----------------------------------------------------------------------
C
      CHARACTER*24 ARCINF
      INTEGER      JARINF
      REAL*8       DIINST,INST      
      LOGICAL      LARCH
      CHARACTER*19 SDARCH     
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      LARCH  = .FALSE.  
C
C --- ACCES SD ARCHIVAGE
C
      SDARCH = SDDISC(1:14)//'.ARCH'
      ARCINF = SDARCH(1:19)//'.AINF'
      CALL JEVEUO(ARCINF,'E',JARINF)
C
C --- ARCHIVAGE INSTANT INITIAL FORCE
C
      IF (NUMINS.EQ.0) THEN
        LARCH  = .TRUE.
      ELSE
        INST   = DIINST(SDDISC,NUMINS)
        CALL NMCRPO(SDARCH,NUMINS,INST  ,LARCH ) 
      ENDIF
C
C --- ARCHIVAGE FORCE
C
      IF (FORCE) THEN
        LARCH  = .TRUE.
      ENDIF
C
C --- NUMERO D'ARCHIVAGE
C
      IF (LARCH) THEN
        NUMARC = ZI(JARINF-1+1)
      ELSE
        NUMARC = - 1
      ENDIF
C
C --- NOUVEAU NUMERO D'ARCHIVAGE (POUR LE PROCHAIN APPEL)
C 
      IF (LARCH) THEN
        ZI(JARINF-1+1) =  ZI(JARINF-1+1) + 1
      ENDIF
C
C --- NUMERO DE REUSE
C
      NUMREU = ZI(JARINF-1+2)
C
      CALL JEDEMA()
C      
      END
