      SUBROUTINE DYLECH(NOMO  ,LISCHA,NBEXRE,EXRECO,EXRESU)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
      IMPLICIT      NONE
      INCLUDE 'jeveux.h'
      CHARACTER*8   NOMO
      CHARACTER*19  LISCHA
      CHARACTER*24  EXRECO,EXRESU
      INTEGER       NBEXRE
C
C ----------------------------------------------------------------------
C
C DYNA_LINE_HARM
C
C LECTURE DES CHARGEMENTS
C
C ----------------------------------------------------------------------
C
C
C IN  NOMO   : NOM DU MODELE
C OUT LISCHA : SD LISTE DES CHARGES
C OUT NBEXRE : NOMBRE DE EXCIT_RESU
C OUT EXRECO : LISTE DES COEFFICIENTS DANS EXCIT_RESU
C OUT EXRESU : LISTE DES RESULTATS DANS EXCIT_RESU
C
C
C
C
      CHARACTER*16 MOTFAC,NOMCMD
      INTEGER      IRESU,JLCCRE,JLRESU,IARG,N
      INTEGER      LISNBG,NBVEAS,NBVEAG,NBVEAT,NBCHAR
      INTEGER      IFM,NIV
C
C ----------------------------------------------------------------------
C
      MOTFAC = 'EXCIT'
      NOMCMD = 'DYNA_LINE_HARM'
      NBEXRE = 0
      CALL INFNIV(IFM,NIV)
C
C --- LECTURE DONNNES CHARGEMENTS
C
      CALL LISLEC(MOTFAC,'MECANIQUE','V',LISCHA)
C
C --- AFFICHAGE DE LA LISTE DES CHARGES
C
      IF (NIV.GE.2) CALL LISIMP(LISCHA,IFM)
C
C --- VERIFICATIONS DE LA LISTE DES CHARGES
C
      CALL LISCHK(NOMO  ,'MECANIQUE',NOMCMD,LISCHA)
C
C --- LECTURE INFORMATIONS EXCIT_RESU
C
      CALL GETFAC('EXCIT_RESU',NBEXRE)
      EXRECO = '&&DYLECH.COEF_CRE'
      EXRESU = '&&DYLECH.LISTRESU'
      IF ( NBEXRE.NE.0 ) THEN
        CALL WKVECT(EXRECO,'V V C  ',NBEXRE,JLCCRE)
        CALL WKVECT(EXRESU,'V V K8 ',NBEXRE,JLRESU)
        DO 252 IRESU = 1, NBEXRE
          CALL GETVID('EXCIT_RESU','RESULTAT',IRESU,IARG,1,
     &                ZK8(JLRESU+IRESU-1),N)
          CALL GETVC8('EXCIT_RESU','COEF_MULT_C',IRESU,IARG,1,
     &                ZC (JLCCRE+IRESU-1),N)
 252    CONTINUE
      ENDIF
C
C --- EXCLUSION VECT_ASSE/CHARGE
C
      NBVEAS = LISNBG(LISCHA,'VECT_ASSE'     )
      NBVEAG = LISNBG(LISCHA,'VECT_ASSE_GENE')
      NBVEAT = NBVEAS+NBVEAG
      CALL LISNNB(LISCHA,NBCHAR)
      IF (NBVEAT.NE.0) THEN
        IF (NBVEAT.NE.NBCHAR) THEN
          CALL U2MESS('F','CHARGES5_1')
        ENDIF
      ENDIF
C
      END
