      SUBROUTINE FEXT ( T, NEQ, NVECT, LIAD, LIFO, F )
      IMPLICIT   NONE
      INCLUDE 'jeveux.h'
      INTEGER           NEQ, NVECT, LIAD(*)
      REAL*8            T, F(*)
      CHARACTER*24      LIFO(*)
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C  CALCUL DU VECTEUR FEXT: FEXT = SOMME  GI(T)*FI(X)
C
C  INPUT:
C        T        : INSTANT DE CALCUL
C        NEQ      : NOMBRE D'EQUATIONS (D.D.L. ACTIFS)
C        NVECT    : NOMBRE DE VECTEURS CHARGEMENT
C        LIAD     : LISTE DES ADRESSES DES VECTEURS CHARGEMENT (NVECT)
C        LIFO     : LISTE DES NOMS DES FONCTIONS EVOLUTION (NVECT)
C
C  OUTPUT:
C        F        : VECTEUR FORCE EXTERIEURE (NEQ)
C
C-----------------------------------------------------------------------
      INTEGER      I, IER
      REAL*8       ZERO, ALPHA
      CHARACTER*8  NOMPAR
C     ------------------------------------------------------------------
C
      NOMPAR = 'INST'
      ZERO   = 0.D0
      CALL R8INIR ( NEQ , ZERO , F , 1 )
      DO 10 I = 1 , NVECT
         CALL FOINTE ( 'F ', LIFO(I), 1, NOMPAR, T, ALPHA, IER )
         CALL DAXPY ( NEQ , ALPHA , ZR(LIAD(I)) , 1 , F , 1 )
 10   CONTINUE
      END
