      SUBROUTINE IMVARI(MOCLEF,IOCC,NCOMEL,LCOMEL,COMCOD,NBVARI,TAVARI)
      IMPLICIT NONE
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C-----------------------------------------------------------------------
C     ECRITURE DES NOMS DES VARIABLES INTERNES DANS UNE TABLE
C ----------------------------------------------------------------------
C OUT COMCOD  : OBJET DECRIVANT LE TYPE DE COMPORTEMENT (ISSU DE LCCREE)
C OUT CARCRI  : OBJET CARCRI(9) CRITERES DE CONVERGENCE LOCAUX
C OUT NBVARI  : NOMBRE DE VARIABLE INTERNES
C OUT k       : =1 si COMP_INCR, =2 si COMP_ELAS
      INCLUDE 'jeveux.h'

      INTEGER NBVARI,NCOMEL,IOCC,II,NUMS(2),LVARI,ICOM,ICOMM
      INTEGER NBVARM,NBVARL,NUMLC,NUMV,LVAR2,INDI,INDK16
      CHARACTER*16 COMCOD,LCOMEL(5),NOMS(2),MOCLEF,COMCOM
      CHARACTER*8  TAVARI
C-----------------------------------------------------------------------

      CALL JEMARQ()
C exceptions
      IF ((LCOMEL(1)(5:11).EQ.'CRISTAL').AND.
     &    (LCOMEL(2).EQ.'SIMO_MIEHE')) THEN
         CALL U2MESS('I','COMPOR2_25')
         CALL U2MESS('I','COMPOR2_26')
      ELSEIF ((LCOMEL(2).EQ.'SIMO_MIEHE').AND.
     &    (LCOMEL(1)(5:10).EQ.'_ISOT_')) THEN
         CALL WKVECT ( '&&PMDORC.LVARI','V V K16',NBVARI, LVARI )
         CALL WKVECT ( '&&PMDORC.LVAR2','V V K16',NBVARI, LVAR2 )
         CALL LCVARI(COMCOD, NBVARI, ZK16(LVARI))
         NOMS(1)=MOCLEF
         NOMS(2)=LCOMEL(1)
         NUMS(1)=IOCC
         NUMS(2)=NBVARI
         CALL U2MESG('I','COMPOR2_23',2,NOMS,2,NUMS,0,0.D0)
C        PLACER INDIPLAS  A LA FIN
         INDI = INDK16( ZK16(LVARI), 'INDIPLAS', 1, NBVARI )
         DO 561 II=1,INDI-1
            ZK16(LVAR2-1+II)=ZK16(LVARI-1+II)
 561     CONTINUE
         DO 562 II=INDI,NBVARI-1
            ZK16(LVAR2-1+II)=ZK16(LVARI-1+II+1)
 562     CONTINUE
         ZK16(LVAR2-1+NBVARI)=ZK16(LVARI-1+INDI)
         DO 563 II=1,NBVARI
            CALL U2MESG('I','COMPOR2_24',1,ZK16(LVAR2-1+II),1,II,0,0.D0)
 563     CONTINUE
         CALL JEDETR ( '&&PMDORC.LVAR2')
         CALL JEDETR ( '&&PMDORC.LVARI')

      ELSEIF ((LCOMEL(2).EQ.'SIMO_MIEHE').AND.
     &    (LCOMEL(1)(1:4).EQ.'META')) THEN
C A FAIRE PLUS TARD

      ELSEIF ((LCOMEL(1)(1:5).EQ.'KIT_H').OR.
     &        (LCOMEL(1)(1:5).EQ.'KIT_T'))  THEN

         CALL WKVECT ( '&&PMDORC.LVARI','V V K16',NBVARI, LVARI )
         NOMS(1)=MOCLEF
         NOMS(2)=LCOMEL(1)
         NUMS(1)=IOCC
         NUMS(2)=NBVARI
         CALL U2MESG('I','COMPOR2_23',2,NOMS,2,NUMS,0,0.D0)
         ICOMM=0
         DO 555 ICOM=1,NCOMEL
C           RECHERCHE DU COMPORTEMENT MECANIQUE
            IF ((LCOMEL(ICOM)(1:3).NE.'HYD').AND.
     &          (LCOMEL(ICOM)(1:3).NE.'LIQ').AND.
     &          (LCOMEL(ICOM)(1:3).NE.'GAZ')) THEN
               ICOMM=ICOM
            ENDIF
 555     CONTINUE
         NUMV=0
         CALL LCCREE(1, LCOMEL(ICOMM), COMCOM)
         CALL LCINFO(COMCOM, NUMLC, NBVARM)
         CALL LCVARI(COMCOM, NBVARM, ZK16(LVARI))
         DO 556 II=1,NBVARM
            CALL U2MESG('I','COMPOR2_24',1,ZK16(LVARI-1+II),1,II,0,0.D0)
 556     CONTINUE

         NUMV=NBVARM
         DO 558 ICOM=1,NCOMEL
C           RECHERCHE DU COMPORTEMENT MECANIQUE
            IF (ICOM.EQ.ICOMM) GOTO 558
            CALL LCCREE(1, LCOMEL(ICOM), COMCOM)
            CALL LCINFO(COMCOM, NUMLC, NBVARL)
            CALL LCVARI(COMCOM, NBVARL, ZK16(LVARI))
            DO 557 II=1,NBVARL
               NUMV=NUMV+II
               CALL U2MESG('I','COMPOR2_24',1,ZK16(LVARI-1+II),1,NUMV,0,
     &                     0.D0)
 557        CONTINUE
 558     CONTINUE

         CALL JEDETR ( '&&PMDORC.LVARI')


      ELSEIF (NBVARI.GT.0) THEN

         CALL WKVECT ( '&&PMDORC.LVARI','V V K16',NBVARI, LVARI )
         CALL LCVARI(COMCOD, NBVARI, ZK16(LVARI))
         NOMS(1)=MOCLEF
         NOMS(2)=LCOMEL(1)
         NUMS(1)=IOCC
         NUMS(2)=NBVARI
         CALL U2MESG('I','COMPOR2_23',2,NOMS,2,NUMS,0,0.D0)

         DO 554 II=1,NBVARI
           CALL U2MESG('I','COMPOR2_24',1,ZK16(LVARI-1+II),1,II,0,0.D0)
 554     CONTINUE

         CALL JEDETR ( '&&PMDORC.LVARI')

      ENDIF

      CALL JEDEMA()
C
      END
