      SUBROUTINE LCMMJ2(TAUR,MATERF,CPMONO,IFA,NMAT,NBCOMM,DT,
     &                NSFV,NSFA,IR,IS,NBSYS,NFS,NSG,HSR,VIND,DY,
     &                DGSDTS,DKSDTS,DGRDBS,DKSDBR,IRET)
      IMPLICIT NONE
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 25/06/2012   AUTEUR PROIX J-M.PROIX 
C TOLE CRP_21
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE PROIX J.M.PROIX
C TOLE CRS_1404
C       MONOCRISTAL : DERIVEES DES TERMES UTILES POUR LE CALCUL  
C                    DU JACOBIEN DU SYSTEME NL A RESOUDRE = DRDY
C                    cf. R5.03.11, COMPO DD_KR
C       IN  
C           TAUR   :  SCISSION REDUITE SYSTEME IR
C           MATERF :  COEFFICIENTS MATERIAU A T+DT
C           CPMONO :  NOM DES COMPORTEMENTS
C           IFA    :  NUMERO FAMILLE
C           NMAT   :  DIMENSION MATER
C           NBCOMM :  INCIDES DES COEF MATERIAU
C           DT     :  ACCROISSEMENT INSTANT ACTUEL
C           NSFV   :  DEBUT DES SYST. GLIS. DE LA FAMILLE IFA DANS VIND
C           NSFA   :  DEBUT DES SYST. GLIS. DE LA FAMILLE IFA DANS Y
C           IS     :  NUMERO DU SYST. GLIS. S
C           IR     :  NUMERO DU SYST. GLIS. R
C           NBSYS  :  NOMBRE DE SYSTEMES DE GLISSEMENT FAMILLE IFA
C           HSR    :  MATRICE D'INTERACTION
C           VIND   :  VARIABLES INTERNES A L'INSTANT PRECEDENT
C           DY     :  SOLUTION           =  ( DSIG DX1 DX2 DP (DEPS3) )
C       OUT DGSDTS :  derivee dGammaS/dTauS
C       OUT DKSDTS :  dkS/dTaus
C       OUT DGRDBS :  dGammaR/dBetaS
C       OUT DKRDBS :  dkR/dBetaS
C       OUT IRET   :  CODE RETOUR
C       ----------------------------------------------------------------
      INTEGER NMAT,NUVR,NBCOMM(NMAT,3),NUVI,IFA,NBSYS,IS,IRET,NFS,NSG
      INTEGER IR,NSFA,NSFV
      REAL*8 VIND(*),DGDTAU,HSR(NSG,NSG),DGSDTS,DKSDTS,DGRDBS,DKSDBR
      REAL*8 DHDALR,HS,TAUR,DP,DY(*),MATERF(NMAT*2),DT,RP,DGDALR,DFDRR
      REAL*8 ALPHAM,DALPHA,ALPHAP,CRIT,DGAMMA,SGNS,GAMMAP,PETITH,SGNR
      CHARACTER*16 NECOUL,CPMONO(5*NMAT+1)
      INTEGER IRR,DECIRR,NBSYST,DECAL
      COMMON/POLYCR/IRR,DECIRR,NBSYST,DECAL
C     ----------------------------------------------------------------

      IRET=0
      
      DGSDTS=0.D0
      DKSDTS=0.D0
      DGRDBS=0.D0
      DKSDBR=0.D0
      
      NUVR=NSFA+IR
      NUVI=NSFV+3*(IR-1)
      NECOUL=CPMONO(5*(IFA-1)+3)
      ALPHAM=VIND(NUVI+1)
      GAMMAP=VIND(NUVI+2)
      ALPHAP=ALPHAM+DY(NUVR)
      DECAL=NSFV
      CALL LCMMFE(TAUR,MATERF(NMAT+1),MATERF(1),IFA,
     &     NMAT,NBCOMM,NECOUL,IR,NBSYS,VIND,
     &     DY(NSFA+1),RP,ALPHAP,GAMMAP,DT,DALPHA,DGAMMA,DP,CRIT,
     &     SGNS,NFS,NSG,HSR,IRET)
      IF (IRET.GT.0)  GOTO 9999
      IF (CRIT.GT.0.D0) THEN
C        CALCUL de dF/dtau
         CALL LCMMJF( TAUR,MATERF(NMAT+1),MATERF(1),
     &         IFA,NMAT,NBCOMM,DT,NECOUL,IR,IS,NBSYS,VIND(NSFV+1),
     &         DY(NSFA+1),NFS,NSG,HSR,RP,ALPHAP,DALPHA,GAMMAP,
     &         DGAMMA,SGNR,DGDTAU,DGDALR,DFDRR,PETITH,IRET)
         IF (IRET.GT.0)  GOTO 9999
         DGSDTS=DGDTAU
         DKSDTS=ABS(DGDTAU)*PETITH
         DGRDBS=DGDALR*SGNR
         DHDALR=DFDRR
         HS=PETITH
         DKSDBR=DGDALR*HS+DP*DHDALR
      ENDIF

9999  CONTINUE
      END
