      SUBROUTINE LCMMJB(TAUR,TAUS,MATERF,CPMONO,IFA,NMAT,NBCOMM,DT,
     &            NUECOU,NSFV,NSFA,IR,IS,NBSYS,NFS,NSG,HSR,VIND,DY,
     &            ITMAX,TOLER,DGSDTS,DKSDTS,DGRDBS,DKRDBS,IRET)
      IMPLICIT NONE
C TOLE CRP_21
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 10/09/2012   AUTEUR PROIX J-M.PROIX 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE PROIX J-M.PROIX
C       ----------------------------------------------------------------
C       MONOCRISTAL : DERIVEES DES TERMES UTILES POUR LE CALCUL  
C                    DU JACOBIEN DU SYSTEME NL A RESOUDRE = DRDY
C                    cf. R5.03.11
C       IN  
C           TAUR   :  SCISSION REDUITE SYSTEME IR
C           TAUS   :  SCISSION REDUITE SYSTEME IS
C           MATERF :  COEFFICIENTS MATERIAU A T+DT
C           CPMONO :  NOM DES COMPORTEMENTS
C           IFA    :  NUMERO FAMILLE
C           NMAT   :  DIMENSION MATER
C           NBCOMM :  INCIDES DES COEF MATERIAU
C           DT     :  ACCROISSEMENT INSTANT ACTUEL
C           NUECOU : NUMERO DE LA LOI D'ECOULEMENT
C           NSFV   :  DEBUT DES SYST. GLIS. DE LA FAMILLE IFA DANS VIND
C           NSFA   :  DEBUT DES SYST. GLIS. DE LA FAMILLE IFA DANS Y
C           IS     :  NUMERO DU SYST. GLIS. S
C           IR     :  NUMERO DU SYST. GLIS. R
C           NBSYS  :  NOMBRE DE SYSTEMES DE GLISSEMENT FAMILLE IFA
C           HSR    :  MATRICE D'INTERACTION
C           VIND   :  VARIABLES INTERNES A L'INSTANT PRECEDENT
C           DY     :  SOLUTION           =  ( DSIG DX1 DX2 DP (DEPS3) )
C           ITMAX  :  ITER_INTE_MAXI
C           TOLER  :  RESI_INTE_RELA
C       OUT DGSDTS :  derivee dGammaS/dTauS
C       OUT DKSDTS :  dkS/dTaus
C       OUT DGRDBS :  dGammaR/dBetaS
C       OUT DKRDBS :  dkR/dBetaS
C       OUT IRET   :  CODE RETOUR
C       ----------------------------------------------------------------
      INTEGER NMAT,NBCOMM(NMAT,3),IFA,NBSYS,IS,IRET,NFS,NSG
      INTEGER IR,NSFA,NSFV,NUECOU,ITMAX
      REAL*8 DGSDTS,DKSDTS,DGRDBS,DKRDBS,VIND(*),HSR(NSG,NSG)
      REAL*8 MATERF(NMAT*2),DT,SGNR,HR,DPR,DPDTAU,DPRDAS,DHRDAS,TOLER
      REAL*8 TAUS,TAUR,DY(*)
      CHARACTER*16  CPMONO(5*NMAT+1)
      INTEGER IRR,DECIRR,NBSYST,DECAL
      COMMON/POLYCR/IRR,DECIRR,NBSYST,DECAL
C     ----------------------------------------------------------------

      IRET=0

      IF (NUECOU.EQ.4) THEN
C        KOCKS-RAUCH
         CALL LCMMJ2 (TAUR,MATERF,CPMONO,IFA,NMAT,NBCOMM,DT,
     &                NSFV,NSFA,IR,IS,NBSYS,NFS,NSG,HSR,VIND,DY,
     &                DGSDTS,DKSDTS,DGRDBS,DKRDBS,IRET)
      ELSEIF (NUECOU.EQ.5) THEN
C        DD-CFC
         DECAL=NSFV
         CALL LCMMJD( TAUR,MATERF,IFA,NMAT,NBCOMM,DT,
     &                IR,IS,NBSYS,NFS,NSG,HSR,VIND,DY(NSFA+1),
     &             DPDTAU,DPRDAS,DHRDAS,HR,DPR,SGNR,IRET)
      
         DGSDTS=DPDTAU*SGNR 
         DKSDTS=DPDTAU*HR
         DGRDBS=DPRDAS*SGNR 
         DKRDBS=DPRDAS*HR+DPR*DHRDAS
      ELSEIF (NUECOU.EQ.6) THEN
C        DD-FAT
         CALL U2MESS('F','COMPOR2_21')
      ELSEIF (NUECOU.GE.7) THEN
C        DD-CC
C        matrice tangente pas encore programmee
C        mais pourquoi EXTRAPOLE appelle RIGI_MECA_TANG ?
         DGSDTS=0.D0
         DKSDTS=0.D0
         DGRDBS=0.D0
         DKRDBS=0.D0
      ELSE
C        AUTRES COMPORTEMENTS
         CALL LCMMJ1 (TAUR,MATERF,CPMONO,IFA,NMAT,NBCOMM,DT,
     &                NSFV,NSFA,IR,IS,NBSYS,NFS,NSG,HSR,VIND,DY,
     &                ITMAX,TOLER,DGSDTS,DKSDTS,DGRDBS,DKRDBS,IRET)
      ENDIF

      END
