      SUBROUTINE LISLEC(MOTFAC,PHENOZ,BASE  ,LISCHA)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT      NONE
      INCLUDE 'jeveux.h'
      CHARACTER*(*) PHENOZ
      CHARACTER*16  MOTFAC
      CHARACTER*19  LISCHA
      CHARACTER*1   BASE
C
C ----------------------------------------------------------------------
C
C ROUTINE UTILITAIRE (LISTE_CHARGES)
C
C LECTURE DES CHARGEMENTS
C
C ----------------------------------------------------------------------
C
C
C IN  PHENOM : TYPE DE PHENOMENE (MECANIQUE, THERMIQUE, ACOUSTIQUE)
C IN  MOTFAC : MOT-CLEF FACTEUR DES EXCITATIONS
C IN  BASE   : BASE DE CREATION DE LA SD LISCHA
C OUT LISCHA : SD LISTE DES CHARGES
C
C
C
C
      INTEGER      IEXCI,NBEXCI,IBID
      CHARACTER*8  CHARGE
      CHARACTER*16 TYPAPP,TYPFCT
      INTEGER      CODCHA
      CHARACTER*8  TYPECH,NOMFCT
      CHARACTER*13 PREFOB
      REAL*8       PHASE
      INTEGER      NPUIS
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- NOMBRE D'EXCITATIONS
C
      CALL GETFAC(MOTFAC,NBEXCI)
C
C --- CREATION SD CHARGEMENT
C
      CALL LISCRS(LISCHA,NBEXCI,BASE  )
C
C --- LECTURE OCCURRENCES EXCIT
C
      DO 100 IEXCI = 1,NBEXCI
C
C ----- LECTURE NOM DE LA CHARGE (PROVENANT DE AFFE_CHAR_*)
C
        CALL LISNNN(MOTFAC,IEXCI ,CHARGE)
C
C ----- PREFIXE DE L'OBJET DE LA CHARGE
C
        CALL LISNNL(PHENOZ,CHARGE,PREFOB)
C
C ----- GENRES DE LA CHARGE
C
        CALL LISGEN(PREFOB,CODCHA)
C
C ----- TYPE DE LA CHARGE (COMPLEXE, FONCTION, REELLE)
C
        CALL LISDEF('TYPC',PREFOB,CODCHA,TYPECH,IBID  )
C
C ----- TYPE D'APPLICATION DE LA CHARGE
C
        CALL LISTAP(MOTFAC,IEXCI ,TYPAPP)
C
C ----- RECUPERATION FONCTION MULTIPLICATRICE
C
        CALL LISLEF(MOTFAC,IEXCI ,NOMFCT,TYPFCT,PHASE ,
     &              NPUIS )
C
C ----- SAUVEGARDE DES INFORMATIONS
C
        CALL LISSAV(LISCHA,IEXCI ,CHARGE,TYPECH,CODCHA,
     &              PREFOB,TYPAPP,NOMFCT,TYPFCT,PHASE ,
     &              NPUIS )
C
 100  CONTINUE
C
      CALL JEDEMA()
      END
