      SUBROUTINE MCOPCO(NOMA  ,NEWGEO,NDIM,NUMMAI,KSI1  ,
     &                  KSI2  ,GEOM)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*32 JEXNUM
      CHARACTER*8  NOMA
      CHARACTER*19 NEWGEO
      INTEGER      NDIM,NUMMAI
      REAL*8       KSI1,KSI2
      REAL*8       GEOM(3)
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - APPARIEMENT - UTILITAIRE)
C
C CALCUL DES COORDONNEES D'UN NOEUD SUR UNE MAILLE A PARTIR
C DE SES COORDONNEES PARAMETRIQUES
C
C ----------------------------------------------------------------------
C
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  NEWGEO : COORDONNEES DE TOUS LES NOEUDS
C IN  NUMMAI : NUMERO ABSOLU DE LA MAILLE DANS LE MAILLAGE
C IN  KSI1   : COORDONNEE PARAMETRIQUE KSI DU PROJETE
C IN  KSI2   : COORDONNEE PARAMETRIQUE ETA DU PROJETE
C OUT GEOM   : COORDONNEES DU NOEUD
C
C
C
C
      INTEGER      JCOOR,JDES
      INTEGER      NNO,INO,NO(9),ICMP,IBID
      REAL*8       COOR(27)
      CHARACTER*8  ALIAS
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- ACCES AUX CHAMPS
C
      CALL JEVEUO(NEWGEO(1:19)//'.VALE','L',JCOOR)
      CALL JEVEUO(JEXNUM(NOMA//'.CONNEX',NUMMAI),'L',JDES)
C
C --- INITIALISATIONS
C
      DO 10 ICMP = 1,3
        GEOM(ICMP) = 0.D0
   10 CONTINUE
C
C --- INFOS SUR LA MAILLE
C
      CALL MMELTY(NOMA,NUMMAI,ALIAS,NNO,IBID)
C
C --- NUMEROS ABSOLUS DES NOEUDS DE LA MAILLE
C
      DO 23 INO = 1,NNO
        NO(INO) = ZI(JDES+INO-1)
   23 CONTINUE
C
C --- COORDONNEES DES NOEUDS DE LA MAILLE
C
      DO 20 INO = 1,NNO
        COOR(3*(INO-1)+1) = ZR(JCOOR+3*(NO(INO)-1))
        COOR(3*(INO-1)+2) = ZR(JCOOR+3*(NO(INO)-1)+1)
        COOR(3*(INO-1)+3) = ZR(JCOOR+3*(NO(INO)-1)+2)
   20 CONTINUE
C
C --- CALCUL DES COORDONNEES
C
      CALL MMVALP(NDIM  ,ALIAS ,NNO   ,3     ,KSI1  ,
     &            KSI2  ,COOR  ,GEOM  )
C
      CALL JEDEMA()
      END
