      SUBROUTINE MDFEXT (TINIT,DT,NEQGEN,NBEXCI,IDESCF,NOMFON,COEFM,
     &                   LIAD,INUMOR,NBPAS,F)
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      INTEGER            NEQGEN,NBEXCI,NBPAS
      INTEGER            IDESCF(*),LIAD(*),INUMOR(*)
      REAL*8             TINIT,DT,T,COEFM(*),F(NEQGEN,*)
      CHARACTER*8        NOMFON(*)

C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 03/07/2012   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
C     CALCULE LES FORCES EXTERIEURES A CHAQUE PAS DE TEMPS
C     ------------------------------------------------------------------
C IN  : TINIT  : PAS DE TEMPS INITIAL POUR LE BLOC DE CALCUL
C IN  : NEQGEN : NOMBRE D'EQUATIONS GENERALISEES
C IN  : NBEXCI : NOMBRE D'EXCITATION (MC EXCIT ET EXCIT_RESU)
C IN  : IDESCF : TYPE D'EXCITATION (VECT_ASSE/NUME_ORDRE,FONC_MULT/
C                COEF_MULT)
C IN  : NOMFON : NOM DES FONC_MULT (QUAND IL Y EN A)
C IN  : COEFM  : VALEUR DU COEF_MULT
C IN  : LIAD   : VALEUR DU VECT_ASSE
C IN  : NUMOR  : NUME_ORDRE DU MODE EXCITE
C IN  : NBPAS  : NOMBRE DE PAS DE CALCUL
C OUT : F      : TABLEAU DES FORCES EXTERIEURES A CHAQUE PAS DE TEMPS
C ----------------------------------------------------------------------
C
C
C
C
      INTEGER       IER
      CHARACTER*4   NOMPAR
C
C     ------------------------------------------------------------------
C
C-----------------------------------------------------------------------
      INTEGER I ,J ,K 
      REAL*8 ALPHA 
C-----------------------------------------------------------------------
      CALL JEMARQ()

      NOMPAR='INST'
      DO 20 I = 1 , NBEXCI
        T=TINIT
        DO 10 K = 1,NBPAS
          IF (IDESCF(I).EQ.1) THEN
            CALL FOINTE('F ',NOMFON(I),1,NOMPAR,T,ALPHA,IER)
            DO 30 J = 1,NEQGEN
              F(J,K) = F(J,K) + ALPHA * ZR(LIAD(I)+J-1)
 30         CONTINUE
          ELSEIF(IDESCF(I).EQ.2) THEN
            CALL FOINTE('F ',NOMFON(I),1,NOMPAR,T,ALPHA,IER)
            F(INUMOR(I),K)=F(INUMOR(I),K)+ALPHA
          ELSEIF(IDESCF(I).EQ.3) THEN
            DO 40 J = 1,NEQGEN
              F(J,K) = F(J,K) + COEFM(I)* ZR(LIAD(I)+J-1)
 40         CONTINUE
          ELSEIF(IDESCF(I).EQ.4) THEN
            F(INUMOR(I),K)=F(INUMOR(I),K)+COEFM(I)
          ENDIF
          T = TINIT + ( K*DT )
 10     CONTINUE
 20   CONTINUE

C
      CALL JEDEMA()
      END
