      SUBROUTINE MMALGO(INDCOI,LVITES,LGLINI,JEU   ,JEUVIT,
     &                  LAMBDC,COEFAC,CTCSTA,MMCVCA,SCOTCH,
     &                  INDCON)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 16/04/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INTEGER  INDCOI,INDCON,CTCSTA
      LOGICAL  LVITES,MMCVCA,LGLINI,SCOTCH
      REAL*8   JEU   ,JEUVIT,LAMBDC,COEFAC
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - CONTRAINTES ACTIVES)
C
C TRAITEMENT DES DIFFERENTS CAS
C
C ----------------------------------------------------------------------
C
C
C IN  INDCOI : INDICATEUR DE CONTACT INITIAL
C              - INDCOI = 0: PAS DE CONTACT
C              - INDCOI = 1: CONTACT
C IN  LVITES : .TRUE. SI FORMULATION EN VITESSE
C IN  LGLINI : .TRUE. SI CONTACT GLISSIERE AVEC CONTACT_INIT AU PREMIER
C               PAS DE TEMPS
C IN  JEU    : VALEUR DU JEU
C IN  JEUVIT : VALEUR DU GAP DES VITESSES NORMALES
C IN  LAMBDC : MULTIPLICATEUR DE CONTACT DU POINT DE CONTACT
C IN  COEFAC : COEFFICIENT D'AUGMENTATION DU CONTACT RHO_N
C OUT INDCON : INDICATEUR DE CONTACT FINAL
C              - INDCON = 0: PAS DE CONTACT
C              - INDCON = 1: CONTACT
C OUT MMCVCA : INDICATEUR DE CONVERGENCE POUR BOUCLE DES
C              CONTRAINTES ACTIVES
C               .TRUE. SI LA BOUCLE DES CONTRAINTES ACTIVES A CONVERGE
C OUT CTCSTA : NOMBRE DE POINTS AYANT CHANGE DE STATUT DE CONTACT
C OUT SCOTCH : VAUT .TRUE. SI LE NOEUD EST COLLE DANS LE MODELE
C              DE COMPLIANCE
C
C ----------------------------------------------------------------------
C
C
C --- INITIALISATIONS
C
      SCOTCH = .FALSE.
C
C --- STATUT DE CONTACT
C
      CALL MMSTAC(INDCOI,LVITES,JEU   ,JEUVIT,LAMBDC,
     &            COEFAC,INDCON)
C
C --- CAS GLISSIERE: TOUT EST EN CONTACT
C
      IF (LGLINI) INDCON = 1
C
C --- THETA-METHODE
C
      IF (INDCOI.EQ.1) THEN
        SCOTCH = .TRUE.
      ELSE
        SCOTCH = .FALSE.
      ENDIF
C
C --- CONVERGENCE ?
C
      IF (INDCOI.NE.INDCON) THEN
        MMCVCA = .FALSE.
        CTCSTA = CTCSTA+1
      ENDIF
C
      END
