      SUBROUTINE MMBCLC(NOMA  ,NOMO  ,NUMEDD,ITERAT,NUMINS,
     &                  SDDISC,SDDYNA,SDIMPR,DEFICO,RESOCO,
     &                  VALINC,SOLALG,SDTIME,SDSTAT,MMCVCA)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 30/10/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE      'jeveux.h'
      CHARACTER*8  NOMA,NOMO
      INTEGER      NUMINS,ITERAT
      CHARACTER*19 SDDISC,SDDYNA
      CHARACTER*24 DEFICO,RESOCO,SDTIME,SDSTAT,SDIMPR,NUMEDD
      CHARACTER*19 VALINC(*),SOLALG(*)
      LOGICAL      MMCVCA
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - ALGORITHME)
C
C CHANGEMENT DES STATUTS SI CONTACT CONTINU NEWTON GENERALISE
C
C ----------------------------------------------------------------------
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  NOMO   : NOM DU MODELE
C IN  ITERAT : NUMERO D'ITERATION DE NEWTON
C IN  NUMEDD : NUMEROTATION NUME_DDL
C IN  NUMINS : NUMERO D'INSTANT
C IN  SDDISC : SD DISCRETISATION
C IN  SDDYNA : SD DYNAMIQUE
C IN  SDIMPR : SD AFFICHAGE
C IN  DEFICO : SD DEFINITION CONTACT
C IN  RESOCO : SD RESOLUTION CONTACT
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C IN  SOLALG : VARIABLE CHAPEAU POUR INCREMENTS SOLUTIONS
C IN  SDTIME : SD TIMER
C IN  SDSTAT : SD STATISTIQUES
C OUT MMCVCA : INDICATEUR DE CONVERGENCE POUR BOUCLE DES
C              CONTRAINTES ACTIVES
C               .TRUE. SI LA BOUCLE DES CONTRAINTES ACTIVES A CONVERGE
C
C ----------------------------------------------------------------------
C
      LOGICAL      CFDISL,LALLV,LNEWTC,LNEWTG
      LOGICAL      LOPTIN
      INTEGER      CTCSTA
      CHARACTER*19 DEPGEO,DEPPLU
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- ACTIVATION DES OPTIONS *_INIT
C
      LOPTIN = .FALSE.
C
C --- FONCTIONNALITES ACTIVEES
C
      LALLV  = CFDISL(DEFICO,'ALL_VERIF')
      LNEWTC = CFDISL(DEFICO,'CONT_NEWTON')
      LNEWTG = CFDISL(DEFICO,'GEOM_NEWTON')
      CTCSTA = 0
      IF (LALLV) THEN
        MMCVCA = .TRUE.
        GOTO 999
      ENDIF
C
C --- DECOMPACTION VARIABLES CHAPEAUX
C
      CALL NMCHEX(VALINC,'VALINC','DEPPLU',DEPPLU)
      DEPGEO = RESOCO(1:14)//'.DEPG'
C
C --- NOUVEL APPARIEMENT
C
      IF (LNEWTG) THEN
        CALL COPISD('CHAMP_GD','V',DEPPLU,DEPGEO)
        CALL NMTIME(SDTIME,'INI','CONT_GEOM')
        CALL NMTIME(SDTIME,'RUN','CONT_GEOM')
        CALL MREACG(NOMA  ,RESOCO)
        CALL MMAPPA(LOPTIN,NOMA  ,NUMEDD,DEFICO,RESOCO)
        CALL NMTIME(SDTIME,'END','CONT_GEOM')
        CALL NMRINC(SDSTAT,'CONT_GEOM')
      ENDIF
C
C --- NOUVELLE NUMEROTATION (ELEMENTS TARDIFS DE CONTACT)
C
      IF (LNEWTG) THEN
        CALL MMLIGR(NOMA  ,NOMO  ,DEFICO,RESOCO)
      ENDIF
C
C --- CHANGEMENT DES STATUTS
C
      IF (LNEWTC.OR.LNEWTG) THEN
        CALL NMTIME(SDTIME,'INI','CTCC_CONT')
        CALL NMTIME(SDTIME,'RUN','CTCC_CONT')
        CALL MMMBCA(NOMA  ,SDDYNA,ITERAT,DEFICO,RESOCO,
     &              VALINC,SOLALG,CTCSTA,MMCVCA)
        CALL NMTIME(SDTIME,'END','CTCC_CONT')
        CALL NMRINC(SDSTAT,'CTCC_CONT')
      ENDIF
C
C --- MISE A JOUR DE LA CARTE
C
      IF (LNEWTC.OR.LNEWTG) THEN
        CALL NMTIME(SDTIME,'INI','CTCC_PREP')
        CALL NMTIME(SDTIME,'RUN','CTCC_PREP')
        CALL MMCHML(NOMA  ,DEFICO,RESOCO,SDDISC,SDDYNA,
     &              NUMINS)
        CALL NMTIME(SDTIME,'END','CTCC_PREP')
        CALL NMRINC(SDSTAT,'CTCC_PREP')
      ENDIF
C
 999  CONTINUE
C
C --- STATUTS DE CONTACT EN NEWTON GENERALISE
C
      IF (LNEWTC) CALL NMIMCI(SDIMPR,'CONT_NEWT',CTCSTA,.TRUE.)
C
      CALL JEDEMA()
C
      END
