      SUBROUTINE MMCALG(NDIM  ,NNM   ,DDFFM ,GEOMAM,TAU1  ,
     &                  TAU2  ,NORM  ,MPRT1N,MPRT2N,GENE11,
     &                  GENE21)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 25/06/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C TOLE CRP_21
C
      IMPLICIT     NONE
      INTEGER      NDIM,NNM
      REAL*8       DDFFM(3,9)
      REAL*8       TAU1(3),TAU2(3)
      REAL*8       NORM(3)
      REAL*8       GEOMAM(9,3)
      REAL*8       MPRT1N(3,3),MPRT2N(3,3)
      REAL*8       GENE11(3,3),GENE21(3,3)
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - UTILITAIRE)
C
C CALCUL DES MATRICES DE PROJECTION POUR NEWTON GENERALISE
C
C ----------------------------------------------------------------------
C
C
C IN  NDIM   : DIMENSION DE LA MAILLE DE CONTACT
C IN  NNM    : NOMBRE DE NOEUDS DE LA MAILLE MAITRE
C IN  DDFFM  : DERIVEES SECONDES DES FONCTIONS DE FORME MAITRES
C IN  GEOMAM : GEOMETRIE ACTUALISEE SUR NOEUDS MAITRES
C IN  TAU1   : PREMIERE TANGENTE EXTERIEURE
C IN  TAU2   : SECONDE TANGENTE EXTERIEURE
C IN  NORM   : NORMALE INTERIEURE
C OUT MPRT1N : MATRICE DE PROJECTION TANGENTE1/NORMALE
C OUT MPRT2N : MATRICE DE PROJECTION TANGENTE2/NORMALE
C OUT GENE11 : MATRICE
C OUT GENE21 : MATRICE
C
C ----------------------------------------------------------------------
C
      INTEGER I,J,INOM
C
C ----------------------------------------------------------------------
C
      CALL MATINI(3,3,0.D0,MPRT1N)
      CALL MATINI(3,3,0.D0,MPRT2N)
      CALL MATINI(3,3,0.D0,GENE11)
      CALL MATINI(3,3,0.D0,GENE21)
C
C --- MATRICE DE PROJECTION TANGENTE1/NORMALE
C
      DO 126 I = 1,NDIM
        DO 116 J = 1,NDIM
          MPRT1N(I,J) = 1.D0*TAU1(I)*NORM(J)
116     CONTINUE
126   CONTINUE
C
C --- MATRICE DE PROJECTION TANGENTE2/NORMALE
C
      DO 127 I = 1,NDIM
        DO 117 J = 1,NDIM
          MPRT2N(I,J) = 1.D0*TAU2(I)*NORM(J)
117     CONTINUE
127   CONTINUE
C
      DO 24 I = 1 , NDIM
        DO 25 J = 1 , NDIM
          DO 27 INOM =1 , NNM
            GENE11(I,J) = GENE11(I,J)+
     &                    DDFFM(1,INOM)*GEOMAM(INOM,I)*NORM(J)

            GENE21(I,J) = GENE21(I,J)+
     &                    DDFFM(3,INOM)*GEOMAM(INOM,I)*NORM(J)
27        CONTINUE
25      CONTINUE
24    CONTINUE




      END
