      SUBROUTINE MMCONV(NOMA  ,SDIMPR,DEFICO,RESOCO,VALINC,
     &                  SOLALG,VFROT ,NFROT ,VGEOM ,NGEOM )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 30/10/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*8  NOMA
      CHARACTER*24 DEFICO,RESOCO
      CHARACTER*24 SDIMPR
      CHARACTER*19 VALINC(*),SOLALG(*)
      REAL*8       VFROT,VGEOM
      CHARACTER*16 NFROT,NGEOM
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE)
C
C RESIDUS SPECIFIQUES POUR NEWTON GENERALISE
C
C ----------------------------------------------------------------------
C
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  SDIMPR : SD AFFICHAGE
C IN  DEFICO : SD POUR LA DEFINITION DE CONTACT
C IN  RESOCO : SD POUR LA RESOLUTION DE CONTACT
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C IN  SOLALG : VARIABLE CHAPEAU POUR INCREMENTS SOLUTIONS
C OUT VFROT  : VALEUR NORME_MAX POUR RESI_FROT
C OUT NFROT  : LIEU OU VALEUR NORME_MAX POUR RESI_FROT
C OUT VGEOM  : VALEUR NORME_MAX POUR RESI_GEOM
C OUT NGEOM  : LIEU OU VALEUR NORME_MAX POUR RESI_GEOM
C
C ----------------------------------------------------------------------
C
      INTEGER      IFM,NIV
      CHARACTER*19 DEPPLU,DEPMOI,DDEPLA
      REAL*8       R8VIDE
      CHARACTER*16 LIECYC,TYPCYC
      LOGICAL      CFDISL,LALLV,LNEWTF,LNEWTG
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('CONTACT',IFM,NIV)
C
C --- INITIALISATIONS
C
      TYPCYC = ' '
      NFROT  = ' '
      VFROT  = R8VIDE()
      NGEOM  = ' '
      VGEOM  = R8VIDE()
C
C --- DECOMPACTION DES VARIABLES CHAPEAUX
C
      CALL NMCHEX(VALINC,'VALINC','DEPMOI',DEPMOI)
      CALL NMCHEX(VALINC,'VALINC','DEPPLU',DEPPLU)
      CALL NMCHEX(SOLALG,'SOLALG','DDEPLA',DDEPLA)
C
C --- FONCTIONNALITES ACTIVEES
C
      LALLV  = CFDISL(DEFICO,'ALL_VERIF'     )
      LNEWTF = CFDISL(DEFICO,'FROT_NEWTON')
      LNEWTG = CFDISL(DEFICO,'GEOM_NEWTON')
C
C --- AFFICHAGE
C
      IF ((NIV.GE.2).AND.(LNEWTG.OR.LNEWTF)) THEN
        WRITE (IFM,*) '<CONTACT> ... CALCUL DES RESIDUS POUR NEWTON '//
     &                'GENERALISE'
      ENDIF
C
C --- EVALUATION RESIDU SEUIL FROTTEMENT
C
      IF (LNEWTF) THEN
C
C ----- MISE A JOUR DES SEUILS
C
        CALL MMREAS(NOMA  ,DEFICO,RESOCO,VALINC)
C
C ----- CALCUL RESIDU DE FROTTEMENT
C
        CALL MMMCRF(NOMA  ,DDEPLA,DEPPLU,NFROT ,VFROT )
      ENDIF
C
C --- EVALUATION RESIDU SEUIL GEOMETRIE
C
      IF (LNEWTG) THEN
C      
C ----- MISE A JOUR DE LA GEOMETRIE
C
        CALL MREACG(NOMA  ,RESOCO)
C
C ----- CALCUL RESIDU DE GEOMETRIE
C
        CALL MMMCRG(NOMA  ,DDEPLA,DEPPLU,NGEOM ,VGEOM )
      ENDIF
C
C --- CYCLAGE ?
C
      IF (.NOT.LALLV) THEN
        CALL MMCYCL(DEFICO,RESOCO,TYPCYC,LIECYC)
        CALL NMIMCK(SDIMPR,'CTCC_CYCL',TYPCYC,.TRUE.)
      ENDIF
C
      CALL JEDEMA()
      END
