      SUBROUTINE MMELEL(NDIM  ,NTYMA1,NTYMA2,IORDR,NNDEL ,
     &                  NUMTYP)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*32 JEXNOM
      INTEGER      NDIM
      CHARACTER*8  NTYMA1,NTYMA2
      INTEGER      NNDEL
      INTEGER      IORDR
      INTEGER      NUMTYP
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - UTILITAIRE)
C
C RETOURNE DES INFOS SUR LES ELEMENTS DE CONTACT FORMES ENTRE
C DEUX ELEMENTS DE SURFACE
C
C LORS DES MODIFICATIONS DE MMELEL, IL FAUT ASSURER LA COHERENCE AVEC
C  - MMLIGR / MMELTC / MMELTF / MMELTM / MMELTN / MMELEM
C  - CATALOGUES &CATA.TM ET ELEMENTS DE CONTACT
C
C ----------------------------------------------------------------------
C
C
C IN  NDIM   : DIMENSION DE L'ESPACE
C IN  NTYMA1 : PREMIERE MAILLE
C IN  NTYMA2 : SECONDE  MAILLE
C OUT IORDR  : ORDRE DANS LA LISTE DES ELEMENTS
C OUT NNDEL  : NOMBRE DE NOEUDS DE L'ELEMENT DE CONTACT
C OUT NUMTYP : NUMERO DU TYPE ELEMENT DANS &CATA.TM
C
C
C
C
C
      INTEGER      NBTYP
      PARAMETER   (NBTYP=40)
      CHARACTER*8  CPL(NBTYP,2),VALK(2)
      INTEGER      K
      CHARACTER*16 MMELTM,NOMTM
      INTEGER      MMELTN
C
      DATA (CPL(K,1),K=1,NBTYP) /
     &      'SEG2' ,'SEG3' ,'SEG2' ,'SEG3' ,'TRIA3',
     &      'TRIA3','TRIA6','TRIA6','QUAD4','QUAD4',
     &      'QUAD8','QUAD8','QUAD4','TRIA3','TRIA6',
     &      'QUAD4','TRIA6','QUAD8','TRIA6','QUAD9',
     &      'QUAD8','TRIA3','QUAD8','QUAD9','QUAD9',
     &      'QUAD4','QUAD9','TRIA3','QUAD9','SEG2' ,
     &      'SEG2', 'SEG2' ,'SEG2' ,'SEG2' ,'SEG2' ,
     &      'SEG3' ,'SEG3', 'SEG3' ,'SEG3' ,'SEG3' /
      DATA (CPL(K,2),K=1,NBTYP) /
     &      'SEG2' ,'SEG3' ,'SEG3' ,'SEG2' ,'TRIA3',
     &      'TRIA6','TRIA3','TRIA6','QUAD4','QUAD8',
     &      'QUAD4','QUAD8','TRIA3','QUAD4','QUAD4',
     &      'TRIA6','QUAD8','TRIA6','QUAD9','TRIA6',
     &      'TRIA3','QUAD8','QUAD9','QUAD8','QUAD4',
     &      'QUAD9','TRIA3','QUAD9','QUAD9','SEG2' ,
     &      'TRIA3','TRIA6','QUAD4','QUAD8','QUAD9',
     &      'TRIA3','TRIA6','QUAD4','QUAD8','QUAD9'/

C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
      IORDR = 0
      NNDEL = 0
C
      DO 10 K=1,NBTYP
        IF (NTYMA1.EQ.CPL(K,1)) THEN
          IF (NTYMA2.EQ.CPL(K,2)) THEN
            NNDEL = MMELTN(K)
            IORDR = K
          ENDIF
        ENDIF
  10  CONTINUE
C
      IF (IORDR.EQ.0) THEN
        VALK(1) = NTYMA1
        VALK(2) = NTYMA2
        CALL U2MESK('F','CONTACT_96',2,VALK)
      ELSE
        NOMTM  = MMELTM(IORDR)
        CALL JENONU(JEXNOM('&CATA.TM.NOMTM',NOMTM),NUMTYP)
      ENDIF
C
C --- DISTINCTION POUTRE/POUTRE ET 2D/2D
C
      IF (NOMTM.EQ.'SEG22') THEN
        IF (NDIM.EQ.2) THEN
          IORDR = 1
        ELSE
          IORDR = 30
        ENDIF
      ENDIF
C
      CALL JEDEMA()
C
      END
