      SUBROUTINE MMEXCR(NOMA  ,NEQ   ,DEFICO,RESOCO,LPIVOT,
     &                  POSMAE,NDEXCL,NDEXFR)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*32 JEXNUM
      LOGICAL       LPIVOT
      INTEGER       POSMAE,NEQ
      CHARACTER*24  DEFICO,RESOCO
      CHARACTER*8   NOMA
      INTEGER       NDEXFR
      INTEGER       NDEXCL(9)
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - APPARIEMENT)
C
C EXCLUE LES NOEUDS SUIVANT OPTIONS
C
C ----------------------------------------------------------------------
C
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  NEQ    : NOMBRE D'EQUATIONS DU SYSTEME
C IN  LPIVOT : IL Y A EXCLUSION_PIV_NUL
C IN  DEFICO : SD POUR LA DEFINITION DE CONTACT
C IN  RESOCO : SD POUR LA RESOLUTION DE CONTACT
C IN  POSMAE : POSITION DE LA MAILLE ESCLAVE DANS LES SD CONTACT
C OUT NDEXCL : NOEUDS EXCLUS SUR LA MAILLE
C OUT NDEXFR : ENTIER CODE POUR LES NOEUDS INTERDITS DANS
C              SANS_GROUP_NO_FR OU SANS_NOEUD_FR
C
C
C
C
      CHARACTER*19 SDAPPA
      CHARACTER*24 APTGEL
      INTEGER      JTGELN
      REAL*8       TAU1(3),TAU2(3),NORM(3),NOOR
      INTEGER      I
      INTEGER      CFDISI,NDIMG
      INTEGER      POSNNO(9),NUMNNO(9)
      INTEGER      INOE,NNOMAI,NUMNOE
      LOGICAL      EXNOE
      CHARACTER*8  NOMNOE
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      DO 10 I=1,9
        NDEXCL(I) = 0
   10 CONTINUE
C
C --- ENTIER CODE POUR LES NOEUDS INTERDITS DANS
C --- SANS_GROUP_NO_FR OU SANS_NOEUD_FR
C
      CALL MMINFM(POSMAE,DEFICO,'NDEXFR',NDEXFR)
C
      IF (.NOT.LPIVOT) GOTO 99
C
C --- ACCES OBJETS
C
      SDAPPA = RESOCO(1:14)//'.APPA'
      APTGEL = SDAPPA(1:19)//'.TGEL'
C
C --- ACCES A LA MAILLE ESCLAVE
C
      NDIMG  = CFDISI(DEFICO,'NDIM')
      CALL CFPOSN(DEFICO,POSMAE,POSNNO,NNOMAI)
      CALL ASSERT(NNOMAI.LE.9)
      CALL CFNUMN(DEFICO,NNOMAI,POSNNO,NUMNNO)
      CALL JEVEUO(JEXNUM(APTGEL,POSMAE),'L',JTGELN)
C
C --- BOUCLE SUR LES NOEUDS
C
      DO 15 INOE = 1,NNOMAI
        NUMNOE = NUMNNO(INOE)
        CALL JENUNO(JEXNUM(NOMA//'.NOMNOE',NUMNOE),NOMNOE)
C       --- NORMALE AU NOEUD
        TAU1(1) = ZR(JTGELN+6*(INOE-1)+1-1)
        TAU1(2) = ZR(JTGELN+6*(INOE-1)+2-1)
        TAU1(3) = ZR(JTGELN+6*(INOE-1)+3-1)
        TAU2(1) = ZR(JTGELN+6*(INOE-1)+4-1)
        TAU2(2) = ZR(JTGELN+6*(INOE-1)+5-1)
        TAU2(3) = ZR(JTGELN+6*(INOE-1)+6-1)
        CALL MMNORM(NDIMG ,TAU1  ,TAU2  ,NORM  ,NOOR)
C       --- ON TESTE SI NOEUDS DE LA MAILLE IMPLIQUES DANS RELATIONS
C       --- DE TYPE LAGRANGE/LIAISON_DDL
        EXNOE  = .FALSE.
        CALL REDCEX(NDIMG ,RESOCO,NEQ   ,NUMNOE,NORM  ,
     &              EXNOE )
        IF (EXNOE) THEN
          NDEXCL(INOE) = 1
        ENDIF
  15  CONTINUE
C
  99  CONTINUE
C
      CALL JEDEMA()
C
      END
