      SUBROUTINE MMMCPT(NOMA  ,SDSTAT,DEFICO,RESOCO,CNSINR)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*8  NOMA
      CHARACTER*19 CNSINR
      CHARACTER*24 DEFICO,RESOCO,SDSTAT
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - POST-TRAITEMENT)
C
C DECOMPTE DES LIAISONS
C
C ----------------------------------------------------------------------
C
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  SDSTAT : SD STATISTIQUES
C IN  DEFICO : SD DE DEFINITION DU CONTACT
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  CNSINR : CHAM_NO_S POUR L'ARCHIVAGE DU CONTACT
C
C
C
C
      INTEGER      IPTC,IZONE,IMAE,IPTM
      INTEGER      NPTM,NBMAE,NZOCO,NBNO
      INTEGER      MMINFI,CFDISI
      INTEGER      CFMMVD,ZTABF,ZRESU
      INTEGER      NUMNOE
      INTEGER      POSMAE
      INTEGER      JDECME
      INTEGER      CONT
      CHARACTER*8  K8BID
      INTEGER      IBID
      CHARACTER*24 TABFIN
      INTEGER      JTABF
      LOGICAL      CFDISL,MMINFL,LVERI,LNOEU
      INTEGER      JCNSVR,JCNSLR
      INTEGER      NBLIAC,NBLIAF
      CHARACTER*24 DEJCAL
      INTEGER      JDEJCA
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C       
      NZOCO  = CFDISI(DEFICO,'NZOCO' )
      NBLIAC = 0
      NBLIAF = 0
C
C --- SD TEMPORAIRE POUR VERIF NOEUDS DEJA CALCULES
C
      CALL DISMOI('F','NB_NO_MAILLA',NOMA,'MAILLAGE',NBNO,K8BID,IBID)
      DEJCAL = '&&XMMRES.DEJCAL'
      CALL WKVECT(DEJCAL,'V V I',NBNO,JDEJCA)
C
C --- TOUTES LES ZONES EN INTEGRATION AUX NOEUDS ?
C
      LNOEU = CFDISL(DEFICO,'ALL_INTEG_NOEUD')
      IF (.NOT.LNOEU) THEN
        NBLIAC = 0
        NBLIAF = 0
        GOTO 999
      ENDIF
C
C --- LECTURE DES STRUCTURES DE DONNEES DE CONTACT
C
      TABFIN = RESOCO(1:14)//'.TABFIN'
      CALL JEVEUO(TABFIN,'L',JTABF)
C
      ZTABF  = CFMMVD('ZTABF')
      ZRESU  = CFMMVD('ZRESU') 
C
C --- ACCES AU CHAM_NO_S POUR LE CONTACT
C
      CALL JEVEUO(CNSINR(1:19)//'.CNSV','L',JCNSVR)
      CALL JEVEUO(CNSINR(1:19)//'.CNSL','L',JCNSLR)
C
C --- BOUCLE SUR LES ZONES
C
      IPTC   = 1
      DO 10 IZONE = 1,NZOCO
C
C --- OPTIONS SUR LA ZONE DE CONTACT
C             
        LVERI  = MMINFL(DEFICO,'VERIF' ,IZONE )       
        NBMAE  = MMINFI(DEFICO,'NBMAE' ,IZONE )
        JDECME = MMINFI(DEFICO,'JDECME',IZONE )
C 
C ----- MODE VERIF: ON SAUTE LES POINTS
C  
        IF (LVERI) THEN
          GOTO 25
        ENDIF
C
C ----- BOUCLE SUR LES MAILLES ESCLAVES
C      
        DO 20 IMAE = 1,NBMAE
C
C ------- POSITION DE LA MAILLE ESCLAVE
C
          POSMAE = JDECME + IMAE        
C
C ------- NOMBRE DE POINTS SUR LA MAILLE ESCLAVE
C            
          CALL MMINFM(POSMAE,DEFICO,'NPTM',NPTM  )         
C
C ------- BOUCLE SUR LES POINTS
C      
          DO 30 IPTM = 1,NPTM         
C
C --------- INFOS
C  
            NUMNOE  = NINT(ZR(JTABF+ZTABF*(IPTC-1)+24))
            IF (NUMNOE.GT.0) THEN  
              IF (ZI(JDEJCA+NUMNOE-1).EQ.0) THEN         
                CONT    = NINT(ZR(JCNSVR+ZRESU*(NUMNOE-1)+1 -1))
                IF (CONT.GE.1) THEN
                  NBLIAC = NBLIAC + 1
                  IF (CONT.EQ.1) THEN
                    NBLIAF = NBLIAF + 1
                  ENDIF
                ENDIF
                ZI(JDEJCA+NUMNOE-1) = 1
              ENDIF
            ENDIF
C
C --------- LIAISON DE CONTACT SUIVANTE
C
            IPTC   = IPTC + 1 
  30      CONTINUE
  20    CONTINUE
  25    CONTINUE
  10  CONTINUE
C
  999 CONTINUE
C
      CALL JEDETR(DEJCAL)
      CALL NMRVAI(SDSTAT,'CONT_NBLIAC','E',NBLIAC)
      CALL NMRVAI(SDSTAT,'CONT_NBLIAF','E',NBLIAF)
C
      CALL JEDEMA()
      END
