      SUBROUTINE MMOPTI(LOPTIN,RESOCO,SEUILI,CTCINI,LGLISS,
     &                  IPTC  ,EPSINT,JEUSGN)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 30/10/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*24 RESOCO
      INTEGER      CTCINI,IPTC
      REAL*8       SEUILI,EPSINT,JEUSGN
      LOGICAL      LOPTIN,LGLISS
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - APPARIEMENT)
C
C REMPLIT LA SD APPARIEMENT POUR LES OPTIONS
C
C ----------------------------------------------------------------------
C
C
C IN  LOPTIN : VAUT .TRUE. SI ACTIVATION DES OPTIONS *_INIT
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C IN  SEUILI : VALEUR DU SEUIL_INIT
C IN  CTCINI : VAUT .TRUE. SI CONTACT_INIT
C IN  LGLISS : SI CONTACT GLISSIERE
C IN  IPTC   : NUMERO DE LA LIAISON DE CONTACT
C IN  EPSINT : TOLERANCE POUR CONTACT_INIT
C IN  JEUSGN : JEU SIGNE
C
C ----------------------------------------------------------------------
C
      INTEGER      CFMMVD,ZTABF
      CHARACTER*24 TABFIN
      INTEGER      JTABF
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- ACCES SD CONTACT
C
      TABFIN = RESOCO(1:14)//'.TABFIN'
      CALL JEVEUO(TABFIN,'E',JTABF)
      ZTABF = CFMMVD('ZTABF')
C
C --- SEUIL_INIT
C
      IF (LOPTIN) THEN
        ZR(JTABF+ZTABF*(IPTC-1)+16) = SEUILI
      END IF
C
C --- CONTACT_INIT
C
      IF (LOPTIN) THEN
        IF (CTCINI.EQ.2) THEN
C ------- SEULEMENT POUR LES POINTS INTERPENETRES
          IF (JEUSGN.LE.EPSINT) THEN
            ZR(JTABF+ZTABF*(IPTC-1)+22) = 1.D0
            IF (LGLISS) THEN
              ZR(JTABF+ZTABF*(IPTC-1)+17) = 1.D0
            ENDIF
          ENDIF
        ELSEIF (CTCINI.EQ.1) THEN
C ------- POUR TOUS LES POINTS
          ZR(JTABF+ZTABF*(IPTC-1)+22) = 1.D0
          IF (LGLISS) THEN
            ZR(JTABF+ZTABF*(IPTC-1)+17) = 1.D0
          ENDIF
        ELSEIF (CTCINI.EQ.0) THEN
C ------- PAS DE CONTACT INITIAL
          ZR(JTABF+ZTABF*(IPTC-1)+22) = 0.D0
        ELSE
          CALL ASSERT(.FALSE.)
        ENDIF
      ENDIF
C
C --- NOEUDS EXCLUS: PAS EN CONTACT
C
      IF (ZR(JTABF+ZTABF*(IPTC-1)+18) .EQ. 1.D0) THEN
        ZR(JTABF+ZTABF*(IPTC-1)+22) = 0.D0
      ENDIF
C
      CALL JEDEMA()
C
      END
