      SUBROUTINE MMREDO(NUMEDD,DEFICO,RESOCO)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*24 DEFICO,RESOCO
      CHARACTER*24 NUMEDD
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - APPARIEMENT)
C
C GESTION AUTOMATIQUE DES RELATIONS REDONDANTES
C
C ----------------------------------------------------------------------
C
C
C IN  NUMEDD : NOM DU NUME_DDL
C IN  DEFICO : SD POUR LA DEFINITION DE CONTACT
C IN  RESOCO : SD DE TRAITEMENT NUMERIQUE DU CONTACT
C
C
C
C
      INTEGER      IFM,NIV
      INTEGER      IZONE
      INTEGER      CFDISI,NZOCO
      LOGICAL      MMINFL,LPIVOT,LDETEC
      CHARACTER*8  K8BID
      INTEGER      NEQ,IRET
      CHARACTER*24 VECNOD,VECNOX,VECNOY,VECNOZ
      INTEGER      JVECNO,JVECNX,JVECNY,JVECNZ
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('CONTACT',IFM,NIV)
C
C --- INITIALISATIONS
C
      LDETEC = .FALSE.
      NZOCO  = CFDISI(DEFICO,'NZOCO')
      CALL DISMOI('F','NB_EQUA',NUMEDD,'NUME_DDL',NEQ,K8BID,IRET)
C
C --- GESTION AUTOMATIQUE DES RELATIONS REDONDANTES
C
      DO 11 IZONE = 1,NZOCO
        LPIVOT = MMINFL(DEFICO,'EXCLUSION_PIV_NUL',IZONE )
        IF (LPIVOT) THEN
          LDETEC = .TRUE.
        ENDIF
   11 CONTINUE
      IF (LDETEC) THEN
C
C --- CREATION DES STRUCTURES DE DONNEES POUR LA
C --- GESTION AUTOMATIQUE DES RELATIONS REDONDANTES
C
        VECNOD = RESOCO(1:14)//'.VECNOD'
        VECNOX = RESOCO(1:14)//'.VECNOX'
        VECNOY = RESOCO(1:14)//'.VECNOY'
        VECNOZ = RESOCO(1:14)//'.VECNOZ'
        CALL WKVECT(VECNOD,'V V I',NEQ,JVECNO)
        CALL WKVECT(VECNOX,'V V I',NEQ,JVECNX)
        CALL WKVECT(VECNOY,'V V I',NEQ,JVECNY)
        CALL WKVECT(VECNOZ,'V V I',NEQ,JVECNZ)
        CALL REDNEX(NUMEDD,NEQ   ,RESOCO)
        IF (NIV.GE.2) THEN
          WRITE (IFM,*) '<CONTACT> ...... REPERAGE AUTOMATIQUE DES '//
     &                  'RELATIONS REDONDANTES'
        ENDIF
      ENDIF
C
      CALL JEDEMA()
      END
