      SUBROUTINE NDMAPP(SDDYNA,VALINC)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*19 VALINC(*)
      CHARACTER*19 SDDYNA    
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C MISE A JOUR DES CHAMPS MULTI-APPUI
C      
C ----------------------------------------------------------------------
C
C
C IN  SDDYNA : SD DYNAMIQUE
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C
C
C
C
      LOGICAL      NDYNLO,LMUAP
      CHARACTER*19 DEPPLU,VITPLU,ACCPLU    
      CHARACTER*19 DEPENT,VITENT,ACCENT
      INTEGER      JDEPEN,JVITEN,JACCEN
      CHARACTER*19 DEPABS,VITABS,ACCABS
      INTEGER      JDEPAB,JVITAB,JACCAB
      INTEGER      JDEPP,JVITP,JACCP
      INTEGER      NEQ,IE
      CHARACTER*8  K8BID
C      
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- FONCTIONNALITES ACTIVEES
C
      LMUAP  = NDYNLO(SDDYNA,'MULTI_APPUI')
C
C --- DECOMPACTION DES VARIABLES CHAPEAUX
C     
      CALL NMCHEX(VALINC,'VALINC','DEPPLU',DEPPLU)
      CALL NMCHEX(VALINC,'VALINC','VITPLU',VITPLU)
      CALL NMCHEX(VALINC,'VALINC','ACCPLU',ACCPLU) 
C
C --- CALCUL DES DEPL/VITE/ACCE ABSOLU EN MULTI-APPUIS
C
      IF (LMUAP) THEN
        CALL NDYNKK(SDDYNA,'DEPENT',DEPENT)
        CALL NDYNKK(SDDYNA,'VITENT',VITENT)
        CALL NDYNKK(SDDYNA,'ACCENT',ACCENT)
        CALL NDYNKK(SDDYNA,'DEPABS',DEPABS)
        CALL NDYNKK(SDDYNA,'VITABS',VITABS)
        CALL NDYNKK(SDDYNA,'ACCABS',ACCABS)
        CALL JEVEUO(DEPENT(1:19)//'.VALE','L',JDEPEN)
        CALL JEVEUO(VITENT(1:19)//'.VALE','L',JVITEN)
        CALL JEVEUO(ACCENT(1:19)//'.VALE','L',JACCEN)
        CALL JEVEUO(DEPPLU(1:19)//'.VALE','L',JDEPP )
        CALL JEVEUO(VITPLU(1:19)//'.VALE','L',JVITP )
        CALL JEVEUO(ACCPLU(1:19)//'.VALE','L',JACCP )     
        CALL JEVEUO(DEPABS(1:19)//'.VALE','E',JDEPAB)
        CALL JEVEUO(VITABS(1:19)//'.VALE','E',JVITAB)
        CALL JEVEUO(ACCABS(1:19)//'.VALE','E',JACCAB)
        CALL JELIRA(DEPENT(1:19)//'.VALE','LONMAX',NEQ,K8BID)         
        DO 20 IE = 1,NEQ
          ZR(JDEPAB+IE-1) = ZR(JDEPEN+IE-1) + ZR(JDEPP+IE-1)
          ZR(JVITAB+IE-1) = ZR(JVITEN+IE-1) + ZR(JVITP+IE-1)
          ZR(JACCAB+IE-1) = ZR(JACCEN+IE-1) + ZR(JACCP+IE-1)
   20   CONTINUE
      ENDIF       
C
      CALL JEDEMA()      
C
      END
