      SUBROUTINE NDXCVG(SDDISC,SDERRO,VALINC)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 02/10/2012   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*19 SDDISC,VALINC(*)
      CHARACTER*24 SDERRO
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C VERIFICATION DES CRITERES D'ARRET - CAS EXPLICITE
C
C ----------------------------------------------------------------------
C
C
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  SDERRO : GESTION DES ERREURS
C IN  VALINC : VARIABLE CHAPEAU INCREMENTS DES VARIABLES
C
C
C
C
      INTEGER      IFM,NIV
      INTEGER      IEVDAC,NUMINS
      CHARACTER*24 K24BLA
      LOGICAL      LERRNE,LERRST
      LOGICAL      LSVIMX,LDVRES,LINSTA,LCRITL,CONVER
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('MECA_NON_LINE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<MECANONLINE> EVALUATION DE LA CONVERGENCE'
      ENDIF
C
C --- PAR DEFINITION LES RESIDUS ET NEWTON SONT TOUJOURS CONVERGES
C
      CALL NMECEB(SDERRO,'RESI','CONV')
      CALL NMECEB(SDERRO,'NEWT','CONV')
C
C --- INITIALISATIONS
C
      K24BLA = ' '
      LSVIMX = .FALSE.
      LDVRES = .FALSE.
      LINSTA = .FALSE.
      LCRITL = .FALSE.
      CONVER = .TRUE.
      NUMINS = -1
      CALL NMLTEV(SDERRO,'ERRI','NEWT',LERRNE)
      CALL NMLTEV(SDERRO,'ERRI','CALC',LERRST)
C
C --- ERREUR FATALE
C
      IF (LERRST) THEN
        CALL NMECEB(SDERRO,'NEWT','STOP')
      ENDIF
C
C --- ERREUR NON FATALE
C
      IF (LERRNE) THEN
        CALL NMECEB(SDERRO,'NEWT','ERRE')
      ENDIF
C
C --- VERIFICATION DU DECLENCHEMENT DES EVENT-DRIVEN
C
      CALL NMEVEL(SDDISC,NUMINS,K24BLA,K24BLA,VALINC,
     &            'NEWT',LSVIMX,LDVRES,LINSTA,LCRITL,
     &            LERRNE,CONVER)
C
C --- UN EVENEMENT SE DECLENCHE
C
      CALL NMACTO(SDDISC,IEVDAC)
      IF (IEVDAC.GT.0) CALL NMECEB(SDERRO,'NEWT','EVEN')
C
      CALL JEDEMA()
      END
