      SUBROUTINE NDXDEP(NUMEDD,FONACT,NUMINS,SDDISC,SDDYNA,
     &                  SDNUME,VALINC,SOLALG,VEASSE)
C     
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      INTEGER      FONACT(*)
      INTEGER      NUMINS
      CHARACTER*19 SDDISC,SDNUME,SDDYNA
      CHARACTER*24 NUMEDD
      CHARACTER*19 VEASSE(*)
      CHARACTER*19 SOLALG(*),VALINC(*)
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C CALCUL DE L'INCREMENT DE DEPLACEMENT A PARTIR DE(S) DIRECTION(S) 
C DE DESCENTE
C
C CAS EXPLICITE
C      
C ----------------------------------------------------------------------
C
C
C IN  NUMEDD : NUME_DDL
C IN  FONACT : FONCTIONNALITES ACTIVEES
C IN  NUMINS : NUMERO D'INSTANT
C IN  SDNUME : SD NUMEROTATION
C IN  SDDISC : SD DISCRETISATION
C IN  SDDYNA : SD DYNAMIQUE
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C IN  SOLALG : VARIABLE CHAPEAU POUR INCREMENTS SOLUTIONS
C IN  VEASSE : VARIABLE CHAPEAU POUR NOM DES VECT_ASSE
C
C
C
C 
      REAL*8       DIINST,INSTAM,INSTAP,DELTAT
      CHARACTER*19 CNFEXT
      CHARACTER*19 DDEPLA,DEPPR1
      CHARACTER*19 DVITLA,VITPR1
      CHARACTER*19 DACCLA,ACCPR1
      INTEGER      IFM,NIV
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('MECA_NON_LINE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<MECANONLINE> CORRECTION INCR. DEPL.' 
      ENDIF 
C
C --- DECOMPACTION VARIABLES CHAPEAUX
C       
      CALL NMCHEX(SOLALG,'SOLALG','DDEPLA',DDEPLA)
      CALL NMCHEX(SOLALG,'SOLALG','DEPPR1',DEPPR1)
      CALL NMCHEX(SOLALG,'SOLALG','DVITLA',DVITLA)
      CALL NMCHEX(SOLALG,'SOLALG','VITPR1',VITPR1)
      CALL NMCHEX(SOLALG,'SOLALG','DACCLA',DACCLA)
      CALL NMCHEX(SOLALG,'SOLALG','ACCPR1',ACCPR1)
C
C --- INITIALISATIONS
C
      INSTAM = DIINST(SDDISC,NUMINS-1)
      INSTAP = DIINST(SDDISC,NUMINS)
      DELTAT = INSTAP - INSTAM                      
C
C --- CALCUL DE LA RESULTANTE DES EFFORTS EXTERIEURS
C
      CALL NMCHEX(VEASSE,'VEASSE','CNFEXT',CNFEXT)
      CALL NMFEXT(0.D0  ,FONACT,SDDYNA,VEASSE,CNFEXT)
C     
C --- CONVERSION RESULTAT dU VENANT DE K.dU = F SUIVANT SCHEMAS 
C    
      CALL NMSOLU(SDDYNA,SOLALG)
C
C --- AJUSTEMENT DE LA DIRECTION DE DESCENTE (AVEC ETA, RHO ET OFFSET)
C
      CALL COPISD('CHAMP_GD','V',DEPPR1,DDEPLA)
      CALL COPISD('CHAMP_GD','V',VITPR1,DVITLA)
      CALL COPISD('CHAMP_GD','V',ACCPR1,DACCLA)
C 
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<MECANONLINE> ... DEPL. PRED. (1) : '        
        CALL NMDEBG('VECT',DEPPR1,IFM   )       
        WRITE (IFM,*) '<MECANONLINE> ... DEPL. SOLU.     : '        
        CALL NMDEBG('VECT',DDEPLA,IFM   )
        WRITE (IFM,*) '<MECANONLINE> ... VITE. PRED. (1) : '        
        CALL NMDEBG('VECT',VITPR1,IFM   )        
        WRITE (IFM,*) '<MECANONLINE> ... VITE. SOLU.     : '        
        CALL NMDEBG('VECT',DVITLA,IFM   )        
        WRITE (IFM,*) '<MECANONLINE> ... ACCE. PRED. (1) : '        
        CALL NMDEBG('VECT',ACCPR1,IFM   )        
        WRITE (IFM,*) '<MECANONLINE> ... ACCE. SOLU.     : '        
        CALL NMDEBG('VECT',DACCLA,IFM   )
      ENDIF 
C
C --- ACTUALISATION DES CHAMPS SOLUTIONS
C
      CALL NMMAJC(FONACT,SDDYNA,SDNUME,DELTAT,NUMEDD,
     &            VALINC,SOLALG)
C      
      CALL JEDEMA()
      END
