      SUBROUTINE NDXPRE(MODELE,NUMEDD,NUMFIX,MATE  ,CARELE,
     &                  COMREF,COMPOR,LISCHA,METHOD,SOLVEU,
     &                  FONACT,CARCRI,SDDISC,SDSTAT,SDTIME,
     &                  NUMINS,VALINC,SOLALG,MATASS,MAPREC,
     &                  SDDYNA,SDERRO,MEELEM,MEASSE,VEELEM,
     &                  VEASSE,LERRIT)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 02/10/2012   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C TOLE CRP_21
C
      IMPLICIT NONE
      INTEGER      FONACT(*)
      INTEGER      NUMINS
      CHARACTER*16 METHOD(*)
      CHARACTER*19 MATASS,MAPREC
      CHARACTER*24 SDTIME,SDSTAT
      CHARACTER*19 LISCHA,SOLVEU,SDDISC,SDDYNA
      CHARACTER*24 MODELE,MATE  ,CARELE,COMREF,COMPOR
      CHARACTER*24 NUMEDD,NUMFIX
      CHARACTER*24 CARCRI
      CHARACTER*24 SDERRO
      CHARACTER*19 MEELEM(*),VEELEM(*)
      CHARACTER*19 MEASSE(*),VEASSE(*)
      CHARACTER*19 SOLALG(*),VALINC(*)
      LOGICAL      LERRIT
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C PHASE DE PREDICTION - CAS EXPLICITE
C
C ----------------------------------------------------------------------
C
C
C IN  MODELE : MODELE
C IN  NUMEDD : NUME_DDL (VARIABLE AU COURS DU CALCUL)
C IN  NUMFIX : NUME_DDL (FIXE AU COURS DU CALCUL)
C IN  MATE   : CHAMP MATERIAU
C IN  CARELE : CARACTERISTIQUES DES ELEMENTS DE STRUCTURE
C IN  COMREF : VARIABLES DE COMMANDE DE REFERENCE
C IN  COMPOR : COMPORTEMENT
C IN  METHOD : INFORMATIONS SUR LES METHODES DE RESOLUTION
C IN  SOLVEU : SOLVEUR
C IN  FONACT : FONCTIONNALITES ACTIVEES (VOIR NMFONC)
C IN  LISCHA : SD LISTE DES CHARGES
C IN  CARCRI : CARTE DES CRITERES DE CONVERGENCE LOCAUX
C IN  SDSTAT : SD STATISTIQUES
C IN  SDDISC : SD DISCRETISATION
C IN  SDTIME : SD TIMER
C IN  SDSTAT : SD STATISTIQUES
C IN  NUMINS : NUMERO D'INSTANT
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C IN  SOLALG : VARIABLE CHAPEAU POUR INCREMENTS SOLUTIONS
C IN  MEELEM : VARIABLE CHAPEAU POUR NOM DES MATR_ELEM
C IN  MEASSE : VARIABLE CHAPEAU POUR NOM DES MATR_ASSE
C IN  VEELEM : VARIABLE CHAPEAU POUR NOM DES VECT_ELEM
C IN  VEASSE : VARIABLE CHAPEAU POUR NOM DES VECT_ASSE
C IN  SDDYNA : SD DYNAMIQUE
C IN  MATASS : NOM DE LA MATRICE DU PREMIER MEMBRE ASSEMBLEE
C IN  MAPREC : NOM DE LA MATRICE DE PRECONDITIONNEMENT (GCPC)
C OUT MATASS : MATRICE DE RESOLUTION ASSEMBLEE
C OUT MAPREC : MATRICE DE RESOLUTION ASSEMBLEE - PRECONDITIONNEMENT
C OUT LERRIT  : .TRUE. SI ERREUR PENDANT PREDICTION
C
C ----------------------------------------------------------------------
C
      REAL*8       INSTAP,DIINST
      CHARACTER*19 CNCINE,CNDONN,CNZERO
      CHARACTER*24 K24BLA,CODERE
      INTEGER      LDCCVG,FACCVG,RESCVG
      REAL*8       R8BID
      INTEGER      IFM,NIV
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('MECA_NON_LINE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<MECANONLINE> CALCUL DE PREDICTION'
      ENDIF
C
C --- INITIALISATIONS
C
      INSTAP = DIINST(SDDISC,NUMINS)
      K24BLA = ' '
      CNDONN = '&&CNCHAR.DONN'
      CNZERO = '&&CNPART.ZERO'
      CALL VTZERO(CNDONN)
C
C --- INITIALISATION CODES RETOURS
C
      CODERE = '&&NDXPRE.CODERE'
      FACCVG = -1
      RESCVG = -1
      LDCCVG = -1
C
C --- DECOMPACTION DES VARIABLES CHAPEAUX
C
      CALL NMCHEX(VEASSE,'VEASSE','CNCINE',CNCINE)
C
C --- CALCUL DE LA MATRICE GLOBALE
C
      CALL NDXPRM(MODELE,MATE  ,CARELE,COMPOR,CARCRI,
     &            METHOD,LISCHA,NUMEDD,NUMFIX,SOLVEU,
     &            COMREF,SDDISC,SDDYNA,SDSTAT,SDTIME,
     &            NUMINS,FONACT,VALINC,SOLALG,VEELEM,
     &            MEELEM,MEASSE,MAPREC,MATASS,CODERE,
     &            FACCVG,LDCCVG)
C
C --- ERREUR SANS POSSIBILITE DE CONTINUER
C
      IF ((FACCVG.EQ.1).OR.(FACCVG.EQ.2)) GOTO 9999
      IF (LDCCVG.EQ.1) GOTO 9999
C
C --- CALCUL DES CHARGEMENTS VARIABLES AU COURS DU PAS DE TEMPS
C
      CALL NMCHAR('VARI','PREDICTION'   ,
     &            MODELE,NUMEDD,MATE  ,CARELE,COMPOR,
     &            LISCHA,CARCRI,NUMINS,SDTIME,SDDISC,
     &            R8BID ,FONACT,K24BLA,K24BLA,COMREF,
     &            VALINC,SOLALG,VEELEM,MEASSE,VEASSE,
     &            SDDYNA)
C
C --- CALCUL DU SECOND MEMBRE
C
      CALL NMASSX(MODELE,NUMEDD,MATE  ,CARELE,COMREF,
     &            COMPOR,LISCHA,CARCRI,FONACT,SDSTAT,
     &            SDDYNA,VALINC,SOLALG,VEELEM,VEASSE,
     &            SDTIME,LDCCVG,CODERE,CNDONN)
C
C --- ERREUR SANS POSSIBILITE DE CONTINUER
C
      IF (LDCCVG.EQ.1) GOTO 9999
C
C --- RESOLUTION
C
      CALL NMRESD(FONACT,SDDYNA,SDSTAT,SDTIME,SOLVEU,
     &            NUMEDD,INSTAP,MAPREC,MATASS,CNDONN,
     &            CNZERO,CNCINE,SOLALG,RESCVG)
C
 9999 CONTINUE
C
C --- TRANSFORMATION DES CODES RETOURS EN EVENEMENTS
C
      CALL NMCRET(SDERRO,'LDC',LDCCVG)
      CALL NMCRET(SDERRO,'FAC',FACCVG)
      CALL NMCRET(SDERRO,'RES',RESCVG)
C
C --- EVENEMENT ERREUR ACTIVE ?
C
      CALL NMLTEV(SDERRO,'ERRI','NEWT',LERRIT)
C
      CALL JEDEMA()
      END
