      SUBROUTINE NMAFFI(FONACT,SDCONV,SDIMPR,SDERRO,SDDISC,
     &                  NOMBCL)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 22/10/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE      'jeveux.h'
      CHARACTER*4  NOMBCL
      CHARACTER*24 SDIMPR,SDERRO,SDCONV
      CHARACTER*19 SDDISC
      INTEGER      FONACT(*)
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C AFFICHAGES PENDANT UNE BOUCLE
C
C ----------------------------------------------------------------------
C
C
C IN  FONACT : FONCTIONNALITES ACTIVEES (VOIR NMFONC)
C IN  SDIMPR : SD AFFICHAGE
C IN  SDERRO : GESTION DES ERREURS
C IN  NOMBCL : NOM DE LA BOUCLE
C               'NEWT' - BOUCLE DE NEWTON
C               'FIXE' - BOUCLE DE POINT FIXE
C               'INST' - BOUCLE SUR LES PAS DE TEMPS
C
C ----------------------------------------------------------------------
C
      LOGICAL      LERREI
      LOGICAL      CVNEWT,CVINST
      LOGICAL      LTABL,MAXREL,MAXNOD
      LOGICAL      ISFONC,LBOUCL,LEXPL
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      LTABL  = .FALSE.
C
C --- FONCTIONNALITES ACTIVEES
C
      LBOUCL = ISFONC(FONACT,'BOUCLE_EXTERNE')
      LEXPL  = ISFONC(FONACT,'EXPLICITE')
C
C --- CONVERGENCES
C
      CALL NMLECV(SDERRO,'NEWT',CVNEWT)
      CALL NMLECV(SDERRO,'INST',CVINST)
      CALL NMERGE(SDERRO,'RESI_MAXR',MAXREL)
      CALL NMERGE(SDERRO,'RESI_MAXN',MAXNOD)
C
C --- AFFICHAGES DES MARQUES DANS LES COLONNES
C
      CALL NMAFFM(SDERRO,SDIMPR,NOMBCL)
C
C --- EVENEMENTS DE TYPE ERREURS
C
      CALL NMLTEV(SDERRO,'ERRI',NOMBCL,LERREI)
C
C --- DOIT-ON IMPRIMER LA LIGNE DU TABLEAU ?
C
      IF (NOMBCL.EQ.'NEWT') THEN
        IF (CVNEWT) THEN
          IF (LBOUCL) THEN
            LTABL = .FALSE.
          ELSE
            LTABL = .TRUE.
          ENDIF
        ELSE
          LTABL = .TRUE.
        ENDIF  
      ELSEIF (NOMBCL.EQ.'FIXE') THEN
        IF (LBOUCL)      LTABL = .TRUE.
        IF (.NOT.CVNEWT) LTABL = .FALSE.
      ELSEIF (NOMBCL.EQ.'INST') THEN
        LTABL = .FALSE.
      ENDIF
C
C --- AFFICHAGE LIGNE DU TABLEAU DE CONVERGENCE
C
      IF (LTABL) CALL NMIMPR(SDIMPR)
C
C --- AFFICHAGE LIGNE DE CONVERGENCE
C
      IF (LTABL) THEN
        IF (CVNEWT.AND..NOT.(LERREI)) THEN
          CALL NMIMPX(SDIMPR)
        ENDIF
      ENDIF
C
C --- AFFICHAGE DE L'ERREUR
C
      IF (LERREI) THEN
        CALL NMIMPX(SDIMPR)
        CALL NMERIM(SDERRO)
      ENDIF
C
C --- AFFICHAGE DE L'EVENEMENT
C
      CALL NMEVIM(SDIMPR,SDDISC,SDERRO,NOMBCL)
C
C --- AFFICHAGE RECAP CONVERGENCE
C
      IF (CVINST.AND..NOT.LEXPL) THEN
        CALL U2MESS('I','MECANONLINE6_60')
        IF (MAXNOD) THEN
          CALL U2MESS('I','MECANONLINE6_61')
        ENDIF
        IF (MAXREL) THEN
          CALL U2MESS('I','MECANONLINE6_62')
        ENDIF
        CALL NMIMPS(SDCONV)
      ENDIF
C
      CALL JEDEMA()
      END
