      SUBROUTINE NMAFFM(SDERRO,SDIMPR,NOMBCL)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 02/10/2012   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE      'jeveux.h'
      CHARACTER*4  NOMBCL
      CHARACTER*24 SDIMPR,SDERRO
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C AFFICHAGE DES MARQUES DANS LES COLONNES
C
C ----------------------------------------------------------------------
C
C
C IN  SDERRO : SD GESTION DES ERREURS
C IN  SDIMPR : SD AFFICHAGE
C IN  NOMBCL : NOM DE LA BOUCLE
C               'RESI' - BOUCLE SUR LES RESIDUS D'EQUILIBRE
C               'NEWT' - BOUCLE DE NEWTON
C               'FIXE' - BOUCLE DE POINT FIXE
C               'INST' - BOUCLE SUR LES PAS DE TEMPS
C               'CALC' - CALCUL
C
C ----------------------------------------------------------------------
C
      LOGICAL      DVRELA,DVMAXI,DVREFE,DVCOMP
      LOGICAL      DVPFIX,DVFIXC,DVFIXF,DVFIXG,DVFROT,DVCONT,DVGEOM
      LOGICAL      DVDEBO,CVPILO
      LOGICAL      CVNEWT,LERRNE
      LOGICAL      ERCTCG,ERCTCF,ERCTCC
      CHARACTER*16 DEBORS
      CHARACTER*24 SDTABC,SLCOLO,LISNOM
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- EVENEMENTS
C
      DEBORS = ' DE BORST...    '
      CALL NMERGE(SDERRO,'DIVE_CTCC',DVCONT)
      CALL NMERGE(SDERRO,'DIVE_DEBO',DVDEBO)
      CALL NMERGE(SDERRO,'DIVE_RELA',DVRELA)
      CALL NMERGE(SDERRO,'DIVE_MAXI',DVMAXI)
      CALL NMERGE(SDERRO,'DIVE_REFE',DVREFE)
      CALL NMERGE(SDERRO,'DIVE_COMP',DVCOMP)
      CALL NMERGE(SDERRO,'DIVE_FROT',DVFROT)
      CALL NMERGE(SDERRO,'DIVE_GEOM',DVGEOM)
      CALL NMERGE(SDERRO,'DIVE_PFIX',DVPFIX)
      CALL NMERGE(SDERRO,'DIVE_FIXG',DVFIXG)
      CALL NMERGE(SDERRO,'DIVE_FIXF',DVFIXF)
      CALL NMERGE(SDERRO,'DIVE_FIXC',DVFIXC)
      CALL NMERGE(SDERRO,'CONV_PILO',CVPILO)
      CALL NMLECV(SDERRO,'NEWT',CVNEWT)
      CALL NMLTEV(SDERRO,'ERRI','NEWT',LERRNE)
      CALL NMERGE(SDERRO,'ERRE_CTCG',ERCTCG)
      CALL NMERGE(SDERRO,'ERRE_CTCF',ERCTCF)
      CALL NMERGE(SDERRO,'ERRE_CTCC',ERCTCC)
C
C --- RECUPERATION DU TABLEAU DE CONVERGENCE
C
      CALL OBGETO(SDIMPR,'TABLEAU_CONV',SDTABC)
C
C --- ACCES REPERTOIRE DE NOMS
C
      CALL OBGETO(SDTABC,'COLONNES_DISPOS',SLCOLO)
      CALL OBGETO(SLCOLO,'NOM_STRUCTS',LISNOM)
C
C --- MISE A JOUR DES MARQUES DANS LES COLONNES
C
      IF (NOMBCL.EQ.'NEWT') THEN
        CALL OBTSDM(LISNOM,'RESI_RELA',' ')
        CALL OBTSDM(LISNOM,'RESI_MAXI',' ')
        CALL OBTSDM(LISNOM,'RESI_REFE',' ')
        CALL OBTSDM(LISNOM,'RESI_COMP',' ')
        IF (DVRELA) CALL OBTSDM(LISNOM,'RESI_RELA','X')
        IF (DVMAXI) CALL OBTSDM(LISNOM,'RESI_MAXI','X')
        IF (DVREFE) CALL OBTSDM(LISNOM,'RESI_REFE','X')
        IF (DVCOMP) CALL OBTSDM(LISNOM,'RESI_COMP','X')
        CALL OBTSDM(LISNOM,'GEOM_NEWT',' ')
        CALL OBTSDM(LISNOM,'FROT_NEWT',' ')
        CALL OBTSDM(LISNOM,'CONT_NEWT',' ')
        CALL OBTSDM(LISNOM,'PILO_COEF',' ')
        CALL OBTSDM(LISNOM,'CTCD_NBIT',' ')
        IF (DVGEOM) CALL OBTSDM(LISNOM,'GEOM_NEWT','X')
        IF (DVFROT) CALL OBTSDM(LISNOM,'FROT_NEWT','X')
        IF (DVCONT) CALL OBTSDM(LISNOM,'CONT_NEWT','X')
        IF (CVPILO) CALL OBTSDM(LISNOM,'PILO_COEF','B')
        IF (DVPFIX) CALL OBTSDM(LISNOM,'CTCD_NBIT','X')
        CALL OBTSDM(LISNOM,'ITER_NUME','X')
        IF (CVNEWT) CALL OBTSDM(LISNOM,'ITER_NUME',' ')
        IF (LERRNE) CALL OBTSDM(LISNOM,'ITER_NUME','E')
        CALL OBTSDM(LISNOM,'BOUC_GEOM','X')
        CALL OBTSDM(LISNOM,'BOUC_FROT','X')
        CALL OBTSDM(LISNOM,'BOUC_CONT','X')
        IF (DVDEBO) CALL NMIMCK(SDIMPR,'DEBORST  ',DEBORS,.TRUE.)
      ELSEIF (NOMBCL.EQ.'FIXE') THEN
        CALL OBTSDM(LISNOM,'BOUC_GEOM','X')
        CALL OBTSDM(LISNOM,'BOUC_FROT','X')
        CALL OBTSDM(LISNOM,'BOUC_CONT','X')
        IF (.NOT.DVFIXG) THEN
          CALL OBTSDM(LISNOM,'BOUC_GEOM',' ')
        ENDIF
        IF (.NOT.DVFIXF) THEN
          CALL OBTSDM(LISNOM,'BOUC_FROT',' ')
        ENDIF
        IF (.NOT.DVFIXC) THEN
          CALL OBTSDM(LISNOM,'BOUC_CONT',' ')
        ENDIF
        IF (DVFIXC) THEN
          CALL OBTSDM(LISNOM,'BOUC_GEOM','X')
          CALL OBTSDM(LISNOM,'BOUC_FROT','X')
        ENDIF
        IF (DVFIXF) THEN
          CALL OBTSDM(LISNOM,'BOUC_GEOM','X')
        ENDIF
        IF (ERCTCG) CALL OBTSDM(LISNOM,'BOUC_GEOM','E')
        IF (ERCTCF) CALL OBTSDM(LISNOM,'BOUC_FROT','E')
        IF (ERCTCC) CALL OBTSDM(LISNOM,'BOUC_CONT','E')
      ENDIF
C
      CALL JEDEMA()
      END
