      SUBROUTINE NMASDI(FONACT,VEASSE,CNDFDO,CNDFPI)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*19 CNDFDO,CNDFPI
      CHARACTER*19 VEASSE(*)
      INTEGER      FONACT(*)
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C CALCUL DES COMPOSANTES DU VECTEUR SECOND MEMBRE
C  - CHARGEMENT DE TYPE DIRICHLET
C  - CHARGEMENT FIXE AU COURS DU PAS DE TEMPS
C  - CHARGEMENT DONNE ET PILOTE
C      
C ----------------------------------------------------------------------
C
C
C IN  FONACT : FONCTIONNALITES ACTIVEES (VOIR NMFONC)
C IN  VEASSE : VARIABLE CHAPEAU POUR NOM DES VECT_ASSE  
C OUT CNDFDO : VECT_ASSE DE TOUS LES DEPLACEMENTS FIXES DONNES
C OUT CNDFPI : VECT_ASSE DE TOUS LES DEPLACEMENTS FIXES PILOTES
C
C
C
C

      INTEGER      IFM,NIV   
      INTEGER      IFDO
      INTEGER      N
      CHARACTER*19 CNDONN(20)
      REAL*8       CODONN(20)
      CHARACTER*19 CNDIDO,CNDIPI
      CHARACTER*19 CNCINE,CNDIDI
      LOGICAL      ISFONC,LDIDI,LPILO
C 
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('MECA_NON_LINE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<MECANONLINE> ...... CALCUL DIRICHLET CONSTANT' 
      ENDIF
C
C --- FONCTIONNALITES ACTIVEES
C     
      LPILO  = ISFONC(FONACT,'PILOTAGE')
      LDIDI  = ISFONC(FONACT,'DIDI')    
C
C --- INITIALISATIONS
C
      IFDO   = 0       
      CALL VTZERO(CNDFDO)
      CALL VTZERO(CNDFPI)         
C
C --- DEPLACEMENTS DONNES (Y COMPRIS DIDI SI NECESSAIRE)
C
      CALL NMCHEX(VEASSE,'VEASSE','CNDIDO',CNDIDO)    
      IFDO         = IFDO+1 
      CNDONN(IFDO) = CNDIDO
      CODONN(IFDO) = 1.D0

      IF (LDIDI) THEN
        CALL NMCHEX(VEASSE,'VEASSE','CNDIDI',CNDIDI)
        IFDO         = IFDO+1 
        CNDONN(IFDO) = CNDIDI
        CODONN(IFDO) = 1.D0
      ENDIF   
C      
C --- CONDITIONS CINEMATIQUES IMPOSEES           
C   
      CALL NMCHEX(VEASSE,'VEASSE','CNCINE',CNCINE) 
      IFDO         = IFDO+1 
      CNDONN(IFDO) = CNCINE
      CODONN(IFDO) = 1.D0        
C
C --- VECTEUR RESULTANT DEPLACEMENTS DONN2S
C       
      DO 17 N = 1,IFDO
        CALL VTAXPY(CODONN(N),CNDONN(N),CNDFDO)  
        IF (NIV.GE.2) THEN
          WRITE (IFM,*) '<MECANONLINE> ......... DEPL. DONNES' 
          WRITE (IFM,*) '<MECANONLINE> .........  ',N,' - COEF: ',
     &                   CODONN(N)
          CALL NMDEBG('VECT',CNDONN(N),IFM)
        ENDIF         
 17   CONTINUE 
C
C --- VECTEUR RESULTANT DEPLACEMENTS PILOTES
C
      IF (LPILO) THEN       
        CALL NMCHEX(VEASSE,'VEASSE','CNDIPI',CNDIPI) 
        CNDFPI       = CNDIPI     
        IF (NIV.GE.2) THEN
          WRITE (IFM,*) '<MECANONLINE> ......... DEPL. PILOTES' 
          WRITE (IFM,*) '<MECANONLINE> .........  ',1,' - COEF: ',
     &                   1.D0
          CALL NMDEBG('VECT',CNDFPI,IFM)
        ENDIF           
        
      ENDIF         
C
      CALL JEDEMA()
      END
