      SUBROUTINE NMASVA(SDDYNA,VEASSE,CNVADO)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*19 CNVADO
      CHARACTER*19 VEASSE(*)
      CHARACTER*19 SDDYNA
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C CALCUL DES COMPOSANTES DU VECTEUR SECOND MEMBRE
C  - CHARGEMENT DE TYPE NEUMANN
C  - CHARGEMENT VARIABLE AU COURS DU PAS DE TEMPS
C  - CHARGEMENT DONNE 
C      
C ----------------------------------------------------------------------
C
C
C IN  SDDYNA : SD DYNAMIQUE 
C IN  VEASSE : VARIABLE CHAPEAU POUR NOM DES VECT_ASSE  
C OUT CNVADO : VECT_ASSE DE TOUS LES CHARGEMENTS VARIABLES DONNES
C
C
C
C
      INTEGER      IFM,NIV   
      INTEGER      IFDO,N
      CHARACTER*19 CNVARI(20)
      REAL*8       COVARI(20)
      REAL*8       COEEXT,COEEX2,COEINT
      REAL*8       NDYNRE
      CHARACTER*19 CNFSDO,CNFINT
      LOGICAL      NDYNLO,LDYNA,LMPAS
C 
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('MECA_NON_LINE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<MECANONLINE> ...... CALCUL NEUMANN VARIABLE' 
      ENDIF
C
C --- FONCTIONNALITES ACTIVEES
C     
      LDYNA  = NDYNLO(SDDYNA,'DYNAMIQUE')
      LMPAS  = NDYNLO(SDDYNA,'MULTI_PAS')
C
C --- INITIALISATIONS
C
      IFDO   = 0    
      CALL VTZERO(CNVADO)
C
C --- COEFFICIENTS POUR MULTI-PAS
C 
      IF (LDYNA) THEN  
        COEEXT = NDYNRE(SDDYNA,'COEF_MPAS_FEXT_PREC')   
        COEEX2 = NDYNRE(SDDYNA,'COEF_MPAS_FEXT_COUR')
        COEINT = NDYNRE(SDDYNA,'COEF_MPAS_FINT_PREC')           
      ELSE
        COEEXT = 1.D0
        COEEX2 = 1.D0         
        COEINT = 1.D0      
      ENDIF                
C
C --- CALCUL DES FORCES EXTERIEURES VARIABLES
C
      CALL NMCHEX(VEASSE,'VEASSE','CNFSDO',CNFSDO) 
      IFDO         = IFDO+1 
      CNVARI(IFDO) = CNFSDO
      COVARI(IFDO) = COEEX2 
C
C --- AJOUT FORCES EXTERIEURES VARIABLES PAS PRECEDENT
C      
      IF (LMPAS) THEN
        CALL NDYNKK(SDDYNA,'OLDP_CNFSDO',CNFSDO)
        IFDO         = IFDO+1 
        CNVARI(IFDO) = CNFSDO
        COVARI(IFDO) = COEEXT        
      ENDIF         
C
C --- AJOUT FORCES INTERNES PAS PRECEDENT
C      
      IF (LMPAS) THEN
        CALL NDYNKK(SDDYNA,'OLDP_CNFINT',CNFINT)
        IFDO         = IFDO+1 
        CNVARI(IFDO) = CNFINT
        COVARI(IFDO) = -1.D0*COEINT 
      ENDIF  
C        
C --- VECTEUR RESULTANT CHARGEMENT DONNE
C       
      DO 10 N = 1,IFDO
        CALL VTAXPY(COVARI(N),CNVARI(N),CNVADO)
        IF (NIV.GE.2) THEN
          WRITE (IFM,*) '<MECANONLINE> ......... FORC. DONNEES' 
          WRITE (IFM,*) '<MECANONLINE> .........  ',N,' - COEF: ',
     &                   COVARI(N)
          CALL NMDEBG('VECT',CNVARI(N),IFM)
        ENDIF           
 10   CONTINUE       
C
      CALL JEDEMA()
      END
