      SUBROUTINE NMBUDI(MODELE,NUMEDD,LISCHA,VECLAG,VEBUDI,
     &                  CNBUDI,MATASS)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE     
      INCLUDE 'jeveux.h'
      CHARACTER*19  LISCHA,MATASS
      CHARACTER*24  MODELE,NUMEDD
      CHARACTER*19  VECLAG
      CHARACTER*19  VEBUDI,CNBUDI
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C CALCUL DES CONDITIONS DE DIRICHLET B.U
C      
C ----------------------------------------------------------------------
C
C
C IN  MODELE : NOM DU MODELE
C IN  NUMEDD : NOM DE LA NUMEROTATION
C IN  LISCHA : LISTE DES CHARGES
C IN  VECLAG : VECTEUR D'INCONNUES PORTANT LES LAGRANGES
C OUT VEBUDI : VECT_ELEM DES CONDITIONS DE DIRICHLET B.U
C OUT CNBUDI : VECT_ASSE DES CONDITIONS DE DIRICHLET B.U
C IN  MATASS : SD MATRICE ASSEMBLEE
C
C
C
C
      INTEGER      IFM,NIV
C 
C ----------------------------------------------------------------------
C
      CALL JEMARQ() 
      CALL INFDBG('MECA_NON_LINE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<MECANONLINE> ... ASSEMBLAGE DES REACTIONS '//
     &                'D''APPUI'
      ENDIF                   
C
C --- CALCUL <CNBUDI>
C
      CALL VEBUME(MODELE,MATASS,VECLAG,LISCHA,VEBUDI) 
C
C --- ASSEMBLAGE <CNBUDI>
C
      CALL ASSVEC('V'   ,CNBUDI,1     ,VEBUDI,1.D0  ,
     &            NUMEDD,' '   ,'ZERO',1     )     
C
      IF (NIV.GE.2) THEN
        CALL NMDEBG('VECT',CNBUDI,6)
      ENDIF    
C
      CALL JEDEMA()
      END
