      SUBROUTINE NMCOUN(NOMA  ,FONACT,SOLVEU,NUMEDZ,MATASS,
     &                  DEFICO,RESOCO,DEFICU,RESOCU,ITERAT,
     &                  VALINC,SOLALG,VEASSE,INSTAN,RESIGR,
     &                  SDTIME,SDSTAT,CTCCVG)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 08/10/2012   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT      NONE
      INCLUDE 'jeveux.h'
      CHARACTER*8   NOMA
      CHARACTER*24  DEFICO,RESOCO
      CHARACTER*24  DEFICU,RESOCU,SDTIME,SDSTAT
      CHARACTER*19  VALINC(*)
      CHARACTER*19  SOLALG(*),VEASSE(*)
      CHARACTER*19  SOLVEU,MATASS
      CHARACTER*(*) NUMEDZ
      INTEGER       ITERAT
      REAL*8        INSTAN
      REAL*8        RESIGR
      INTEGER       CTCCVG
      INTEGER       FONACT(*)
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C MISE A JOUR DE L'INCREMENT DE DEPLACEMENT SI CONTACT OU
C LIAISON_UNILATER
C
C
C ----------------------------------------------------------------------
C
C
C IN  MAILLA : NOM DU MAILLAGE
C IN  FONACT : FONCTIONNALITES ACTIVEES (VOIR NMFONC)
C IN  SOLVEU : SD SOLVEUR
C IN  NUMEDD : NUME_DDL
C IN  MATASS : NOM DE LA MATRICE DU PREMIER MEMBRE ASSEMBLEE
C IN  DEFICO : SD DE DEFINITION DU CONTACT
C IN  RESOCO : SD DE RESOLUTION DU CONTACT
C IN  DEFICU : SD DE DEFINITION DE LIAISON_UNILATER
C IN  RESOCU : SD DE RESOLUTION DE LIAISON_UNILATER
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C IN  SOLALG : VARIABLE CHAPEAU POUR INCREMENTS SOLUTIONS
C               OUT: DDEPLA
C IN  SDTIME : SD TIMER
C IN  SDSTAT : SD STATISTIQUES
C IN  VEASSE : VARIABLE CHAPEAU POUR NOM DES VECT_ASSE
C IN  RESIGR : RESI_GLOB_RELA
C IN  ITERAT : ITERATION DE NEWTON
C IN  INSTAN : VALEUR DE L'INSTANT DE CALCUL
C OUT CTCCVG : CODE RETOUR CONTACT DISCRET
C                -1 : PAS DE CALCUL DU CONTACT DISCRET
C                 0 : CAS DU FONCTIONNEMENT NORMAL
C                 1 : NOMBRE MAXI D'ITERATIONS
C                 2 : MATRICE SINGULIERE
C
C
C
C
      LOGICAL      ISFONC,LUNIL,LCTCD
      LOGICAL      CFDISL,LALLV
      CHARACTER*19 DEPDEL,DDEPLA,CNCINE
      CHARACTER*19 DEPPLU
      CHARACTER*14 NUMEDD
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- FONCTIONNALITES ACTIVEES
C
      LUNIL  = ISFONC(FONACT,'LIAISON_UNILATER')
      LCTCD  = ISFONC(FONACT,'CONT_DISCRET')
      CTCCVG = -1
      NUMEDD = NUMEDZ(1:14)
C
C --- DECOMPACTION VARIABLES CHAPEAUX
C
      CALL NMCHEX(VALINC,'VALINC','DEPPLU',DEPPLU)
      CALL NMCHEX(SOLALG,'SOLALG','DDEPLA',DDEPLA)
      CALL NMCHEX(SOLALG,'SOLALG','DEPDEL',DEPDEL)
      CALL NMCHEX(VEASSE,'VEASSE','CNCINE',CNCINE)
C
C --- TRAITEMENT DU CONTACT ET/OU DU FROTTEMENT DISCRET
C
      IF (LCTCD) THEN
        LALLV  = CFDISL(DEFICO,'ALL_VERIF')
        IF (.NOT.LALLV) THEN
          CALL NMCOFR(NOMA  ,DEPPLU,DEPDEL,DDEPLA,SOLVEU,
     &                NUMEDD,MATASS,DEFICO,RESOCO,ITERAT,
     &                RESIGR,SDSTAT,SDTIME,CTCCVG)
        ENDIF
        CTCCVG = 0
      ENDIF
C
C --- TRAITEMENT DE LIAISON_UNILATER
C
      IF (LUNIL) THEN
        CALL NMUNIL(NOMA  ,DEPPLU,DDEPLA,SOLVEU,MATASS,
     &              DEFICU,RESOCU,CNCINE,ITERAT,INSTAN,
     &              CTCCVG)
      ENDIF
C
C --- LE CALCUL DE CONTACT A FORCEMENT ETE REALISE
C
      CALL ASSERT(CTCCVG.GE.0)
C
      CALL JEDEMA()
      END
