      SUBROUTINE NMCREL(SDERRO,NOMEVT,VALL  )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT      NONE
      INCLUDE 'jeveux.h'

      CHARACTER*24  SDERRO
      CHARACTER*9   NOMEVT
      LOGICAL       VALL
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (SD ERREUR)
C
C ENREGISTREMENT D'UN EVENEMENT INTRINSEQUE
C
C ----------------------------------------------------------------------
C
C POUR LES EVENEMENTS A CODE RETOUR, IL FAUT D'ABORD TRANSFORMER LE
C CODE RETOUR EN EVENEMENT - UTILISER NMCRET
C
C
C IN  SDERRO : SD GESTION DES ERREURS
C IN  NOMEVT : NOM DE L'EVENEMENT (VOIR LA LISTE DANS NMCRER)
C IN  VALL   : .TRUE. SI ON ACTIVE
C
C ----------------------------------------------------------------------
C
      INTEGER      IEVEN,ZEVEN
      CHARACTER*24 ERRENO,ERRENI,ERRAAC
      INTEGER      JEENOM,JEENIV,JEEACT
      CHARACTER*24 ERRINF
      INTEGER      JEINFO
      CHARACTER*16 NEVEN,TEVEN
      CHARACTER*4  NOMBCL
      INTEGER      IEVACT
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      IEVACT = 0
C
C --- ACCES SD
C
      ERRINF = SDERRO(1:19)//'.INFO'
      CALL JEVEUO(ERRINF,'L',JEINFO)
      ZEVEN  = ZI(JEINFO-1+1)
C
      ERRENO = SDERRO(1:19)//'.ENOM'
      ERRENI = SDERRO(1:19)//'.ENIV'
      ERRAAC = SDERRO(1:19)//'.EACT'
      CALL JEVEUO(ERRENO,'L',JEENOM)
      CALL JEVEUO(ERRENI,'L',JEENIV)
      CALL JEVEUO(ERRAAC,'E',JEEACT)
C
C --- RECHERCHE DE L'EVENEMENT
C
      DO 15 IEVEN = 1,ZEVEN
C
C ----- NOM DE L'EVENEMENT
C
        NEVEN  = ZK16(JEENOM-1+IEVEN)
C
C ----- TYPE DE L'EVENEMENT
C
        TEVEN  = ZK16(JEENIV-1+IEVEN)
C
C ----- ACTIVATION DE L'EVENEMENT
C
        IF (NEVEN.EQ.NOMEVT) THEN
          IEVACT = IEVEN
          GOTO 66
        ENDIF
 15   CONTINUE
C
 66   CONTINUE
C
      CALL ASSERT(IEVACT.NE.0)
C
C --- (DES-)ACTIVATION DE L'EVENEMENT
C
      IF (VALL) THEN
        ZI(JEEACT-1+IEVACT) = 1
      ELSE
        ZI(JEEACT-1+IEVACT) = 0
      ENDIF
C
C --- EVENEMENT DE TYPE ERREUR ACTIVE: ON CHANGE LE STATUT DE LA BOUCLE
C
      IF (VALL) THEN
        TEVEN  = ZK16(JEENIV-1+IEVACT)
        IF (TEVEN(1:5).EQ.'ERRI_') THEN
          NOMBCL = TEVEN(6:9)
          CALL NMECEB(SDERRO,NOMBCL,'ERRE')
C
C ------- UNE ERREUR DE NIVEAU CALC EST FATALE POUR TOUT LE MONDE
C
          IF (NOMBCL.EQ.'CALC') THEN
            CALL NMECEB(SDERRO,'NEWT','STOP')
            CALL NMECEB(SDERRO,'FIXE','STOP')
            CALL NMECEB(SDERRO,'INST','STOP')
          ENDIF
        ENDIF
      ENDIF
C
C
      CALL JEDEMA()
      END
