      SUBROUTINE NMCRLD(SDDISC)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*19 SDDISC
C
C ----------------------------------------------------------------------
C
C ROUTINE *_NON_LINE (STRUCTURES DE DONNES - DISCRETISATION)
C
C CREATION EVENEMENTS ERREURS: ARRET
C
C ----------------------------------------------------------------------
C
C IN  SDDISC : SD DISCRETISATION
C
C
C
C
      INTEGER      DFLLVD,LEEVR,LEEVK,LESUR
      INTEGER      IECERR
      INTEGER      NECHEC
      CHARACTER*24 TPSINF
      CHARACTER*24 TPSEVR,TPSEVK,TPSESU
      INTEGER      JEEVR,JEEVK,JESUR
      REAL*8       R8BID
      CHARACTER*8  K8BID
      INTEGER      IBID
      CHARACTER*16 EVEN
      REAL*8       DTMIN
      REAL*8       PASMIN,PCPLUS,PENMAX
      CHARACTER*16 SUBMET,SUBAUT,ACTION
      INTEGER      NBRPAS,NIVEAU
      REAL*8       VALERE
      CHARACTER*16 NOCHAM,NOCMP,CRICMP
      REAL*8       CMMAXI,PRCOLL,DUCOLL
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      NECHEC = 2
      IECERR = 1
      CALL UTDIDT('E'   ,SDDISC,'LIST',IBID  ,'NECHEC',
     &            R8BID ,NECHEC,K8BID )
      CALL UTDIDT('L'   ,SDDISC,'LIST',IBID  ,'DTMIN'  ,
     &            DTMIN ,IBID  ,K8BID )
C
C --- TAILLE DES VECTEURS
C
      LEEVR  = DFLLVD('LEEVR')
      LEEVK  = DFLLVD('LEEVK')
      LESUR  = DFLLVD('LESUR')
C
C --- NOM DES SDS
C
      TPSINF = SDDISC(1:19)//'.LINF'
      TPSEVR = SDDISC(1:19)//'.EEVR'
      TPSEVK = SDDISC(1:19)//'.EEVK'
      TPSESU = SDDISC(1:19)//'.ESUR'
C
C --- CREATION DES SD
C
      CALL WKVECT(TPSEVR,'V V R',  NECHEC*LEEVR,JEEVR )
      CALL WKVECT(TPSEVK,'V V K16',NECHEC*LEEVK,JEEVK )
      CALL WKVECT(TPSESU,'V V R'  ,NECHEC*LESUR,JESUR )
C
C --- VALEURS POUR ACTION = ARRET
C
      ACTION = 'ARRET'
      SUBMET = ' '
      SUBAUT = ' '
      PASMIN = 0.D0
      NBRPAS = 0
      NIVEAU = 0
      PCPLUS = 0.D0
      CMMAXI = 0.D0
      PRCOLL = 0.D0
      DUCOLL = 0.D0
      PENMAX = 0.D0
      CRICMP = ' '
      VALERE = 0.D0
      NOCHAM = ' '
      NOCMP  = ' '
C
C --- CREATION EVENEMENT 'ERRE' 
C
      EVEN   = 'ERRE'
      CALL DFLLSV(TPSINF,TPSEVR,TPSEVK,TPSESU,IECERR,
     &            EVEN  ,ACTION,SUBMET,SUBAUT,PASMIN,
     &            NBRPAS,NIVEAU,PCPLUS,CMMAXI,PRCOLL,
     &            DUCOLL,PENMAX,CRICMP,VALERE,NOCHAM,
     &            NOCMP )
C
      CALL JEDEMA()

      END
