      SUBROUTINE NMCROB(NOMA  ,NOMO  ,RESULT,NUMREU,SDIETO,
     &                  SDOBSE)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 05/11/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*8  RESULT,NOMA,NOMO
      INTEGER      NUMREU
      CHARACTER*19 SDOBSE
      CHARACTER*24 SDIETO
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (STRUCTURES DE DONNES)
C
C CREATION SD OBSERVATION
C
C ----------------------------------------------------------------------
C
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  NOMO   : NOM DU MODELE
C IN  SDIETO : SD GESTION IN ET OUT
C IN  SDOBSE : NOM DE LA SD POUR OBSERVATION
C IN  RESULT : NOM UTILISATEUR DU RESULTAT
C IN  NUMREU : NUMERO DE REUSE
C
C ----------------------------------------------------------------------
C
      INTEGER      IFM,NIV
      INTEGER      NTOBS,NBOCC
      CHARACTER*16 MOTFAC
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFNIV(IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<    NONLINE> ... CREATION SD OBSERVATION'
      ENDIF
C
C --- INITIALISATIONS
C
      NTOBS  = 0
      MOTFAC = 'OBSERVATION'
C
C --- NOMBRE OCCURRENCES
C
      CALL GETFAC(MOTFAC,NBOCC)
      CALL ASSERT(NBOCC.LE.99)
C
C --- LECTURE DES DONNEES
C
      CALL NMEXTR(NOMA  ,NOMO  ,SDOBSE,SDIETO,MOTFAC,
     &            NBOCC ,NUMREU,NTOBS )
C
C --- CONTROLE
C
      IF (NTOBS.NE.0) THEN
        CALL U2MESI('I','OBSERVATION_3',1,NTOBS)
      ELSE
        GOTO 999
      ENDIF
C
C --- LECTURE LISTES INSTANTS
C
      CALL NMCROI(SDOBSE,MOTFAC,NBOCC )
C
C --- NOM DES COLONNES
C
      CALL NMOBNO(SDOBSE,MOTFAC,NBOCC )
C
C --- CREATION DE LA TABLE D'OBSERVATION
C
      CALL NMCROT(RESULT,SDOBSE)
C
 999  CONTINUE
C
      CALL JEDEMA()

      END
