      SUBROUTINE NMCRPA(MOTFAZ,IOCC  ,SDLIST,BASE  ,NBINST,
     &                  DTMIN )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*24  SDLIST
      CHARACTER*(*) MOTFAZ
      CHARACTER*1   BASE
      INTEGER       IOCC
      REAL*8        DTMIN
      INTEGER       NBINST
C
C ----------------------------------------------------------------------
C
C ROUTINE *_NON_LINE (UTILITAIRE - SELEC. INST.)
C
C LECTURE LISTE INSTANTS
C
C ----------------------------------------------------------------------
C
C
C IN  SDLIST : NOM DE LA SD DANS LAQUELLE ON CONSERVERA LA LISTE
C               ON CREE UN VECTEUR DE LONGUEUR NBINST SUR BASE
C NB: LA LISTE N'EST PAS FORCEMENT CROISSANTE
C IN  BASE   : NOM DE LA BASE POUR CREATION SD
C IN  MOTFAC : MOT-FACTEUR POUR LIRE (LIST_INST/INST)
C IN  IOCC   : OCCURRENCE DU MOT-CLEF FACTEUR MOTFAC
C OUT NBINST : NOMBRE D'INSTANTS DANS LA LISTE
C OUT DTMIN  : INCREMENT DE TEMPS MINIMUM DANS LA LISTE
C
C
C
C
      INTEGER      N2,N3,I,IRET
      CHARACTER*19 LIST
      INTEGER      JLIST,JSLIST
      CHARACTER*8  K8BID
      REAL*8       R8BID
      CHARACTER*16 MOTFAC
      INTEGER      IARG
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      NBINST = 0
      MOTFAC = MOTFAZ
      DTMIN  = 0.D0
C
C --- CREATION ET INITIALISATION SD
C
      CALL GETVID(MOTFAC,'LIST_INST',IOCC,IARG,1,LIST  ,N2)
      CALL GETVR8(MOTFAC,'INST'     ,IOCC,IARG,0,R8BID ,N3)
      N3 = -N3
C
C --- RECUPERATION DU NOMBRE D'INSTANTS
C      
      IF ((N2.GE.1).AND.(N3.GE.1)) THEN
        CALL ASSERT(.FALSE.)
      ENDIF
C
      IF (N3.GE.1) THEN
        NBINST =  N3
      ELSEIF (N2.GE.1) THEN
        CALL JELIRA(LIST//'.VALE','LONMAX',NBINST,K8BID )
      ELSE
        NBINST = 0
        GOTO 99  
      ENDIF
C
C --- CREATION DE LA LISTE
C
      CALL WKVECT(SDLIST,BASE//' V R',NBINST,JSLIST)
C
C --- REMPLISSAGE DE LA LISTE
C
      IF (N3.GE.1) THEN
        CALL GETVR8(MOTFAC,'INST',IOCC,IARG,NBINST,ZR(JSLIST),IRET)
      ELSE
        CALL JEVEUO(LIST//'.VALE','L',JLIST)
        DO 43 I = 1,NBINST
          ZR(JSLIST+I-1) = ZR(JLIST+I-1)
  43    CONTINUE
      ENDIF
C
C --- CALCUL DU DELTA MINIMUM DE LA LISTE
C
      CALL NMCRPM(ZR(JSLIST),NBINST,DTMIN )
C
  99  CONTINUE      
C
      CALL JEDEMA()

      END
