      SUBROUTINE NMCRSD(TYPESD,NOMSD )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*(*) TYPESD
      CHARACTER*(*) NOMSD
      
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (UTILITAIRE)
C
C CREATION D'UNE SD
C
C ----------------------------------------------------------------------
C
C
C IN  TYPESD :  TYPE DE LA SD
C               'POST_TRAITEMENT' - MODES VIBRATOIRES OU FLAMBAGE
C               'ENERGIE        ' - ENERGIES
C IN  NOMSD  : NOM DE LA SD
C
C
C
C
      INTEGER      ZPOSTI,ZPOSTR,ZPOSTK,ZENER
      PARAMETER   (ZPOSTI=11,ZPOSTR=8,ZPOSTK=14,ZENER=6)
C      
      INTEGER      IFM,NIV
      CHARACTER*24 SDINFI,SDINFR,SDINFK
      INTEGER      JPINFI,JPINFR,JPINFK,JENER
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()

      CALL INFDBG('MECA_NON_LINE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<MECANONLINE> ... CREATION SD'
      ENDIF
C
C --- CREATION
C 
      IF (TYPESD.EQ.'POST_TRAITEMENT') THEN
        SDINFI = NOMSD(1:19)//'.INFI'
        SDINFR = NOMSD(1:19)//'.INFR'
        SDINFK = NOMSD(1:19)//'.INFK'         
        CALL WKVECT(SDINFI,'V V I  ',ZPOSTI,JPINFI)
        CALL WKVECT(SDINFR,'V V R  ',ZPOSTR,JPINFR)      
        CALL WKVECT(SDINFK,'V V K24',ZPOSTK,JPINFK)              
      ELSE IF (TYPESD.EQ.'ENERGIE') THEN
C COMPOSANTES DE SDENER//'.VALE'
C WEXT : TRAVAIL DES EFFORTS EXTERIEURS
C ECIN : ENERGIE CINETIQUE
C WINT : ENERGIE DE DEFORMATION IRREVERSIBLE
C AMOR : ENERGIE DISSIPEE PAR AMORTISSEMENT
C LIAI : ENERGIE DISSIPEE PAR LES LIAISONS
C WSCH : ENERGIE DISSIPEE PAR LE SCHEMA
        CALL WKVECT(NOMSD(1:19)//'.VALE','V V R  ',ZENER,JENER)
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF 
C          
      CALL JEDEMA()
      END
