      SUBROUTINE NMCSOL(LISCHA,SDDYNA,LVISS )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 02/10/2012   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT     NONE
      INCLUDE      'jeveux.h'
      LOGICAL      LVISS
      CHARACTER*19 LISCHA,SDDYNA
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (INITIALISATION)
C
C DETERMINE LA PRESENCE DE CHARGES FORCE_SOL
C
C ----------------------------------------------------------------------
C
C
C IN  LISCHA : SD LISTE DES CHARGES
C IN  SDDYNA : SD DYNAMIQUE
C OUT LVISS  : .TRUE SI PRESENCE D'UNE CHARGE FORCE_SOL
C
C ----------------------------------------------------------------------
C
      CHARACTER*8  CNFSOL
      CHARACTER*24 CHARGE,INFCHA
      INTEGER      JALICH,JINFCH
      INTEGER      NCHAR,ICHAR,NFSOL
      CHARACTER*24 NCHSOL
      INTEGER      JCHSOL
      CHARACTER*15 SDEXSO
      CHARACTER*19 SDEXSZ
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      LVISS  = .FALSE.
      NFSOL  = 0
      CNFSOL = ' '
      CALL NDYNKK(SDDYNA,'SDEXSO',SDEXSZ)
      SDEXSO = SDEXSZ(1:15)
C
C --- ACCES SD LISTE_CHARGES
C
      CHARGE = LISCHA(1:19)//'.LCHA'
      INFCHA = LISCHA(1:19)//'.INFC'
      CALL JEVEUO(CHARGE,'E',JALICH)
      CALL JEVEUO(INFCHA,'E',JINFCH)
      NCHAR  = ZI(JINFCH)
C
C --- DETECTION CHARGE
C
      DO 30 ICHAR = 1,NCHAR
        IF (ZI(JINFCH+NCHAR+ICHAR).EQ.20) THEN
          NFSOL = NFSOL + 1
          CNFSOL = ZK24(JALICH+ICHAR-1)(1:8)
        END IF
   30 CONTINUE
C
C --- ACTIVATION CHARGE
C
      IF (NFSOL.EQ.0) THEN
        LVISS  = .FALSE.
      ELSEIF (NFSOL.EQ.1) THEN
        LVISS  = .TRUE.
      ELSE
        CALL U2MESS('F','DYNAMIQUE_9')
      ENDIF
C
C --- NOM DE _LA_CHARGE
C
      IF (LVISS) THEN
        NCHSOL = SDEXSO(1:15)//'.CHAR'
        CALL WKVECT(NCHSOL,'V V K8',1,JCHSOL)
        ZK8(JCHSOL) = CNFSOL
      ENDIF
C
      CALL JEDEMA()
C
      END
