      SUBROUTINE NMCTCC(NOMA  ,MODELE,MATE  ,SDDYNA,SDIMPR,
     &                  SDERRO,DEFICO,RESOCO,VALINC,SOLALG,
     &                  MMCVCA)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 22/10/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      CHARACTER*8  NOMA
      CHARACTER*24 MODELE
      CHARACTER*24 DEFICO,RESOCO
      CHARACTER*19 SDDYNA
      CHARACTER*24 SDIMPR,SDERRO
      CHARACTER*19 VALINC(*),SOLALG(*)
      LOGICAL      MMCVCA
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGO - BOUCLE CONTACT)
C
C ALGO. DES CONTRAINTES ACTIVES
C
C ----------------------------------------------------------------------
C
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  MODELE : NOM DU MODELE
C IN  MATE   : SD MATERIAU
C IN  SDDYNA : SD POUR DYNAMIQUE
C IN  SDIMPR : SD AFFICHAGE
C IN  SDERRO : GESTION DES ERREURS
C IN  DEFICO : SD POUR LA DEFINITION DE CONTACT
C IN  RESOCO : SD POUR LA RESOLUTION DE CONTACT
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C IN  SOLALG : VARIABLE CHAPEAU POUR INCREMENTS SOLUTIONS
C OUT MMCVCA : INDICATEUR DE CONVERGENCE POUR BOUCLE DES
C              CONTRAINTES ACTIVES
C               .TRUE. SI LA BOUCLE DES CONTRAINTES ACTIVES A CONVERGE
C
C ----------------------------------------------------------------------
C
      INTEGER      IFM,NIV
      LOGICAL      CFDISL,LTFCM,LCTCC,LXFCM,LFROT,LERROC
      INTEGER      CFDISI,NTPC,ITEMUL,MAXCON,CTCSTA
      INTEGER      MMITCA
      CHARACTER*8  NOMO
      INTEGER      ITERAT
      CHARACTER*16 TYPCYC,LIECYC
      CHARACTER*24 MATE
C
C ----------------------------------------------------------------------
C
      CALL INFDBG('MECANONLINE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<MECANONLINE> ALGORITHME DES CONTRAINTES ACTIVES'
      ENDIF
C
C --- INITIALISATIONS
C
      NOMO   = MODELE(1:8)
      NTPC   = CFDISI(DEFICO,'NTPC')
      TYPCYC = ' '
      MMCVCA = .FALSE.
      LERROC = .FALSE.
      ITERAT = -1
C
C --- INFOS BOUCLE CONTACT
C
      CALL MMBOUC(RESOCO,'CONT','READ',MMITCA)
      ITEMUL  = CFDISI(DEFICO,'ITER_CONT_MULT')
      IF (ITEMUL.EQ.-1) THEN
        MAXCON  = CFDISI(DEFICO,'ITER_CONT_MAXI')
      ELSE
        MAXCON  = ITEMUL*NTPC
      ENDIF
C
C --- TYPE DE CONTACT
C
      LCTCC  = CFDISL(DEFICO,'FORMUL_CONTINUE')
      LXFCM  = CFDISL(DEFICO,'FORMUL_XFEM')
      LFROT  = CFDISL(DEFICO,'FROTTEMENT')
      LTFCM  = CFDISL(DEFICO,'CONT_XFEM_GG')
C
C --- APPEL ALGO DES CONT. ACTIVES
C
      IF (LXFCM) THEN
        IF (LTFCM) THEN
          CALL XMTBCA(NOMA  ,DEFICO,RESOCO,VALINC,MMCVCA)
        ELSE
          CALL XMMBCA(NOMA  ,NOMO  ,MATE  ,RESOCO,VALINC,
     &                MMCVCA)
        ENDIF
      ELSEIF (LCTCC) THEN
        CALL MMMBCA(NOMA  ,SDDYNA,ITERAT,DEFICO,RESOCO,
     &              VALINC,SOLALG,CTCSTA,MMCVCA)
        CALL MMCYCL(DEFICO,RESOCO,TYPCYC,LIECYC)
C ----- FLIP-FLOP: ON FORCE LA CONVERGENCE
        IF (TYPCYC.EQ.'FLIP FLOP') THEN
          MMCVCA = .TRUE.
          CALL NMIMCK(SDIMPR,'CTCC_CYCL',TYPCYC,.TRUE.)
        ENDIF
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF
C
C --- CONVERGENCE CONTRAINTES ACTIVES
C
      IF ((.NOT.MMCVCA).AND.(MMITCA.EQ.MAXCON)) THEN
        IF (LFROT.AND.LXFCM) THEN
C ------- CONVERGENCE FORCEE
          CALL U2MESS('A','CONTACT3_86')
          MMCVCA = .TRUE.
        ELSE
          LERROC = .TRUE.
          MMCVCA = .FALSE.
        ENDIF
      ENDIF
C
C --- CONVERGENCE ET ERREUR
C
      CALL NMCREL(SDERRO,'ERRE_CTCC',LERROC)
      IF (MMCVCA) THEN
        CALL NMCREL(SDERRO,'DIVE_FIXC',.FALSE.)
      ELSE
        CALL NMCREL(SDERRO,'DIVE_FIXC',.TRUE.)
      ENDIF
C

      END
