      SUBROUTINE NMCTCG(MODELE,NOMA  ,DEFICO,RESOCO,LOPTIN,
     &                  SDSTAT,SDTIME,NUMEDD)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 30/10/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      CHARACTER*8  NOMA
      CHARACTER*24 MODELE
      CHARACTER*24 DEFICO,RESOCO
      CHARACTER*24 SDSTAT,SDTIME
      CHARACTER*24 NUMEDD
      LOGICAL      LOPTIN
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGO - BOUCLE CONTACT)
C
C BOUCLE DE POINT FIXE GEOMETRIQUE - APPARIEMENT
C
C ----------------------------------------------------------------------
C
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  MODELE : NOM DU MODELE
C IN  LOPTIN : VAUT .TRUE. SI ACTIVATION DES OPTIONS *_INIT
C IN  DEFICO : SD POUR LA DEFINITION DE CONTACT
C IN  RESOCO : SD POUR LA RESOLUTION DE CONTACT
C IN  NUMEDD : NOM DU NUME_DDL
C IN  SDTIME : SD TIMER
C IN  SDSTAT : SD STATISTIQUES
C
C ----------------------------------------------------------------------
C
      INTEGER      IFM,NIV
      CHARACTER*8  NOMO
      INTEGER      CFDISI,IFORM
C
C ----------------------------------------------------------------------
C
      CALL INFDBG('MECANONLINE',IFM,NIV)
C
C --- INITIALISATIONS
C
      NOMO   = MODELE(1:8)
C
C --- TYPE DE CONTACT
C
      IFORM  = CFDISI(DEFICO,'FORMULATION')
      IF (IFORM.EQ.1) GOTO 99
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*)
     &     '<MECANONLINE> BOUCLE DE REACTUALISATION GEOMETRIQUE'
      ENDIF
C
C --- REACTUALISATION DE LA GEOMETRIE ET APPARIEMENT
C
      CALL NMTIME(SDTIME,'INI','CONT_GEOM')
      CALL NMTIME(SDTIME,'RUN','CONT_GEOM')
      IF (IFORM.EQ.3) THEN
        CALL XREACG(NOMO  ,RESOCO)
        CALL XAPPAR(LOPTIN,NOMA  ,NOMO  ,DEFICO,RESOCO)
      ELSEIF (IFORM.EQ.2) THEN
        CALL MREACG(NOMA  ,RESOCO)
        CALL MMAPPA(LOPTIN,NOMA  ,NUMEDD,DEFICO,RESOCO)
      ENDIF
      CALL NMTIME(SDTIME,'END','CONT_GEOM')
      CALL NMRINC(SDSTAT,'CONT_GEOM')
C
  99  CONTINUE
C
      END
