      SUBROUTINE NMCVGN(SDDISC,SDERRO,VALINC,DEFICO,RESOCO)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*19 SDDISC,VALINC(*)
      CHARACTER*24 SDERRO
      CHARACTER*24 DEFICO,RESOCO
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C ETAT DE LA CONVERGENCE DE NEWTON
C
C ----------------------------------------------------------------------
C
C
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  SDERRO : SD GESTION DES ERREURS
C IN  VALINC : VARIABLE CHAPEAU INCREMENTS DES VARIABLES
C IN  DEFICO : SD DE DEFINITION DU CONTACT
C IN  RESOCO : SD DE RESOLUTION DU CONTACT
C
C
C
C
      INTEGER      IEVDAC,NUMINS
      CHARACTER*4  ETNEWT
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      NUMINS = -1
C
C --- ETAT DE LA BOUCLE DE NEWTON
C
      CALL NMLEEB(SDERRO,'NEWT',ETNEWT)
C
C --- ERREUR FATALE -> ON NE PEUT RIEN FAIRE
C
      IF (ETNEWT.EQ.'STOP') GOTO 99
C
C --- DETECTION DU PREMIER EVENEMENT DECLENCHE
C
      CALL NMEVEV(SDDISC,NUMINS,VALINC,SDERRO,DEFICO,
     &            RESOCO,'NEWT')
C
C --- UN EVENEMENT SE DECLENCHE
C
      CALL NMACTO(SDDISC,IEVDAC)
      IF (IEVDAC.GT.0) CALL NMECEB(SDERRO,'NEWT','EVEN')
C
  99  CONTINUE
C
      CALL JEDEMA()
      END
