      SUBROUTINE NMDCAX(SDDISC,INSREF,NUMINS,DURDEC,DELTAC)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 22/10/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*19 SDDISC
      INTEGER      NUMINS
      REAL*8       DURDEC,INSREF,DELTAC
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (GESTION DES EVENEMENTS - DECOUPE)
C
C EXTENSION DE LA DECOUPE AUX INSTANTS SUIVANTS - AUTOMATIQUE
C
C ----------------------------------------------------------------------
C
C
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  INSREF : INSTANT AU-DELA DUQUEL ON ETEND LA DECOUPE
C IN  DURDEC : DUREEE DE L'EXTENSION DE LA DECOUPE
C IN  DELTAC : INCREMENT DE TEMPS CIBLE
C
C
C
C
      REAL*8       VALR(2)
      CHARACTER*24 TPSEXT,TPSDIT
      INTEGER      JTPSEX
      REAL*8       DIINST,INSTAP,INSTAM,INST
      REAL*8       INSFIN,R8VIDE
      REAL*8       OLDREF
      INTEGER      NUMMAX,NBRPAS
      CHARACTER*8  K8BID
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- PROCHAIN INSTANT INSTAP
C
      TPSDIT = SDDISC(1:19)//'.DITR'
      CALL JELIRA(TPSDIT,'LONMAX',NUMMAX,K8BID)
      INSTAM = DIINST(SDDISC,NUMINS)
      IF (NUMINS.EQ.NUMMAX) THEN
        INSTAP = INSTAM+DELTAC
      ELSE
        INSTAP = DIINST(SDDISC,NUMINS+1)
      ENDIF
C
C --- VALEURS STOCKEES
C
      TPSEXT = SDDISC(1:19)//'.AEXT'
      CALL JEVEUO(TPSEXT,'E',JTPSEX)
      CALL ASSERT(DURDEC.GT.0.D0)
      OLDREF = ZR(JTPSEX-1+1)
C
C --- PREMIERE EXTENSION
C
      IF (OLDREF.EQ.R8VIDE()) THEN
        NBRPAS = 1
        INSFIN = INSREF+DURDEC
C
C ----- RECHERCHE DE LA "VRAIE FIN"
C
   11   CONTINUE
        INST = INSREF + NBRPAS*DELTAC
        IF (INST.GT.INSFIN) THEN
          NBRPAS = NBRPAS - 1
          GOTO 12
        ELSE
          NBRPAS = NBRPAS + 1
        ENDIF
        GOTO 11

   12   CONTINUE
        INSFIN = INSREF+DELTAC*NBRPAS
      ENDIF
C
C --- EXTENSION
C
      IF (OLDREF.NE.R8VIDE()) THEN
        INSFIN = ZR(JTPSEX-1+3)
        IF (INSTAP.LE.INSFIN) THEN
          INSREF = INSTAP
        ENDIF
      ENDIF
C
C --- SAUVEGARDE
C
      ZR(JTPSEX-1+1) = INSREF
      ZR(JTPSEX-1+2) = DELTAC
      ZR(JTPSEX-1+3) = INSFIN
C
C --- AFFICHAGE
C
      VALR(1) = INSREF
      VALR(2) = DURDEC
      CALL U2MESR('I','SUBDIVISE_18',2,VALR)
C
      CALL JEDEMA()
      END
