      SUBROUTINE NMDCDC(SDDISC,NUMINS,NOMLIS,NBRPAS)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*19 SDDISC
      CHARACTER*24 NOMLIS
      INTEGER      NBRPAS,NUMINS
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (GESTION DES EVENEMENTS - DECOUPE)
C
C MISE A JOUR DES SD APRES DECOUPE
C
C ----------------------------------------------------------------------
C
C
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  NUMINS : NUMERO D'INSTANTS
C IN  NOMLIS : NOM DE LA LISTE DES INSTANTS A AJOUTER
C IN  NBRPAS : NOMBRE D'INSTANTS A AJOUTER
C
C
C
C
      INTEGER      JINST
      INTEGER      NBINS,NBINI
      REAL*8       R8BID,DT0
      CHARACTER*8  K8BID
      INTEGER      IBID
      CHARACTER*16 METLIS
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- ACCES OBJET INST
C
      CALL JEVEUO(NOMLIS,'L',JINST )
C
C --- GESTION DE LA LISTE D'INSTANT
C
      CALL UTDIDT('L'   ,SDDISC,'LIST',IBID  ,'METHODE',
     &            R8BID ,IBID  ,METLIS)
C
C --- LONGUEUR INITIALE DE LA LISTE D'INSTANTS
C
      CALL UTDIDT('L'   ,SDDISC,'LIST',IBID  ,'NBINST' ,
     &            R8BID ,NBINI ,K8BID )
C
C --- NOMBRE D'INSTANTS A AJOUTER
C
      IF (METLIS.EQ.'AUTO') THEN
        NBINS = 1
      ELSEIF (METLIS.EQ.'MANUEL') THEN
        NBINS = NBRPAS - 1
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF
C
C --- EXTENSION DE LA LISTE D'INSTANTS
C
      CALL NMDCEI(SDDISC,NUMINS,ZR(JINST),NBINI ,NBINS ,
     &            'DECO',DT0   )
C
C --- EXTENSION DE LA LISTE DES NIVEAUX DE DECOUPAGE
C
      CALL NMDCEN(SDDISC,NUMINS,NBINI ,NBINS )
C
C --- ENREGISTREMENT INFOS
C
      CALL UTDIDT('E'   ,SDDISC,'LIST',IBID  ,'DT-',
     &            DT0   ,IBID  ,K8BID )
C
      CALL JEDEMA()
      END
