      SUBROUTINE NMDECA(SDDISC,ITERAT,IEVDAC,NOMLIS,INSTAM,
     &                  DELTAT,NBRPAS,DTMIN ,LDCEXT,DURDEC,
     &                  RETDEC)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*19 SDDISC
      CHARACTER*24 NOMLIS
      INTEGER      NBRPAS
      INTEGER      IEVDAC,ITERAT,RETDEC
      REAL*8       INSTAM,DELTAT,DTMIN,DURDEC
      LOGICAL      LDCEXT
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (GESTION DES EVENEMENTS - DECOUPE)
C
C DECOUPE DU PAS DE TEMPS - CAS AUTOMATIQUE
C
C ----------------------------------------------------------------------
C
C
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  ITERAT : NUMERO D'ITERATION DE NEWTON
C IN  NOMLIS : NOM DE LA LISTE DES INSTANTS A AJOUTER
C IN  IEVDAC : INDICE DE L'EVENEMENT ACTIF
C IN  INSTAM : INSTANT AU DEBUT
C IN  DELTAT : INCREMENT DE TEMPS COURANT
C OUT LDCEXT : .TRUE. SI ON DOIT CONTINUER LA DECOUPE
C OUT NBRPAS : NOMBRE DE PAS DE TEMPS
C OUT DTMIN  : INTERVALLE DE TEMPS MINIMAL SUR LA LISTE CREEE
C OUT RETDEC : CODE RETOUR DECOUPE
C     0 - ECHEC DE LA DECOUPE
C     1 - ON A DECOUPE
C     2 - PAS DE DECOUPE
C OUT DURDEC : DUREEE DE LA DECOUPE APRES (SI LDCEXT =.TRUE.)
C
C
C
C
      REAL*8       R8GAEM
      REAL*8       RATIO,DELTAC
      CHARACTER*4  TYPDEC
      CHARACTER*16 OPTDEC
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      DTMIN  = R8GAEM()
      RETDEC = 0
      OPTDEC = ' '
      RATIO  = -1.D0
      NBRPAS = -1
      DELTAC = -1.D0
      TYPDEC = ' '
      LDCEXT = .FALSE.
      DURDEC = -1.D0
C
C --- PARAMETRES DE LA DECOUPE AUTOMATIQUE
C
      CALL NMDECP(SDDISC,ITERAT,IEVDAC,TYPDEC,NBRPAS,
     &            DELTAC,RATIO ,OPTDEC,LDCEXT,DURDEC,
     &            RETDEC)
C
C --- PAS DE DECOUPE: ON SORT
C
      IF (RETDEC.NE.1) GOTO 999
C
C --- CONSTRUCTION DE LA LISTE DES INSTANTS
C
      CALL NMDECC(NOMLIS,.TRUE.,OPTDEC,DELTAT,INSTAM,
     &            RATIO ,TYPDEC,NBRPAS,DELTAC,DTMIN ,
     &            RETDEC)
C
      IF (RETDEC.EQ.1) THEN
        CALL ASSERT(NBRPAS.GT.0)
        CALL ASSERT(RATIO.GT.0.D0)
      ENDIF
C
C --- PAS DE DECOUPE
C
      IF (NBRPAS.EQ.1) RETDEC = 2
C
  999 CONTINUE
C
      CALL JEDEMA()
      END
