      SUBROUTINE NMDECM(SDDISC,IEVDAC,NOMLIS,INSTAM,DELTAT,
     &                  NBRPAS,DTMIN ,RETDEC)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      INTEGER      IEVDAC
      CHARACTER*19 SDDISC
      CHARACTER*24 NOMLIS
      INTEGER      NBRPAS
      REAL*8       INSTAM,DELTAT,DTMIN
      INTEGER      RETDEC
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (GESTION DES EVENEMENTS - DECOUPE)
C
C DECOUPE DU PAS DE TEMPS - CAS MANUEL
C
C ----------------------------------------------------------------------
C
C
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  IEVDAC : INDICE DE L'EVENEMENT ACTIF
C IN  NOMLIS : NOM DE LA LISTE DES INSTANTS A AJOUTER
C IN  INSTAM : INSTANT AU DEBUT
C IN  DELTAT : INCREMENT DE TEMPS COURANT
C IN  TYPDEC : TYPE DE DECOUPE
C     'SUBD' - SUBDIVISION PAR UN NOMBRE DE PAS DONNE
C     'DELT' - SUBDIVISION PAR UN INCREMENT DONNE
C OUT NBRPAS : NOMBRE DE PAS DE TEMPS
C OUT DTMIN  : INTERVALLE DE TEMPS MINIMAL SUR LA LISTE CREEE
C OUT RETDEC : CODE RETOUR DECOUPE
C     0 - ECHEC DE LA DECOUPE
C     1 - ON A DECOUPE
C     2 - PAS DE DECOUPE
C
C
C
C
      REAL*8       R8BID,R8GAEM,RATIO,DELTAC
      CHARACTER*8  K8BID
      CHARACTER*16 OPTDEC
      CHARACTER*4  TYPDEC
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      DTMIN  = R8GAEM()
      RETDEC = 0
      RATIO  = 1.D0
      NBRPAS = -1
      DELTAC = -1.D0
      OPTDEC = 'UNIFORME'
      TYPDEC = 'SUBD'
C
C --- DONNEES
C
      IF (TYPDEC.EQ.'SUBD') THEN
        CALL UTDIDT('L'   ,SDDISC,'ECHE',IEVDAC,'SUBD_PAS'   ,
     &              R8BID ,NBRPAS,K8BID )
C      ELSEIF (TYPDEC.EQ.'DELT') THEN
C        CALL UTDIDT('L'   ,SDDISC,'ECHE',IEVDAC,'SUBD_INCR'  ,
C     &              DELTAC,IBID  ,K8BID )
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF
C
C --- CONSTRUCTION DE LA LISTE DES INSTANTS
C
      CALL NMDECC(NOMLIS,.TRUE.,OPTDEC,DELTAT,INSTAM,
     &            RATIO ,TYPDEC,NBRPAS,DELTAC,DTMIN ,
     &            RETDEC)
C
      CALL JEDEMA()
      END
