      SUBROUTINE NMDECP(SDDISC,ITERAT,IEVDAC,TYPDEC,NBRPAS,
     &                  DELTAC,RATIO ,OPTDEC,LDCEXT,DURDEC,
     &                  RETDEC)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*19 SDDISC
      INTEGER      IEVDAC,ITERAT,RETDEC
      INTEGER      NBRPAS
      LOGICAL      LDCEXT
      REAL*8       RATIO,DELTAC,DURDEC
      CHARACTER*4  TYPDEC
      CHARACTER*16 OPTDEC
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (GESTION DES EVENEMENTS - DECOUPE)
C
C PARAMETRES DE DECOUPE
C
C ----------------------------------------------------------------------
C
C
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  ITERAT : NUMERO D'ITERATION DE NEWTON
C IN  IEVDAC : INDICE DE L'EVENEMENT ACTIF
C OUT RATIO  : RATIO DU PREMIER PAS DE TEMPS
C OUT TYPDEC : TYPE DE DECOUPE
C              'SUBD' - SUBDIVISION PAR UN NOMBRE DE PAS DONNE
C              'DELT' - SUBDIVISION PAR UN INCREMENT DONNE
C OUT NBRPAS : NOMBRE DE PAS DE TEMPS
C OUT DELTAC : INCREMENT DE TEMPS CIBLE
C OUT OPTDEC : OPTION DE DECOUPE
C     'UNIFORME'   - DECOUPE REGULIERE ET UNIFORME
C     'PROGRESSIF' - DECOUPE EN DEUX ZONES, UN PAS LONG+ UNE SERIE
C                    DE PAS UNIFORMES
C     'DEGRESSIF'  - DECOUPE EN DEUX ZONES, UNE SERIE DE PAS
C                    UNIFORMES + UN PAS LONG
C OUT RETDEC : CODE RETOUR DECOUPE
C     0 - ECHEC DE LA DECOUPE
C     1 - ON A DECOUPE
C     2 - PAS DE DECOUPE
C OUT LDCEXT : .TRUE. SI ON DOIT CONTINUER LA DECOUPE
C OUT DURDEC : DUREEE DE LA DECOUPE APRES (SI LDCEXT =.TRUE.)
C
C
C
C
      INTEGER      IBID
      REAL*8       R8BID
      CHARACTER*16 SUBAUT
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      RETDEC = 0
      OPTDEC = ' '
      RATIO  = 0.D0
      NBRPAS = -1
      DELTAC = -1.D0
      TYPDEC = ' '
      OPTDEC = ' '
      LDCEXT = .FALSE.
      DURDEC = -1.D0
C
C --- TYPE DE DECOUPAGE AUTO
C
      CALL UTDIDT('L'   ,SDDISC,'ECHE',IEVDAC,'SUBD_METHODE_AUTO',
     &            R8BID ,IBID  ,SUBAUT)
C
C --- PARAMETRES SUIVANT DECOUPE
C
      IF (SUBAUT.EQ.'EXTRAPOLE') THEN
        CALL NMDCAE(SDDISC,ITERAT,TYPDEC,NBRPAS,RATIO ,
     &              OPTDEC,RETDEC)
      ELSEIF (SUBAUT.EQ.'COLLISION') THEN
        CALL NMDCCO(SDDISC,IEVDAC,TYPDEC,NBRPAS,DELTAC,
     &              RATIO ,OPTDEC,RETDEC,LDCEXT,DURDEC)
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF
C
      CALL JEDEMA()
      END
