      SUBROUTINE NMDECV(SDDISC,NUMINS,IEVDAC,DTMIN ,RETDEC)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 22/10/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*19 SDDISC
      INTEGER      NUMINS,IEVDAC,RETDEC
      REAL*8       DTMIN
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (GESTION DES EVENEMENTS - DECOUPE)
C
C VERIFICATIONS DE LA DECOUPE
C
C ----------------------------------------------------------------------
C
C
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  NUMINS : NUMERO DE L'INSTANT COURANT
C IN  IEVDAC : INDICE DE L'EVENEMENT ACTIF
C IN  DTMIN  : INTERVALLE DE TEMPS MINIMAL SUR LA LISTE CREEE
C OUT RETDEC : CODE RETOUR DECOUPE
C               0 ECHEC DE LA DECOUPE
C               1 ON A DECOUPE
C               2 PAS DE DECOUPE
C
C ----------------------------------------------------------------------
C
      INTEGER      DININS
      REAL*8       R8BID
      CHARACTER*8  K8BID
      INTEGER      IBID
      INTEGER      NBNIVO,LENIVO
      REAL*8       PASMIN,R8PREM
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- NIVEAU DE REDECOUPAGE ACTUEL
C
      LENIVO = DININS(SDDISC,NUMINS)
C
C --- NIVEAU MAXI DE SUBDIVISION
C
      CALL UTDIDT('L'   ,SDDISC,'ECHE',IEVDAC,'SUBD_NIVEAU'  ,
     &            R8BID ,NBNIVO,K8BID )
C
C --- PAS MINIMUM
C
      CALL UTDIDT('L'   ,SDDISC,'ECHE',IEVDAC,'SUBD_PAS_MINI',
     &            PASMIN,IBID  ,K8BID)
C
C --- TAILLE DE PAS MINIMALE ATTEINTE PENDANT LA SUBDIVISION
C
      IF ( (DTMIN .LT. PASMIN) .OR.(DTMIN.LE.R8PREM())) THEN
        RETDEC = 0
        CALL U2MESR('I','SUBDIVISE_16',1,PASMIN)
        GOTO 999
      ELSE
        RETDEC = 1
      ENDIF
C
C --- NIVEAU MAXIMUM DE REDECOUPAGE ATTEINT
C
      IF (( NBNIVO .GT. 1 ).AND.(LENIVO.EQ.NBNIVO) ) THEN
        CALL U2MESI('I','SUBDIVISE_17',1,LENIVO)
        RETDEC = 0
      ELSE
        RETDEC = 1
      ENDIF
C
 999  CONTINUE
C
      CALL JEDEMA()
      END
