      SUBROUTINE NMDIFI(MOTFAC,IOCC  ,PROVLI,TOLE  ,NBINST,
     &                  NUMFIN)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*16 MOTFAC
      CHARACTER*19 PROVLI
      REAL*8       TOLE
      INTEGER      NUMFIN,NBINST,IOCC
C
C ----------------------------------------------------------------------
C
C ROUTINE *_NON_LINE (STRUCTURES DE DONNES - DISCRETISATION)
C
C DETERMINATION DU NUMERO D'ORDRE FINAL
C
C ----------------------------------------------------------------------
C
C
C IN  MOTFAC : MOT-CLEF FACTEUR
C IN  IOCC   : OCCURRENCE DU MOT-CLEF FACTEUR MOTFAC
C IN  PROVLI : NOM DE LA LISTE D'INSTANT PROVISOIRE
C IN  TOLE   : TOLERANCE POUR RECHERCHE DANS LISTE D'INSTANTS
C IN  NBINST : NOMBRE D'INSTANTS DANS LA LISTE
C OUT NUMFIN : NUMERO D'ORDRE FINAL
C
C
C
C
      INTEGER      N1,N2
      REAL*8       INST
      INTEGER      JINST
      INTEGER      IARG
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      NUMFIN = 0
C
C --- NOM SD_DISC
C
      CALL JEVEUO(PROVLI,'L',JINST )
C
C --- LECTURE MOTS-CLEFS
C
      CALL GETVIS(MOTFAC,'NUME_INST_FIN',IOCC,IARG,1,NUMFIN,N1)
      CALL GETVR8(MOTFAC,'INST_FIN'     ,IOCC,IARG,1,INST  ,N2)
C
C --- PAS D'OCCURENCE DES MOTS-CLES -> NUMERO INITIAL
C
      IF (N1+N2 .EQ. 0) THEN
        NUMFIN = NBINST-1
C
C --- MOTS-CLES INST_FIN
C
      ELSE IF (N1 .EQ. 0) THEN
        CALL UTACLI(INST,ZR(JINST),NBINST,TOLE,NUMFIN)
      ENDIF
C
C --- VERIFICATIONS
C
      IF (NUMFIN.LT.0 .OR. NUMFIN.GT.(NBINST-1)) THEN
        CALL U2MESS('F','DISCRETISATION_94')
        NUMFIN = NBINST - 1
      END IF
C
      CALL JEDEMA()

      END
