      SUBROUTINE NMDOCV(MCFACT,IOCC,ALGO,NOMMC,VALRMC)
      IMPLICIT NONE
C
      CHARACTER*14  NOMMC
      CHARACTER*16  MCFACT,ALGO
      INTEGER       IOCC
      REAL*8        VALRMC
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/12/2011   AUTEUR GENIAUT S.GENIAUT 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
C     RECUPERATION ET VERIFICATION DES MOT-CLES LIES
C     A LA CONVERGENCE LOCALE DES COMPOREMENTS
C     LES MOT-CLES TRAITES SONT RESI_INTE_RELA ET ITER_INTE_MAXI
C
C IN  MCFACT : MOT-CLE FACTEUR (COMP_ELAS OU COMP_INCR)
C IN  IOCC   : NUMERO D'OCCURENCE DU MOT-CLE FACTEUR
C IN  ALGO   : ALGO_INTE (SERT A LA VERIF DE COHERENCE)
C IN  NOMMC  : MOT-CLE A TRAITER ('RESI_INTE_RELA' / 'ITER_INTE_MAXI')
C OUT VALRMC : VALEUR REELLE DU MOT-CLE
C
C ----------------------------------------------------------------------
C
      INTEGER IARG,IRET,VALIMC,vali
      REAL*8  RBID
      CHARACTER*16  VALK(2)
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()

C     VERIFICATIONS INITIALES
      CALL ASSERT(MCFACT.EQ.'COMP_ELAS'.OR.
     &            MCFACT.EQ.'COMP_INCR')

      CALL ASSERT(NOMMC.EQ.'RESI_INTE_RELA'.OR.
     &            NOMMC.EQ.'ITER_INTE_MAXI')

C     RECUP DES VALEURS
      IF (NOMMC.EQ.'RESI_INTE_RELA') THEN
        CALL GETVR8(MCFACT,NOMMC,IOCC,IARG,1,VALRMC,IRET)
      ELSEIF (NOMMC.EQ.'ITER_INTE_MAXI') THEN
        CALL GETVIS(MCFACT,NOMMC,IOCC,IARG,1,VALIMC,IRET)
        VALRMC = VALIMC
      ENDIF

      CALL ASSERT(IRET.NE.0)

C     VERIFICATIONS DE COHERENCE
      IF (IARG.EQ.0) THEN
C        LA VALEUR A ETE FOURNIE PAR L'UTILISATEUR
C        VERIF QUE C'EST BIEN COMPATIBLE AVEC LE RESTE
         IF (ALGO.EQ.'ANALYTIQUE') THEN
           VALK(1)=NOMMC
           VALK(2)=MCFACT
           VALI=IOCC
           CALL U2MESG('A','COMPOR1_70',2,VALK,1,VALI,0,RBID)
C          ON MET LA VALEUR A -999 (ON POURRAIT METTRE R8VIDE)
           VALRMC = -999.D0
        ENDIF
      ENDIF

      IF (NOMMC.EQ.'RESI_INTE_RELA') THEN
        IF (VALRMC.GT.1.0001D-6) CALL U2MESS('A','ALGORITH7_60')
      ENDIF

      CALL JEDEMA()
      END
