      SUBROUTINE NMDPMF(COMPOR)
      IMPLICIT NONE
      CHARACTER*19 COMPOR
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 29/10/2012   AUTEUR FLEJOU J-L.FLEJOU 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE FLEJOU J-L.FLEJOU
C
C     POUR LES MULTIFIBRES, FUSION AVEC LA CARTE CREEE DANS
C        AFFE_MATERIAU / AFFE_COMPOR AVEC RCCOMP.F
C
C IN/OUT  COMPOR    carte de comportement
C ----------------------------------------------------------------------
      INCLUDE 'jeveux.h'
      INTEGER        N1,IBID,IARG
      LOGICAL        LCUMU(2),LCOC(2)
      CHARACTER*6    NOMPRO
      CHARACTER*8    CHMAT,LICMP
      CHARACTER*19   CHS(2),CHS3,CHSX
      REAL*8         LCOER(2)
      COMPLEX*16     LCOEC(2)
C
      PARAMETER (NOMPRO='NMDPMF')
C ----------------------------------------------------------------------
      DATA LCUMU/.FALSE.,.FALSE./
      DATA LCOC/.FALSE.,.FALSE./
      DATA LCOER/1.D0,1.D0/
C ----------------------------------------------------------------------
      CALL JEMARQ()
C
C     EN PRESENCE DE MULTIFIBRE, ON FUSIONNE LES CARTES
C     S'IL EXISTE UNE POUTRE MULTIFIBRE LA CARTE A ETE CREEE LORS
C        DE AFFE_MATERIAU / AFFE_COMPOR AVEC RCCOMP
C
C     CHAM_ELEM_S DE TRAVAIL
      CHS(1)='&&'//NOMPRO//'.CHS1'
      CHS(2)='&&'//NOMPRO//'.CHS2'
      CHS3  ='&&'//NOMPRO//'.CHS3'
      CHSX  ='&&'//NOMPRO//'.CHSX'
C
C     ON RECUPERE LA CARTE COMPOR ==> CHAM_ELEM_S
      CALL CARCES(COMPOR,'ELEM',' ','V',CHS(1),'A',IBID)
C
C     ON RECUPERE LA CARTE COMPOR DE AFFE_COMPOR ==> CHAM_ELEM_S
      CALL GETVID(' ','CHAM_MATER',1,IARG,1,CHMAT,N1)
      CALL CARCES(CHMAT//'.COMPOR','ELEM',' ','V',CHSX,'A',IBID)
C     ON ENLEVE LA COMPOSANTE 'DEFORM' DE LA CARTE
      LICMP = 'DEFORM'
      CALL CESRED(CHSX,0,IBID,-1,LICMP,'V',CHS(2))
C
C     FUSION DES CHAM_ELEM_S + COPIE DANS "COMPOR"
      CALL DETRSD('CARTE',COMPOR)
      CALL CESFUS(2,CHS,LCUMU,LCOER,LCOEC,LCOC,'V',CHS3)
      CALL CESCAR(CHS3,COMPOR,'V')
C
C     MENAGE
      CALL DETRSD('CHAM_ELEM_S',CHS(1))
      CALL DETRSD('CHAM_ELEM_S',CHS(2))
      CALL DETRSD('CHAM_ELEM_S',CHS3)
      CALL DETRSD('CHAM_ELEM_S',CHSX)
C
      CALL JEDEMA()
      END
