      SUBROUTINE NMERRO(SDERRO,SDTIME,NUMINS)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 22/10/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT      NONE
      INCLUDE 'jeveux.h'
      INTEGER       NUMINS
      CHARACTER*24  SDTIME,SDERRO
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C GESTION DES ERREURS ET EXCEPTIONS
C
C ----------------------------------------------------------------------
C
C
C IN  NUMINS : NUMERO DU PAS DE TEMPS
C IN  SDTIME : SD TIMER
C IN  SDERRO : SD GESTION ERREUR
C
C ----------------------------------------------------------------------
C
      CHARACTER*24 TIMPAS,TIMITE
      INTEGER      JTPAS,JTITE
      REAL*8       RTAB(2),R8BID
      INTEGER      ITAB(2),IBID
      CHARACTER*8  K8BID
      LOGICAL      ECHLDC,ECHEQ1,ECHEQ2,ECHCO1,ECHCO2,ECHPIL
      LOGICAL      MTCPUI,MTCPUP,ITEMAX
      LOGICAL      ECHPFG,ECHPFF,ECHPFC
      LOGICAL      ERRRES
      INTEGER      ETAUSR
      REAL*8       TPSRST,MOYITE,MOYPAS
      CHARACTER*16 NOMEVD,ACTION,VALK(2)
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- VERIFICATION SI INTERRUPTION DEMANDEE PAR SIGNAL USR1
C
      IF ( ETAUSR().EQ.1 ) CALL SIGUSR()
C
C --- ACCES SD TIMER
C
      TIMPAS = SDTIME(1:19)//'.TPAS'
      TIMITE = SDTIME(1:19)//'.TITE'
      CALL JEVEUO(TIMPAS,'L',JTPAS)
      CALL JEVEUO(TIMITE,'L',JTITE)
C
C --- TEMPS RESTANT
C
      TPSRST = ZR(JTPAS+1-1)
C
C --- TEMPS MOYENS
C
      MOYITE = ZR(JTITE+4-1)
      MOYPAS = ZR(JTPAS+4-1)
C
C --- RECUPERE LES CODES ERREURS ACTIFS
C
      CALL NMERGE(SDERRO,'ERRE_INTE',ECHLDC)
      CALL NMERGE(SDERRO,'ERRE_PILO',ECHPIL)
      CALL NMERGE(SDERRO,'ERRE_FACS',ECHEQ1)
      CALL NMERGE(SDERRO,'ERRE_FACT',ECHEQ2)
      CALL NMERGE(SDERRO,'ERRE_CTD1',ECHCO1)
      CALL NMERGE(SDERRO,'ERRE_CTD2',ECHCO2)
      CALL NMERGE(SDERRO,'ERRE_TIMN',MTCPUI)
      CALL NMERGE(SDERRO,'ERRE_TIMP',MTCPUP)
      CALL NMERGE(SDERRO,'ITER_MAXI',ITEMAX)
      CALL NMERGE(SDERRO,'ERRE_CTCG',ECHPFG)
      CALL NMERGE(SDERRO,'ERRE_CTCF',ECHPFF)
      CALL NMERGE(SDERRO,'ERRE_CTCC',ECHPFC)
      CALL NMERGE(SDERRO,'SOLV_ITMX',ERRRES)
C
C --- LANCEE EXCEPTIONS
C
      IF (MTCPUI) THEN
        ITAB(1) = NUMINS
        RTAB(1) = MOYITE
        RTAB(2) = TPSRST
        CALL UTEXCM(28,'MECANONLINE9_1',0,K8BID,1,ITAB  ,2,RTAB)
      ELSE IF (MTCPUP) THEN
        ITAB(1) = NUMINS
        RTAB(1) = MOYPAS
        RTAB(2) = TPSRST
        CALL UTEXCM(28,'MECANONLINE9_2',0,K8BID,1,ITAB  ,2,RTAB)
      ELSE IF (ECHLDC) THEN
        CALL UTEXCP(23,'MECANONLINE9_3')
      ELSE IF (ECHEQ1.OR.ECHEQ2) THEN
        CALL UTEXCP(25,'MECANONLINE9_4')
      ELSE IF (ECHCO1) THEN
        CALL UTEXCP(26,'MECANONLINE9_5')
      ELSE IF (ECHCO2) THEN
        CALL UTEXCP(27,'MECANONLINE9_6')
      ELSE IF (ITEMAX) THEN
        CALL UTEXCP(22,'MECANONLINE9_7')
      ELSE IF (ECHPIL) THEN
        CALL UTEXCP(29,'MECANONLINE9_8')
      ELSE IF (ECHPFG) THEN
        CALL UTEXCP(30,'MECANONLINE9_9')
      ELSE IF (ECHPFF) THEN
        CALL UTEXCP(31,'MECANONLINE9_10')
      ELSE IF (ECHPFC) THEN
        CALL UTEXCP(32,'MECANONLINE9_11')
      ELSE IF (ERRRES) THEN
        CALL UTEXCP(35,'MECANONLINE9_12')
      ELSE
        CALL NMECEV(SDERRO,'L',NOMEVD,ACTION)
        VALK(1) = ACTION
        VALK(2) = NOMEVD
        IF (ACTION.EQ.'ARRET') THEN
          CALL UTEXCM(33,'MECANONLINE9_51',1,NOMEVD,0,IBID,0,R8BID)
        ELSE
          CALL UTEXCM(34,'MECANONLINE9_50',2,VALK  ,0,IBID,0,R8BID)
        ENDIF
      ENDIF
C
      CALL JEDEMA()
C
      END
