      SUBROUTINE NMETDO(SDCRIQ)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 31/07/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      CHARACTER*24 SDCRIQ
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (INITIALISATION)
C
C POUR CALCUL DE L'INDICATEUR D'ERREUR TEMPORELLE, ON VERIFIE QU'ON EST
C BIEN DANS LE CADRE DES MODELISATIONS HM SATUREES AVEC COMPORTEMENT 
C MECANIQUE ELASTIQUE
C
C ----------------------------------------------------------------------
C
C IN  SDCRIQ : SD CRITERE QUALITE
C
C ----------------------------------------------------------------------
C
C DIMAKI = DIMENSION MAX DE LA LISTE DES RELATIONS KIT
      INTEGER      DIMAKI
      PARAMETER (DIMAKI=9)
C
      INTEGER      NBOCC,N1,N2,II,JJ,IOCC
      INTEGER      IDEBUT,IRET
      LOGICAL      ELLISQ
      CHARACTER*16 COMP1,COMEL(DIMAKI),ARGII,ARGJJ
      INTEGER      IARG
      CHARACTER*24 ERRTHM
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATION
C
      ERRTHM = SDCRIQ(1:19)//'.ERRT'
      CALL JEEXIN(ERRTHM,IRET)
      IF (IRET.EQ.0) GOTO 999
C
C --- INDICATEUR D'ERREUR EN TEMPS -> ON VERIFIE QUE C'EST POSSIBLE
C
      CALL GETFAC('COMP_INCR',NBOCC)
C
      IF (NBOCC.EQ.0) THEN
        CALL U2MESS('F','INDICATEUR_25')
      ELSE
        DO 10 IOCC = 1,NBOCC
          CALL GETVTX('COMP_INCR','RELATION',IOCC,IARG,1,COMP1,N1)
          IF (COMP1(1:6).EQ.'KIT_HM') THEN
            CALL GETVTX('COMP_INCR','RELATION_KIT',IOCC,IARG,
     &                  DIMAKI,COMEL(1),N2)
            IF (N2.EQ.0) THEN
              CALL ASSERT(.FALSE.)
            ELSE IF (N2.GT.DIMAKI) THEN
              CALL ASSERT(.FALSE.)
            ELSE
              ELLISQ = .FALSE.
              DO 101 II = 1,N2
                ARGII = COMEL(II)
                IF ((ARGII(1:4).EQ.'ELAS').OR.
     &              (ARGII(1:9).EQ.'LIQU_SATU')) THEN
                  IDEBUT = II + 1
                  DO 102 JJ = IDEBUT,N2
                    ARGJJ = COMEL(JJ)
                    IF ((ARGJJ(1:4).EQ.'ELAS').OR.
     &                  (ARGJJ(1:9).EQ.'LIQU_SATU')) THEN
                      ELLISQ = .TRUE.
                    ENDIF
 102              CONTINUE
                ENDIF
 101          CONTINUE
            ENDIF
          ENDIF
 10     CONTINUE
      ENDIF
C
      IF (.NOT.ELLISQ) THEN
        CALL U2MESS('F','INDICATEUR_23')
      ENDIF
C
  999 CONTINUE
C
      CALL JEDEMA()
C
      END
