      SUBROUTINE NMEVCV(SDERRO,FONACT,NOMBCL)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      INTEGER      FONACT(*)
      CHARACTER*24 SDERRO
      CHARACTER*4  NOMBCL
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C EVALUATION DE LA CONVERGENCE
C
C ----------------------------------------------------------------------
C
C
C IN  SDERRO : SD GESTION DES ERREURS
C IN  FONACT : FONCTIONNALITES ACTIVEES (VOIR NMFONC)
C IN  NOMBCL : NOM DE LA BOUCLE
C               'RESI' - BOUCLE SUR LES RESIDUS D'EQUILIBRE
C               'NEWT' - BOUCLE DE NEWTON
C               'FIXE' - BOUCLE DE POINT FIXE
C               'INST' - BOUCLE SUR LES PAS DE TEMPS
C               'CALC' - CALCUL
C
C
C
C
      LOGICAL      CVEVEN,ISFONC
      INTEGER      IEVEN,ZEVEN
      CHARACTER*24 ERRENI,ERRENO,ERRFCT
      INTEGER      JEENIV,JEENOM,JEEFCT
      CHARACTER*24 ERRINF
      INTEGER      JEINFO
      CHARACTER*9  NEVEN,TEVEN
      CHARACTER*24 FEVEN
      LOGICAL      DV,CV,LFONC
      CHARACTER*4  ETABCL
      LOGICAL      CVRESI,CVNEWT,CVFIXE,CVINST
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      ETABCL = 'CONT'
C
C --- ACCES SD
C
      ERRINF = SDERRO(1:19)//'.INFO'
      ERRENO = SDERRO(1:19)//'.ENOM'
      ERRENI = SDERRO(1:19)//'.ENIV'
      ERRFCT = SDERRO(1:19)//'.EFCT'
      CALL JEVEUO(ERRINF,'L',JEINFO)
      CALL JEVEUO(ERRENO,'L',JEENOM)
      CALL JEVEUO(ERRENI,'L',JEENIV)
      CALL JEVEUO(ERRFCT,'L',JEEFCT)
      ZEVEN  = ZI(JEINFO-1+1)
C
      CALL NMLECV(SDERRO,'RESI',CVRESI)
      CALL NMLECV(SDERRO,'NEWT',CVNEWT)
      CALL NMLECV(SDERRO,'FIXE',CVFIXE)
      CALL NMLECV(SDERRO,'INST',CVINST)
C
C --- EVALUATION DE LA CONVERGENCE
C
      CVEVEN = .TRUE.
      DO 10 IEVEN = 1,ZEVEN
        TEVEN  = ZK16(JEENIV-1+IEVEN)(1:9)
        NEVEN  = ZK16(JEENOM-1+IEVEN)(1:9)
        FEVEN  = ZK24(JEEFCT-1+IEVEN)
        DV     = .FALSE.
        CV     = .TRUE.
        IF (TEVEN.EQ.'CONV_'//NOMBCL) THEN
          IF (FEVEN.EQ.' ') THEN
            LFONC = .TRUE.
          ELSE
            LFONC = ISFONC(FONACT,FEVEN)
          ENDIF
          IF (NEVEN(1:4).EQ.'DIVE') THEN
            CALL NMERGE(SDERRO,NEVEN,DV)
            DV     = DV.AND.LFONC
            CV     = .TRUE.
          ELSEIF (NEVEN(1:4).EQ.'CONV') THEN
            CALL NMERGE(SDERRO,NEVEN,CV)
            CV     = CV.AND.LFONC
            DV     = .FALSE.
          ENDIF
          CVEVEN = CVEVEN.AND.(.NOT.DV).AND.CV
        ENDIF
 10   CONTINUE
C
C --- RECUPERE CONVERGENCES PRECEDENTES
C
      IF (NOMBCL.EQ.'NEWT') THEN
        CVEVEN = CVEVEN.AND.CVRESI
      ENDIF
      IF (NOMBCL.EQ.'FIXE') THEN
        CVEVEN = CVEVEN.AND.CVNEWT.AND.CVRESI
      ENDIF
      IF (NOMBCL.EQ.'INST') THEN
        CVEVEN = CVEVEN.AND.CVFIXE.AND.CVNEWT.AND.CVRESI
      ENDIF
      IF (NOMBCL.EQ.'CALC') THEN
        CVEVEN = CVEVEN.AND.CVINST.AND.CVFIXE.AND.CVNEWT.AND.CVRESI
      ENDIF
C
      IF (CVEVEN) ETABCL = 'CONV'
C
C --- ENREGISTREMENT DE LA CONVERGENCE
C
      CALL NMECEB(SDERRO,NOMBCL,ETABCL)
C
      CALL JEDEMA()
      END
