      SUBROUTINE NMEVDP(SDDISC,IEVDAC,RETSWA)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 22/10/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      INTEGER      IEVDAC,RETSWA
      CHARACTER*19 SDDISC
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME - EVENEMENTS)
C
C GESTION DE L'EVENEMENT DIVE_ITER_PILO
C
C ----------------------------------------------------------------------
C
C
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  IEVDAC : INDICE DE L'EVENEMENT ACTIF
C OUT RETSWA : CODE RETOUR CHANGE PILOTAGE
C               0 ECHEC DU SWAP
C               1 SWAP OK - ON REFAIT LE PAS DE TEMPS
C
C
C
C
      REAL*8       R8BID
      INTEGER      IBID
      INTEGER      PILESS
      CHARACTER*8  K8BID,PILCHO
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      RETSWA = 0
C
C --- PARAMETRES
C
      CALL UTDIDT('L'   ,SDDISC,'ECHE',IEVDAC,'ESSAI_ITER_PILO',
     &            R8BID ,PILESS,K8BID )
C
C --- L'UTILISATEUR UTILISE LE PILOTAGE
C --- ET SOUHAITE BASCULER SI NON-CONVERGENCE
C
      IF (PILESS.EQ.2) THEN
C
C ----- ON A DEJA CHOISI UNE SOLUTION: ON DECOUPE
C
        PILESS = 1
        PILCHO = 'NATUREL'
        RETSWA = 0
        CALL U2MESS('I','MECANONLINE10_42')
      ELSEIF (PILESS.EQ.1) THEN
C
C ----- ON RETENTE EN CHOISISSANT L'AUTRE SOLUTION
C
        PILESS = 2
        PILCHO = 'AUTRE'
        CALL U2MESS('I','MECANONLINE10_43')
        RETSWA = 1
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF
C
C --- SAUVEGARDE INFO
C
      CALL UTDIDT('E'   ,SDDISC,'ECHE',IEVDAC,'ESSAI_ITER_PILO',
     &            R8BID ,PILESS,K8BID )
      CALL UTDIDT('E'   ,SDDISC,'ECHE',IEVDAC,'CHOIX_SOLU_PILO',
     &            R8BID ,IBID  ,PILCHO)
C
      CALL JEDEMA()
      END
