      SUBROUTINE NMEVEV(SDDISC,NUMINS,VALINC,SDERRO,DEFICO,
     &                  RESOCO,NOMBCL)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 02/10/2012   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*24 SDERRO,DEFICO,RESOCO
      INTEGER      NUMINS
      CHARACTER*19 SDDISC,VALINC(*)
      CHARACTER*4  NOMBCL
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C DETECTION DU PREMIER EVENEMENT DECLENCHE
C
C ----------------------------------------------------------------------
C
C NB: DES QU'UN EVENT-DRIVEN EST SATISFAIT, ON SORT
C ON NE CHERCHE PAS A VERIFIER LES AUTRES EVENEMENTS
C
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  NUMINS : NUMERO D'INSTANT
C IN  SDERRO : SD GESTION DES ERREURS
C IN  NOMBCL : NOM DE LA BOUCLE
C               'NEWT' - BOUCLE DE NEWTON
C               'FIXE' - BOUCLE DE POINT FIXE
C IN  VALINC : VARIABLE CHAPEAU INCREMENTS DES VARIABLES
C IN  DEFICO : SD DE DEFINITION DU CONTACT
C IN  RESOCO : SD DE RESOLUTION DU CONTACT
C
C
C
C
      LOGICAL      LSVIMX,LDVRES,LINSTA
      LOGICAL      CONVER,LERROR,LERRCV
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- EVENEMENTS DE L'ALGORITHME
C
      CALL NMERGE(SDERRO,'SOLV_ITMX',LSVIMX)
      CALL NMERGE(SDERRO,'DIVE_RESI',LDVRES)
      CALL NMERGE(SDERRO,'CRIT_STAB',LINSTA)
C
C --- LA BOUCLE COURANTE A-T-ELLE CONVERGE ?
C
      CALL NMLECV(SDERRO,NOMBCL,CONVER)
C
C --- DECLENCHEMENT DE L'ERREUR A CONVERGENCE
C
      CALL NMLTEV(SDERRO,'ERRC',NOMBCL,LERROR)
      IF (CONVER.AND.LERROR) THEN
        LERRCV = .TRUE.
      ELSE
        LERRCV = .FALSE.
      ENDIF
C
C --- ERREUR IMMEDIATE AU NIVEAU DE LA BOUCLE COURANTE ?
C
      CALL NMLTEV(SDERRO,'ERRI',NOMBCL,LERROR)
C
C --- PREMIER EVENT DECLENCHE
C
      CALL NMEVEL(SDDISC,NUMINS,DEFICO,RESOCO,VALINC,
     &            NOMBCL,LSVIMX,LDVRES,LINSTA,LERRCV,
     &            LERROR,CONVER)
C
      CALL JEDEMA()
      END
