      SUBROUTINE NMFINT(MODELE,MATE  ,CARELE,COMREF,COMPOR,
     &                  CARCRI,FONACT,ITERAT,SDDYNA,SDSTAT,
     &                  SDTIME,VALINC,SOLALG,LDCCVG,CODERE,
     &                  VEFINT)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 24/09/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      INTEGER       LDCCVG
      INTEGER       ITERAT
      INTEGER       FONACT(*)
      CHARACTER*19  SDDYNA
      CHARACTER*24  SDTIME,SDSTAT
      CHARACTER*24  MODELE,MATE  ,CODERE
      CHARACTER*24  CARELE,COMPOR,COMREF,CARCRI
      CHARACTER*19  SOLALG(*),VALINC(*)
      CHARACTER*19  VEFINT
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C INTEGRATION DE LA LOI DE COMPORTEMENT
C CALCUL DES FORCES INTERIEURES
C
C ----------------------------------------------------------------------
C
C
C IN  MODELE : NOM DU MODELE
C IN  MATE   : NOM DU CHAMP DE MATERIAU
C IN  SDTIME : SD TIMER
C IN  SDSTAT : SD STATISTIQUES
C IN  CARELE : CARACTERISTIQUES DES ELEMENTS DE STRUCTURE
C IN  COMREF : VALEURS DE REF DES VARIABLES DE COMMANDE
C IN  COMPOR : CARTE DECRIVANT LE TYPE DE COMPORTEMENT
C IN  CARCRI : CARTE DES CRITERES DE CONVERGENCE LOCAUX
C IN  FONACT : FONCTIONNALITES ACTIVEES
C IN  ITERAT : NUMERO DE L'ITERATION DE NEWTON
C IN  SDDYNA : SD DYNAMIQUE
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C IN  SOLALG : VARIABLE CHAPEAU POUR INCREMENTS SOLUTIONS
C OUT VEFINT : VECT_ELEM DES FORCES INTERNES
C OUT CODERE : CHAM_ELEM CODE RETOUR ERREUR INTEGRATION LDC
C OUT LDCCVG : CODE RETOUR DE L'INTEGRATION DU COMPORTEMENT
C                -1 : PAS D'INTEGRATION DU COMPORTEMENT
C                 0 : CAS DE FONCTIONNEMENT NORMAL
C                 1 : ECHEC DE L'INTEGRATION DE LA LDC
C                 3 : SIZZ PAS NUL POUR C_PLAN DEBORST
C
C ----------------------------------------------------------------------
C
      LOGICAL      TABRET(0:10)
      INTEGER      ITER
      INTEGER      IFM,NIV
      CHARACTER*1  BASE
      CHARACTER*16 OPTION
      CHARACTER*19 K19BLA
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('MECA_NON_LINE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<MECANONLINE> ... CALCUL DES FORCES INTERNES'
      ENDIF
C
C --- INITIALISATIONS
C
      ITER   = ITERAT+1
      BASE   = 'V'
      K19BLA = ' '
      OPTION = 'RAPH_MECA'
      CODERE = '&&OP0070.CODERE'
      LDCCVG = 0
C
C --- INIT TIMER
C
      CALL NMTIME(SDTIME,'INI','INTEGRATION')
      CALL NMTIME(SDTIME,'RUN','INTEGRATION')
C
C --- CALCUL DES FORCES INTERIEURES
C
      CALL MERIMO(BASE  ,MODELE,CARELE,MATE  ,COMREF,
     &            COMPOR,CARCRI,ITER  ,FONACT,SDDYNA,
     &            VALINC,SOLALG,K19BLA,VEFINT,OPTION,
     &            TABRET,CODERE)
C
C --- FIN TIMER
C
      CALL NMTIME(SDTIME,'END','INTEGRATION')
      CALL NMRINC(SDSTAT,'INTEGRATION')
C
C --- CODE RETOUR ERREUR INTEGRATION LDC
C
      IF (TABRET(0)) THEN
        IF ( TABRET(3) ) THEN
          LDCCVG = 3
        ELSEIF ( TABRET(2) ) THEN
          LDCCVG = 2
        ELSE
          LDCCVG = 1
        ENDIF
        IF ( TABRET(1) ) THEN
          LDCCVG = 1
        ENDIF
      ENDIF
C
      CALL JEDEMA()
      END
