       SUBROUTINE  NMGRTG(NDIM,NNO,POIDS,KPG,VFF,DFDI,DEF,PFF,OPTION,
     &               AXI,R,FM,F,DSIDEP,SIGN,SIGMA,MATSYM,MATUU,VECTU)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 07/11/2011   AUTEUR PROIX J-M.PROIX 
C ======================================================================
C COPYRIGHT (C) 1991 - 2011  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
       IMPLICIT NONE
C
       INTEGER NDIM,NNO,KPG
       CHARACTER*16  OPTION
       REAL*8 PFF(*),DEF(*),R,DSIDEP(6,6),POIDS,VECTU(*)
       REAL*8 SIGMA(6),SIGN(6),MATUU(*),VFF(*)
       REAL*8 FM(3,3),F(3,3),FR(3,3),DFDI(*)
       LOGICAL MATSYM,AXI,RESI,RIGI

C.......................................................................
C     BUT:  CALCUL DE LA MATRICE TANGENTE EN CONFIGURATION LAGRANGIENNE
C           OPTIONS RIGI_MECA_TANG ET FULL_MECA 
C.......................................................................
C IN  NNO     : NOMBRE DE NOEUDS DE L'ELEMENT
C IN  NDIM    : DIMENSION DU PB
C IN  POIDS   : POIDS DES POINTS DE GAUSS
C IN  KPG     : NUMERO DU POINT DE GAUSS
C IN  VFF     : VALEUR  DES FONCTIONS DE FORME
C IN  DEF     : PRODUIT DE F PAR LA DERIVEE DES FONCTIONS DE FORME
C IN  PFF     : PRODUIT DES FONCTIONS DE FORME
C IN  OPTION  : OPTION DE CALCUL
C IN  AXI     : .TRUE. SI AXIS
C IN  R       : RAYON DU POINT DE GAUSS COURANT (EN AXI)
C IN  DSIDEP  : OPERATEUR TANGENT ISSU DU COMPORTEMENT
C IN  SIGN    : CONTRAINTES PK2 A L'INSTANT PRECEDENT (AVEC RAC2)
C IN  SIGMA   : CONTRAINTES PK2 A L'INSTANT ACTUEL    (AVEC RAC2)
C IN  MATSYM  : VRAI SI LA MATRICE DE RIGIDITE EST SYMETRIQUE
C OUT MATUU   : MATRICE DE RIGIDITE PROFIL (RIGI_MECA_TANG ET FULL_MECA)
C.......................................................................
C
      RESI = OPTION(1:4).EQ.'RAPH' .OR. OPTION(1:4).EQ.'FULL'
      RIGI = OPTION(1:4).EQ.'RIGI' .OR. OPTION(1:4).EQ.'FULL'

C     CALCUL DES PRODUITS SYMETR. DE F PAR N

      IF (RESI) THEN
         CALL DCOPY(9,F,1,FR,1)
      ELSE
         CALL DCOPY(9,FM,1,FR,1)
      ENDIF
      
      CALL NMFDFF(NDIM,NNO,AXI,KPG,R,RIGI,MATSYM,FR,VFF,DFDI,DEF,PFF)

C     DEUX ROUTINES DIFFERENTES POUR OPTIMISER lE TEMPS CPU      

      IF (NDIM.EQ.3) THEN
      
         CALL  NMGRT3(NNO,POIDS,KPG,VFF,DEF,PFF,OPTION,AXI,R,
     &                RESI,RIGI,DSIDEP,SIGN,SIGMA,MATSYM,MATUU,VECTU)
     
      ELSEIF (NDIM.EQ.2) THEN
      
         CALL  NMGRT2(NNO,POIDS,KPG,VFF,DEF,PFF,OPTION,AXI,R,
     &                RESI,RIGI,DSIDEP,SIGN,SIGMA,MATSYM,MATUU,VECTU)
     
      ENDIF

      END
