      SUBROUTINE NMIBLE(MODELE,NOMA  ,DEFICO,RESOCO,FONACT,
     &                  NUMINS,NIVEAU,NUMEDD,SDSTAT,SDTIME,
     &                  SDIMPR)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 30/10/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      INTEGER      NUMINS,NIVEAU
      CHARACTER*8  NOMA
      CHARACTER*24 DEFICO,RESOCO
      CHARACTER*24 SDSTAT,SDTIME,SDIMPR
      CHARACTER*24 MODELE,NUMEDD
      CHARACTER*19 SDDISC
      INTEGER      FONACT(*)
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C GESTION DEBUT DE BOUCLE POINTS FIXES
C
C ----------------------------------------------------------------------
C
C
C LES ITERATIONS ONT LIEU ENTRE CETTE ROUTINE ET SA COUSINE
C (NMTBLE) QUI COMMUNIQUENT PAR LA VARIABLE NIVEAU
C
C I/O NIVEAU : INDICATEUR D'UTILISATION DE LA BOUCLE DE POINT FIXE
C                  0     ON N'UTILISE PAS CETTE BOUCLE
C                  3     BOUCLE GEOMETRIE
C                  2     BOUCLE SEUILS DE FROTTEMENT
C                  1     BOUCLE CONTRAINTES ACTIVES
C IN  NUMINS : NUMERO D'INSTANT
C IN  MODELE : NOM DU MODELE
C IN  NOMA   : NOM DU MAILLAGE
C IN  FONACT : FONCTIONNALITES ACTIVEES
C IN  DEFICO : SD POUR LA DEFINITION DE CONTACT
C IN  RESOCO : SD POUR LA RESOLUTION DE CONTACT
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  SDTIME : SD TIMER
C IN  SDSTAT : SD STATISTIQUES
C IN  SDIMPR : SD AFFICHAGE
C IN  NUMEDD : NOM DU NUME_DDL
C
C ----------------------------------------------------------------------
C
      INTEGER      MMITGO,MMITCA,MMITFR
      LOGICAL      ISFONC,LBOUCF,LBOUCG,LBOUCC
      LOGICAL      LAPPA,LOPTIN
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
      IF (NIVEAU.EQ.0) THEN
        GOTO 9999
      ENDIF
C
C --- PAS D'ACTIVATION DES OPTIONS *_INIT (FAIT DANS MMAPIN)
C
      LOPTIN = .FALSE.
C
C --- PAS D'APPARIEMENT AU PREMIER COUP (FAIT DANS MMAPIN)
C
      LAPPA  = .TRUE.
      CALL MMBOUC(RESOCO,'GEOM','READ',MMITGO)
      IF (MMITGO.EQ.1) LAPPA = .FALSE.
C
C --- INFOS SUR LES BOUCLES
C
      LBOUCF = ISFONC(FONACT,'BOUCLE_EXT_FROT')
      LBOUCG = ISFONC(FONACT,'BOUCLE_EXT_GEOM')
      LBOUCC = ISFONC(FONACT,'BOUCLE_EXT_CONT')
C
C --- BRANCHEMENT
C
      GOTO (101,102,103) NIVEAU
C
C --- NIVEAU: 3   BOUCLE GEOMETRIE
C
 103  CONTINUE
C
C --- ECRITURE NUMERO ITERATION
C
      CALL NMIMCI(SDIMPR,'BOUC_GEOM',MMITGO,.TRUE.)
C
C --- NOUVELLE ITERATION DE GEOMETRIE
C
      IF (LBOUCG) THEN
        NIVEAU = 3
        IF (LAPPA) THEN
          CALL NMCTCG(MODELE,NOMA  ,DEFICO,RESOCO,LOPTIN,
     &                SDSTAT,SDTIME,NUMEDD)
        ENDIF
      ENDIF
C
C --- PREMIERE ITERATION DE FROTTEMENT
C
      CALL MMBOUC(RESOCO,'FROT','INIT',MMITFR)
      CALL MMBOUC(RESOCO,'FROT','INCR',MMITFR)
      CALL NMIMCI(SDIMPR,'BOUC_FROT',MMITFR,.TRUE.)
C
C --- NIVEAU: 2   BOUCLE SEUILS DE FROTTEMENT
C
 102  CONTINUE
C
C --- NOUVELLE ITERATION DE FROTTEMENT
C
      IF (LBOUCF) THEN
        NIVEAU = 2
      ENDIF
C
C --- PREMIERE ITERATION DE CONTACT
C
      CALL MMBOUC(RESOCO,'CONT','INIT',MMITCA)
      CALL MMBOUC(RESOCO,'CONT','INCR',MMITCA)
      CALL NMIMCI(SDIMPR,'BOUC_CONT',MMITCA,.TRUE.)
C
C --- NIVEAU: 1   BOUCLE CONTACT
C
 101  CONTINUE
C
C --- NOUVELLE ITERATION DE CONTACT
C
      IF (LBOUCC) THEN
        NIVEAU = 1
      ENDIF
C
 9999 CONTINUE
C
      CALL JEDEMA()
      END
