      SUBROUTINE NMIMR0(SDIMPR,NOMBCL)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE      'jeveux.h'

      CHARACTER*24 SDIMPR
      CHARACTER*4  NOMBCL
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (UTILITAIRE)
C
C INITIALISATION AFFECTATION DES COLONNES
C
C ----------------------------------------------------------------------
C
C
C IN  SDIMPR : SD AFFICHAGE
C IN  NOMBCL : NOM DE LA BOUCLE
C               'RESI' - BOUCLE SUR LES RESIDUS D'EQUILIBRE
C               'NEWT' - BOUCLE DE NEWTON
C               'FIXE' - BOUCLE DE POINT FIXE
C               'INST' - BOUCLE SUR LES PAS DE TEMPS
C               'CALC' - CALCUL
C IN  SDCONV : SD GESTION DE LA CONVERGENCE
C
C ----------------------------------------------------------------------
C
      INTEGER      ICOL,NCOL
      CHARACTER*9  TYPCOL
      LOGICAL      LAFFE,LACTI
      CHARACTER*24 SLCOLO,SDTABC,SDCOLO
      CHARACTER*4  LIEUIN
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      LAFFE  = .FALSE.
C
C --- LISTE DES COLONNES DISPONIBLES DANS LE TABLEAU DE CONVERGENCE
C
      CALL OBGETO(SDIMPR,'TABLEAU_CONV'   ,SDTABC)
      CALL OBGETO(SDTABC,'COLONNES_DISPOS',SLCOLO)
      CALL OBGETI(SLCOLO,'NBRE_STRUCTS'   ,NCOL  )
C
C --- DESAFFECTE TOUTES LES COLONNES
C
       DO 30 ICOL = 1,NCOL
        CALL OBLGOI(SLCOLO,ICOL  ,SDCOLO)
        CALL OBLGAI(SLCOLO,ICOL  ,LACTI )
        IF (LACTI) THEN
          CALL OBGETK(SDCOLO,'TYPE_COLONNE',TYPCOL)
          CALL OBGETK(SDCOLO,'TYPE_COLONNE',LIEUIN)
          IF (NOMBCL.EQ.LIEUIN) CALL NMIMCA(SDIMPR,TYPCOL,LAFFE )
        ENDIF
 30   CONTINUE
C
      CALL JEDEMA()
      END
