      SUBROUTINE NMIMRV(SDIMPR,FONACT,ITERAT,FETITE,RELCOE,
     &                  RELITE,ETA   )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 18/09/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INTEGER      FONACT(*),ITERAT
      CHARACTER*24 SDIMPR
      REAL*8       RELCOE,ETA
      INTEGER      RELITE,FETITE
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME - CONVERGENCE)
C
C ENREGISTRE LES DONNEES DANS LA SDIMPR
C LES DONNES POUR LES RESIDUS SONT ECRITS DANS NMIMRE
C
C ----------------------------------------------------------------------
C
C
C IN  SDIMPR : SD AFFICHAGE
C IN  FONACT : FONCTIONNALITES ACTIVEES
C IN  ITERAT : NUMERO D'ITERATION DE NEWTON
C IN  FETITE : NB ITER. FETI
C IN  RELCOE : VALEUR COEF. RECHERCHE LINEAIRE
C IN  RELITE : NB ITER. RECHERCHE LINEAIRE
C IN  ETA    : VALEUR COEF. PILOTAGE
C
C ----------------------------------------------------------------------
C
      LOGICAL      LRELI,LFETI,LPILO,LBORST
      LOGICAL      ISFONC
C
C ----------------------------------------------------------------------
C

C
C --- INITIALISATIONS
C
      LBORST = ISFONC(FONACT,'DEBORST')
      LPILO  = ISFONC(FONACT,'PILOTAGE')
      LRELI  = ISFONC(FONACT,'RECH_LINE')
      LFETI  = ISFONC(FONACT,'FETI')
C
C --- ECRITURE CRITERES RECHERCHE LINEAIRE
C
      IF (LRELI.AND.(ITERAT.NE.0)) THEN
        CALL NMIMCI(SDIMPR,'RELI_NBIT',RELITE,.TRUE.)
        CALL NMIMCR(SDIMPR,'RELI_COEF',RELCOE,.TRUE.)
      ENDIF
C
C --- ECRITURE CRITERES PILOTAGE
C
      IF (LPILO) THEN
        CALL NMIMCR(SDIMPR,'PILO_COEF',ETA   ,.TRUE.)
      ENDIF
C
C --- ECRITURE NUMERO ITERATION FETI
C
      IF (LFETI) THEN
        CALL NMIMCI(SDIMPR,'FETI_NBIT',FETITE,.TRUE.)
      ENDIF
C
C --- ECRITURE DE BORST
C
      IF (LBORST) THEN
        CALL NMIMCK(SDIMPR,'DEBORST  ','DE BORST...',.TRUE.)
      ENDIF
C
      END
