      SUBROUTINE NMMASS(FONACT,LISCHA,SDDYNA,SOLVEU,NUMEDD,
     &                  NUMFIX,MEELEM,MASSE)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 05/03/2012   AUTEUR IDOUX L.IDOUX 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE IDOUX L.IDOUX
      IMPLICIT NONE
      INTEGER       FONACT(*)
      CHARACTER*19  LISCHA,SDDYNA,SOLVEU
      CHARACTER*24  NUMEDD,NUMFIX
      CHARACTER*19  MEELEM(*)
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (CALCUL)
C
C PRE-CALCUL DES MATRICES ASSEMBLEES CONSTANTES AU COURS DU CALCUL
C      
C ----------------------------------------------------------------------
C
C
C IN  FONACT : FONCTIONNALITES ACTIVEES (VOIR NMFONC)
C IN  LISCHA : LISTE DES CHARGEMENTS
C IN  SDDYNA : SD DYNAMIQUE
C IN  SOLVEU : SOLVEUR
C IN  NUMEDD : NUME_DDL (VARIABLE AU COURS DU CALCUL)
C IN  NUMFIX : NUME_DDL (FIXE AU COURS DU CALCUL)
C IN  MEELEM : MATRICES ELEMENTAIRES
C OUT MASSE  : MATRICE MASSE POUR LE CALCUL DES ENERGIES
C      
C ----------------------------------------------------------------------
C
      LOGICAL      NDYNLO,LDYNA,LEXPL,LIMPL
      CHARACTER*16 OPTASS
      CHARACTER*19 MASSE   
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      LDYNA  = NDYNLO(SDDYNA,'DYNAMIQUE')
      LEXPL  = NDYNLO(SDDYNA,'EXPLICITE')
      LIMPL  = NDYNLO(SDDYNA,'IMPLICITE')
C
C --- ASSEMBLAGE DE LA MATRICE MASSE
C
      IF (LDYNA) THEN 
        IF (LIMPL) THEN
          OPTASS = ' '
        ELSEIF (LEXPL) THEN
          OPTASS = 'AVEC_DIRICHLET'
        ELSE
          CALL ASSERT(.FALSE.)
        ENDIF     
        MASSE = '&&NMMASS.MASSENER' 
        CALL NMASSM(FONACT  ,LISCHA,SOLVEU,NUMEDD,NUMFIX,
     &              'MEMASS',OPTASS,MEELEM,MASSE)
        CALL MTDSCR(MASSE)
      ENDIF
C
      CALL JEDEMA()
      END
