      SUBROUTINE NMNBLE(NUMINS,MODELE,NOMA  ,NUMEDD,SDSTAT,
     &                  SDTIME,SDDYNA,SDDISC,FONACT,DEFICO,
     &                  RESOCO,VALINC,SOLALG)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 30/10/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      INTEGER      FONACT(*)
      CHARACTER*8  NOMA
      CHARACTER*24 MODELE
      CHARACTER*24 NUMEDD
      CHARACTER*24 DEFICO,RESOCO
      CHARACTER*24 SDTIME,SDSTAT
      CHARACTER*19 SDDYNA,SDDISC
      CHARACTER*19 SOLALG(*),VALINC(*)
      INTEGER      NUMINS
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGO - BOUCLE CONTACT)
C
C BOUCLE CONTACT: GESTION DES CONTRAINTES ACTIVES
C
C ----------------------------------------------------------------------
C
C
C IN  MODELE : NOM DU MODELE
C IN  NOMA   : NOM DU MAILLAGE
C IN  NUMINS : NUMERO D'INSTANT
C IN  FONACT : FONCTIONNALITES ACTIVEES
C IN  SDTIME : SD TIMER
C IN  SDSTAT : SD STATISTIQUES
C IN  DEFICO : SD POUR LA DEFINITION DE CONTACT
C IN  RESOCO : SD POUR LA RESOLUTION DE CONTACT
C IN  SDDYNA : SD DEDIEE A LA DYNAMIQUE
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  NUMEDD : NOM DU NUME_DDL
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C IN  SOLALG : VARIABLE CHAPEAU POUR INCREMENTS SOLUTIONS
C
C ----------------------------------------------------------------------
C
      INTEGER      NEQ,IRET
      LOGICAL      NDYNLO,ISFONC,CFDISL
      CHARACTER*8  K8BID
      CHARACTER*19 DEPMOI,DEPPLU
      CHARACTER*19 DEPDEL,DDEPLA
      INTEGER      JDEPDE,JDDEPL
      CHARACTER*19 VITINI,ACCINI,VITPLU,ACCPLU
      LOGICAL      LOPTIN,LALLV,LELTC,LDYNA
      INTEGER      MMITGO,MMITFR,MMITCA
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- FONCTIONNALITES ACTIVEES
C
      LELTC  = ISFONC(FONACT,'ELT_CONTACT')
      LDYNA  = NDYNLO(SDDYNA,'DYNAMIQUE')
      IF (.NOT.LELTC) GOTO 999
C
C --- ACTIVATION DES OPTIONS *_INIT ?
C
      CALL MMBOUC(RESOCO,'GEOM','READ',MMITGO)
      CALL MMBOUC(RESOCO,'FROT','READ',MMITFR)
      CALL MMBOUC(RESOCO,'CONT','READ',MMITCA)
      LOPTIN  = (NUMINS.LE.1).AND.(MMITGO.EQ.0).AND.(MMITFR.EQ.1)
     &           .AND.(MMITCA.EQ.1)
C
C --- INITIALISATIONS
C
      CALL DISMOI('F','NB_EQUA',NUMEDD,'NUME_DDL',NEQ,K8BID,IRET)

      LALLV  = CFDISL(DEFICO,'ALL_VERIF')
      IF (LALLV) GOTO 999
C
C --- DECOMPACTION DES VARIABLES CHAPEAUX
C
      CALL NMCHEX(VALINC,'VALINC','DEPMOI',DEPMOI)
      CALL NMCHEX(VALINC,'VALINC','DEPPLU',DEPPLU)
      CALL NMCHEX(VALINC,'VALINC','VITPLU',VITPLU)
      CALL NMCHEX(VALINC,'VALINC','ACCPLU',ACCPLU)
      CALL NMCHEX(SOLALG,'SOLALG','DEPDEL',DEPDEL)
      CALL NMCHEX(SOLALG,'SOLALG','DDEPLA',DDEPLA)
C
C --- INITIALISATION DES CHAMPS DE DEPLACEMENT
C
      CALL COPISD('CHAMP_GD','V',DEPMOI,DEPPLU)
      CALL JEVEUO(DEPDEL(1:19)//'.VALE','E',JDEPDE)
      CALL JEVEUO(DDEPLA(1:19)//'.VALE','E',JDDEPL)
      CALL R8INIR(NEQ,0.D0,ZR(JDEPDE),1)
      CALL R8INIR(NEQ,0.D0,ZR(JDDEPL),1)
C
C --- AFIN QUE LE VECTEUR DES FORCES D'INERTIE NE SOIT PAS MODIFIE AU
C --- COURS DE LA BOUCLE DES CONTRAINTES ACTIVES PAR L'APPEL A OP0070
C --- ON LE DUPLIQUE ET ON UTILISE CETTE COPIE FIXE (VITINI,ACCINI)
C
      IF (LDYNA) THEN
        VITINI = RESOCO(1:14)//'.VITI'
        ACCINI = RESOCO(1:14)//'.ACCI'
        CALL COPISD('CHAMP_GD','V',VITINI,VITPLU)
        CALL COPISD('CHAMP_GD','V',ACCINI,ACCPLU)
      ENDIF
C
C --- CREATION ELEMENTS TARDIFS ET CARTE
C
      CALL NMTIME(SDTIME,'INI','CTCC_PREP')
      CALL NMTIME(SDTIME,'RUN','CTCC_PREP')
      CALL NMCTCL(NUMINS,MODELE,NOMA  ,DEFICO,RESOCO,
     &            SDDYNA,SDDISC,LOPTIN)
      CALL NMTIME(SDTIME,'END','CTCC_PREP')
      CALL NMRINC(SDSTAT,'CTCC_PREP')
C
  999 CONTINUE
C
      CALL JEDEMA()
C
      END
