      SUBROUTINE NMPICH(MODELE,NUMEDD,MATE  ,CARELE,COMREF,
     &                  COMPOR,LISCHA,CARCRI,FONACT,SDSTAT,
     &                  DEFICO,RESOCO,SDPILO,ITERAT,SDNUME,
     &                  DELTAT,VALINC,SOLALG,VEELEM,VEASSE,
     &                  SDTIME,SDDISC,ETA   ,RHO   ,OFFSET,
     &                  LDCCVG,PILCVG,MATASS)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C TOLE CRP_21
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      INTEGER       FONACT(*)
      INTEGER       ITERAT,PILCVG,LDCCVG
      REAL*8        DELTAT,ETA,RHO,OFFSET
      CHARACTER*19  LISCHA,SDNUME,SDPILO,SDDISC,MATASS
      CHARACTER*24  CARCRI,MODELE,NUMEDD,MATE  ,CARELE,COMREF,COMPOR
      CHARACTER*24  DEFICO,RESOCO
      CHARACTER*24  SDSTAT,SDTIME
      CHARACTER*19  VEELEM(*),VEASSE(*)
      CHARACTER*19  SOLALG(*),VALINC(*)
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME - PILOTAGE)
C
C CALCUL DU ETA DE PILOTAGE ET CALCUL DE LA CORRECTION
C
C ----------------------------------------------------------------------
C
C
C IN  MODELE : MODELE
C IN  NUMEDD : NUME_DDL
C IN  MATE   : CHAMP MATERIAU
C IN  CARELE : CARACTERISTIQUES DES ELEMENTS DE STRUCTURE
C IN  SDNUME : SD NUMEROTATION
C IN  COMREF : VARI_COM DE REFERENCE
C IN  COMPOR : COMPORTEMENT
C IN  LISCHA : LISTE DES CHARGES
C IN  SDSTAT : SD STATISTIQUES
C IN  SDPILO : SD PILOTAGE
C IN  CARCRI : PARAMETRES DES METHODES D'INTEGRATION LOCALES
C IN  FONACT : FONCTIONNALITES ACTIVEES
C IN  DEFICO : SD DEFINITION CONTACT
C IN  RESOCO : SD RESOLUTION CONTACT VOLATILE OP0070
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C IN  SOLALG : VARIABLE CHAPEAU POUR INCREMENTS SOLUTIONS
C IN  VEASSE : VARIABLE CHAPEAU POUR NOM DES VECT_ASSE
C IN  ITERAT : NUMERO D'ITERATION DE NEWTON
C IN  DELTAT : INCREMENT DE TEMPS
C IN  NBEFFE : NOMBRE DE VALEURS DE PILOTAGE ENTRANTES
C IN  SDTIME : SD TIMER
C IN  SDDISC : SD DISCRETISATION
C OUT ETA    : PARAMETRE DE PILOTAGE
C OUT RHO    : PARAMETRE DE RECHERCHE_LINEAIRE
C OUT OFFSET : DECALAGE DE ETA_PILOTAGE EN FONCTION DE RHO
C OUT PILCVG : CODE DE CONVERGENCE POUR LE PILOTAGE
C                -1 : PAS DE CALCUL DU PILOTAGE
C                 0 : CAS DU FONCTIONNEMENT NORMAL
C                 1 : PAS DE SOLUTION
C                 2 : BORNE ATTEINTE -> FIN DU CALCUL
C OUT LDCCVG : CODE RETOUR DE L'INTEGRATION DU COMPORTEMENT
C                -1 : PAS D'INTEGRATION DU COMPORTEMENT
C                 0 : CAS DU FONCTIONNEMENT NORMAL
C                 1 : ECHEC DE L'INTEGRATION DE LA LDC
C                 2 : ERREUR SUR LA NON VERIF. DE CRITERES PHYSIQUES 
C                 3 : SIZZ PAS NUL POUR C_PLAN DEBORST
C IN  MATASS : SD MATRICE ASSEMBLEE
C
C
C
C
      INTEGER      NBEFFE,NBATTE
      REAL*8       PROETA(2),RESIDU
      INTEGER      IFM,NIV
      LOGICAL      IRECLI
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('PILOTAGE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<PILOTAGE> ... PILOTAGE SANS RECH_LINE'
      ENDIF
C
C --- INITIALISATIONS
C
      PILCVG = -1
      RHO    = 1.D0
      OFFSET = 0.D0
      NBATTE = 2
      IRECLI = .FALSE.
C
C --- RESOLUTION DE L'EQUATION DE PILOTAGE
C
      CALL NMPILO(SDPILO,DELTAT,RHO   ,SOLALG,VEASSE,
     &            MODELE,MATE  ,COMPOR,RESOCO,VALINC,
     &            NBATTE,NUMEDD,NBEFFE,PROETA,PILCVG,
     &            CARELE)
C
      IF (PILCVG.EQ.1) GOTO 9999
C
C --- CHOIX DE ETA_PILOTAGE
C
      CALL NMCETA(MODELE,NUMEDD,MATE  ,CARELE,COMREF,
     &            COMPOR,LISCHA,CARCRI,FONACT,SDSTAT,
     &            DEFICO,SDPILO,ITERAT,SDNUME,VALINC,
     &            SOLALG,VEELEM,VEASSE,SDTIME,SDDISC,
     &            NBEFFE,IRECLI,PROETA,OFFSET,RHO   ,
     &            ETA   ,LDCCVG,PILCVG,RESIDU,MATASS)
C
 9999 CONTINUE
C
C --- LE CALCUL DE PILOTAGE A FORCEMENT ETE REALISE
C
      CALL ASSERT(PILCVG.GE.0)
C
      CALL JEDEMA()
      END
