      SUBROUTINE NMPILK(INCPR1,INCPR2,DDINCC,NEQ   ,ETA,
     &                  RHO   ,OFFSET)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      INTEGER      NEQ
      REAL*8       ETA,RHO,OFFSET
      CHARACTER*19 INCPR1,INCPR2,DDINCC
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C AJUSTEMENT DE LA DIRECTION DE DESCENTE
C      
C ----------------------------------------------------------------------
C
C CORR = RHO * PRED(1) + (ETA-OFFSET) * PRED(2)
C
C IN  NEQ    : LONGUEUR DES CHAM_NO
C IN  INCPR1 : INCREMENT SOLUTION PHASE PREDICTION 1
C IN  INCPR2 : INCREMENT SOLUTION PHASE PREDICTION 2 (TERME PILOTAGE)
C OUT DDINNC : INCREMENT SOLUTION APRES PILOTAGE/RECH. LINE.
C IN  ETA    : PARAMETRE DE PILOTAGE
C IN  RHO    : PARAMETRE DE RECHERCHE LINEAIRE
C IN  OFFSET : DECALAGE DU PARMAETRE DE PILOTAGE
C
C
C
C
      INTEGER      I,JDU0,JDU1,JDDEPL      
C 
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      CALL JEVEUO(INCPR1(1:19)//'.VALE','L',JDU0)
      CALL JEVEUO(INCPR2(1:19)//'.VALE','L',JDU1)
      CALL JEVEUO(DDINCC(1:19)//'.VALE','E',JDDEPL)
C     
C --- CALCUL
C
      DO 10 I = 1, NEQ
        ZR(JDDEPL+I-1) = RHO*ZR(JDU0+I-1) + (ETA-OFFSET)*ZR(JDU1+I-1)
 10   CONTINUE
C
      CALL JEDEMA()
      END
