      SUBROUTINE NMPRDE(MODELE,NUMEDD,NUMFIX,MATE  ,CARELE,
     &                  COMREF,COMPOR,LISCHA,METHOD,SOLVEU,
     &                  FONACT,PARMET,CARCRI,SDIMPR,SDSTAT,
     &                  SDTIME,SDDISC,NUMINS,VALINC,SOLALG,
     &                  MATASS,MAPREC,DEFICO,RESOCO,SDDYNA,
     &                  MEELEM,MEASSE,VEELEM,VEASSE,LDCCVG,
     &                  FACCVG,RESCVG,CODERE)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 02/10/2012   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C TOLE CRP_21
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      INTEGER      FONACT(*)
      INTEGER      NUMINS,LDCCVG,FACCVG,RESCVG
      REAL*8       PARMET(*)
      CHARACTER*16 METHOD(*)
      CHARACTER*19 MAPREC,MATASS
      CHARACTER*24 SDIMPR,SDTIME,SDSTAT
      CHARACTER*19 LISCHA,SOLVEU,SDDISC,SDDYNA
      CHARACTER*24 NUMEDD,NUMFIX
      CHARACTER*24 MODELE,MATE, CARELE, COMREF, COMPOR
      CHARACTER*24 CARCRI
      CHARACTER*24 DEFICO,RESOCO
      CHARACTER*24 CODERE
      CHARACTER*19 VEELEM(*),VEASSE(*)
      CHARACTER*19 MEELEM(*),MEASSE(*)
      CHARACTER*19 SOLALG(*),VALINC(*)
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME - PREDICTION)
C
C PREDICTION PAR DEPLACEMENT DONNE (EXTRAPOL/DEPL_CALCULE)
C
C ----------------------------------------------------------------------
C
C
C IN  MODELE : MODELE
C IN  NUMEDD : NUME_DDL (VARIABLE AU COURS DU CALCUL)
C IN  NUMFIX : NUME_DDL (FIXE AU COURS DU CALCUL)
C IN  MATE   : CHAMP MATERIAU
C IN  CARELE : CARACTERISTIQUES DES ELEMENTS DE STRUCTURE
C IN  COMREF : VARI_COM DE REFERENCE
C IN  COMPOR : COMPORTEMENT
C IN  LISCHA : LISTE DES CHARGES
C IN  MAPREC : MATRICE DE PRECONDITIONNEMENT (GCPC)
C IN  MATASS : MATRICE ASSEMBLEE
C IN  METHOD : INFORMATIONS SUR LES METHODES DE RESOLUTION
C IN  SOLVEU : SOLVEUR
C IN  PARMET : PARAMETRES DES METHODES DE RESOLUTION
C IN  CARCRI : PARAMETRES DES METHODES D'INTEGRATION LOCALES
C IN  SDIMPR : SD AFFICHAGE
C IN  SDDYNA : SD POUR LA DYNAMIQUE
C IN  SDTIME : SD TIMER
C IN  SDSTAT : SD STATISTIQUES
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  RESOCO : SD RESOLUTION CONTACT
C IN  DEFICO : SD DEFINITION CONTACT
C IN  FONACT : FONCTIONNALITES ACTIVEES
C IN  NUMINS : NUMERO D'INSTANT
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C IN  SOLALG : VARIABLE CHAPEAU POUR INCREMENTS SOLUTIONS
C IN  MEELEM : VARIABLE CHAPEAU POUR NOM DES MATR_ELEM
C IN  MEASSE : VARIABLE CHAPEAU POUR NOM DES MATR_ASSE
C IN  VEELEM : VARIABLE CHAPEAU POUR NOM DES VECT_ELEM
C IN  VEASSE : VARIABLE CHAPEAU POUR NOM DES VECT_ASSE
C OUT FACCVG : CODE RETOUR FACTORISATION MATRICE GLOBALE
C                -1 : PAS DE FACTORISATION
C                 0 : CAS DU FONCTIONNEMENT NORMAL
C                 1 : MATRICE SINGULIERE
C                 2 : ERREUR LORS DE LA FACTORISATION
C                 3 : ON NE SAIT PAS SI SINGULIERE
C OUT RESCVG : CODE RETOUR RESOLUTION SYSTEME LINEAIRE
C                -1 : PAS DE RESOLUTION
C                 0 : CAS DU FONCTIONNEMENT NORMAL
C                 1 : NOMBRE MAXIMUM D'ITERATIONS ATTEINT
C OUT LDCCVG : CODE RETOUR DE L'INTEGRATION DU COMPORTEMENT
C                -1 : PAS D'INTEGRATION DU COMPORTEMENT
C                 0 : CAS DU FONCTIONNEMENT NORMAL
C                 1 : ECHEC DE L'INTEGRATION DE LA LDC
C                 2 : ERREUR SUR LA NON VERIF. DE CRITERES PHYSIQUES
C                 3 : SIZZ PAS NUL POUR C_PLAN DEBORST
C OUT CODERE : CHAM_ELEM CODE RETOUR INTEGRATION LDC
C
C
C
C
      CHARACTER*19 INCEST,DEPEST,DEPMOI
      CHARACTER*19 DEPSO1,DEPSO2
      LOGICAL      LPROJ
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      DEPEST    = '&&CNPART.CHP1'
      INCEST    = '&&CNPART.CHP2'
      CALL VTZERO(DEPEST)
      CALL VTZERO(INCEST)
      CALL NMCHEX(SOLALG,'SOLALG','DEPSO1',DEPSO1)
      CALL NMCHEX(SOLALG,'SOLALG','DEPSO2',DEPSO2)
      CALL VTZERO(DEPSO1)
      CALL VTZERO(DEPSO2)
      LPROJ     = .TRUE.
      FACCVG    = -1
      RESCVG    = -1
      LDCCVG    = -1
C
C --- DECOMPACTION DES VARIABLES CHAPEAUX
C
      CALL NMCHEX(VALINC,'VALINC','DEPMOI',DEPMOI)
C
C --- VALEUR DU DEPLACEMENT -> DEPEST
C --- VALEUR DE L'INCREMENT DE DEPLACEMENT -> INCEST
C
      IF (METHOD(5) .EQ. 'EXTRAPOLE') THEN
        CALL NMPREX(NUMEDD,DEPMOI,SOLALG,SDDISC,NUMINS,
     &              INCEST,DEPEST)
      ELSE IF (METHOD(5) .EQ. 'DEPL_CALCULE') THEN
        CALL NMPRDC(METHOD,NUMEDD,DEPMOI,SDDISC,NUMINS,
     &              INCEST,DEPEST)
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF
C
C --- RECOPIE DE LA SOLUTION
C
      IF (NUMINS.EQ.1) THEN
        CALL VTCOPY(INCEST,DEPSO1)
      ELSE
        CALL COPISD('CHAMP_GD','V',INCEST,DEPSO1)
      ENDIF
C
C --- PROJECTION POUR AVOIR UN CHAMP DE DEPLACEMENT
C --- CINEMATIQUEMENT ADMISSIBLE
C
      IF (LPROJ) THEN
        CALL NMPRCA(MODELE,NUMEDD,NUMFIX,MATE  ,CARELE,
     &              COMREF,COMPOR,LISCHA,METHOD,SOLVEU,
     &              FONACT,PARMET,CARCRI,SDIMPR,SDSTAT,
     &              SDDISC,SDTIME,NUMINS,VALINC,SOLALG,
     &              MATASS,MAPREC,DEFICO,RESOCO,SDDYNA,
     &              MEELEM,MEASSE,VEELEM,VEASSE,DEPEST,
     &              LDCCVG,FACCVG,RESCVG,CODERE)
      ENDIF
C
      CALL JEDEMA()
      END
