      SUBROUTINE NMPRTA(MODELE,NUMEDD,NUMFIX,MATE  ,CARELE,
     &                  COMREF,COMPOR,LISCHA,METHOD,SOLVEU,
     &                  FONACT,PARMET,CARCRI,SDIMPR,SDSTAT,
     &                  SDTIME,SDDISC,NUMINS,VALINC,SOLALG,
     &                  MATASS,MAPREC,DEFICO,RESOCO,RESOCU,
     &                  SDDYNA,MEELEM,MEASSE,VEELEM,VEASSE,
     &                  SDNUME,LDCCVG,FACCVG,RESCVG,CODERE)
C
C MODIF ALGORITH  DATE 02/10/2012   AUTEUR DESOZA T.DESOZA 
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C TOLE CRP_21
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      INTEGER      FONACT(*)
      INTEGER      NUMINS,FACCVG,RESCVG,LDCCVG
      REAL*8       PARMET(*)
      CHARACTER*16 METHOD(*)
      CHARACTER*24 SDIMPR,SDTIME,SDSTAT
      CHARACTER*19 MATASS,MAPREC
      CHARACTER*19 LISCHA,SOLVEU,SDDISC,SDDYNA,SDNUME
      CHARACTER*24 MODELE,MATE  ,CARELE,COMREF,COMPOR
      CHARACTER*24 NUMEDD,NUMFIX
      CHARACTER*24 CARCRI,CODERE
      CHARACTER*19 SOLALG(*),VALINC(*)
      CHARACTER*24 DEFICO,RESOCO,RESOCU
      CHARACTER*19 VEELEM(*),VEASSE(*)
      CHARACTER*19 MEELEM(*),MEASSE(*)
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME - PREDICTION)
C
C PREDICTION PAR METHODE DE NEWTON-EULER
C
C ----------------------------------------------------------------------
C
C
C IN  MODELE : MODELE
C IN  NUMEDD : NUME_DDL (VARIABLE AU COURS DU CALCUL)
C IN  NUMFIX : NUME_DDL (FIXE AU COURS DU CALCUL)
C IN  MATE   : CHAMP MATERIAU
C IN  CARELE : CARACTERISTIQUES DES ELEMENTS DE STRUCTURE
C IN  COMREF : VARIABLES DE COMMANDE DE REFERENCE
C IN  COMPOR : COMPORTEMENT
C IN  LISCHA : LISTE DES CHARGES
C IN  METHOD : INFORMATIONS SUR LES METHODES DE RESOLUTION
C IN  SOLVEU : SOLVEUR
C IN  FONACT : FONCTIONNALITES ACTIVEES (VOIR NMFONC)
C IN  PARMET : PARAMETRES DES METHODES DE RESOLUTION
C IN  CARCRI : PARAMETRES DES METHODES D'INTEGRATION LOCALES
C IN  SDIMPR : SD AFFICHAGE
C IN  SDDYNA : SD POUR LA DYNAMIQUE
C IN  SDTIME : SD TIMER
C IN  SDSTAT : SD STATISTIQUES
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  NUMINS : NUMERO D'INSTANT
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C IN  SOLALG : VARIABLE CHAPEAU POUR INCREMENTS SOLUTIONS
C IN  MEELEM : VARIABLE CHAPEAU POUR NOM DES MATR_ELEM
C IN  MEASSE : VARIABLE CHAPEAU POUR NOM DES MATR_ASSE
C IN  VEELEM : VARIABLE CHAPEAU POUR NOM DES VECT_ELEM
C IN  VEASSE : VARIABLE CHAPEAU POUR NOM DES VECT_ASSE
C IN  DEFICO : SD DEFINITION CONTACT
C IN  RESOCO : SD RESOLUTION CONTACT
C IN  RESOCU : SD RESOLUTION LIAISON_UNILATER
C IN  SDDYNA : SD DYNAMIQUE
C IN  MATASS : NOM DE LA MATRICE DU PREMIER MEMBRE ASSEMBLEE
C IN  MAPREC : NOM DE LA MATRICE DE PRECONDITIONNEMENT (GCPC)
C IN  SDNUME : SD NUMEROTATION
C OUT FACCVG : CODE RETOUR FACTORISATION MATRICE GLOBALE
C                -1 : PAS DE FACTORISATION
C                 0 : CAS DU FONCTIONNEMENT NORMAL
C                 1 : MATRICE SINGULIERE
C                 2 : ERREUR LORS DE LA FACTORISATION
C                 3 : ON NE SAIT PAS SI SINGULIERE
C OUT RESCVG : CODE RETOUR RESOLUTION SYSTEME LINEAIRE
C                -1 : PAS DE RESOLUTION
C                 0 : CAS DU FONCTIONNEMENT NORMAL
C                 1 : NOMBRE MAXIMUM D'ITERATIONS ATTEINT
C OUT LDCCVG : CODE RETOUR DE L'INTEGRATION DU COMPORTEMENT
C                -1 : PAS D'INTEGRATION DU COMPORTEMENT
C                 0 : CAS DU FONCTIONNEMENT NORMAL
C                 1 : ECHEC DE L'INTEGRATION DE LA LDC
C                 2 : ERREUR SUR LA NON VERIF. DE CRITERES PHYSIQUES
C                 3 : SIZZ PAS NUL POUR C_PLAN DEBORST
C OUT CODERE : CHAM_ELEM CODE RETOUR INTEGRATION LDC
C
C
C
C
      REAL*8       INSTAP,DIINST
      CHARACTER*19 CNCINE,CNDONN,CNPILO
      REAL*8       R8BID
      LOGICAL      NDYNLO,LSTAT,LIMPL,LELTC,ISFONC
      INTEGER      IFM,NIV
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('MECA_NON_LINE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<MECANONLINE> PREDICTION TYPE EULER'
      ENDIF
C
C --- FONCTIONNALITES ACTIVEES
C
      LSTAT  = NDYNLO(SDDYNA,'STATIQUE')
      LIMPL  = NDYNLO(SDDYNA,'IMPLICITE')
      LELTC  = ISFONC(FONACT,'ELT_CONTACT')
C
C --- INITIALISATIONS
C
      INSTAP = DIINST(SDDISC,NUMINS)
      LDCCVG = -1
      FACCVG = -1
      RESCVG = -1
      CNDONN = '&&CNCHAR.DONN'
      CNPILO = '&&CNCHAR.PILO'
      CALL VTZERO(CNDONN)
      CALL VTZERO(CNPILO)
C
C --- DECOMPACTION DES VARIABLES CHAPEAUX
C
      CALL NMCHEX(VEASSE,'VEASSE','CNCINE',CNCINE)
C
C --- INCREMENT DE DEPLACEMENT NUL EN PREDICTION
C
      IF (LSTAT.OR.LIMPL) THEN
        CALL NMDEP0('ON ',SOLALG)
      ENDIF
C
C --- CALCUL DE LA MATRICE GLOBALE
C
      CALL NMPRMA(MODELE,MATE  ,CARELE,COMPOR,CARCRI,
     &            PARMET,METHOD,LISCHA,NUMEDD,NUMFIX,
     &            SOLVEU,COMREF,SDIMPR,SDSTAT,SDTIME,
     &            SDDISC,SDDYNA,NUMINS,FONACT,DEFICO,
     &            RESOCO,VALINC,SOLALG,VEELEM,MEELEM,
     &            MEASSE,MAPREC,MATASS,CODERE,FACCVG,
     &            LDCCVG)
C
C --- ERREUR SANS POSSIBILITE DE CONTINUER
C
      IF ((FACCVG.EQ.1).OR.(FACCVG.EQ.2)) GOTO 9999
      IF (LDCCVG.EQ.1) GOTO 9999
C
C --- CALCUL DES CHARGEMENTS VARIABLES AU COURS DU PAS DE TEMPS
C
      CALL NMCHAR('VARI','PREDICTION'   ,
     &            MODELE,NUMEDD,MATE  ,CARELE,COMPOR,
     &            LISCHA,CARCRI,NUMINS,SDTIME,SDDISC,
     &            R8BID ,FONACT,RESOCO,RESOCU,COMREF,
     &            VALINC,SOLALG,VEELEM,MEASSE,VEASSE,
     &            SDDYNA)
C
C --- CALCUL DU SECOND MEMBRE POUR CONTACT/XFEM
C
      IF (LELTC) THEN
        CALL NMFOCC('PREDICTION',
     &              MODELE,MATE  ,NUMEDD,FONACT,DEFICO,
     &              RESOCO,SOLALG,VALINC,VEELEM,VEASSE)
      ENDIF
C
C --- CALCUL DU SECOND MEMBRE
C
      CALL NMASSP(MODELE,NUMEDD,MATE  ,CARELE,COMREF,
     &            COMPOR,LISCHA,CARCRI,FONACT,SDSTAT,
     &            DEFICO,SDDYNA,VALINC,SOLALG,VEELEM,
     &            VEASSE,SDTIME,LDCCVG,CODERE,CNPILO,
     &            CNDONN,SDNUME,MATASS)
C
C --- INCREMENT DE DEPLACEMENT NUL EN PREDICTION
C
      IF (LSTAT.OR.LIMPL) THEN
        CALL NMDEP0('OFF',SOLALG)
      ENDIF
C
C --- RESOLUTION K.DU = DF
C
      CALL NMRESD(FONACT,SDDYNA,SDSTAT,SDTIME,SOLVEU,
     &            NUMEDD,INSTAP,MAPREC,MATASS,CNDONN,
     &            CNPILO,CNCINE,SOLALG,RESCVG)
C
9999  CONTINUE
C
      CALL JEDEMA()
      END
