      SUBROUTINE NMRENU(MODELZ,FONACT,NUMEDD,LISCHA,SOLVEU,
     &                  RESOCO,RENUME)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE    
      INCLUDE 'jeveux.h'
      CHARACTER*(*) MODELZ
      CHARACTER*24  NUMEDD 
      CHARACTER*19  LISCHA,SOLVEU
      CHARACTER*24  RESOCO
      INTEGER       FONACT(*) 
      LOGICAL       RENUME   
C 
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (CALCUL)
C
C CHOIX DE RE-CREATION DU NUME_DDL
C      
C ----------------------------------------------------------------------
C
C
C IN  MODELE : MODELE
C IN  NUMEDD : NUME_DDL
C IN  FONACT : FONCTIONNALITES ACTIVEES (vOIR NMFONC)
C IN  LISCHA : LISTE DES CHARGES
C IN  SOLVEU : SOLVEUR
C IN  RESOCO : SD RESOLUTION CONTACT
C OUT RENUME : .TRUE. SI RECREER NUMEDDL
C
C
C
C
      LOGICAL      ISFONC,LELTC,LXFCM,LCTCC
      CHARACTER*24 CRNUDD
      INTEGER      JCRNUD  
      INTEGER      IFM,NIV
C      
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('MECA_NON_LINE',IFM,NIV)  
C
C --- ACCES OBJETS
C 
      CRNUDD = RESOCO(1:14)//'.NUDD'         
C
C --- INITIALISATIONS
C      
      RENUME = .FALSE.
C
C --- FONCTIONNALITES ACTIVEES
C
      LELTC  = ISFONC(FONACT,'ELT_CONTACT')
      LXFCM  = ISFONC(FONACT,'CONT_XFEM')
      LCTCC  = ISFONC(FONACT,'CONT_CONTINU')
C
C --- SI ELT_CONTACT: NUMEDDL PEUT AVOIR BOUGE - REASSEMBLAGE ?
C 
      IF (LELTC) THEN
        IF (LXFCM) THEN
          RENUME = .TRUE.
        ELSE
          CALL JEVEUO(CRNUDD,'E',JCRNUD) 
          RENUME = ZL(JCRNUD)
        ENDIF
      ENDIF
C
C --- RE-CREATION NUME_DDL SI NECESSAIRE
C
      IF (RENUME) THEN
        IF (NIV.GE.2) THEN
          WRITE (IFM,*) '<MECANONLINE> ...... RE-CREATION DU NUME_DDL '
        ENDIF
        CALL NUMER3(MODELZ,LISCHA,SOLVEU,NUMEDD)         
      ENDIF
      IF (LCTCC) THEN
        ZL(JCRNUD) = .FALSE.
      ENDIF                           
C
      CALL JEDEMA()      
C
      END
