      SUBROUTINE NMREPC(SDDISC,SOLVEU,IEVDAC,RETRPC)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 22/10/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*19 SDDISC,SOLVEU
      INTEGER      IEVDAC,RETRPC
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME - ACTIONS)
C
C GESTION DE L'ACTION REAC_PRECOND
C
C ----------------------------------------------------------------------
C
C
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  SOLVEU : SD SOLVEUR
C IN  IEVDAC : INDICE DE L'EVENEMENT ACTIF
C OUT RETRPC : CODE RETOUR REACTUALISATION PRECONDTIONNEUR
C               0 ECHEC  : ON A DEJA REACTUALISE LE PRECONDITIONNEUR
C               1 SUCCES : ON REACTUALISE LE PRECONDITIONNEUR
C
C
      REAL*8       R8BID
      INTEGER      IREAPC,JSLVI
      CHARACTER*8  K8BID
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      RETRPC = 0
C
C --- PARAMETRES
C
      CALL UTDIDT('L'   ,SDDISC,'ECHE',IEVDAC,'ESSAI_REAC_PRECOND',
     &            R8BID ,IREAPC,K8BID )
C
C --- L'UTILISATEUR UTILISE UN PRECONDITIONNEUR SIMPLE PRECISION
C --- ET SOUHAITE LE REACTUALISER EN CAS D'ECHEC A LA RESOLUTION
C
      IF (IREAPC.EQ.1) THEN
C
C ----- ON A DEJA REACTUALISE LE PRECONDITIONNEUR : ON DECOUPE
C
        IREAPC = 1
        RETRPC = 0
        CALL U2MESS('I','MECANONLINE10_40')
      ELSEIF (IREAPC.EQ.0) THEN
C
C ----- ON RETENTE EN REACTUALISANT LE PRECONDITIONNEUR
C
        IREAPC = 1
        CALL JEVEUO(SOLVEU//'.SLVI','E',JSLVI)
        ZI(JSLVI-1+5) = 0
        RETRPC = 1
        CALL U2MESS('I','MECANONLINE10_41')
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF
C
C --- SAUVEGARDE INFO
C
      CALL UTDIDT('E'   ,SDDISC,'ECHE',IEVDAC,'ESSAI_REAC_PRECOND',
     &            R8BID ,IREAPC,K8BID )
C
      CALL JEDEMA()
      END
