      SUBROUTINE NMRESD(FONACT,SDDYNA,SDSTAT,SDTIME,SOLVEU,
     &                  NUMEDD,INSTAN,MAPREC,MATASS,CNDONN,
     &                  CNPILO,CNCINE,SOLALG,RESCVG)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 02/10/2012   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      INTEGER       FONACT(*)
      CHARACTER*19  SOLALG(*)
      CHARACTER*19  MAPREC,MATASS
      CHARACTER*24  SDTIME,SDSTAT
      CHARACTER*19  SOLVEU,SDDYNA
      CHARACTER*19  CNCINE,CNDONN,CNPILO
      CHARACTER*24  NUMEDD
      REAL*8        INSTAN
      INTEGER       RESCVG
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME - CALCUL)
C
C RESOLUTION DU SYSTEME LINEAIRE K.dU = F
C
C ----------------------------------------------------------------------
C
C
C IN  FONACT : FONCTIONNALITES ACTIVEES (VOIR NMFONC)
C IN  SDDYNA : SD DYNAMIQUE
C IN  SDTIME : SD TIMER
C IN  SDSTAT : SD STATISTIQUES
C IN  SOLVEU : SOLVEUR
C IN  NUMEDD : NUME_DDL
C IN  INSTAN : INSTANT COURANT
C IN  MAPREC : MATRICE DE PRECONDITIONNEMENT (GCPC)
C IN  MATASS : MATRICE ASSEMBLEE
C IN  CNDONN : CHAM_NO DE CHARGE DONNEE
C IN  CNPILO : CHAM_NO DE CHARGE PILOTEE
C IN  CNCINE : CHAM_NO DE CHARGE CINEMATIQUE
C OUT DEPSOL : SOLUTION DU DU SYSTEME K.DU = DF
C                      DEPSOL(1) EN L'ABSENCE DE PILOTAGE
C                      DEPSOL(1) ET DEPSOL(2) AVEC PILOTAGE
C OUT RESCVG : CODE RETOUR RESOLUTION SYSTEME LINEAIRE
C                -1 : PAS DE RESOLUTION
C                 0 : CAS DU FONCTIONNEMENT NORMAL
C                 1 : NOMBRE MAXIMUM D'ITERATIONS ATTEINT
C

      LOGICAL      NDYNLO,LPRMO
      CHARACTER*19 DEPSO1,DEPSO2
      INTEGER      IFM,NIV
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('MECA_NON_LINE',IFM,NIV)
C
C --- AFFICHAGE
C
      IF (NIV.GE.2) THEN
        WRITE (IFM,*) '<MECANONLINE> ... RESOLUTION'
      ENDIF
C
C --- EXTRACTION VARIABLES CHAPEAUX
C
      CALL NMCHEX(SOLALG,'SOLALG','DEPSO1',DEPSO1)
      CALL NMCHEX(SOLALG,'SOLALG','DEPSO2',DEPSO2)
C
C --- FONCTIONNALITES ACTIVEES
C
      LPRMO  = NDYNLO(SDDYNA,'PROJ_MODAL')
C
C --- RESOLUTION GENERALISEE OU PHYSIQUE
C
      CALL NMTIME(SDTIME,'INI','SOLVE')
      CALL NMTIME(SDTIME,'RUN','SOLVE')
C
      IF (LPRMO) THEN
        CALL NMRESG(NUMEDD,SDDYNA,INSTAN,CNDONN,DEPSO1)
      ELSE
        CALL NMRESO(FONACT,CNDONN,CNPILO,CNCINE,SOLVEU,
     &              MAPREC,MATASS,DEPSO1,DEPSO2,RESCVG)
      ENDIF
C
      CALL NMTIME(SDTIME,'END','SOLVE')
      CALL NMRINC(SDSTAT,'SOLVE')
C
      CALL JEDEMA()
      END
