      SUBROUTINE NMRIGI(MODELZ,MATE  ,CARELE,COMPOR,CARCRI,
     &                  SDDYNA,SDSTAT,SDTIME,FONACT,ITERAT,
     &                  VALINC,SOLALG,COMREF,MEELEM,VEELEM,
     &                  OPTIOZ,LDCCVG,CODERE)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 24/09/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      CHARACTER*(*) OPTIOZ
      CHARACTER*(*) MODELZ
      CHARACTER*(*) MATE
      CHARACTER*24  SDSTAT,SDTIME
      CHARACTER*24  COMPOR,CARCRI,CARELE
      INTEGER       ITERAT,LDCCVG
      CHARACTER*19  SDDYNA
      CHARACTER*24  COMREF,CODERE
      CHARACTER*19  MEELEM(*),VEELEM(*)
      CHARACTER*19  SOLALG(*),VALINC(*)
      INTEGER       FONACT(*)
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (CALCUL - UTILITAIRE)
C
C CALCUL DES MATR_ELEM DE RIGIDITE
C
C ----------------------------------------------------------------------
C
C
C IN  MODELE : MODELE
C IN  OPTRIG : OPTION DE CALCUL POUR MERIMO
C IN  MATE   : CHAMP MATERIAU
C IN  CARELE : CARACTERISTIQUES DES ELEMENTS DE STRUCTURE
C IN  COMREF : VARI_COM DE REFERENCE
C IN  COMPOR : COMPORTEMENT
C IN  SDDYNA : SD POUR LA DYNAMIQUE
C IN  SDTIME : SD TIMER
C IN  SDSTAT : SD STATISTIQUES
C IN  CARCRI : PARAMETRES METHODES D'INTEGRATION LOCALES (VOIR NMLECT)
C IN  ITERAT : NUMERO D'ITERATION
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C IN  SOLALG : VARIABLE CHAPEAU POUR INCREMENTS SOLUTIONS
C OUT LDCCVG : CODE RETOUR DE L'INTEGRATION DU COMPORTEMENT
C                -1 : PAS D'INTEGRATION DU COMPORTEMENT
C                 0 : CAS DU FONCTIONNEMENT NORMAL
C                 1 : ECHEC DE L'INTEGRATION DE LA LDC
C                 2 : ERREUR SUR LA NON VERIF. DE CRITERES PHYSIQUES
C                 3 : SIZZ PAS NUL POUR C_PLAN DEBORS
C OUT CODERE : CHAM_ELEM CODE RETOUR ERREUR INTEGRATION LDC
C
C ----------------------------------------------------------------------
C
      CHARACTER*19 VEFINT,MERIGI
      CHARACTER*1  BASE
      CHARACTER*24 MODELE
      CHARACTER*16 OPTRIG
      LOGICAL      TABRET(0:10),ISFONC,LENDO
C
C ----------------------------------------------------------------------
C

C
C --- INITIALISATIONS
C
      BASE   = 'V'
      MODELE = MODELZ
      LDCCVG = 0
      OPTRIG = OPTIOZ
      CODERE = '&&OP0070.CODERE'
C
C --- VECT_ELEM ET MATR_ELEM
C
      CALL NMCHEX(VEELEM,'VEELEM','CNFINT',VEFINT)
      CALL NMCHEX(MEELEM,'MEELEM','MERIGI',MERIGI)
C
C --- INCREMENT DE DEPLACEMENT NUL EN PREDICTION
C
      LENDO = ISFONC(FONACT,'ENDO_NO')
C
      IF (.NOT.LENDO) THEN
        IF (OPTRIG(1:9).EQ.'RIGI_MECA') THEN
          CALL NMDEP0('ON ',SOLALG)
        ENDIF
      ENDIF
C
C --- INIT TIMER
C
      CALL NMTIME(SDTIME,'INI','INTEGRATION')
      CALL NMTIME(SDTIME,'RUN','INTEGRATION')
C
C --- CALCUL DES MATR_ELEM DE RIGIDITE
C
      CALL MERIMO(BASE  ,MODELE,CARELE  ,MATE  ,COMREF,
     &            COMPOR,CARCRI,ITERAT+1,FONACT,SDDYNA,
     &            VALINC,SOLALG,MERIGI  ,VEFINT,OPTRIG,
     &            TABRET,CODERE)
C
C --- FIN TIMER
C
      CALL NMTIME(SDTIME,'END','INTEGRATION')
      CALL NMRINC(SDSTAT,'INTEGRATION')
C
C --- CODE RETOUR ERREUR INTEGRATION LDC
C
      IF (TABRET(0)) THEN
        IF ( TABRET(3) ) THEN
          LDCCVG = 3
        ELSEIF ( TABRET(2) ) THEN
          LDCCVG = 2
        ELSE
          LDCCVG = 1
        ENDIF
        IF ( TABRET(1) ) THEN
          LDCCVG = 1
        ENDIF
      ENDIF
C
C --- REMISE INCREMENT DE DEPLACEMENT
C
      IF (OPTRIG(1:9).EQ.'RIGI_MECA') THEN
        CALL NMDEP0('OFF',SOLALG)
      ENDIF
C
      END
