      SUBROUTINE NMTBLE(MODELE,NOMA  ,MATE  ,DEFICO,RESOCO,
     &                  NIVEAU,FONACT,SDIMPR,SDSTAT,SDTIME,
     &                  SDDYNA,SDERRO,SDCONV,SDDISC,VALINC,
     &                  SOLALG)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 22/10/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      INTEGER      NIVEAU
      CHARACTER*8  NOMA
      CHARACTER*24 DEFICO,RESOCO
      CHARACTER*24 SDSTAT,SDIMPR,SDTIME,SDERRO,SDCONV
      CHARACTER*24 MODELE,MATE
      CHARACTER*19 SDDYNA,SDDISC,VALINC(*),SOLALG(*)
      INTEGER      FONACT(*)
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C GESTION DEBUT DE BOUCLE POINTS FIXES
C
C ----------------------------------------------------------------------
C
C
C LES ITERATIONS ONT LIEU ENTRE CETTE ROUTINE ET SA COUSINE
C (NMIBLE) QUI COMMUNIQUENT PAR LA VARIABLE NIVEAU
C
C I/O NIVEAU : INDICATEUR D'UTILISATION DE LA BOUCLE DE POINT FIXE
C                  0     ON N'UTILISE PAS CETTE BOUCLE
C                  3     BOUCLE GEOMETRIE
C                  2     BOUCLE SEUILS DE FROTTEMENT
C                  1     BOUCLE CONTRAINTES ACTIVES
C IN  MODELE : NOM DU MODELE
C IN  NOMA   : NOM DU MAILLAGE
C IN  MATE   : SD MATERIAU
C IN  FONACT : FONCTIONNALITES ACTIVEES
C IN  DEFICO : SD POUR LA DEFINITION DE CONTACT
C IN  RESOCO : SD POUR LA RESOLUTION DE CONTACT
C IN  SDIMPR : SD AFFICHAGE
C IN  SDTIME : SD TIMER
C IN  SDSTAT : SD STATISTIQUES
C IN  SDDYNA : SD POUR DYNAMIQUE
C IN  SDERRO : SD ERREUR
C IN  SDCONV : SD CONVERGENCE
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  VALINC : VARIABLE CHAPEAU POUR INCREMENTS VARIABLES
C IN  SOLALG : VARIABLE CHAPEAU POUR INCREMENTS SOLUTIONS
C
C ----------------------------------------------------------------------
C
      LOGICAL      MMCVCA,MMCVFR,MMCVGO
      LOGICAL      ISFONC,LBOUCF,LBOUCG,LBOUCC
      INTEGER      MMITGO,MMITFR,MMITCO
      CHARACTER*4  ETNEWT
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- NEWTON A NECESSAIREMENT CONVERGE
C
      CALL NMLEEB(SDERRO,'NEWT',ETNEWT)
      IF ((NIVEAU.EQ.0).OR.(ETNEWT.NE.'CONV')) THEN
        GOTO 9999
      ENDIF
C
C --- INFOS SUR LES BOUCLES
C
      LBOUCF = ISFONC(FONACT,'BOUCLE_EXT_FROT')
      LBOUCG = ISFONC(FONACT,'BOUCLE_EXT_GEOM')
      LBOUCC = ISFONC(FONACT,'BOUCLE_EXT_CONT')
C
C --- INITIALISATIONS
C
      MMCVCA = .FALSE.
      MMCVFR = .FALSE.
      MMCVGO = .FALSE.
C
      GO TO (101,102,103) NIVEAU
C
C --- NIVEAU: 1   BOUCLE CONTRAINTES ACTIVES
C
 101  CONTINUE
C
C --- EVALUATION STATUTS DU CONTACT
C
      IF (LBOUCC) THEN
        NIVEAU = 1
        CALL NMTIME(SDTIME,'INI','CTCC_CONT')
        CALL NMTIME(SDTIME,'RUN','CTCC_CONT')
        CALL NMCTCC(NOMA  ,MODELE,MATE  ,SDDYNA,SDIMPR,
     &              SDERRO,DEFICO,RESOCO,VALINC,SOLALG,
     &              MMCVCA)
        CALL NMTIME(SDTIME,'END','CTCC_CONT')
        CALL NMRINC(SDSTAT,'CTCC_CONT')
C
C ----- ON CONTINUE LA BOUCLE
C
        IF (.NOT.MMCVCA) THEN
          NIVEAU = 1
          GOTO 999
        ENDIF
      ENDIF
C
C --- NIVEAU: 2   BOUCLE SEUILS DE FROTTEMENT
C
 102  CONTINUE
C
C --- CALCUL SEUILS DE FROTTEMENT
C
      IF (LBOUCF) THEN
        NIVEAU = 2
        CALL NMTIME(SDTIME,'INI','CTCC_FROT')
        CALL NMTIME(SDTIME,'RUN','CTCC_FROT')
        CALL NMCTCF(NOMA  ,MODELE,SDIMPR,SDERRO,DEFICO,
     &              RESOCO,VALINC,MMCVFR)
        CALL NMTIME(SDTIME,'END','CTCC_FROT')
        CALL NMRINC(SDSTAT,'CTCC_FROT')
C
C ----- ON CONTINUE LA BOUCLE
C
        IF (.NOT.MMCVFR) THEN
          NIVEAU = 2
          GOTO 999
        ENDIF
      ENDIF
C
C --- NIVEAU: 3   BOUCLE GEOMETRIE
C
 103  CONTINUE
C
C --- CALCUL SEUILS DE GEOMETRIE
C
      IF (LBOUCG) THEN
        NIVEAU = 3
        CALL NMCTGO(NOMA  ,SDIMPR,SDERRO,DEFICO,RESOCO,
     &              VALINC,MMCVGO)
C
C ----- ON CONTINUE LA BOUCLE
C
        IF (.NOT.MMCVGO) THEN
          NIVEAU = 3
          GOTO 999
        ENDIF
      ENDIF
C
 999  CONTINUE
C
C --- REMISE A ZERO DES COMPTEURS DE CYCLE
C
      IF (MMCVCA.OR.MMCVFR.OR.MMCVGO) CALL MMCYCZ(DEFICO,RESOCO)
C
C --- AFFICHAGES PENDANT LA BOUCLE DE POINT FIXE
C
      CALL NMAFFI(FONACT,SDCONV,SDIMPR,SDERRO,SDDISC,
     &            'FIXE')
C
C --- INCREMENTATION DES COMPTEURS
C
      IF (.NOT.MMCVCA.AND.NIVEAU.EQ.1) 
     & CALL MMBOUC(RESOCO,'CONT','INCR',MMITCO)
      IF (.NOT.MMCVFR.AND.NIVEAU.EQ.2) 
     & CALL MMBOUC(RESOCO,'FROT','INCR',MMITFR)
      IF (.NOT.MMCVGO.AND.NIVEAU.EQ.3)  
     & CALL MMBOUC(RESOCO,'GEOM','INCR',MMITGO)
C
C --- MISE A JOUR DES ITERATEURS DE BOUCLE
C
      CALL MMBOUC(RESOCO,'CONT','READ',MMITCO)
      CALL MMBOUC(RESOCO,'FROT','READ',MMITFR)
      CALL MMBOUC(RESOCO,'GEOM','READ',MMITGO)
      CALL NMIMCI(SDIMPR,'BOUC_CONT',MMITCO,.TRUE.)
      CALL NMIMCI(SDIMPR,'BOUC_FROT',MMITFR,.TRUE.)
      CALL NMIMCI(SDIMPR,'BOUC_GEOM',MMITGO,.TRUE.)
C
C --- ETAT DE LA CONVERGENCE POINT FIXE
C
 9999 CONTINUE
      CALL NMEVCV(SDERRO,FONACT,'FIXE')
C
      CALL JEDEMA()
      END
