      SUBROUTINE NMUNIL(MAILLA,DEPPLU,DDEPLA,SOLVEU,MATASS,
     &                  DEFICU,RESOCU,CNCINE,ITERAT,INST  ,
     &                  CTCCVG)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 08/10/2012   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*8  MAILLA
      CHARACTER*19 DEPPLU,DDEPLA,SOLVEU,MATASS,CNCINE
      CHARACTER*24 DEFICU
      CHARACTER*24 RESOCU
      INTEGER      ITERAT
      REAL*8       INST
      INTEGER      CTCCVG
C
C ----------------------------------------------------------------------
C
C ROUTINE LIAISON_UNILATER
C
C TRAITEMENT DES CONDITIONS UNILATERALES (SAUF CONTACT MECANIQUE)
C
C ----------------------------------------------------------------------
C
C
C IN  DEPPLU : CHAMP DE DEPLACEMENTS A L'ITERATION DE NEWTON PRECEDENTE
C IN  DEPPLA : INCREMENT DE DEPLACEMENTS CALCULE EN IGNORANT LE CONTACT
C IN  SOLVEU : SD SOLVEUR
C IN  DEFICU : SD DE DEFINITION (ISSUE D'AFFE_CHAR_MECA)
C IN  RESOCU : SD DE TRAITEMENT NUMERIQUE
C IN  CNCINE : CHAM_NO CINEMATIQUE
C IN  ITERAT : ITERATION DE NEWTON
C IN  INST   : VALEUR DE L'INSTANT DE CALCUL
C OUT CTCCVG : CODE RETOUR CONTACT DISCRET
C                -1 : PAS DE CALCUL DU CONTACT DISCRET
C                 0 : CAS DU FONCTIONNEMENT NORMAL
C                 1 : NOMBRE MAXI D'ITERATIONS
C                 2 : MATRICE SINGULIERE
C
C
C
C
      CHARACTER*19 MATR
      INTEGER      LDSCON,LMAT
      INTEGER      IFM,NIV,NEQ
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFNIV(IFM,NIV)
C
C --- RECUPERATION DU DESCRIPTEUR DE LA MATRICE DE LIAISON UNIL
C
      MATR   = RESOCU(1:14)//'.MATC'
      CALL MTDSC3( MATR )
      CALL JEVEUO( MATR(1:19)//'.&INT', 'E', LDSCON )
C
C --- INITIALISATIONS
C
      CTCCVG = 0
C
C --- RECUPERATION DU DESCRIPTEUR DE LA MATRICE MECANIQUE
C
      CALL JEVEUO( MATASS//'.&INT', 'E', LMAT )
C
C --- PRE-TRAITEMENT DES CONDITIONS UNILATERALES
C
      IF (ITERAT.EQ.0)  THEN
        NEQ = ZI(LMAT+2)
        CALL CUPREP(MAILLA,NEQ,DEFICU,RESOCU,DEPPLU,INST)
      ENDIF
C
C --- CHOIX DE L'ALGO DE RESOLUTION
C
      CALL ALGOCU(DEFICU,RESOCU,SOLVEU,LMAT  ,LDSCON,
     &            CNCINE,DDEPLA,CTCCVG)
C
C --- LE CALCUL DE CONTACT A FORCEMENT ETE REALISE
C
      CALL ASSERT(CTCCVG.GE.0)
C
      CALL JEDEMA()
      END
