      SUBROUTINE NMVCLE(MODELZ,MATZ,CARELZ,LISCHZ,INSTAN,COMZ,CODRET)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================

      IMPLICIT NONE

      INCLUDE 'jeveux.h'
      CHARACTER*(*) MODELZ, MATZ, CARELZ, LISCHZ, COMZ
      REAL*8        INSTAN

      CHARACTER*2  CODRET
      CHARACTER*8   MODELE, MATE, CARELE
      CHARACTER*19  LISCHA
      CHARACTER*14  COM

C ----------------------------------------------------------------------
C  LECTURE DES VARIABLES DE COMMANDE
C ----------------------------------------------------------------------
C IN/JXIN   MODELE  K8  SD MODELE
C IN/JXIN   MATE    K8  SD MATERIAU
C IN/JXIN   LISCHA  K19 SD L_CHARGES
C IN        INSTAN   R  INSTANT D'EVALUATION
C IN/JXOUT  COM     K14 SD VARI_COM
C OUT       CODRET (K2) POUR CHAQUE RESULTAT, 'OK' SI ON A TROUVE, 
C                                             'NO' SINON
C ----------------------------------------------------------------------

C
C

      LOGICAL      EXIVRC
      CHARACTER*24 CHARGE
      CHARACTER*19 CTPS, TOUT
      INTEGER      IBID, IEX,IRET,NCHAR,JCHAR
      CHARACTER*8  K8BID
      COMPLEX*16   CBID


      CALL JEMARQ()
      COM    = COMZ
      MODELE = MODELZ
      CARELE = CARELZ
      MATE   = MATZ
      LISCHA = LISCHZ
      EXIVRC = .FALSE.


C    SUPPRESSION DE L'OBJET S'IL EXISTE DEJA
      CALL DETRSD('VARI_COM',COM)


C    LISTE DES VARIABLES DE COMMANDE
      TOUT =  COM // '.TOUT'


C    DETERMINATION DU CHAMP DE VARC :
      CHARGE = LISCHA // '.LCHA'
      CALL JEVEUO(CHARGE,'L',JCHAR)
      CALL JELIRA(CHARGE,'LONMAX',NCHAR,K8BID)
      CALL VRCINS(MODELE,MATE,CARELE,INSTAN,TOUT,CODRET)
      CALL EXISD('CHAMP',TOUT,IRET)
      IF ( IRET.EQ.1 ) EXIVRC=.TRUE.

C    CARTE DE L'INSTANT COURANT
      CTPS =  COM // '.INST'
      K8BID = ' '
      CALL MECACT('V', CTPS, 'MODELE', MODELE(1:8)//'.MODELE',
     &            'INST_R', 1, 'INST', IBID, INSTAN, CBID, K8BID)

C    CHAMPS REELS (TRUE) OU PAR DEFAUT (FALSE)
      CALL WKVECT(COM//'.EXISTENCE','V V L ',1,IEX)
      ZL(IEX+0) = EXIVRC


      CALL JEDEMA()
      END
