      SUBROUTINE NTINIT(RESULT,MODELE,MATE  ,CARELE,LISCHA,
     &                  LISCH2,SOLVEU,PARA  ,NUMEDD,LOSTAT,
     &                  LEVOL ,LNONL ,SDDISC,SDIETO,
     &                  MAILLA,SDCRIT,TIME  )
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 29/10/2012   AUTEUR SELLENET N.SELLENET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE DURAND C.DURAND
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      LOGICAL       LOSTAT,LEVOL,LNONL
      CHARACTER*19  LISCHA,LISCH2,SOLVEU
      CHARACTER*19  SDDISC,SDCRIT
      CHARACTER*24  MODELE,MATE  ,CARELE
      CHARACTER*24  RESULT,NUMEDD,TIME
      CHARACTER*24  SDIETO
      CHARACTER*8   MAILLA
      REAL*8        PARA(*)
C
C ---------------------------------------------------------------------
C     THERMIQUE : INITIALISATIONS.
C     *           ****
C   -------------------------------------------------------------------
C     SUBROUTINES APPELLEES:
C       JEVEUX: JEDETR,COPISD,UTCRRE.
C       PARAMETRE DE CMD: GETRES,NTINST.
C       MSG: INFNIV.
C       MANIP SD: VTCREB.
C       LECTURE DONNEES: NTDOET,NTDOED.
C       MATRICE: NUMERO.
C
C     FONCTIONS INTRINSEQUES:
C       AUCUNE.
C   -------------------------------------------------------------------
C
C
C
      INTEGER      IRET,INITPR,IBID
      INTEGER      NIV,IFM
      CHARACTER*14 NUPOSS
      CHARACTER*19 K19BLA
      CHARACTER*24 NOOJB,K24BLA,VHYDR,HYDR0
      REAL*8       INSTIN
      LOGICAL      LREUSE
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFNIV(IFM,NIV)
C
C --- INITIALISATIONS
C
      LREUSE = .FALSE.
      K24BLA = ' '
      K19BLA = ' '
      VHYDR  = K24BLA
      LOSTAT = .FALSE.
      LNONL  = .FALSE.
      LEVOL  = .FALSE.
      TIME   = RESULT(1:8)//'.CHTPS'
      CALL DISMOI('F','NOM_MAILLA',MODELE,'MODELE',IBID,MAILLA,IBID)
C
C --- CONCEPT REENTRANT ?
C
      CALL GCUCON(RESULT,'EVOL_THER', IRET)
      IF (IRET.GT.0) THEN
        LREUSE = .TRUE.
      ENDIF
C
C --- NUMEROTATION ET CREATION DU PROFIL DE LA MATRICE
C
      NUMEDD = '12345678.NUMED'
      NOOJB  = '12345678.00000.NUME.PRNO'
      CALL GNOMSD ( ' ',NOOJB,10,14 )
      NUMEDD = NOOJB(1:14)
      CALL RSNUME(RESULT,'TEMP',NUPOSS)
      CALL NUMERO(NUPOSS,MODELE,LISCHA,SOLVEU,'VG',NUMEDD )
C
C --- CREATION DES CHAMPS
C
      CALL NTCRCH(MODELE,NUMEDD,HYDR0 ,VHYDR )
C 
C --- CREATION DE LA SD IN ET OUT 
C
      CALL NTETCR(NUMEDD,K24BLA,SDIETO,LNONL ,K24BLA,
     &            K24BLA)
C
C --- LECTURE ETAT INITIAL
C
      CALL NXDOET(MODELE,NUMEDD,LREUSE,LOSTAT,
     &            SDIETO,INITPR,INSTIN)
C
C --- CREATION SD DISCRETISATION, ARCHIVAGE ET OBSERVATION
C
      CALL TIINIT(MAILLA,MODELE,RESULT,LOSTAT,LREUSE,
     &            LNONL ,INSTIN,SDDISC,SDIETO,
     &            K19BLA,LEVOL  )
C
C --- CREATION DE LA SD EVOL_THER
C
      CALL NXNOLI(MODELE,MATE  ,CARELE,LOSTAT,LREUSE,
     &            LNONL ,LEVOL ,PARA  ,SDDISC,SDCRIT,
     &            SDIETO,LISCH2)
      CALL COPISD('LISTE_CHARGES','G',LISCHA,LISCH2)
C
C --- CREATION DE LA SD POUR ARCHIVAGE DES INFORMATIONS DE CONVERGENCE
C
      CALL NTCRCV(SDCRIT)
C
      CALL JEDEMA()
      END
