      SUBROUTINE NTRESO(MODELE,MATE  ,CARELE,
     &                  FOMULT,CHARGE,LISCHA,INFOCH,NUMEDD,
     &                  SOLVEU,LOSTAT,TIME  ,TPSTHE,REASVC,
     &                  REASVT,REASMT,REASRG,REASMS,CREAS ,
     &                  VEC2ND,MATASS,MAPREC,CNDIRP,CNCHCI,
     &                  MEDIRI,COMPOR)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 02/10/2012   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C TOLE CRP_21
C
      IMPLICIT   NONE
      INCLUDE 'jeveux.h'
      REAL*8        TPSTHE(6)
      CHARACTER*1   CREAS
      CHARACTER*19  LISCHA,SOLVEU,MAPREC
      CHARACTER*24  MODELE,MATE,CARELE,FOMULT,CHARGE,INFOCH,NUMEDD,
     &              TIME,VEC2ND,MATASS,CNDIRP,CNCHCI,COMPOR
      LOGICAL       REASVC,REASVT,REASMT,REASRG,REASMS,LOSTAT
C
C ----------------------------------------------------------------------
C     THERMIQUE LINEAIRE - RESOLUTION
C     *                    ****
C     COMMANDE:  THER_LINEAIRE
C ----------------------------------------------------------------------
C     SUBROUTINES APPELLEES:
C       MESSAGE:INFMAJ,INFNIV.
C       JEVEUX/SD:COPISD,DETRSD,RSEXCH,RSAGSD,RSNOCH.
C       THERMIQUE: NXACMV,NTARCH.
C       SOLVEUR EF: RESOUD.
C
C     FONCTIONS INTRINSEQUES:
C       AUCUNE.
C
C
C
      INTEGER      IFM,NIV
      REAL*8       R8BID
      CHARACTER*16 K16B1,K16B2
      CHARACTER*19 CHSOL
      CHARACTER*24 MEDIRI,VHYDR,TMPCHI,TMPCHF,VEC2NI,CRITER,
     &             RESULT,VTEMP
      COMPLEX*16   C16BID
      INTEGER      IRET
C
C ----------------------------------------------------------------------
C
      CALL INFNIV(IFM,NIV)

      CHSOL  = '&&NTRESO_SOLUTION  '
      CRITER = '&&NTRESO_RESGRA_GCPC    '

      CALL GETRES(RESULT,K16B1,K16B2)
      VTEMP='&&NXLECTVAR_____'

C 1 ==> ASSEMBLAGE DU SECOND MEMBRE
      CALL NXACMV(MODELE,MATE,CARELE,FOMULT,CHARGE,LISCHA,
     &            INFOCH,NUMEDD,SOLVEU,LOSTAT,TIME,TPSTHE,
     &            REASVC,REASVT,REASMT,REASRG,REASMS,CREAS,
     &            VTEMP,VHYDR,TMPCHI,TMPCHF,VEC2ND,VEC2NI,
     &            MATASS,MAPREC,CNDIRP,CNCHCI,MEDIRI,COMPOR)

C 2 ==> RESOLUTION AVEC VEC2ND COMME SECOND MEMBRE
      CALL RESOUD(MATASS,MAPREC,SOLVEU,CNCHCI,0     ,
     &            VEC2ND,CHSOL ,'V'   ,R8BID ,C16BID,
     &            CRITER,.TRUE.,0     ,IRET  )

C 3. ==> SAUVEGARDE DE LA SOLUTION

C 4.1 ==> SAUVEGARDE DU CHAMP SOLUTION CHSOL DANS VTEMP
      CALL COPISD('CHAMP_GD','V',CHSOL(1:19),VTEMP(1:19))

C 4.2 ==> DESTRUCTION DU CHAMP SOLUTION CHSOL
      CALL DETRSD('CHAMP_GD',CHSOL)

      END
