      SUBROUTINE OBTTIT(SDTABL,SEPCOL,ENTET1,ENTET2,ENTET3)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 18/09/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT      NONE
      CHARACTER*24  SDTABL
      CHARACTER*1   SEPCOL
      CHARACTER*255 ENTET1,ENTET2,ENTET3
C
C ----------------------------------------------------------------------
C
C ROUTINE UTILITAIRE (GESTION STRUCTS - TABLEAU POUR IMPRESSION)
C
C CREATION DE L'ENTETE DU TABLEAU
C
C ----------------------------------------------------------------------
C
C
C IN  SDTABL : STRUCT TABLEAU POUR IMPRESSION
C IN  SEPCOL : SEPARATEUR COLONNE
C OUT ENTET1 : LIGNE 1 DE L'ENTETE
C OUT ENTET2 : LIGNE 2 DE L'ENTETE
C OUT ENTET3 : LIGNE 3 DE L'ENTETE
C
C ----------------------------------------------------------------------
C
      INTEGER       IFM,NIV
      CHARACTER*24  SLCOLO,SDCOLO
      INTEGER       ICOL,NCOL,POS
      INTEGER       LARCOL,LARLIG,TITHAU
      LOGICAL       LACTI
      CHARACTER*16  TITLI1,TITLI2,TITLI3
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFNIV(IFM,NIV)
C
C --- INITIALISATIONS
C
      ENTET1 = ' '
      ENTET2 = ' '
      ENTET3 = ' '
C
C --- HAUTEUR TITRE
C
      CALL OBGETI(SDTABL,'HAUTEUR_TITRE',TITHAU)
      CALL ASSERT((TITHAU.GT.0).AND.(TITHAU.LE.3))
C
C --- LISTE DES COLONNES DISPONIBLES
C
      CALL OBGETO(SDTABL,'COLONNES_DISPOS',SLCOLO)
C
C --- NOMBRE DE COLONNES
C
      CALL OBGETI(SLCOLO,'NBRE_STRUCTS'   ,NCOL  )
C
C --- LARGEUR D'UNE LIGNE
C
      CALL OBGETI(SDTABL,'LARGEUR_LIGNE'  ,LARLIG)
      CALL ASSERT(LARLIG.LE.255)
C
C --- LIGNES VIDES AVEC LES SEPARATEURS DE COLONNES
C
      CALL OBTLIG(SDTABL,SEPCOL,ENTET1)
      IF (TITHAU.GE.2) CALL OBTLIG(SDTABL,SEPCOL,ENTET2)
      IF (TITHAU.EQ.3) CALL OBTLIG(SDTABL,SEPCOL,ENTET3)
C
C --- TITRE DES COLONNES
C
      POS = 2
      DO 10 ICOL = 1,NCOL
        CALL OBLGOI(SLCOLO,ICOL  ,SDCOLO)
        CALL OBLGAI(SLCOLO,ICOL  ,LACTI )
        IF (LACTI) THEN
          CALL OBGETI(SDCOLO,'LARGEUR'     ,LARCOL)
          CALL OBGETK(SDCOLO,'TITRE_LIGN_1',TITLI1)
          IF (TITHAU.GE.2) CALL OBGETK(SDCOLO,'TITRE_LIGN_2',TITLI2)
          IF (TITHAU.EQ.3) CALL OBGETK(SDCOLO,'TITRE_LIGN_3',TITLI3)
          ENTET1(POS:POS+LARCOL-1) = TITLI1
          IF (TITHAU.GE.2) ENTET2(POS:POS+LARCOL-1) = TITLI2
          IF (TITHAU.EQ.3) ENTET3(POS:POS+LARCOL-1) = TITLI3
          POS = POS+LARCOL+1
        ENDIF
 10   CONTINUE
C
      CALL JEDEMA()

      END
