      SUBROUTINE PHI2EL(MODELE,CARELE,MATE,ACCEL,PHIBAR,INSTAP,VE)
      IMPLICIT NONE

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 03/07/2012   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      INCLUDE 'jeveux.h'
      CHARACTER*(*) MODELE,CARELE,MATE,ACCEL,PHIBAR,VE
      REAL*8 INSTAP
C ---------------------------------------------------------------------
C     CALCUL DES VECTEURS ELEMENTAIRES DES FLUX FLUIDES

C IN  MODELE  : NOM DU MODELE
C IN  CARELE  : CARACTERISTIQUES DES POUTRES ET COQUES
C IN  MATE    : MATERIAU
C IN  ACCEL  : CHAM_NO DE OU DE DEPL
C IN  INSTAP  : INSTANT DU CALCUL
C VAR VE  : VECTEUR ELEMENTAIRE DE CHARGEMENT THERMIQUE

C               & & V E C T ? ? .
C               1 2 3 4 5 6 7 8 9

C               POSITION 7-8  : NUMERO DE LA CHARGE



      CHARACTER*8 LPAIN(5),LPAOUT(1),K8BID,KBID
      CHARACTER*16 OPTION
      CHARACTER*19 VECEL
      CHARACTER*24 CHGEOM,CHTIME
      CHARACTER*24 LIGRMO,LCHIN(5),LCHOUT(1),PHIB24,VE2
      INTEGER IBID,IRET
      LOGICAL EXIGEO,PREM
      COMPLEX*16 CBID

C-----------------------------------------------------------------------
      INTEGER JLVE ,NBCHTE 
C-----------------------------------------------------------------------
      CALL JEMARQ()

      VECEL=VE
      VE2 = VECEL//'.RELR'
      CALL JEEXIN(VE2,IRET)

      IF (IRET.EQ.0) THEN
        PREM = .TRUE.
        CALL MEMARE('V',VECEL,MODELE(1:8),MATE,CARELE,'CHAR_THER')
        CALL WKVECT(VE2,'V V K24',1,JLVE)
        IF (ACCEL(9:14).EQ.'.BIDON') THEN
          CALL JEECRA(VE2,'LONUTI',0,K8BID)
          GO TO 10
        END IF
      ELSE
        PREM = .FALSE.
        CALL JELIRA(VE2,'LONUTI',NBCHTE,K8BID)
        IF (NBCHTE.EQ.0) THEN
          GO TO 10
        END IF
        CALL JEVEUO(VE2,'E',JLVE)
      END IF

      LIGRMO = MODELE(1:8)//'.MODELE'

      CALL MEGEOM(MODELE(1:8),ACCEL,EXIGEO,CHGEOM)

      PHIB24 = PHIBAR


      LPAIN(1) = 'PGEOMER'
      LCHIN(1) = CHGEOM
      CHTIME = '&&VECHME.CH_INST_R'
      CALL MECACT('V',CHTIME,'MODELE',LIGRMO,'INST_R  ',1,'INST   ',
     &            IBID,INSTAP,CBID,KBID)
      CALL MECACT('V','&PHI2M.VEC','MODELE',LIGRMO,'TEMP_R  ',1,
     &            'TEMP   ',IBID,0.D0,CBID,KBID)
      LPAIN(2) = 'PTEMPSR'
      LCHIN(2) = CHTIME
      LPAIN(3) = 'PACCELR'
      LCHIN(3) = ACCEL
      LPAIN(4) = 'PMATERC'
      LCHIN(4) = MATE
      LPAOUT(1) = 'PVECTTR'
      OPTION = 'CHAR_THER_PHID_R'
      LPAIN(5) = 'PTEMPER'
      LCHIN(5) = PHIB24


      IF (PREM) THEN

C ----- CREATION DU VECT_ELEM

        LCHOUT(1) = VECEL(1:8)//'.VE'
        CALL CODENT(1,'D0',LCHOUT(1) (7:8))
        CALL CALCUL('S',OPTION,LIGRMO,5,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V',
     &                 'OUI')
        ZK24(JLVE) = LCHOUT(1)
        CALL JEECRA(VE2,'LONUTI',1,K8BID)
      ELSE

C ----- LE VECT_ELEM EXISTE DEJA

        LCHOUT(1) = ZK24(JLVE)
        CALL CALCUL('S',OPTION,LIGRMO,5,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V',
     &                 'OUI')
      END IF
   10 CONTINUE

C FIN ---------------------------------------------------------------
      CALL JEDEMA()
      END
