      SUBROUTINE PIL000(TYPILO,COMPOR,NEPS,TAU,MAT,VIM,SIGM,EPSM,EPSP,
     &   EPSD,TYPMOD,ETAMIN,ETAMAX,COPILO)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================

      IMPLICIT NONE
      CHARACTER*8 TYPMOD(*)
      CHARACTER*16 COMPOR(*),TYPILO
      INTEGER  NEPS, MAT
      REAL*8   TAU,EPSM(NEPS),EPSD(NEPS),EPSP(NEPS),ETAMIN,ETAMAX
      REAL*8   VIM(*),SIGM(NEPS),COPILO(2,2)

C ----------------------------------------------------------------------
C     PILOTAGE PRED_ELAS : BRANCHEMENT SELON COMPORTEMENT
C ----------------------------------------------------------------------
C IN  TYPILO  TYPE DE PILOTAGE : 'PRED_ELAS' OU 'DEFORMATION'
C IN  NEPS    DIMENSION DES DEFORMATIONS
C IN  TAU     INCREMENT DE PILOTAGE
C IN  MAT     NATURE DU MATERIAU                             (PRED_ELAS)
C IN  VIM     VARIABLES INTERNES EN T-                       (PRED_ELAS)
C IN  SIGM    CONTRAINTES EN T- (SI NECESSAIRE)              (PRED_ELAS)
C IN  EPSM    CHAMP DE DEFORMATION EN T-
C IN  EPSP    INCREMENT FIXE
C IN  EPSD    INCREMENT PILOTE
C IN  ETAMIN  BORNE INF DU PILOTAGE (SI UTILE)               (PRED_ELAS)
C IN  ETAMAX  BORNE SUP DU PILOTAGE (SI UTILE)               (PRED_ELAS)
C OUT COPILO  COEFFICIENT DE PILOTAGE : F := A0+A1*ETA = TAU
C ----------------------------------------------------------------------
      REAL*8 R8GAEM
C ----------------------------------------------------------------------

C MODELISATION A GRADIENT DE VARIABLES INTERNES
      IF (TYPMOD(2).EQ.'GRADVARI') THEN

C      PILOTAGE 'DEFORMATION'
        IF (TYPILO.EQ.'DEFORMATION') THEN
        CALL PIDEGV(NEPS,TAU,EPSM,EPSP,EPSD,COPILO)

C      PILOTAGE 'PRED_ELAS'
        ELSE
          IF (ETAMIN.EQ.-R8GAEM() .OR. ETAMAX.EQ.R8GAEM())
     &      CALL U2MESG('F','MECANONLINE_60',1,COMPOR,0,0,0,0.D0)

          IF (COMPOR(1).EQ.'ENDO_SCALAIRE') THEN
            CALL PIESGV(NEPS,TAU,MAT,VIM,EPSM,EPSP,EPSD,TYPMOD,
     &        ETAMIN,ETAMAX,COPILO)

          ELSE IF ( COMPOR(1).EQ.'ENDO_ISOT_BETON') THEN
            CALL PIEIGV(NEPS,TAU,MAT,VIM,EPSM,EPSP,EPSD,TYPMOD,
     &        ETAMIN,ETAMAX,COPILO)

          ELSE
            CALL U2MESS('F','MECANONLINE_59')
          END IF

        END IF
      ELSE
        CALL U2MESG('F','MECANONLINE_61',1,TYPMOD(2),0,0,0,0.D0)
      END IF

      END
