      SUBROUTINE PMACTN(SDDISC,PARCRI,ITERAT,NUMINS,ITEMAX,
     &                  LICCVG,ACTITE,ACTION)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 02/10/2012   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*19 SDDISC
      REAL*8       PARCRI(*)
      INTEGER      LICCVG(5)
      LOGICAL      ITEMAX
      INTEGER      ACTION,ACTITE
      INTEGER      ITERAT,NUMINS
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (ALGORITHME)
C
C GESTION DES ACTIONS SUITE A UN EVENEMENT DANS NEWTON
C
C PASSAGE DE NEWTON -> BOUCLE CONTACT
C
C ----------------------------------------------------------------------
C
C
C IN  SDDISC : SD DISCRETISATION
C IN  PARCRI : CRITERES DE CONVERGENCE
C IN  ITERAT : NUMERO D'ITERATION DE NEWTON
C IN  NUMINS : NUMERO D'INSTANT
C I/O ITEMAX : .TRUE. SI ITERATION MAXIMUM ATTEINTE
C IN  ACTITE : BOUCLE NEWTON -> ACTION POUR LA SUITE
C     0 - NEWTON OK   - BOUCLE DE CONTACT SUIVANTE
C     1 - NEWTON NOOK - IL FAUT FAIRE QUELQUE CHOSE
C     2 - NEWTON NCVG - ON CONTINUE NEWTON
C     3 - NEWTON STOP - TEMPS/USR1
C OUT ACTION : CODE RETOUR ACTION
C               0 ARRET DU CALCUL
C               1 NOUVEAU PAS DE TEMPS
C               2 ON FAIT DES ITERATIONS DE NEWTON EN PLUS
C               3 ON FINIT LE PAS DE TEMPS NORMALEMENT
C
C
C
C
      INTEGER      RETACT,IEVDAC
      LOGICAL      ARRET
      INTEGER      LDCCVG,FACCVG
      CHARACTER*24 SDIMPR,K24BLA
      CHARACTER*19 SOLVEU
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      LDCCVG = LICCVG(2)
      FACCVG = LICCVG(5)
      ARRET  = (NINT(PARCRI(4)).EQ.0)
      ACTION = 0
      SDIMPR = '&&PMACTN.SDIMPR'
      K24BLA = ' '
      SOLVEU = '&&OP0033'
C
C --- CONTINUER LA BOUCLE DE NEWTON EST IMPOSSIBLE ICI
C
      IF (ACTITE.EQ.2) CALL ASSERT(.FALSE.)
C
C --- AFFICHAGE
C
      IF (LDCCVG.EQ.1) THEN
        CALL U2MESS('I','COMPOR1_9')
      ELSEIF (FACCVG.EQ.1) THEN
        CALL U2MESS('I','COMPOR2_4')
      ENDIF
C
C --- BOUCLE TEMPS SUIVANTE
C
      IF (ACTITE.EQ.0) THEN
        ACTION = 3
        GOTO 999
      ENDIF
C
C --- SORTIE DE BOUCLE (PROBLEME)
C
      IF (ACTITE.EQ.3) THEN
        ACTION = 0
        GOTO 999
      ENDIF
C
C --- ECHEC DE NEWTON: IL FAUT FAIRE QUELQUE CHOSE
C
      CALL ASSERT(ACTITE.EQ.1)
C
C --- RECHERCHE DES EVENEMENTS ACTIVES
C
      CALL NMACTO(SDDISC,IEVDAC)
C
C --- ACTIONS SUITE A UN EVENEMENT
C
      IF (IEVDAC.EQ.0) THEN
        RETACT = 0
      ELSE
        CALL NMEVAC(SDIMPR,SDDISC,K24BLA,K24BLA,K24BLA,
     &              SOLVEU,IEVDAC,NUMINS,ITERAT,RETACT)
      ENDIF
C
C --- TRAITEMENT DE L'ACTION
C
      IF (RETACT.EQ.1)  THEN
C
C ----- LA SUBDIVISION S'EST BIEN PASSEE: ON REFAIT LE PAS
C
        ACTION = 1

      ELSE IF (RETACT.EQ.2) THEN
C
C ----- AUTORISATION DE FAIRE DES ITERATIONS DE NEWTON EN PLUS
C
        ACTION = 2

      ELSEIF (RETACT.EQ.3) THEN
C
C ----- ON REFAIT LE PAS
C
        ACTION = 1

      ELSEIF ((RETACT.EQ.4).AND.(.NOT.ARRET).AND.ITEMAX) THEN
C
C ----- CONVERGENCE FORCEE: ON VA AU PAS DE TEMPS SUIVANT
C
        CALL U2MESS('A','MECANONLINE2_37')
        ACTION = 3

      ELSEIF ((RETACT.EQ.4).AND.(.NOT.ARRET)) THEN
C
C ----- CONVERGENCE FORCEE: ON VA AU PAS DE TEMPS SUIVANT
C
        CALL U2MESS('A','MECANONLINE2_37')
        ACTION = 3

      ELSE
C
C ----- ARRET DU CALCUL
C
        ACTION = 0
        CALL U2MESS('A','MECANONLINE9_7')
      ENDIF
C
 999  CONTINUE
C
      ITEMAX = .FALSE.
C
      CALL JEDEMA()
      END
