      SUBROUTINE RDIF01( FAMI,KPG,KSP,
     &                   COMP,   MOD,   IMAT,   MATCST,NBCOMM,
     &                   CPMONO ,NFS,NSG,TOUTMS, NVI,    NMAT, VINI,
     &                   COTHE, COEFF, DCOTHE, DCOEFF,PGL,NBPHAS, 
     &                   COEL,X,DTIME,NEPS,EPSD,  DETOT,
     &                   DVIN, NHSR,NUMHSR,HSR, ITMAX, TOLER, IRET )
      IMPLICIT NONE
C     ================================================================
C          CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 18/06/2012   AUTEUR PROIX J-M.PROIX 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C TOLE CRP_21 CRS_1404
C     ----------------------------------------------------------------
C     ROUTINE D AIGUILLAGE
C     ----------------------------------------------------------------
C     INTEGRATION DE LOIS DE COMPORTEMENT ELASTO-VISCOPLASTIQUE
C     PAR UNE METHODE DE RUNGE KUTTA
C     ----------------------------------------------------------------
C     IN  FAMI    FAMILLE DE POINT DE GAUSS (RIGI,MASS,...)
C     IN  KPG,KSP NUMERO DU (SOUS)POINT DE GAUSS
C     IN  COMP     :  NOM DU MODELE DE COMPORTEMENT
C         MOD     :  TYPE DE MODELISATION
C         IMAT    :  ADRESSE DU MATERIAU CODE
C         MATCST  :  NATURE DES PARAMETRES INELASTIQUES
C         NVI     :  NOMBRE DE VARIABLES INTERNES
C         NMAT    :  NOMBRE DE PARAMETRES MATERIAU INELASTIQUE
C         VINI    :  VARIABLES INTERNES A T
C         COTHE   :  COEFFICIENTS MATERIAU ELASTIQUE A T
C         COEFF   :  COEFFICIENTS MATERIAU INELASTIQUE A T
C         DCOTHE  :  DELTA COEFFICIENTS MATERIAU ELASTIQUE A T+DT
C         DCOEFF  :  DELTA COEFFICIENTS MATERIAU INELASTIQUE A T+DT
C         COEL    :  COEFFICIENTS D'ELASTICITE
C         X       :  INTERVALE DE TEMPS ADAPTATIF
C         DTIME   :  INTERVALE DE TEMPS
C         EPSD    :  DEFORMATION TOTALE A T
C         DETOT   :  INCREMENT DE DEFORMATION TOTALE
C         DVIN    :  DERIVEES DES VARIABLES INTERNES A T
C     ----------------------------------------------------------------
      INTEGER KPG,KSP,IMAT,NMAT,NVI,NBCOMM(NMAT,3),ITENS
      INTEGER NBPHAS,NFS,IRET,ITMAX,NSG,NHSR,NUMHSR(*),NEPS
      CHARACTER*16 LOI,COMP(*),CPMONO(5*NMAT+1)
      CHARACTER*8 MOD
      CHARACTER*(*) FAMI
      CHARACTER*3 MATCST
      REAL*8 PGL(3,3),TOLER,X, DTIME,COEL(NMAT)
      REAL*8 COTHE(NMAT),DCOTHE(NMAT),COEFF(NMAT),DCOEFF(NMAT)
      REAL*8 EPSD(6),DETOT(6),COEFT(NMAT),XM,SIGI(6)
      REAL*8 VINI(NVI),DVIN(NVI),HSR(NSG,NSG,NHSR),EVI(6)
C     POUR GAGNER EN TEMPS CPU
      REAL*8 TOUTMS(*)
C
      LOI=COMP(1)
      IF (LOI(1:8).EQ.'MONOCRIS') THEN
C       PAS DE VARIATION DES COEF AVEC LA TEMPERATURE        
        XM=0.D0
        CALL COEFFT(COTHE,COEFF,DCOTHE,DCOEFF,XM,DTIME,COEFT,
     &              NMAT,COEL)
        CALL LCMMON(FAMI,KPG,KSP,COMP,NBCOMM,CPMONO,NMAT,NVI,VINI,
     &              X,DTIME,PGL,MOD,COEFT,NEPS,EPSD,DETOT,COEL,
     &              DVIN,NFS,NSG,TOUTMS,HSR(1,1,1),ITMAX,TOLER,IRET)

      ELSEIF (LOI(1:8).EQ.'POLYCRIS') THEN
C       PAS DE VARIATION DES COEF AVEC LA TEMPERATURE              
        XM=0.D0
        CALL COEFFT(COTHE,COEFF,DCOTHE,DCOEFF,XM,DTIME,COEFT,
     &              NMAT,COEL)
        CALL LCMMOP(FAMI,KPG,KSP,COMP,NBCOMM,CPMONO,NMAT,NVI,
     &              VINI,X,DTIME,MOD,COEFT,EPSD,
     &              DETOT,COEL,NBPHAS,NFS,NSG,TOUTMS,DVIN,
     &              NHSR,NUMHSR,HSR,ITMAX,TOLER,IRET)

      ELSE
         
         DO 5 ITENS=1,6
           EVI(ITENS) = VINI(ITENS)
    5    CONTINUE
 
         CALL COEFFT(COTHE,COEFF,DCOTHE,DCOEFF,X,DTIME,COEFT,
     &               NMAT,COEL)
 
         
         CALL CALSIG(FAMI,KPG,KSP,EVI,MOD,COMP,VINI,X,DTIME,EPSD,
     &                 DETOT,NMAT,COEL,SIGI)

         CALL LCDVIN(FAMI,KPG,KSP,COMP,MOD,IMAT,MATCST,NVI,NMAT,VINI,
     &               COEFT,X,DTIME,SIGI,DVIN,IRET)
     
      END IF
      END
