      SUBROUTINE RKCAH2( COMP,Y,PAS,NVI,W,WK,H,EPS,IRET)
      IMPLICIT NONE
C     ================================================================
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 18/06/2012   AUTEUR PROIX J-M.PROIX 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
C     INTEGRATION DE LOIS DE COMPORTEMENT PAR  RUNGE KUTTA
C     CALCUL DU NOUVEAU PAS DE TEMPS (DIMINUTION)
C      IN COMP    :  NOM DU MODELE DE COMPORTEMENT
C         Y       :  VARIABLES INTERNES
C     OUT H       :  PAS DE TEMPS

      INTEGER  NE,NY,NA,NVI,IRET
      CHARACTER*16 LOI,COMP(*)
      REAL*8 Y(*),H,W,DMG0,DMG1,MAXOUT,MAXDOM,WK(*),EPS
      REAL*8 PREC,R8PREM,COEF,PAS
      PARAMETER  ( MAXDOM = 9.90D-01  )
C
      LOI=COMP(1)
      NE=0
      NY=NVI
      NA=NY+NVI
      PREC=R8PREM()
      
      IRET=0
      
      MAXOUT=MAXDOM-EPS
      
      IF (LOI(1:9).EQ.'VENDOCHAB') THEN
C        TRAITEMENT VENDOCHAB
         DMG1=Y(9)
C        TEST SUR LE NIVEU DE DOMMAGE--
         IF (DMG1.GE.MAXDOM) THEN
            DMG0=(DMG1-WK(NE+9))-(WK(NA+9)*H)
            H=(MAXOUT-DMG0)/((WK(NE+9)/H)+WK(NA+9))
         ELSE
            W=W/ABS(EPS)
            W=MIN(W,1.0D08)
            COEF=W**(-2.0D-01)*9.0D-01
            H=H*COEF
         ENDIF
C        FIN TEST SUR LE NIVEAU DE DOMMAGE

      ELSE

         W=W/ABS(EPS)
         W=MIN(W,1.0D08)
C        CALCUL CLASSIQUE DU NOUVEAU PAS DE TEMPS (ISSU DE RK4)
C        POUR W=1.D8, COEF=2.26070E-02      
         COEF=W**(-2.0D-01)*9.0D-01
         H=H*COEF
      ENDIF
      
      IF ((H/PAS).LT.PREC) THEN
         CALL U2MESS('I','ALGORITH3_83')
         IRET=1
      ENDIF

      END
