      SUBROUTINE SATUVG(VG,PC,SAT,DSDPC)
C ======================================================================
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C ======================================================================
C
C SATUVG : CALCUL DE LA SATURATION PAR VAN-GENUCHTEN + REGULARISATION
C  GAUCHE
      IMPLICIT NONE
C
C IN
      REAL*8 VG(5),PC
C OUT
      REAL*8 SAT,DSDPC
C
      REAL*8 SATUMA
      REAL*8 N,M,PR,SMAX,SR,S1MAX,PCMAX,DPCMAX
      REAL*8 USN,USM,B1,C1
      REAL*8 BIDON

      N    = VG(1)
      PR   = VG(2)
      SR   = VG(3)
      SMAX = VG(4)
      SATUMA = VG(5)
      M=1.D0-1.D0/N
      USN=1.D0/N
      USM=1.D0/M
C
      S1MAX=(SMAX-SR)/(1.D0-SR)
C
C FONCTION PROLONGATION A GAUCHE DE S(PC) (S > SMAX)
      CALL PCAPVG(SR,PR,USM,USN,S1MAX,PCMAX,DPCMAX,BIDON)
      CALL REGUH1(PCMAX,SMAX,1.D0/DPCMAX,B1,C1)
C
C FONCTION PROLONGATION A DROITE PAR FONCTION LINEAIRE DE S(PC)
C ON SUPPRIME CAR INUTILE ET DANGEUREUX
C      CALL PCAPVG(SR,PR,USM,USN,S1MIN,PCMIN,DPCMIN,BIDON)
C     CALL REGUP1(X0,PCMIN,DPCMIN,AR,BR)
C
      IF ( (PC.GT.PCMAX)) THEN
C
       CALL SATFVG(SR,PR,N,M,PC,SAT,DSDPC)
C
      ELSE IF(PC.LE.PCMAX) THEN
C
        SAT=1.D0-B1/(C1-PC)
        DSDPC=-B1/((C1-PC)**2.D0)
C
C
      ENDIF
      SAT=SAT*SATUMA

      END
