      SUBROUTINE VEBUME(MODELZ,MATASZ,DEPLAZ,LISCHA,VECELZ)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE MABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*(*) MODELZ,MATASZ,DEPLAZ,VECELZ
      CHARACTER*19  LISCHA
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (CALCUL)
C
C CALCUL DES VECTEURS ELEMENTAIRES B.U - ELEMENTS DE LAGRANGE
C
C ----------------------------------------------------------------------
C
C
C IN  MODELE : NOM DU MODELE
C IN  DEPLA  : CHAMP DE DEPLACEMENTS
C IN  LISCHA : SD L_CHARGES
C OUT VECELE : VECTEURS ELEMENTAIRES
C
C
C
C
      INTEGER      NBOUT,NBIN
      PARAMETER    (NBOUT=1, NBIN=3)
      CHARACTER*8  LPAOUT(NBOUT),LPAIN(NBIN)
      CHARACTER*19 LCHOUT(NBOUT),LCHIN(NBIN)
C
      INTEGER      IRET, NCHAR,NDIR,  ICHA,  IBID
      INTEGER      JCHAR,JINF, IFMDBG,NIVDBG
      REAL*8       ALPHA
      CHARACTER*8  NOMCHA,K8BID,MASQUE,MODELE
      CHARACTER*16 OPTION
      CHARACTER*19 DEPLA,VECELE,MATASS
      CHARACTER*24 LIGRCH,CHALPH
      COMPLEX*16   CBID
      LOGICAL      DEBUG
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('PRE_CALCUL',IFMDBG,NIVDBG)
C
C --- INITIALISATIONS
C
      MASQUE = '.0000000'
      VECELE = VECELZ
      MATASS = MATASZ
      MODELE = MODELZ
      DEPLA  = DEPLAZ
      OPTION = 'MECA_BU_R'
      IF (NIVDBG.GE.2) THEN
        DEBUG  = .TRUE.
      ELSE
        DEBUG  = .FALSE.
      ENDIF
C
C --- INITIALISATION DES CHAMPS POUR CALCUL
C
      CALL INICAL(NBIN  ,LPAIN ,LCHIN ,
     &            NBOUT ,LPAOUT,LCHOUT)
C
C --- ACCES AUX CHARGES
C
      CALL JEEXIN(LISCHA(1:19)//'.LCHA',IRET)
      IF ( IRET .EQ. 0 ) GOTO 9999
      CALL JELIRA(LISCHA(1:19)//'.LCHA','LONMAX',NCHAR,K8BID)
      CALL JEVEUO(LISCHA(1:19)//'.LCHA','L',JCHAR)
      CALL JEVEUO(LISCHA(1:19)//'.INFC','L',JINF)
C
C --- ALLOCATION DE LA CARTE DU CONDITIONNEMENT DES LAGRANGES
C
C      CALL UTIMSD(6,0,.TRUE.,.FALSE.,'&&OP0070',1,'V')
      CALL CONLAG(MATASS, ALPHA)
      CHALPH = '&&VEBUME.CH_NEUT_R'
      CALL MECACT('V',CHALPH,'MODELE',MODELE,'NEUT_R  ',1,'X1',
     &            IBID,ALPHA,CBID,K8BID)
C
C --- ALLOCATION DU VECT_ELEM RESULTAT :
C
      CALL DETRSD('VECT_ELEM',VECELE)
      CALL MEMARE('V',VECELE,MODELE(1:8),' ',' ','CHAR_MECA')
      CALL REAJRE(VECELE,' ','V')
C
C --- CALCUL DE L'OPTION B.U
C
      NDIR = 0
      DO 10 ICHA = 1,NCHAR
        IF (ZI(JINF+ICHA).LE.0) GO TO 10
        NOMCHA = ZK24(JCHAR+ICHA-1) (1:8)
        LIGRCH = NOMCHA//'.CHME.LIGRE'
        CALL JEEXIN(NOMCHA//'.CHME.LIGRE.LIEL',IRET)
        IF (IRET.LE.0) GO TO 10
        CALL EXISD('CHAMP_GD',NOMCHA//'.CHME.CMULT',IRET)
        IF (IRET.LE.0) GO TO 10

        LPAIN(1)  = 'PDDLMUR'
        LCHIN(1)  = NOMCHA(1:8)//'.CHME.CMULT'
        LPAIN(2)  = 'PDDLIMR'
        LCHIN(2)  = DEPLA
        LPAIN(3)  = 'PALPHAR'
        LCHIN(3)  = CHALPH
        LPAOUT(1) = 'PVECTUR'
        LCHOUT(1) = '&&VEBUME.???????'
        CALL GCNCO2(MASQUE)
        LCHOUT(1)(10:16) = MASQUE(2:8)
        CALL CORICH('E',LCHOUT(1),ICHA,IBID)
C
        CALL CALCUL('S',OPTION,LIGRCH,NBIN ,LCHIN ,LPAIN ,
     &                                NBOUT,LCHOUT,LPAOUT,'V','OUI')
C
        IF (DEBUG) THEN
          CALL DBGCAL(OPTION,IFMDBG,
     &                NBIN  ,LPAIN ,LCHIN ,
     &                NBOUT ,LPAOUT,LCHOUT)
        ENDIF
C
        NDIR = NDIR + 1
        CALL REAJRE(VECELE,LCHOUT(1),'V')
   10 CONTINUE
C

 9999 CONTINUE

      CALL JEDEMA()
      END
