      SUBROUTINE VECHMS(NOMO  ,MATE  ,CARELE,VARPLU,LISCHA,
     &                  PARTPS,VECELE)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 20/06/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT      NONE
      INCLUDE 'jeveux.h'
      CHARACTER*8   NOMO
      CHARACTER*24  MATE,CARELE
      REAL*8        PARTPS(3)
      CHARACTER*19  LISCHA,VARPLU
      CHARACTER*19  VECELE
C
C ----------------------------------------------------------------------
C
C CALCUL DES VECTEURS ELEMENTAIRES DES CHARGEMENTS MECANIQUES
C DE NEUMANN STANDARD (VOIR DEFINITION DANS LISDEF)
C
C CALCUL EFFECTIF - BOUCLE SUR LES CHARGES
C
C ----------------------------------------------------------------------
C
C
C IN  NOMO   : NOM DU MODELE
C IN  LISCHA : SD LISTE DES CHARGES
C IN  PARTPS : TABLEAU DONNANT T+, DELTAT ET THETA (POUR LE THM)
C IN  CARELE : CARACTERISTIQUES DES POUTRES ET COQUES
C IN  MATE   : MATERIAU CODE
C IN  VARPLU : VARIABLES DE COMMANDE A L'INSTANT T+
C IN  NBIN   : NOMBRE MAXI DE CHAMPS D'ENTREE
C IN  LPAIN  : LISTE DES PARAMETRES IN
C IN  LCHIN  : LISTE DES CHAMPS IN
C IN  LASTIN : NOMBRE EFFECTIF DE CHAMPS IN
C OUT VECELE : VECT_ELEM RESULTAT
C
C ----------------------------------------------------------------------
C
      INTEGER      NBIN
      PARAMETER    (NBIN=42)
      CHARACTER*8  LPAIN(NBIN)
      CHARACTER*19 LCHIN(NBIN)
C
      INTEGER      ICHAR,NBCHAR,LASTIN
      CHARACTER*8  NOMCH0
      CHARACTER*24 NOMLIS
      INTEGER      CODCHA,IER
      LOGICAL      LISICO,LNEUM,LXFEM
      INTEGER      NBCH,NBNEUM,LISNBG
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      NOMLIS = '&&NOMLIS'
      CALL EXIXFE(NOMO,IER)
      LXFEM  = IER.NE.0
      CALL DETRSD('VECT_ELEM',VECELE)
C
C --- NOMBRE DE CHARGES
C
      CALL LISNNB(LISCHA,NBCHAR)
C
C --- NOMBRE DE CHARGES DE TYPE NEUMANN MECANIQUE
C
      NBNEUM = LISNBG(LISCHA,'NEUM_MECA')
      IF (NBNEUM.EQ.0) GOTO 99
C
C --- CHAMPS D'ENTREES STANDARDS
C
      CALL VECHMP(NOMO  ,MATE  ,CARELE,VARPLU,LXFEM ,
     &            PARTPS,NBIN  ,LPAIN ,LCHIN ,LASTIN)
C
C --- LISTE DES INDEX DES CHARGES
C
      CALL LISNOL(LISCHA,'NEUM_MECA',NOMLIS,NBCH  )
      CALL ASSERT(NBCH.GT.0)
C
C --- CALCUL
C
      DO 80 ICHAR = 1,NBCHAR
        CALL LISLCO(LISCHA,ICHAR ,CODCHA)
        LNEUM  = LISICO('NEUM_MECA',CODCHA)
        IF (LNEUM) THEN
C
C ------- CALCUL DE LA CHARGE ?
C
          CALL LISLCH(LISCHA,ICHAR ,NOMCH0)
C
C ------- BOUCLE SUR LES TOUS LES TYPES DE CHARGE PREVUS
C
          CALL VECHMX(NOMO  ,LISCHA,ICHAR ,NBCH  ,NOMLIS,
     &                NBIN  ,LPAIN ,LCHIN ,LASTIN,VECELE)
        ENDIF
   80 CONTINUE
C
   99 CONTINUE
C
      CALL JEDETR(NOMLIS)
C
      CALL JEDEMA()
      END
