      SUBROUTINE VECHMX(NOMO  ,LISCHA,ICHAR ,NBCH  ,NOMLIS,
     &                  NBIN  ,LPAIN ,LCHIN ,LASTIN,VECELE)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 20/06/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT      NONE
      INCLUDE 'jeveux.h'
      INTEGER       NBIN,LASTIN
      CHARACTER*8   LPAIN(NBIN)
      CHARACTER*19  LCHIN(NBIN)
      CHARACTER*19  LISCHA
      CHARACTER*24  NOMLIS
      INTEGER       ICHAR,NBCH
      CHARACTER*8   NOMO
      CHARACTER*19  VECELE
C
C ----------------------------------------------------------------------
C
C CALCUL DES VECTEURS ELEMENTAIRES DES CHARGEMENTS MECANIQUES
C DE NEUMANN (VOIR DEFINITION DANS LISDEF)
C
C CALCUL EFFECTIF - BOUCLE SUR LES TYPES DE CHARGEMENT
C
C ----------------------------------------------------------------------
C
C
C IN  NOMO   : NOM DU MODELE
C IN  LISCHA : SD LISTE DES CHARGES
C IN  ICHAR  : INDICE DE LA CHARGE
C IN  NOMLIS : LISTE DES INDEX DES CHARGES
C IN  NBCH   : LONGUEUR DE NOMLIS
C IN  NBIN   : NOMBRE MAXI DE CHAMPS D'ENTREE
C IN  LPAIN  : LISTE DES PARAMETRES IN
C IN  LCHIN  : LISTE DES CHAMPS IN
C IN  LASTIN : NOMBRE EFFECTIF DE CHAMPS IN
C OUT VECELE : VECT_ELEM RESULTAT
C
C ----------------------------------------------------------------------
C
      INTEGER      NBOUT
      PARAMETER    (NBOUT=1)
      CHARACTER*8  LPAOUT(NBOUT)
      CHARACTER*19 LCHOUT(NBOUT)
C
      INTEGER      JLISCI,ICH,IBID
      INTEGER      IRET
      INTEGER      INDXCH
      CHARACTER*16 OPTION
      CHARACTER*8  PARAIN,PARAOU,NEWNOM
      CHARACTER*8  TYPECH
      CHARACTER*19 CARTE
      CHARACTER*19 LIGCAL
      CHARACTER*13 PREFOB
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      NEWNOM = '.0000000'
C
C --- PREFIXE DE L'OBJET DE LA CHARGE
C
      CALL LISLLC(LISCHA,ICHAR ,PREFOB)
C
C --- TYPE DE LA CHARGE
C
      CALL LISLTC(LISCHA,ICHAR ,TYPECH)
C
C --- CHAMP DE SORTIE
C
      CALL GCNCO2(NEWNOM)
      LCHOUT(1) = '&&VECHMX.'//NEWNOM(2:8)
      CALL CORICH('E',LCHOUT(1),ICHAR,IBID)
C
C --- LISTE DES INDEX DES CHARGES
C
      CALL JEVEUO(NOMLIS,'L',JLISCI)
C
C --- CALCUL
C
      DO 70 ICH = 1,NBCH
        INDXCH = ZI(JLISCI-1+ICH)
        CALL LISOPT(PREFOB,NOMO  ,TYPECH,INDXCH,OPTION,
     &              PARAIN,PARAOU,CARTE ,LIGCAL)
        CALL JEEXIN(CARTE(1:19)//'.DESC',IRET)
        IF (IRET.NE.0) THEN
C
C ------- CARTE D'ENTREE
C
          LASTIN = LASTIN + 1
          LCHIN(LASTIN) = CARTE
          LPAIN(LASTIN) = PARAIN
C
C ------- CARTE DE SORTIE
C
          LPAOUT(1) = PARAOU
C
C ------- CALCUL
C
          CALL ASSERT(LASTIN.LE.NBIN)
          CALL CALCUL('S',OPTION,LIGCAL,LASTIN,LCHIN ,LPAIN ,
     &                                  NBOUT ,LCHOUT,LPAOUT,
     &                                  'V'   ,'OUI' )
C
C ------- RESU_ELEM DANS LE VECT_ELEM
C
          CALL EXISD('CHAMP_GD',LCHOUT(1),IRET)
          CALL ASSERT(IRET.GT.0)
          CALL REAJRE(VECELE,LCHOUT(1),'V')
        ENDIF
   70 CONTINUE
C
      CALL JEDEMA()
      END
