      SUBROUTINE VEIMPD(MODELE,MATE  ,VITINI,SDDYNA,VECELZ)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*(*) VECELZ
      CHARACTER*24  MODELE,MATE
      CHARACTER*19  VITINI
      CHARACTER*19  SDDYNA
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE (CALCUL)
C
C CALCUL DES VECTEURS ELEMENTAIRES DES IMPEDANCES DE SOL
C
C ----------------------------------------------------------------------
C
C
C IN  MODELE : NOM DU MODELE
C IN  MATE   : CHAMP DE MATERIAU
C IN  VITINI : VITESSE INITIALE
C IN  SDDYNA : SD DYNAMIQUE
C OUT VECELE : VECTEURS ELEMENTAIRES IMPEDANCES DE SOL
C
C
C
C
C
      INTEGER      NBOUT,NBIN
      PARAMETER    (NBOUT=1, NBIN=4)
      CHARACTER*8  LPAOUT(NBOUT),LPAIN(NBIN)
      CHARACTER*19 LCHOUT(NBOUT),LCHIN(NBIN)
C
      INTEGER      IBID
      CHARACTER*19 VECELE
      CHARACTER*16 OPTION
      CHARACTER*24 CHGEOM,LIGRMO
      CHARACTER*19 VITENT
      LOGICAL      DEBUG
      INTEGER      JNOMA
      INTEGER      IFMDBG,NIVDBG
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('PRE_CALCUL',IFMDBG,NIVDBG)
C
C --- INITIALISATIONS
C
      VECELE = VECELZ
      LIGRMO = MODELE(1:8)//'.MODELE'
      CALL NDYNKK(SDDYNA,'VITENT',VITENT)
      CALL JEVEUO(LIGRMO(1:19)//'.LGRF','L',JNOMA)
      CHGEOM = ZK8(JNOMA)//'.COORDO'
      OPTION = 'IMPE_ABSO'
      IF (NIVDBG.GE.2) THEN
        DEBUG  = .TRUE.
      ELSE
        DEBUG  = .FALSE.
      ENDIF
C
C --- INITIALISATION DES CHAMPS POUR CALCUL
C
      CALL INICAL(NBIN  ,LPAIN ,LCHIN ,
     &            NBOUT ,LPAOUT,LCHOUT)
C
C --- CHAMPS D'ENTREE
C
      LPAIN(1) = 'PGEOMER'
      LCHIN(1) = CHGEOM(1:19)
      LPAIN(2) = 'PMATERC'
      LCHIN(2) = MATE(1:19)
      LPAIN(3) = 'PVITPLU'
      LCHIN(3) = VITINI(1:19)
      LPAIN(4) = 'PVITENT'
      LCHIN(4) = VITENT
C
C --- CHAMPS DE SORTIE
C
      LPAOUT(1) = 'PVECTUR'
      LCHOUT(1) = VECELE
C
C --- ALLOCATION DU VECT_ELEM RESULTAT :
C
      CALL JEDETR(VECELE//'.RELR')
C
C --- CALCUL
C
      CALL CORICH('E',LCHOUT(1),-1,IBID)
      CALL CALCUL('S',OPTION,LIGRMO,NBIN ,LCHIN ,LPAIN ,
     &                              NBOUT,LCHOUT,LPAOUT,'V','OUI')
C
      IF (DEBUG) THEN
        CALL DBGCAL(OPTION,IFMDBG,
     &              NBIN  ,LPAIN ,LCHIN ,
     &              NBOUT ,LPAOUT,LCHOUT)
      ENDIF
C
      CALL REAJRE(VECELE,LCHOUT(1),'V')
C
      CALL JEDEMA()
      END
