      SUBROUTINE VETHBU(MODELE,MATASZ,CHARGE,INFCHA,CARELE,
     &                  MATE  ,CHTNI ,VEBTEM)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*24  MODELE,CHARGE,INFCHA,CARELE,MATE,CHTNI,VEBTEM
      CHARACTER*(*) MATASZ
C ----------------------------------------------------------------------
C CALCUL DES VECTEURS ELEMENTAIRES B * TEMPERATURE

C IN  MODELE  : NOM DU MODELE
C IN  MATASZ  : SD MATRICE ASSEMBLEE
C IN  CHARGE  : LISTE DES CHARGES
C IN  INFCHA  : INFORMATIONS SUR LES CHARGEMENTS
C IN  CARELE  : CHAMP DE CARA_ELEM
C IN  MATE    : MATERIAU CODE
C IN  CHTNI   : IEME ITEREE DU CHAMP DE TEMPERATURE
C OUT VEBTEM  : VECTEURS ELEMENTAIRES PROVENANT DE B * TMOINS



      INTEGER      NBOUT,NBIN
      PARAMETER    (NBOUT=1, NBIN=3)
      CHARACTER*8  LPAOUT(NBOUT),LPAIN(NBIN)
      CHARACTER*19 LCHOUT(NBOUT),LCHIN(NBIN)
C
      REAL*8       ALPHA
      CHARACTER*8  NOMCHA,K8BID, NEWNOM
      CHARACTER*16 OPTION
      CHARACTER*19 VECEL, MATASS
      CHARACTER*24 LIGRCH,CHALPH
      INTEGER      IRET,  NCHAR, ICHA,JCHAR,JINF,IBID,JDIR,NDIR
      COMPLEX*16   CBID
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- ACCES AUX CHARGES
C
      CALL JEEXIN(CHARGE,IRET)
      IF (IRET.NE.0) THEN
        CALL JELIRA(CHARGE,'LONMAX',NCHAR,K8BID)
        CALL JEVEUO(CHARGE,'L',JCHAR)
      ELSE
        NCHAR = 0
      END IF
C
C --- ALLOCATION DU VECT_ELEM RESULTAT :
C
      CALL JEEXIN(VEBTEM,IRET)
      VECEL = '&&VEBUEE           '
      IF (IRET.EQ.0) THEN
        VEBTEM = VECEL//'.RELR'
        CALL MEMARE('V',VECEL,MODELE(1:8),MATE,CARELE,'CHAR_THER')
        CALL WKVECT(VEBTEM,'V V K24',NCHAR,JDIR)
      ELSE
        CALL JEVEUO(VEBTEM,'E',JDIR)
      END IF
      CALL JEECRA(VEBTEM,'LONUTI',0,K8BID)
C
C --- ALLOCATION DE LA CARTE DU CONDITIONNEMENT DES LAGRANGES
C
      MATASS = MATASZ
      CALL CONLAG(MATASS, ALPHA)
      CHALPH = '&&VETHBU.CH_NEUT_R'
      CALL MECACT('V',CHALPH,'MODELE',MODELE,'NEUT_R  ',1,'X1',
     &            IBID,ALPHA,CBID,K8BID)
C
C --- CALCUL DE L'OPTION B.T
C
      OPTION = 'THER_BU_R'
      IF (NCHAR.GT.0) THEN
        CALL JEVEUO(INFCHA,'L',JINF)
        DO 10 ICHA = 1,NCHAR
          NDIR = 0
          IF (ZI(JINF+ICHA).GT.0) THEN
            NOMCHA = ZK24(JCHAR+ICHA-1) (1:8)
            LIGRCH = NOMCHA//'.CHTH.LIGRE'
            LPAIN(1) = 'PDDLMUR'
            LCHIN(1) = NOMCHA//'.CHTH.CMULT'
            LPAIN(2) = 'PDDLIMR'
            LCHIN(2) = CHTNI
            LPAIN(3)  = 'PALPHAR'
            LCHIN(3)  = CHALPH
            LPAOUT(1) = 'PVECTTR'
            LCHOUT(1) = '&&VETHBU.???????'
            CALL GCNCON('.',NEWNOM)
            LCHOUT(1) (10:16) = NEWNOM(2:8)
            CALL CORICH('E',LCHOUT(1),-1,IBID)
            CALL CALCUL('S',OPTION,LIGRCH,NBIN, LCHIN, LPAIN,
     &                                    NBOUT,LCHOUT,LPAOUT,'V','OUI')
            NDIR = NDIR + 1
            ZK24(JDIR+NDIR-1) = LCHOUT(1)
          END IF
          CALL JEECRA(VEBTEM,'LONUTI',NDIR,K8BID)

   10   CONTINUE

      END IF
C FIN ------------------------------------------------------------------
      CALL JEDEMA()
      END
