      SUBROUTINE XAJPIN(NDIM,LIST,LONG,IPT,CPT,NEWPT,LONGAR,AINTER,IA,
     &                  IN,AL)
      IMPLICIT NONE

      INCLUDE 'jeveux.h'
      INTEGER       NDIM,LONG,IPT,CPT,IA,IN
      REAL*8        NEWPT(3),LONGAR,AL,LIST(*),AINTER(*)
C     ------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 20/06/2012   AUTEUR GENIAUT S.GENIAUT 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE GENIAUT S.GENIAUT
C         AJOUTER UN POINT D'INTERSECTION DANS UNE LISTE
C              ET INFORMATIONS COMPLMENTAIRES SUR LES ARETES
C
C     ENTREE
C       NDIM   : DIMENSION DU MAILLAGE
C       LIST   : LA LISTE
C       LONG   : LONGUEUR MAX DE LA LISTE
C       IPT    : LONGUEUR DE LA LISTE AVANT AJOUT
C       CPT    : COMPTEUR SPCIFIQUE
C       NEWPT  : COORDONNES DU POINT A AJOUTER
C       LONGAR : LONGUEUR DE L'ARETE
C       AINTER : LISTE DES ARETES
C       IA     : NUMERO DE L'ARETE (0 SI NOEUD SOMMET)
C       IN     : NUMRO NOEUD SI NOEUD SOMMET        (0 SINON)
C       AL     : POSITION DU PT SUR L'ARETE (0.D0 SI NOEUD SOMMET)
C     SORTIE
C       LIST,AINTER
C     ------------------------------------------------------------------
      REAL*8          PADIST,P(3)
      INTEGER         I,J
      LOGICAL         DEJA
      INTEGER         ZXAIN,XXMMVD
C ----------------------------------------------------------------------

      CALL JEMARQ()
      
      ZXAIN = XXMMVD('ZXAIN')

C     VERIFICATION SI CE POINT EST DEJA DANS LA LISTE
      DEJA = .FALSE.

      DO 100 I = 1,IPT
        DO 99 J = 1, NDIM
         P(J) = LIST(NDIM*(I-1)+J)
 99     CONTINUE
        IF (PADIST(NDIM,P,NEWPT) .LT. (LONGAR*1.D-6)) DEJA = .TRUE.
 100  CONTINUE

      IF (.NOT. DEJA) THEN
C       CE POINT N'A PAS DEJA ETE TROUVE, ON LE GARDE
        IPT = IPT + 1
        CPT = CPT + 1
C       TROP DE POINTS DANS LA LISTE
        CALL ASSERT(IPT .LE. LONG)
        DO 101 J = 1, NDIM
         LIST(NDIM*(IPT-1)+J) = NEWPT(J)
 101    CONTINUE
        AINTER(ZXAIN*(IPT-1)+1)=IA
        AINTER(ZXAIN*(IPT-1)+2)=IN
        AINTER(ZXAIN*(IPT-1)+3)=LONGAR
        AINTER(ZXAIN*(IPT-1)+4)=AL
      ENDIF

      CALL JEDEMA()
      END
