      SUBROUTINE XCODEC(NOMA  ,MODELX,NDIM  ,CRIMAX,LINTER)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*8 NOMA,MODELX
      INTEGER     NDIM
      REAL*8      CRIMAX
      LOGICAL     LINTER
C
C ----------------------------------------------------------------------
C
C ROUTINE XFEM (MODIF. DU MODELE)
C
C CALCUL DU DCOUPAGE EN SOUS-TETRAS, DES FACETTES DE CONTACT
C ET VERIFICATION DES CRITERES DE CONDITIONNEMENT
C
C ----------------------------------------------------------------------
C
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  MODELX : NOM DU MODELE XFEM MODIFIE
C IN  NDIM   : DIMENSION DU PROBLEME
C IN  CRIMAX : CRITERE MAXIMUM
C
C
C
C
      CHARACTER*19 LTNO,LNNO,STNO,BASLOC,GRLNNO,GRLTNO
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- CONCATENER LES CHAMPS NODAUX POUR DES FISSURES DU MODELE
C
      LTNO   = MODELX(1:8)//'.LTNO'
      LNNO   = MODELX(1:8)//'.LNNO'
      STNO   = MODELX(1:8)//'.STNO'
      BASLOC = MODELX(1:8)//'.BASLOC'
      GRLNNO = MODELX(1:8)//'.GRLNNO'
      GRLTNO = MODELX(1:8)//'.GRLTNO'
      CALL XCONNO(MODELX,'.STNO      ','G','FULL_MECA','PSTANO',STNO)
      CALL XCONNO(MODELX,'.LNNO      ','G','FULL_MECA','PLSN',LNNO)
      CALL XCONNO(MODELX,'.LTNO      ','G','FULL_MECA','PLST',LTNO)
      CALL XCONNO(MODELX,'.BASLOC    ','G','FULL_MECA','PBASLOR',BASLOC)
      CALL XCONNO(MODELX,'.GRLNNO    ','V','TOPOFA','PGRADLN',GRLNNO)
      CALL XCONNO(MODELX,'.GRLTNO    ','V','TOPOFA','PGRADLT',GRLTNO)
C
C --- UTILE POUR LES INTERSECTIONS
C
      IF (LINTER) THEN
        CALL XFISNO(NOMA  ,MODELX)
        CALL XFISCO(NOMA  ,MODELX)
      ENDIF
C
C --- CALCUL DES DONNEES UTILES POUR L'INTGRATION (SOUS-TETRAS...)
C
      CALL XTOPOI(NOMA, MODELX)
C
C --- CALCUL DE LA TOPOLOGIE DES FACETTES DE CONTACT
C
      CALL XTOPOC(MODELX)
C
C --- ON MODIFIE MODELX(1:8)//'TOPOFAC.AI' POUR LE MULTI-HEAVISIDE
C
      IF (LINTER) THEN
        CALL XAINT2(NOMA,MODELX)
      ENDIF
C
C --- ON MODIFIE MODELX(1:8)//'.STNO' POUR LE CONDITIONNEMENT HEAVISIDE
C
      CALL XSTAN2(CRIMAX,NOMA  ,MODELX)
C
C --- ORIENTATION DES FACETTES DE PEAU X-FEM (COMME ORIE_PEAU)
C
      CALL XORIPE(MODELX)

C
      CALL JEDEMA()
      END
