      SUBROUTINE XCRVOL(NSE,NDIM,JCNSE,NNOSE,JPINT,IGEOM,ELREFP,INOLOC,
     &                  NBNOMA,JCESD3,JCESL3,JCESV3,NUMA2,IFISS,
     &                  VMOIN,VPLUS,VTOT)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/11/2012   AUTEUR MARTIN A.MARTIN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE GENIAUT S.GENIAUT
C TOLE CRS_1404
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      INTEGER       NSE,NDIM,JCNSE,NNOSE,JPINT,IGEOM,INOLOC
      CHARACTER*8   ELREFP
      INTEGER       NBNOMA,JCESD3,JCESL3,JCESV3,NUMA2,IFISS
      REAL*8        VMOIN,VPLUS,VTOT
C
C  BUT: ESTIMATION CRITERE DE RIGIDITE
C
      REAL*8        CO(NDIM+1,NDIM),MAT(NDIM,NDIM),VSE,BARY(NDIM)
      REAL*8        POINT(NDIM)
      REAL*8        RBID,FF(NBNOMA),DFDI(NBNOMA,NDIM),XE(NDIM),DERIV
      INTEGER       ISE,INO2,I,J,IAD,IBID,K
      LOGICAL       ISMALI
C
C ----------------------------------------------------------------------
C
C     BOUCLE SUR LES SOUS ELEMENTS
      DO 70 ISE=1,NSE
C       RECUPERATION DES COORDONNEES DES NOEUDS DU SOUS ELEMENT
        DO 80 I=1,NDIM+1
          INO2 = ZI(JCNSE-1+NNOSE*(ISE-1)+I)
          IF (INO2.GT.1000) THEN
            DO 90 J=1,NDIM
              CO(I,J)=ZR(JPINT-1+NDIM*(INO2-1000-1)+J)
  90        CONTINUE
          ELSE
            DO 100 J=1,NDIM
              CO(I,J)=ZR(IGEOM-1+NDIM*(INO2-1)+J)
 100        CONTINUE
          ENDIF
  80    CONTINUE
        DO 110 I=1,NDIM
          DO 120 J=1,NDIM
            MAT(I,J)=CO(1,J)-CO(I+1,J)
 120      CONTINUE
 110    CONTINUE
C
C       CALCUL DU VOLUME DU SOUS ELEMENTS (DTERMINANT)
C
        VSE = 0.D0
        IF (NDIM.EQ.2) THEN
          VSE = ABS(MAT(1,1)*MAT(2,2)- MAT(2,1)*MAT(1,2))/2
        ELSEIF (NDIM.EQ.3) THEN
          VSE = ABS( MAT(1,1)*MAT(2,2)*MAT(3,3)
     +             + MAT(2,1)*MAT(3,2)*MAT(1,3)
     +             + MAT(3,1)*MAT(1,2)*MAT(2,3)
     +             - MAT(3,1)*MAT(2,2)*MAT(1,3)
     +             - MAT(2,1)*MAT(1,2)*MAT(3,3)
     +             - MAT(1,1)*MAT(3,2)*MAT(2,3))/6
        ENDIF
C
C       CALCUL DU BARYCENTRE
C
        CALL VECINI(NDIM,0.D0,BARY)
        DO 170 J = 1,NDIM
          DO 180 I = 1,NDIM+1
            BARY(J) = BARY(J)+CO(I,J)
 180      CONTINUE
          BARY(J) = BARY(J)/(NDIM+1)
 170    CONTINUE
C
C        CALCUL DES DERIVEES DES FONCTIONS DE FORME
C
        CALL REEREF(ELREFP,.FALSE., NBNOMA,IBID,ZR(IGEOM),BARY,1,
     &        .FALSE.,NDIM,RBID,RBID, RBID,
     &        IBID,IBID,IBID,IBID,IBID,IBID,RBID,RBID,'DFF',
     &        XE,FF,DFDI,RBID,RBID,RBID)
        DERIV =0.D0
        DO 190 I=1,NDIM
          DERIV = MAX(ABS(DFDI(INOLOC,I)),DERIV)
 190    CONTINUE
C       EN QUADRATIQUE : AUGMENTATION DU NOMBRE DE POINTS  
        IF(.NOT.ISMALI(ELREFP)) THEN
          DO 200 K=1,NDIM+1
          CALL VECINI(NDIM,0.D0,POINT)
          DO 210 J = 1,NDIM
            POINT(J) = (BARY(J)+CO(K,J))/2
 210      CONTINUE
          CALL REEREF(ELREFP,.FALSE., NBNOMA,IBID,ZR(IGEOM),POINT,IBID,
     &        .FALSE.,NDIM,RBID,RBID, RBID,
     &        IBID,IBID,IBID,IBID,IBID,IBID,RBID,RBID,'DFF',
     &        XE,FF,DFDI,RBID,RBID,RBID) 
          DO 220 I=1,NDIM
            DERIV = MAX(ABS(DFDI(INOLOC,I)),DERIV)
 220      CONTINUE     
 200      CONTINUE
        ENDIF
        VSE = VSE*DERIV**2
        CALL CESEXI('S',JCESD3,JCESL3,NUMA2,1,IFISS,ISE,IAD)
C       ON AJOUTE LE VOLUME SELON LA VALEUR DE LA FONCTION HEAVISIDE
        IF (ZI(JCESV3-1+IAD).EQ.-1) VMOIN = VMOIN+VSE
        IF (ZI(JCESV3-1+IAD).EQ.1)  VPLUS = VPLUS+VSE
        VTOT  = VTOT + VSE
  70  CONTINUE
C
      END
