      SUBROUTINE XGECFI(MODELE,DEPGEO)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*8    MODELE
      CHARACTER*19   DEPGEO
C
C ----------------------------------------------------------------------
C
C ROUTINE XFEM-GG
C
C CREATION DES SD CONTENANT LA GEOMETRIE DES
C                FACETTES DE CONTACT (ESCLAVES ET MAITRE)
C
C ----------------------------------------------------------------------
C
C
C ----------------------------------------------------------------------
C ROUTINE SPECIFIQUE A L'APPROCHE <<GRANDS GLISSEMENTS AVEC XFEM>>,
C TRAVAIL EFFECTUE EN COLLABORATION AVEC I.F.P.
C ----------------------------------------------------------------------
C
C IN  MODELE : NOM DU MODELE
C IN  DEPGEO : CHAMP DE DEPLACEMENTS
C
C
C
C
      INTEGER      NBOUT,NBIN
      PARAMETER    (NBOUT=2, NBIN=7)
      CHARACTER*8  LPAOUT(NBOUT),LPAIN(NBIN),LICMP(2),NOMA,KBID
      CHARACTER*19 LCHOUT(NBOUT),LCHIN(NBIN)
C
      CHARACTER*16 OPTION
      CHARACTER*19 LIGREL,PINTER,FACLON,NEWGES,NEWGEM
      CHARACTER*19 GESCLO,LTNO,FISSNO,HEAVFA
      CHARACTER*1  BASE
      LOGICAL      DEBUG
      INTEGER      IFMDBG,NIVDBG,IRET,JNOMA,IBID,NBMA,IMA
      INTEGER      JCESD,JCESL,JCESD2,JCESV,IAD
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('PRE_CALCUL',IFMDBG,NIVDBG)
C
C --- INITIALISATIONS
C
      IF (NIVDBG.GE.2) THEN
        DEBUG  = .TRUE.
      ELSE
        DEBUG  = .FALSE.
      ENDIF
      BASE   = 'V'
      OPTION = 'GEOM_FAC'
C
C --- INITIALISATION DES CHAMPS POUR CALCUL
C
      CALL INICAL(NBIN  ,LPAIN ,LCHIN ,
     &            NBOUT ,LPAOUT,LCHOUT)
      LIGREL   = MODELE//'.MODELE'
      PINTER   = MODELE//'.TOPOFAC.PI'
      FACLON   = MODELE//'.TOPOFAC.LO'
      GESCLO   = MODELE//'.TOPOFAC.OE'
      LTNO     = MODELE//'.LTNO'
      FISSNO = MODELE(1:8)//'.FISSNO'
      HEAVFA = MODELE(1:8)//'.TOPOFAC.HE'
      NEWGES = MODELE//'.TOPOFAC.GE'
      NEWGEM = MODELE//'.TOPOFAC.GM'
      CALL JEEXIN(NEWGES//'.CESD',IRET)
      IF (IRET.EQ.0) THEN
C
C --- RECOPIE DU NOMBRE DE SOUS POINTS DE TOPOFAC.OE DANS TOPOFAC.GE/M
C
        CALL JEVEUO(MODELE//'.MODELE    .LGRF','L',JNOMA)
        NOMA = ZK8(JNOMA)
        CALL DISMOI('F','NB_MA_MAILLA',NOMA,'MAILLAGE',NBMA,KBID,IBID)
        CALL CELCES(GESCLO,'V','&&XGECFI.GESCLO')
        CALL JEVEUO('&&XGECFI.GESCLO    .CESD','L',JCESD2)
        LICMP(1) = 'NPG_DYN'
        LICMP(2) = 'NCMP_DYN'
        CALL CESCRE('V',NEWGES,'ELEM',NOMA,'DCEL_I',2,LICMP,IBID,-1,-2)
        CALL JEVEUO(NEWGES//'.CESD','L',JCESD)
        CALL JEVEUO(NEWGES//'.CESV','E',JCESV)
        CALL JEVEUO(NEWGES//'.CESL','E',JCESL)
        DO 10 IMA=1,NBMA
          CALL CESEXI('S',JCESD,JCESL,IMA,1,1,1,IAD)
          ZL(JCESL-1-IAD) = .TRUE.
          ZI(JCESV-1-IAD) = ZI(JCESD2-1+5+4*(IMA-1)+2)
 10     CONTINUE
        CALL COPISD('CHAM_ELEM_S','V',NEWGES,NEWGEM)
        CALL DETRSD('CHAM_ELEM_S','&&XGECFI.GESCLO')
      ENDIF
C
C --- CREATION DES LISTES DES CHAMPS IN ET OUT
C
      LPAIN(1)  = 'PDEPLA'
      LCHIN(1)  = DEPGEO
      LPAIN(2)  = 'PPINTER'
      LCHIN(2)  = PINTER
      LPAIN(3)  = 'PLONCHA'
      LCHIN(3)  = FACLON
      LPAIN(4)  = 'PGESCLO'
      LCHIN(4)  = GESCLO
      LPAIN(5)  = 'PLST'
      LCHIN(5)  = LTNO
      LPAIN(6)  = 'PFISNO'
      LCHIN(6)  = FISSNO
      LPAIN(7) = 'PHEAVFA'
      LCHIN(7) = HEAVFA
C
      LPAOUT(1) = 'PNEWGES'
      LCHOUT(1) = NEWGES
      LPAOUT(2) = 'PNEWGEM'
      LCHOUT(2) = NEWGEM
C
C --- APPEL A CALCUL
C
      CALL CALCUL('C',OPTION,LIGREL,NBIN  ,LCHIN ,LPAIN ,
     &                              NBOUT ,LCHOUT,LPAOUT,BASE,'OUI')
      IF (DEBUG) THEN
        CALL DBGCAL(OPTION,IFMDBG,
     &              NBIN  ,LPAIN ,LCHIN ,
     &              NBOUT ,LPAOUT,LCHOUT)
      ENDIF

      CALL JEDEMA()
      END
