      SUBROUTINE XLAG2C(NOMO  ,NLISEQ,JNBPT )
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*8   NOMO
      CHARACTER*19  NLISEQ
      INTEGER      JNBPT
C
C ----------------------------------------------------------------------
C
C ROUTINE XFEM (PREPARATION)
C
C    DETERMINATION DES NUMROS DE LAGRANGES ASSOCIS AUX NOEUDS
C    POUR LES RELATIONS D'GALITES DANS LE CAS MULTI-HEAVISIDE
C
C ----------------------------------------------------------------------
C
C
C IN  NOMO  : NOMBRE MAXIMUM D'ARETES COUPEES PAR LA FISSURE
C IN NLISEQ : LISTE REL. LIN.
C IN JNBPT  : POINTEUR DU COMPTAGE DES FISSURE
C
C
C
C
      INTEGER     IER,JLISEQ,NEQ,JLISLA,I,NUNO,IMA,INO,IFISS
      INTEGER     JCNSL,JCNSV,JCESD,JCESV,JCESL,IAD
      CHARACTER*8  K8BID
      CHARACTER*19  NOXFEM,HEAVNO
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- RECUPERATION DE NLISEQ
C
      CALL JEEXIN(NLISEQ,IER)
      IF (IER.EQ.0) GOTO 999
      CALL JEVEUO(NLISEQ,'L',JLISEQ)
      CALL JELIRA(NLISEQ,'LONMAX',NEQ,K8BID)
C
C --- RECUPRATION DE NOXFEM
C
      NOXFEM = '&&XLAG2S.NOXFEM'
      CALL CNOCNS(NOMO//'.NOXFEM','V',NOXFEM)
      CALL JEVEUO(NOXFEM//'.CNSL','L',JCNSL)
      CALL JEVEUO(NOXFEM//'.CNSV','L',JCNSV)
C
C --- RECUPRATION DE HEAVNO
C
      HEAVNO = '&&XLAG2S.HEAVNO'
      CALL CELCES(NOMO//'.HEAVNO','V',HEAVNO)
      CALL JEVEUO(HEAVNO//'.CESD','L',JCESD)
      CALL JEVEUO(HEAVNO//'.CESV','L',JCESV)
      CALL JEVEUO(HEAVNO//'.CESL','L',JCESL)
C
C --- CREATION DE LA SD FISS.LISEQ_LAGR
C
      CALL WKVECT(NLISEQ(1:14)//'_LAGR','G V I',NEQ,JLISLA)
C
      DO 10 I = 1,NEQ
        NUNO = ZI(JLISEQ-1+I)
        CALL ASSERT(ZL(JCNSL-1+2*NUNO))
        IMA = ZI(JCNSV-1+2*(NUNO-1)+1)
        INO = ZI(JCNSV-1+2*(NUNO-1)+2)
        IFISS = ZI(JNBPT-1+IMA)
        CALL CESEXI('C',JCESD,JCESL,IMA,INO,IFISS,1,IAD)
        IF (IAD.GT.0) THEN
          ZI(JLISLA-1+I) = ZI(JCESV-1+IAD)
        ELSE
          ZI(JLISLA-1+I) = 1
        ENDIF
  10  CONTINUE
C
      CALL DETRSD('CHAM_NO_S',NOXFEM)
      CALL DETRSD('CHAM_ELEM_S',HEAVNO)
 999  CONTINUE
C
      CALL JEDEMA()
      END
