      SUBROUTINE XMAFR2(TAU1,TAU2,B,ABC)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE GENIAUT S.GENIAUT
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      REAL*8     TAU1(3),TAU2(3),B(3,3),ABC(2,2)

C ----------------------------------------------------------------------
C
C                CALCUL DES MATRICES DE FROTTEMENT UTILES

C IN    NLI,NLJ     : NUMRO DES POINTS D'INTERSECTION O ON VEUT TAU
C IN    TAU1,TAU2   : VECTEURS DU PLAN TANGENT DE LA BASE COVARIANTE
C                     AUX POINTS D'INTERSECTION
C IN    B           : MATRICE (Id-KN)

C OUT   ABC         : PRODUIT MATRICE TAU(NLI).(Id-KN).TAU(NLJ)





      INTEGER    NDIM,I,J,K,IBID
      REAL*8     A(2,3),BC(3,2),C(3,2)

      CALL ELREF4(' ','RIGI',NDIM,IBID,IBID,IBID,IBID,IBID,IBID,IBID)


C  CALCUL DE A.B.C AVEC A=(TAU1) EN NLI ET C=(TAU1 TAU2) EN NLJ
C                         (TAU2)

C     MATRICES A ET C
      DO 10 J=1,NDIM
        A(1,J)=TAU1(J)
        IF (NDIM.EQ.3) A(2,J)=TAU2(J)
        C(J,1)=TAU1(J)
        IF (NDIM.EQ.3) C(J,2)=TAU2(J)
 10   CONTINUE

C     PRODUIT B.C
      DO 20 I=1,NDIM
        DO 21 J=1,NDIM-1
          BC(I,J)=0.D0
          DO 22 K=1,NDIM
            BC(I,J)=BC(I,J)+B(I,K)*C(K,J)
 22       CONTINUE
 21     CONTINUE
 20   CONTINUE

C     PRODUIT A.BC
      DO 30 I=1,NDIM-1
        DO 31 J=1,NDIM-1
          ABC(I,J)=0.D0
          DO 32 K=1,NDIM
            ABC(I,J)=ABC(I,J)+A(I,K)*BC(K,J)
 32       CONTINUE
 31     CONTINUE
 30   CONTINUE

      END
