      SUBROUTINE XMMAA0(NDIM  ,NNC   ,JNNE  ,HPG   ,
     &                  NFAES ,CFACE ,FFC   ,JACOBI,JPCAI ,
     &                  COEFCR,COEFCP,LPENAC,TYPMAI,
     &                  JDDLE,NCONTA,NFHE,LMULTI,HEAVNO,MMAT  )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 30/01/2012   AUTEUR DESOZA T.DESOZA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
      IMPLICIT NONE
      INTEGER      NDIM,NNC,JNNE(3),NFAES,JDDLE(2),NCONTA
      INTEGER      CFACE(5,3),JPCAI,NFHE,HEAVNO(8)
      REAL*8       MMAT(336,336)
      REAL*8       HPG,FFC(8),JACOBI,COEFCR,COEFCP
      CHARACTER*8  TYPMAI
      LOGICAL      LPENAC,LMULTI
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE XFEMGG - CALCUL ELEM.)
C
C CALCUL DE C POUR LE CONTACT METHODE CONTINUE
C CAS SANS CONTACT (XFEM)
C
C
C ----------------------------------------------------------------------
C
C ----------------------------------------------------------------------
C ROUTINE SPECIFIQUE A L'APPROCHE <<GRANDS GLISSEMENTS AVEC XFEM>>,
C TRAVAIL EFFECTUE EN COLLABORATION AVEC I.F.P.
C ----------------------------------------------------------------------
C
C
C IN  NDIM   : DIMENSION DU PROBLEME
C IN  NNC    : NOMBRE DE NOEUDS DE CONTACT
C IN  NNE    : NOMBRE TOTAL DE NOEUDS DE LA MAILLE ESCLAVE
C IN  NNES   : NOMBRE DE NOEUDS SOMMETS DE LA MAILLE ESCLAVE
C IN  HPG    : POIDS DU POINT INTEGRATION DU POINT DE CONTACT
C IN  NFAES  : NUMERO DE LA FACETTE DE CONTACT ESCLAVE
C IN  CFACE  : MATRICE DE CONECTIVITE DES FACETTES DE CONTACT
C IN  FFC    : FONCTIONS DE FORME DU POINT DE CONTACT DANS ELC
C IN  JACOBI : JACOBIEN DE LA MAILLE AU POINT DE CONTACT
C IN  JPCAI  : POINTEUR VERS LE VECTEUR DES ARRETES ESCLAVES
C              INTERSECTEES
C IN  COEFCA : COEF_REGU_CONT
C IN  TYPMAI : NOM DE LA MAILLE ESCLAVE D'ORIGINE (QUADRATIQUE)
C IN  DDLES : NOMBRE DE DDLS D'UN NOEUD SOMMET ESCLAVE
C I/O MMAT   : MATRICE ELEMENTAIRE DE CONTACT/FROTTEMENT
C
C ----------------------------------------------------------------------
C
      INTEGER I,J,INI,INJ,PLI,PLJ,XOULA,NNE,NNES,DDLES
C
C ----------------------------------------------------------------------
C
      NNE=JNNE(1)
      NNES=JNNE(2)
      DDLES=JDDLE(1)

C ---  BOUCLE SUR LES NOEUDS PORTANT DES DDL DE CONTACT
      DO 10 I = 1,NNC
C --- BOUCLE SUR LES NOEUDS PORTANT DES DDL DE CONTACT
        DO 20 J = 1,NNC
          INI=XOULA(CFACE,NFAES,I,JPCAI,TYPMAI,NCONTA)
          CALL XPLMA2(NDIM,NNE,NNES,DDLES,INI,NFHE,PLI)
          IF (LMULTI) PLI = PLI + (HEAVNO(I)-1)*NDIM
          INJ=XOULA(CFACE,NFAES,J,JPCAI,TYPMAI,NCONTA)
          CALL XPLMA2(NDIM,NNE,NNES,DDLES,INJ,NFHE,PLJ)
          IF (LMULTI) PLJ = PLJ + (HEAVNO(J)-1)*NDIM
          IF(LPENAC) THEN
            MMAT(PLI,PLJ) = -HPG*FFC(J)*FFC(I)*JACOBI/COEFCP
          ELSE
            MMAT(PLI,PLJ) = -HPG*FFC(J)*FFC(I)*JACOBI/COEFCR
          ENDIF
 20     CONTINUE
 10   CONTINUE
C
      END
