      SUBROUTINE XMMAA4(NNOL ,NNOF,PLA,IPGF,IVFF  ,FFC,
     &                  JAC, NOEUD  ,CSTACO,MMAT )

      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      INTEGER     NNOL,NNOF,IVFF,IPGF,PLA(27)
      REAL*8      MMAT(216,216)
      
      REAL*8      FFC(8),JAC,CSTACO
      LOGICAL     NOEUD

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================

C
C ROUTINE CONTACT (METHODE XFEM HPP - CALCUL ELEM.)
C
C --- CALCUL DE LA MATRICE C - CAS SANS CONTACT
C
C ----------------------------------------------------------------------
C
C IN  NNOL   : NOMBRE DE NOEUDS PORTEURS DE DDLC
C IN  NNOF   : NOMBRE DE NOEUDS DE LA FACETTE DE CONTACT
C IN  PLA    : PLACE DES LAMBDAS DANS LA MATRICE
C IN  IPGF   : NUMRO DU POINTS DE GAUSS
C IN  IVFF   : ADRESSE DANS ZR DU TABLEAU FF(INO,IPG)
C IN  FFC    : FONCTIONS DE FORME DE L'ELEMENT DE CONTACT
C IN  JAC    : PRODUIT DU JACOBIEN ET DU POIDS
C IN  NOEUD  : INDICATEUR FORMULATION (T=NOEUDS , F=ARETE)
C IN  CSTACO : COEFFICIENTS DE STABILISATION DU CONTACT
C I/O  MMAT  : MATRICE ELEMENTAITRE DE CONTACT/FROTTEMENT
C
C
C
C
      INTEGER I,J,PLI,PLJ
      REAL*8  FFI,FFJ
C
C ----------------------------------------------------------------------

      DO 120 I = 1,NNOL
        PLI=PLA(I)
        IF (NOEUD) THEN
          FFI=FFC(I)
        ELSE
          FFI=ZR(IVFF-1+NNOF*(IPGF-1)+I)
        ENDIF

        DO 121 J = 1,NNOL
          PLJ=PLA(J)
          IF (NOEUD) THEN
            FFJ=FFC(J)
          ELSE
            FFJ=ZR(IVFF-1+NNOF*(IPGF-1)+J)
          ENDIF

          MMAT(PLI,PLJ) = MMAT(PLI,PLJ)
     &    - FFJ * FFI * JAC / CSTACO
 121    CONTINUE
 120  CONTINUE

      END
