      SUBROUTINE       XPLMAT(NDIM,NFH,NFE,DDLC,DDLM,NNOS,NNOM,N,PL)

      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      INTEGER          NDIM,NFH,NFE,DDLC,NNOS,NNOM,N,PL,DDLM

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE GENIAUT S.GENIAUT
C
C    CADRE : X-FEM ET CONTACT CONTINU
C             CALCULE LA PLACE DU LAMBDA(N) NORMAL DANS LA MATRICE
C             DE RAIDEUR DUE AU CONTACT
C
C IN  NDIM    : DIMENSION (=3)
C IN  NFH     : NOMBRE DE FONCTIONS HEAVYSIDE
C IN  NFE     : NOMBRE DE FONCTIONS SINGULIRES
C IN  DDLC    : NOMBRE DE DDL DE CONTACT (PAR NOEUD)
C IN  NNO     : NOMBRE DE NOEUDS SOMMET
C IN  NNOM    : NOMBRE DE NOEUDS MILIEU
C IN  N       : NUMRO DU NOEUD PORTANT LE LAMBDA
C
C OUT PL      : PLACE DU LMBDA DANS LA MATRICE
C     ------------------------------------------------------------------
C
      INTEGER       DDLS

C ----------------------------------------------------------------------
      CALL ASSERT(N.LE.(NNOS+NNOM))

C     NOMBRE DE DDL PAR NOEUD SOMMET
      DDLS=NDIM*(1+NFH+NFE)+DDLC

C     PLACE DU PREMIER DDL DE CONTACT POUR CHAQUE N
      IF (N.LE.NNOS) THEN
        PL=DDLS*N-DDLC+1
      ELSE
        PL=DDLS*NNOS+DDLM*(N-NNOS)-DDLC+1
      ENDIF

      END
