      SUBROUTINE XTOPOC(MODELE)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE GENIAUT S.GENIAUT
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*8   MODELE
C
C ----------------------------------------------------------------------
C
C ROUTINE XFEM (METHODE XFEM - PREPARATION)
C
C AJOUTER  LA SD FISS_XFEM LES DONNES TOPOLOGIQUES CONCERNANT
C LES FACETTES DE CONTACT
C
C ----------------------------------------------------------------------
C
C
C  IN  MODELE : NOM DE L'OBJET MODELE
C
C
C
C
C
      INTEGER      NBOUT,NBIN
      PARAMETER    (NBOUT=7, NBIN=6)
      CHARACTER*8  LPAOUT(NBOUT),LPAIN(NBIN),NOMA,LICMP(2),KBID
      CHARACTER*19 LCHOUT(NBOUT),LCHIN(NBIN)
C
      INTEGER      JNOMA
      CHARACTER*19 LIGREL,CHGEOM
      CHARACTER*19 LNNO,GRLNNO,LTNO,GRLTNO,FISSCO,CHAMP(7)
      LOGICAL      DEBUG
      CHARACTER*16 OPTION
      INTEGER      IFMDBG,NIVDBG
      INTEGER      JCESD,JCESV,JCESL,IAD,I,IRET,NBMA,IMA,JNBSP,IBID
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFDBG('PRE_CALCUL',IFMDBG,NIVDBG)
C
C --- INITIALISATIONS
C
      LIGREL = MODELE//'.MODELE'
      CALL JEVEUO(MODELE//'.MODELE    .LGRF','L',JNOMA)
      NOMA = ZK8(JNOMA)
      CHGEOM = NOMA//'.COORDO'
      IF (NIVDBG.GE.2) THEN
        DEBUG  = .TRUE.
      ELSE
        DEBUG  = .FALSE.
      ENDIF
      OPTION = 'TOPOFA'
C
C --- INITIALISATION DES CHAMPS POUR CALCUL
C
      CALL INICAL(NBIN  ,LPAIN ,LCHIN ,
     &            NBOUT ,LPAOUT,LCHOUT)
C
C --- RECUPERATION DES DONNEES XFEM
C
      LNNO     = MODELE(1:8)//'.LNNO'
      LTNO     = MODELE(1:8)//'.LTNO'
      GRLNNO   = MODELE(1:8)//'.GRLNNO'
      GRLTNO   = MODELE(1:8)//'.GRLTNO'
      FISSCO   = MODELE(1:8)//'.FISSCO'
      CHAMP(1) = MODELE(1:8)//'.TOPOFAC.PI'
      CHAMP(2) = MODELE(1:8)//'.TOPOFAC.AI'
      CHAMP(3) = MODELE(1:8)//'.TOPOFAC.CF'
      CHAMP(4) = MODELE(1:8)//'.TOPOFAC.LO'
      CHAMP(5) = MODELE(1:8)//'.TOPOFAC.BA'
      CHAMP(6) = MODELE(1:8)//'.TOPOFAC.OE'
      CHAMP(7) = MODELE(1:8)//'.TOPOFAC.HE'
C
C --- POUR LE MULTI-HEAVISIDE, TOUS LES CHAMPS DE SORTIE SONT
C --- DUPLIQUS PAR LE NOMBRE DE FISSURES VUES
C
      CALL JEVEUO('&&XTYELE.NBSP','L',JNBSP)
      CALL DISMOI('F','NB_MA_MAILLA',NOMA,'MAILLAGE',NBMA,KBID,IRET)
      LICMP(1) = 'NPG_DYN'
      LICMP(2) = 'NCMP_DYN'
C
      DO 20 I = 1,7
        CALL CESCRE('V',CHAMP(I),'ELEM',NOMA,'DCEL_I',2,LICMP,
     &              IBID,-1,-2)
        CALL JEVEUO(CHAMP(I)//'.CESD','L',JCESD)
        CALL JEVEUO(CHAMP(I)//'.CESV','E',JCESV)
        CALL JEVEUO(CHAMP(I)//'.CESL','E',JCESL)
C
C --- REMPLISSAGE DES SOUS-POINTS DE CHAMP(I)
C
        DO 10 IMA=1,NBMA
          CALL CESEXI('S',JCESD,JCESL,IMA,1,1,1,IAD)
          ZL(JCESL-1-IAD) = .TRUE.
          ZI(JCESV-1-IAD) = ZI(JNBSP-1+IMA)
          IF (I.EQ.7) ZI(JCESV-1-IAD) = ZI(JNBSP-1+IMA)**2
 10     CONTINUE
C
 20   CONTINUE
C
C --- CREATION DES LISTES DES CHAMPS IN
C
      LPAIN(1)  = 'PGEOMER'
      LCHIN(1)  = CHGEOM
      LPAIN(2)  = 'PLSN'
      LCHIN(2)  = LNNO
      LPAIN(3)  = 'PLST'
      LCHIN(3)  = LTNO
      LPAIN(4)  = 'PGRADLN'
      LCHIN(4)  = GRLNNO
      LPAIN(5)  = 'PGRADLT'
      LCHIN(5)  = GRLTNO
      LPAIN(6)  = 'PFISCO'
      LCHIN(6)  = FISSCO
C
C --- CREATION DES LISTES DES CHAMPS OUT
C
      LPAOUT(1) = 'PPINTER'
      LCHOUT(1) = CHAMP(1)
      LPAOUT(2) = 'PAINTER'
      LCHOUT(2) = CHAMP(2)
      LPAOUT(3) = 'PCFACE'
      LCHOUT(3) = CHAMP(3)
      LPAOUT(4) = 'PLONCHA'
      LCHOUT(4) = CHAMP(4)
      LPAOUT(5) = 'PBASECO'
      LCHOUT(5) = CHAMP(5)
      LPAOUT(6) = 'PGESCLA'
      LCHOUT(6) = CHAMP(6)
      LPAOUT(7) = 'PHEAVFA'
      LCHOUT(7) = CHAMP(7)
C
      IF (DEBUG) THEN
        CALL DBGCAL(OPTION,IFMDBG,
     &              NBIN  ,LPAIN ,LCHIN ,
     &              NBOUT ,LPAOUT,LCHOUT)
      ENDIF
C
      CALL CALCUL('C',OPTION,LIGREL,NBIN  ,LCHIN ,LPAIN,
     &                              NBOUT ,LCHOUT,LPAOUT,'G','OUI')
C
      CALL JEDEMA()
      END
