      SUBROUTINE DEBCA1(NOMOP,LIGREL,NIN)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE PELLET J.PELLET
      IMPLICIT NONE
C     ARGUMENTS:
C     ----------
      INCLUDE 'jeveux.h'

      CHARACTER*32 JEXNUM,JEXNOM,JEXATR
      CHARACTER*16 NOMOP
      CHARACTER*19 LIGREL
      INTEGER NIN
C ----------------------------------------------------------------------
C     BUT : INITIALISER CERTAINS COMMONS DE CALCUL : CAII02, ...

C     ENTREES:
C        NOMOP  :  NOM D'1 OPTION
C        LIGREL :  NOM DU LIGREL SUR LEQUEL ON DOIT FAIRE LE CALCUL
C        NIN    :  MAJORANT DU NOMBRE DE CHAMPS "IN"
C     SORTIES:
C       ALLOCATION D'OBJETS DE TRAVAIL ET MISE A JOUR DE COMMONS

C ----------------------------------------------------------------------
      CHARACTER*8 MA
C---------------- COMMUNS POUR CALCUL ----------------------------------
      INTEGER IAOPTT,LGCO,IAOPMO,ILOPMO,IAOPNO,ILOPNO,IAOPDS
      INTEGER IAOPPA,NPARIO,NPARIN,IAMLOC,ILMLOC,IADSGD
      COMMON /CAII02/IAOPTT,LGCO,IAOPMO,ILOPMO,IAOPNO,ILOPNO,IAOPDS,
     &       IAOPPA,NPARIO,NPARIN,IAMLOC,ILMLOC,IADSGD

      INTEGER IAMACO,ILMACO,IAMSCO,ILMSCO,IALIEL,ILLIEL
      COMMON /CAII03/IAMACO,ILMACO,IAMSCO,ILMSCO,IALIEL,ILLIEL

      INTEGER IANOOP,IANOTE,NBOBTR,IAOBTR,NBOBMX
      COMMON /CAII05/IANOOP,IANOTE,NBOBTR,IAOBTR,NBOBMX

      INTEGER NBOBJ,IAINEL,ININEL
      COMMON /CAII09/NBOBJ,IAINEL,ININEL

      INTEGER ICAELI,ICAELK
      COMMON /CAII10/ICAELI,ICAELK

      INTEGER NUTE,JNBELR,JNOELR,IACTIF,JPNLFP,JNOLFP,NBLFPG
      COMMON /CAII11/NUTE,JNBELR,JNOELR,IACTIF,JPNLFP,JNOLFP,NBLFPG

      INTEGER CAINDZ(512),CAPOIZ
      COMMON /CAII12/CAINDZ,CAPOIZ

      INTEGER NBSAV
      COMMON /CAII13/NBSAV

      INTEGER EVFINI,CALVOI,JREPE,JPTVOI,JELVOI
      COMMON /CAII19/EVFINI,CALVOI,JREPE,JPTVOI,JELVOI

      REAL*8 TIMED1,TIMEF1,TD1,TF1
      COMMON /CARR01/TIMED1,TIMEF1,TD1,TF1
C -------------------------------------------------------------------
C VARIABLES LOCALES :
      INTEGER IRET,IER,IBID,IERD,OPT,IANBLC,NBSCMX,NBPARA
      INTEGER NNOMX,NBOPT,NBTE,I,JNVGE
      CHARACTER*16 NOMOP2,NOMTE
      CHARACTER*8 KBID
      CHARACTER*3 BEVOIS,EXIVF,EXIELE
      CHARACTER*12 VGE
      REAL*8 R8NNEM, RUNDEF
C -------------------------------------------------------------------

      CALL DISMOI('F','EXI_ELEM',LIGREL,'LIGREL',IBID,EXIELE,IERD)
      IF (EXIELE.NE.'OUI') CALL U2MESK('F','CALCULEL2_25',1,LIGREL)

      CALL JENONU(JEXNOM('&CATA.OP.NOMOPT',NOMOP),OPT)
      IF (OPT.EQ.0) CALL U2MESK('F','CALCULEL2_26',1,NOMOP)


C     INITIALISATION DU COMMON CAII02 :
C     ---------------------------------
      CALL JEVEUO('&CATA.TE.OPTTE','L',IAOPTT)
      CALL JEVEUO('&CATA.TE.NBLIGCOL','L',IANBLC)
      LGCO=ZI(IANBLC-1+1)
      CALL JEVEUO('&CATA.TE.OPTMOD','L',IAOPMO)
      CALL JEVEUO(JEXATR('&CATA.TE.OPTMOD','LONCUM'),'L',ILOPMO)
      CALL JEVEUO('&CATA.TE.OPTNOM','L',IAOPNO)
      CALL JEVEUO(JEXATR('&CATA.TE.OPTNOM','LONCUM'),'L',ILOPNO)
      CALL JEVEUO(JEXNUM('&CATA.OP.DESCOPT',OPT),'L',IAOPDS)
      CALL JEVEUO(JEXNUM('&CATA.OP.OPTPARA',OPT),'L',IAOPPA)

      NPARIN=ZI(IAOPDS-1+2)
      NPARIO=ZI(IAOPDS-1+2)+ZI(IAOPDS-1+3)
      CALL JEVEUO('&CATA.TE.MODELOC','L',IAMLOC)
      CALL JEVEUO(JEXATR('&CATA.TE.MODELOC','LONCUM'),'L',ILMLOC)
      CALL JEVEUO('&CATA.GD.DESCRIGD','L',IADSGD)


C     INITIALISATION DU COMMON CAII05
C     ET CREATION DE L'OBJET '&&CALCUL.OBJETS_TRAV' QUI CONTIENDRA TOUS
C     LES NOMS DES OBJETS DE TRAVAIL NECESSAIRES A CALCUL :
C     ------------------------------------------------------------------
      NBSCMX=9
C     NBSCMX = NB DE TYPES SCALAIRES MAX : I,R,C,L,K8,K16,K24,K32,K80
      NBOBTR=0
      NBPARA=ZI(IAOPDS-1+2)+ZI(IAOPDS-1+3)
      NBOBMX=2*NBSCMX+NIN*3+NBPARA+35
      CALL WKVECT('&&CALCUL.OBJETS_TRAV','V V K24',NBOBMX,IAOBTR)


C     INITIALISATION DU COMMON CAII03 :
C     ---------------------------------
      CALL DISMOI('F','NOM_MAILLA',LIGREL,'LIGREL',IBID,MA,IERD)
      CALL JEEXIN(MA//'.CONNEX',IRET)
      IF (IRET.GT.0) THEN
        CALL JEVEUO(MA//'.CONNEX','L',IAMACO)
        CALL JEVEUO(JEXATR(MA//'.CONNEX','LONCUM'),'L',ILMACO)
      ENDIF
      CALL JEEXIN(LIGREL//'.NEMA',IRET)
      IF (IRET.GT.0) THEN
        CALL JEVEUO(LIGREL//'.NEMA','L',IAMSCO)
        CALL JEVEUO(JEXATR(LIGREL//'.NEMA','LONCUM'),'L',ILMSCO)
      ENDIF
      CALL JEVEUO(LIGREL//'.LIEL','L',IALIEL)
      CALL JEVEUO(JEXATR(LIGREL//'.LIEL','LONCUM'),'L',ILLIEL)


C     INITIALISATION DU COMMON CAII11 :
C     ---------------------------------
      CALL JEVEUO('&CATA.TE.NBELREFE','L',JNBELR)
      CALL JEVEUO('&CATA.TE.NOELREFE','L',JNOELR)
      CALL JEVEUO('&CATA.TE.PNLOCFPG','L',JPNLFP)
      CALL JEVEUO('&CATA.TE.NOLOCFPG','L',JNOLFP)
      CALL JELIRA('&CATA.TE.NOLOCFPG','LONMAX',NBLFPG,KBID)


C     INITIALISATION DU COMMON CAII19 :
C     ---------------------------------
      CALL DISMOI('F','EXI_VF',LIGREL,'LIGREL',IBID,EXIVF,IBID)
      CALL DISMOI('F','BESOIN_VOISIN',LIGREL,'LIGREL',IBID,BEVOIS,IBID)
      IF (EXIVF.EQ.'OUI') THEN
        EVFINI=1
        CALVOI=1
      ELSE
        EVFINI=0
        IF (BEVOIS.EQ.'OUI') THEN
          CALVOI=1
        ELSE
          CALVOI=0
        ENDIF
      ENDIF
      IF (CALVOI.EQ.1) THEN
        CALL JEEXIN(LIGREL//'.REPE',IER)
        IF (IER.EQ.0) CALL CORMGI('V',LIGREL)
        CALL JEVEUO(LIGREL//'.REPE','L',JREPE)
        CALL DISMOI('F','NOM_MAILLA',LIGREL,'LIGREL',IBID,MA,IBID)
        CALL JEEXIN(LIGREL//'.NVGE',IER)
        IF (IER.NE.0) THEN
          CALL JEVEUO(LIGREL//'.NVGE','L',JNVGE)
          VGE=ZK16(JNVGE-1+1)
          CALL JEVEUO(VGE//'.PTVOIS','L',JPTVOI)
          CALL JEVEUO(VGE//'.ELVOIS','L',JELVOI)
        ELSE
          JREPE=0
        ENDIF
      ELSE
        JREPE=0
      ENDIF


C     INITIALISATION DU COMMON CAII10 :
C     ---------------------------------
      CALL DISMOI('F','NB_NO_MAX','&','CATALOGUE',NNOMX,KBID,IER)
      CALL WKVECT('&&CALCUL.TECAEL_K24','V V K24',8+NNOMX,ICAELK)
      NBOBTR=NBOBTR+1
      ZK24(IAOBTR-1+NBOBTR)='&&CALCUL.TECAEL_K24'
      ZK24(ICAELK-1+1)=MA
      ZK24(ICAELK-1+2)=LIGREL
      CALL WKVECT('&&CALCUL.TECAEL_I','V V I',4+NNOMX,ICAELI)
      NBOBTR=NBOBTR+1
      ZK24(IAOBTR-1+NBOBTR)='&&CALCUL.TECAEL_I'


C     -- INITIALISATION DU COMMON CAII09 :
C     NBOBJ EST LE NOMBRE MAXI D'OBJETS '&INEL.XXX' CREES PAR UN INI00K
C     ------------------------------------------------------------------
      NBOBJ=30
      CALL WKVECT('&&CALCUL.NOM_&INEL','V V K24',NBOBJ,ININEL)
      NBOBTR=NBOBTR+1
      ZK24(IAOBTR-1+NBOBTR)='&&CALCUL.NOM_&INEL'
      CALL WKVECT('&&CALCUL.IAD_&INEL','V V I',NBOBJ,IAINEL)
      NBOBTR=NBOBTR+1
      ZK24(IAOBTR-1+NBOBTR)='&&CALCUL.IAD_&INEL'


C     -- INITIALISATION DU COMMON CAII12 :
C     -------------------------------------
      DO 10 I=1,512
        CAINDZ(I)=1
   10 CONTINUE

C     -- INITIALISATION DU COMMON CAII13 :
C     -------------------------------------
      NBSAV=0

C     -- INITIALISATION DU COMMON CARR01 :
C     -------------------------------------
      RUNDEF=R8NNEM()
      TIMED1=RUNDEF
      TIMEF1=RUNDEF
      TD1=RUNDEF
      TF1=RUNDEF




C     LES TABLEAUX SUIVANTS PEUVENT N'ETRE CONSTRUITS QU'UNE
C     FOIS POUR TOUTES LORS DU PREMIER APPEL A DEBCAL
C     &&CALCUL.NOMOP ET &&CALCUL.NOMTE NE SERONT SUPPRIMES
C     QU'EN SORTIE DE COMMANDE
C     --------------------------------------------------------
      CALL JEEXIN('&&CALCUL.NOMOP',IRET)
      IF (IRET.EQ.0) THEN
        CALL JELIRA('&CATA.OP.NOMOPT','NOMMAX',NBOPT,KBID)
        CALL WKVECT('&&CALCUL.NOMOP','V V K16',NBOPT,IANOOP)
        DO 20,I=1,NBOPT
          CALL JENUNO(JEXNUM('&CATA.OP.NOMOPT',I),NOMOP2)
          ZK16(IANOOP-1+I)=NOMOP2
   20   CONTINUE
        CALL JELIRA('&CATA.TE.NOMTE','NOMMAX',NBTE,KBID)
        CALL WKVECT('&&CALCUL.NOMTE','V V K16',NBTE,IANOTE)
        DO 30,I=1,NBTE
          CALL JENUNO(JEXNUM('&CATA.TE.NOMTE',I),NOMTE)
          ZK16(IANOTE-1+I)=NOMTE
   30   CONTINUE
      ELSE
        CALL JEVEUO('&&CALCUL.NOMOP','L',IANOOP)
        CALL JEVEUO('&&CALCUL.NOMTE','L',IANOTE)
      ENDIF

C     -- APPEL A MECOEL (INUTILE) POUR CONSERVER LA DOC :
      CALL MECOEL(1)

      END
