      SUBROUTINE ECLATY ( NOMTE, ELREFA, FAPG, NPG, NPOINI,
     &                    NTERM1, NSOMM1, CSOMM1, TYMA, NBNO2, CONNX,
     &                    MXNBN2,  MXNBPI, MXNBTE,
     &                    MXNBSE, NBSEL, CORSEL)
      IMPLICIT   NONE
      INTEGER       MXNBN2,MXNBPI,MXNBTE,MXNBSE
      INTEGER       NDIM,NPG,CONNX(MXNBN2,MXNBSE),NSOMM1(MXNBPI,MXNBTE)
      INTEGER       NTERM1(MXNBPI),NBNO2(MXNBSE),NPOINI,TYMA(MXNBSE)
      INTEGER       NBSEL, CORSEL(MXNBSE)
      REAL*8        CSOMM1(MXNBPI,MXNBTE)
      CHARACTER*8   ELREFA, FAPG
      CHARACTER*16  NOMTE
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 29/05/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C --------------------------------------------------------------------
C BUT : DECOMPOSER LES TYPE_ELEM EN AUTANT DE SOUS-ELEMENTS QUE
C       DE POINTS DE GAUSS.
C ---------------------------------------------------------------------
C IN : NOMTE  : NOM D'UN TYPE_ELEM
C IN : ELREFA : NOM DE L'ELREFA
C IN : FAPG   : FAMILLE DE POINTS DE GAUSS
C      MXNBN2 : MAX DU NOMBRE DE NOEUDS D'UN SOUS-ELEMENT (HEXA8)
C      MXNBPI : MAX DU NOMBRE DE POINT_I (HEXA A 27 POINTS DE GAUSS)
C      MXNBTE : MAX DU NOMBRE DE TERMES DE LA C.L. DEFINISSANT 1 POINT_I
C      MXNBSE : MAX DU NOMBRE DE SOUS-ELEMENTS
C
C OUT : NPG    : NOMBRE DE POINTS DE GAUSS (PG)
C OUT : NBSEL  : NOMBRE DE SOUS-ELEMENTS (SE)
C OUT : CORSEL : CORRESPONDANCE SE -> KPG
C       EN GENERAL : NBSE=NBPG ET CORSEL(KSE)=KPG
C       MAIS PARFOIS :
C           NBSEL > NBPG : PLUSIEURS SE POUR 1 SEUL PG
C           NBSEL < NBPG : IL Y A DES PG SANS SE (DEHORS)
C
C ---------------------------------------------------------------------
C DESCRIPTION DES POINTS INTERMEDIAIRES (POINT_I) :
C ------------------------------------------------
C UN POINT_I EST DEFINI COMME UNE COMBINAISON LINEAIRE DES NOEUDS
C DE LA MAILLE SOUS-JACENTE AU TYPE_ELEM :
C POINT_I = SOMME COEF(K)*NOEUD(K)  (1<= K <=NTERMES)
C           NTERMES <= 27 (HEXA27)
C
C OUT : NPOINI : NOMBRE DE POINT_I POUR LE TYPE_ELEM/FAPG
C                    (NPOINI <= 64 : (HEXA20 A 27 POINTS DE GAUSS))
C OUT : NTERM1 : NTERM1(IPOINI) : NOMBRE DE TERMES DE LA COMBINAISON
C                POUR LE POINT_I IPOINI
C OUT : NSOMM1 : NSOMM1(IPOINI,K) NUMERO DU NOEUD DU KEME TERME.
C OUT : CSOMM1 : CSOMM1(IPOINI,K) COEF. DU NOEUD DU KEME TERME.
C
C CONNECTIVITE DES SOUS-ELEMENTS :
C-------------------------------
C OUT : TYMA (I)  : TYMA(KSE)-> TYPE_MAILLE ASSOCIE AU SOUS-ELEMENT KSE
C OUT : NBNO2 (I) : NBNO2(KSE) -> NNO2
C                    NNO2 : NOMBRE DE NOEUDS DU SOUS-ELEMENT KSE
C OUT : CONNX (I) : CONNX(INO2,KSE) -> IPOINI
C                    IPOINI= NUMERO DU POINT_I ASSOCIE AU
C                    SOMMET INO2 DU SOUS-ELEMENT KSE
C                    (1<= INO2 <= NNO2(KSE))
C                    (1<= IPOINI <= NPOINI)
C
C ---------------------------------------------------------------------
      INTEGER        NBNOMX,    NBFAMX
      PARAMETER    ( NBNOMX=27, NBFAMX=20)
      INTEGER      NNO, NNOS, NBFPG, NBPG(NBFAMX), NUFPG, INDIK8
      REAL*8       VOL, X(3*NBNOMX)
      CHARACTER*8  FAMG(NBFAMX)
C ---------------------------------------------------------------------
      CALL JEMARQ()
C
      NPG    = 0
      NPOINI = 0
      NBSEL  = 0
C
      CALL ELRACA ( ELREFA, NDIM, NNO, NNOS, NBFPG, FAMG, NBPG, X, VOL )

      NUFPG = INDIK8( FAMG, FAPG, 1, NBFPG )
      CALL ASSERT(NUFPG.GT.0)
      NPG = NBPG(NUFPG)
C
      IF ( NDIM .EQ. 2 ) THEN
         CALL ECLA2D ( NOMTE, ELREFA, FAPG, NPG, NPOINI,
     &                 NTERM1, NSOMM1, CSOMM1, TYMA, NBNO2, CONNX,
     &                 MXNBN2,  MXNBPI, MXNBTE,
     &                 MXNBSE, NBSEL, CORSEL)

      ELSEIF ( NDIM .EQ. 3 ) THEN
         CALL ECLA3D ( NOMTE, ELREFA, FAPG, NPG, NPOINI,
     &                 NTERM1, NSOMM1, CSOMM1, TYMA, NBNO2, CONNX,
     &                 MXNBN2,  MXNBPI, MXNBTE,
     &                 MXNBSE, NBSEL, CORSEL)

      ENDIF

      CALL JEDEMA()

      END
