      SUBROUTINE MERIME(MODELZ,NCHAR ,LCHAR ,MATE  ,CARELZ,
     &                  EXITIM,TIME  ,COMPOZ,MATELZ,NH    ,
     &                  BASZ  )
C
C ----------------------------------------------------------------------
C MODIF CALCULEL  DATE 30/10/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C                          DE MERIME...  PROSPER YOUP-LA-BOUM!
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      INTEGER       NCHAR,NH
      REAL*8        TIME
      CHARACTER*(*) MODELZ,CARELZ,MATELZ
      CHARACTER*(*) LCHAR(*),MATE,BASZ,COMPOZ
      LOGICAL       EXITIM
C
C ----------------------------------------------------------------------
C
C CALCUL DES MATRICES ELEMENTAIRES DE RIGIDITE MECANIQUE
C
C ----------------------------------------------------------------------
C
C IN  MODELE : NOM DU MODELE
C IN  NCHAR  : NOMBRE DE CHARGES
C IN  LCHAR  : LISTE DES CHARGES
C IN  MATE   : CARTE DE MATERIAU
C IN  CARELE : CHAMP DE CARAC_ELEM
C IN  MATELZ : NOM DU MATR_ELEM RESULTAT
C IN  EXITIM : VRAI SI L'INSTANT EST DONNE
C IN  TIME   : INSTANT DE CALCUL
C IN  NH     : NUMERO D'HARMONIQUE DE FOURIER
C IN  BASE   : NOM DE LA BASE
C IN  COMPOR : COMPOR POUR LES MULTIFIBRE (POU_D_EM)
C
C ----------------------------------------------------------------------
C
      INTEGER      NBOUT,NBIN
      PARAMETER    (NBOUT=2, NBIN=31)
      CHARACTER*8  LPAOUT(NBOUT),LPAIN(NBIN)
      CHARACTER*19 LCHOUT(NBOUT),LCHIN(NBIN)
C
      CHARACTER*2  CODRET
      CHARACTER*8  K8BID
      CHARACTER*16 OPTION,K16BID,NOMCMD
      CHARACTER*19 CHVARC,COMPOR
      CHARACTER*19 PINTTO,CNSETO,HEAVTO,LONCHA,BASLOC,LSN,LST,STANO
      CHARACTER*19 PMILTO,FISSNO,PINTER
      CHARACTER*24 CHGEOM,CHCARA(18),CHHARM
      CHARACTER*24 ARGU,CHTIME
      COMPLEX*16   C16BID
      CHARACTER*8  MODELE,CARELE
      CHARACTER*19 MATELE,LIGRMO,LIGRCH
      CHARACTER*1  BASE
      INTEGER      IAREFE,IBID,ICHA,ICODE,ILIRES,IRET 
      LOGICAL      LXFEM
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      MODELE = MODELZ
      CALL ASSERT(MODELE.NE.' ')
      CARELE = CARELZ
      MATELE = MATELZ
      COMPOR = COMPOZ
      BASE   = BASZ
      CHVARC = '&&MERIME.CH_VARC_R'
      CHTIME = '&&MERIME.CHAMP_INST'
      CALL GETRES(K8BID,K16BID,NOMCMD)
      LIGRMO = MODELE//'.MODELE'
      OPTION = 'RIGI_MECA'
      CALL EXIXFE(MODELE,IRET)
      LXFEM  = IRET.NE.0
C
C --- INITIALISATION DES CHAMPS POUR CALCUL
C
      CALL INICAL(NBIN  ,LPAIN ,LCHIN ,
     &            NBOUT ,LPAOUT,LCHOUT)
C
C --- CHAMPS DE BASE
C
      CALL MECHAM(OPTION,MODELE,NCHAR ,LCHAR ,CARELE,
     &            NH    ,CHGEOM,CHCARA,CHHARM,ICODE )
C
C --- CHAMP TEMPS
C
      IF (.NOT.EXITIM) TIME = 0.D0
      CALL MECACT('V'   ,CHTIME,'MODELE',LIGRMO,'INST_R',
     &            1     ,'INST',IBID    ,TIME  ,C16BID  ,
     &            K8BID )
C
C --- CHAMP DES VARIABLES DE COMMANDE
C
      IF (NOMCMD.EQ.'MECA_STATIQUE'.OR.NOMCMD.EQ.'CALC_MATR_ELEM') THEN
        CALL VRCINS(MODELE,MATE,CARELE,TIME,CHVARC,CODRET)
      ENDIF
C
C --- PREPARATION DES MATRICES ELEMENTAIRES
C
      CALL MEMARE(BASE,MATELE,MODELE,MATE,CARELE,OPTION)
C     SI LA RIGIDITE EST CALCULEE SUR LE MODELE, ON ACTIVE LES S_STRUC:
      IF (ICODE.EQ.0 .OR. ICODE.EQ.2) THEN
        CALL JEVEUO(MATELE//'.RERR','E',IAREFE)
        ZK24(IAREFE-1+3) (1:3) = 'OUI'
      END IF

      CALL JEEXIN(MATELE//'.RELR',IRET)
      IF (IRET.GT.0) CALL JEDETR(MATELE//'.RELR')
C
C --- CHAMPS DE SORTIE
C
      LPAOUT(1) = 'PMATUUR'
      LCHOUT(1) = MATELE(1:8)//'.ME001'
      LPAOUT(2) = 'PMATUNS'
      LCHOUT(2) = MATELE(1:8)//'.ME002'
C
C --- CHAMPS POUR XFEM
C
      ILIRES = 0
      IF (LXFEM) THEN
        ILIRES = ILIRES+1
        PINTTO = MODELE(1:8)//'.TOPOSE.PIN'
        CNSETO = MODELE(1:8)//'.TOPOSE.CNS'
        HEAVTO = MODELE(1:8)//'.TOPOSE.HEA'
        LONCHA = MODELE(1:8)//'.TOPOSE.LON'
        PMILTO = MODELE(1:8)//'.TOPOSE.PMI'
        BASLOC = MODELE(1:8)//'.BASLOC'
        LSN    = MODELE(1:8)//'.LNNO'
        LST    = MODELE(1:8)//'.LTNO'
        STANO  = MODELE(1:8)//'.STNO'
        FISSNO = MODELE(1:8)//'.FISSNO'
        PINTER = MODELE(1:8)//'.TOPOFAC.OE'
      ELSE
        PINTTO = '&&MERIME.PINTTO.BID'
        CNSETO = '&&MERIME.CNSETO.BID'
        HEAVTO = '&&MERIME.HEAVTO.BID'
        LONCHA = '&&MERIME.LONCHA.BID'
        BASLOC = '&&MERIME.BASLOC.BID'
        PMILTO = '&&MERIME.PMILTO.BID'
        LSN    = '&&MERIME.LNNO.BID'
        LST    = '&&MERIME.LTNO.BID'
        STANO  = '&&MERIME.STNO.BID'
        FISSNO = '&&MERIME.FISSNO.BID'
        PINTER = '&&MERIME.PINTER.BID'
      ENDIF
C
C --- MATRICES DE RIGIDITE
C
      IF ((LXFEM).OR.((.NOT.LXFEM).AND.(ICODE.EQ.0))) THEN
        LPAIN(1)  = 'PGEOMER'
        LCHIN(1)  = CHGEOM(1:19)
        LPAIN(2)  = 'PMATERC'
        LCHIN(2)  = MATE(1:19)
        LPAIN(3)  = 'PCAORIE'
        LCHIN(3)  = CHCARA(1)(1:19)
        LPAIN(4)  = 'PCADISK'
        LCHIN(4)  = CHCARA(2)(1:19)
        LPAIN(5)  = 'PCAGNPO'
        LCHIN(5)  = CHCARA(6)(1:19)
        LPAIN(6)  = 'PCACOQU'
        LCHIN(6)  = CHCARA(7)(1:19)
        LPAIN(7)  = 'PCASECT'
        LCHIN(7)  = CHCARA(8)(1:19)
        LPAIN(8)  = 'PCAARPO'
        LCHIN(8)  = CHCARA(9)(1:19)
        LPAIN(9)  = 'PHARMON'
        LCHIN(9)  = CHHARM(1:19)
        LPAIN(10) = 'PGEOME2'
        LCHIN(10) = CHGEOM(1:19)
        LPAIN(11) = 'PCAGNBA'
        LCHIN(11) = CHCARA(11)(1:19)
        LPAIN(12) = 'PCAMASS'
        LCHIN(12) = CHCARA(12)(1:19)
        LPAIN(13) = 'PCAPOUF'
        LCHIN(13) = CHCARA(13)(1:19)
        LPAIN(14) = 'PCAGEPO'
        LCHIN(14) = CHCARA(5)(1:19)
        LPAIN(15) = 'PVARCPR'
        LCHIN(15) = CHVARC(1:19)
        LPAIN(16) = 'PTEMPSR'
        LCHIN(16) = CHTIME(1:19)
        LPAIN(17) = 'PNBSP_I'
        LCHIN(17) = CHCARA(16)(1:19)
        LPAIN(18) = 'PFIBRES'
        LCHIN(18) = CHCARA(17)(1:19)
        LPAIN(19) = 'PCOMPOR'
        LCHIN(19) = COMPOR
        LPAIN(20) = 'PCINFDI'
        LCHIN(20) = CHCARA(15)(1:19)
        LPAIN(21) = 'PPINTTO'
        LCHIN(21) = PINTTO(1:19)
        LPAIN(22) = 'PHEAVTO'
        LCHIN(22) = HEAVTO(1:19)
        LPAIN(23) = 'PLONCHA'
        LCHIN(23) = LONCHA(1:19)
        LPAIN(24) = 'PCNSETO'
        LCHIN(24) = CNSETO(1:19)
        LPAIN(25) = 'PBASLOR'
        LCHIN(25) = BASLOC(1:19)
        LPAIN(26) = 'PLSN'
        LCHIN(26) = LSN(1:19)
        LPAIN(27) = 'PLST'
        LCHIN(27) = LST(1:19)
        LPAIN(28) = 'PSTANO'
        LCHIN(28) = STANO(1:19)
        LPAIN(29) = 'PPMILTO'
        LCHIN(29) = PMILTO(1:19)
        LPAIN(30) = 'PFISNO'
        LCHIN(30) = FISSNO(1:19)
        LPAIN(31) = 'PPINTER'
        LCHIN(31) = PINTER(1:19)
        CALL CALCUL('S',OPTION,LIGRMO,NBIN,LCHIN,LPAIN,
     &                                NBOUT,LCHOUT,LPAOUT,
     &                                BASE,'OUI')
        CALL REAJRE(MATELE,LCHOUT(1),BASE)
        CALL REAJRE(MATELE,LCHOUT(2),BASE)
        ILIRES = ILIRES + 2      
      ENDIF
C
C --- MATRICE DIRICHLET
C
      OPTION = 'MECA_DDLM_R'
      DO 10 ICHA = 1,NCHAR
        LIGRCH = LCHAR(ICHA) (1:8)//'.CHME.LIGRE'
        ARGU = LCHAR(ICHA) (1:8)//'.CHME.LIGRE.LIEL'
        CALL JEEXIN(ARGU,IRET)
        IF (IRET.LE.0) GO TO 10
        LCHIN(1) = LCHAR(ICHA) (1:8)//'.CHME.CMULT'
        ARGU = LCHAR(ICHA) (1:8)//'.CHME.CMULT.DESC'
        CALL JEEXIN(ARGU,IRET)
        IF (IRET.LE.0) GO TO 10
        LPAIN(1) = 'PDDLMUR'
        ILIRES=ILIRES+1
        CALL CODENT(ILIRES,'D0',LCHOUT(1) (12:14))
        OPTION = 'MECA_DDLM_R'
        CALL CALCUL('S',OPTION,LIGRCH,1,LCHIN,LPAIN,
     &                                1,LCHOUT,LPAOUT,
     &                                BASE,'OUI')
        CALL REAJRE(MATELE,LCHOUT(1),BASE)
   10 CONTINUE
C
C --- DESTRUCTION DES RESUELEM NULS
C
      CALL REDETR(MATELE)
      CALL DETRSD('CHAMP_GD',CHTIME)

      CALL JEDEMA()
      END
