      SUBROUTINE NBPTCA(LIGREL,OPTION,PARAM,OBNBPT,OBNBNO)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 13/11/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE PELLET J.PELLET
C A_UTIL
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*32 JEXATR
      CHARACTER*(*) LIGREL,OPTION,PARAM,OBNBPT,OBNBNO
C ------------------------------------------------------------------
C BUT: CREER L'OBJET OBNBPT QUI CONTIENDRA LE NOMBRE DE POINTS
C      DE DISCRETISATION (POUR LES MAILLES D'UN LIGREL)
C      POUR LE CHAMP ASSOCIE A UN PARAMETRE D'UNE OPTION
C ------------------------------------------------------------------
C     ARGUMENTS:
C LIGREL  IN/JXIN  K19 : LIGREL
C OPTION  IN       K16 : NOM D'UNE OPTION DE CALCUL
C PARAM   IN       K8  : NOM D'UN PARAMETRE DE OPTION
C OBNBPT  IN/JXOUT K24 : OBJET QUI CONTIENDRA LES NOMBRES DE POINTS
C OBNBNO  IN/JXOUT K24 : OBJET QUI CONTIENDRA LES NOMBRES DE NOEUDS
C ------------------------------------------------------------------
C REMARQUES :
C  CETTE ROUTINE PEUT ETRE UTILISEE PAR EXEMPLE POUR DETERMINER LES
C  NOMBRE DE POINTS DE GAUSS D'UN MODELE MECANIQUE NON-LINEAIRE:
C  OPTION = 'RAPH_MECA' + PARAM='PCONTMR'

C  L'OBJET CREE EST UN VECTEUR D'ENTIERS DIMENSIONNE AU NOMBRE DE
C  MAILLES DU MAILLAGE : V(IMA) : NBPT(MAILLE_IMA)
C  LES MAILLES TARDIVES SONT IGNOREES.
C-----------------------------------------------------------------------

C     ------------------------------------------------------------------
      INTEGER IBID,IRET,NBMA,IMA,JCESD,JNBPT,JNBNO,IACNX1,ILCNX1,NBNO
      CHARACTER*1 KBID
      CHARACTER*8 MA
      CHARACTER*19 CEL,CES
C     ------------------------------------------------------------------
      CALL JEMARQ()
      CEL = '&&NBPTCA.CEL'
      CES = '&&NBPTCA.CES'

      CALL DISMOI('F','NOM_MAILLA',LIGREL,'LIGREL',IBID,MA,IBID)
      CALL DISMOI('F','NB_MA_MAILLA',MA,'MAILLAGE',NBMA,KBID,IBID)
      CALL WKVECT(OBNBPT,'V V I',NBMA,JNBPT)
      CALL WKVECT(OBNBNO,'V V I',NBMA,JNBNO)
      CALL JEVEUO(MA//'.CONNEX','L',IACNX1)
      CALL JEVEUO(JEXATR(MA//'.CONNEX','LONCUM'),'L',ILCNX1)

      CALL ALCHML(LIGREL,OPTION,PARAM,'V',CEL,IRET,' ')
      IF (IRET.NE.0) THEN
C       - IL N'Y A RIEN A FAIRE : NBPT(IMA)=0
      ELSE
        CALL CELCES(CEL,'V',CES)
        CALL JEVEUO(CES//'.CESD','L',JCESD)
        DO 10,IMA = 1,NBMA
          ZI(JNBPT-1+IMA) = ZI(JCESD-1+5+4* (IMA-1)+1)
          NBNO = ZI(ILCNX1+IMA) - ZI(ILCNX1-1+IMA)
          ZI(JNBNO-1+IMA) = NBNO
   10   CONTINUE

      END IF


      CALL DETRSD('CHAM_ELEM',CEL)
      CALL DETRSD('CHAM_ELEM_S',CES)

      CALL JEDEMA()
      END
