      SUBROUTINE OP0038()
      IMPLICIT NONE
C ----------------------------------------------------------------------
C MODIF CALCULEL  DATE 20/11/2012   AUTEUR FLEJOU J-L.FLEJOU 
C ======================================================================
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C ----------------------------------------------------------------------
C     COMMANDE:  CALC_CHAM_ELEM
C     - FONCTION REALISEE:
C         CALCUL DES FLUX ELEMENTAIRES EN THERMIQUE ;
C         CALCUL DE LA PRESSION ACOUSTIQUE ;
C         CALCUL DES COOREDONNEES DES POINTS DE GAUSS
C
C ----------------------------------------------------------------------
C
      INCLUDE 'jeveux.h'
C
      INTEGER IBID,IERD,IRET,JCHA,N1,N3,N4,N6,N7,NCHAR,NH,IARG

      REAL*8 TIME,RUNDF,R8VIDE

      CHARACTER*1 BASE
      CHARACTER*4 CTYP
      CHARACTER*8 MODELE,CARA,TEMP,NOMA,BLAN8,KMPIC
      CHARACTER*8 LPAIN(8),LPAOUT(1)
      CHARACTER*16 TYPE,OPER,OPTION
      CHARACTER*19 KCHA,CHELEM,PRESS,LIGREL
      CHARACTER*24 CHGEOM,CHCARA(18),CHHARM,MATE,K24B
      CHARACTER*24 CHTEMP,CHTIME,CHFLUG,CHPRES
      CHARACTER*24 LCHIN(8),LCHOUT(1)

      LOGICAL EXITIM
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
      CALL INFMAJ()
C               123456789012345678901234
      K24B   = '                        '
      BLAN8  = '        '
      KCHA   = '&&OP0038.CHARGES   '
C
      BASE   = 'G'
      RUNDF  = R8VIDE()
      PRESS  = ' '
      CHTIME = ' '
      EXITIM = .FALSE.

      CALL GETRES(CHELEM,TYPE,OPER)
      CALL GETVID(' ','ACCE',0,IARG,0,OPTION,N1)
      IF (N1.NE.0) THEN
         CALL U2MESS('A','CALCULEL3_96')
      ENDIF

      CALL UTALRM('OFF', 'CALCULEL3_40')
      CALL MEDOM1(MODELE,MATE,CARA,KCHA,NCHAR,CTYP,BLAN8,1)
      CALL UTALRM('ON', 'CALCULEL3_40')
      CALL JEVEUO(KCHA//'.LCHA','E',JCHA)

      CALL EXLIMA(' ',0,'G',MODELE,LIGREL)

      CALL GETVTX(' ','OPTION',0,IARG,1,OPTION,N1)
      CALL GETVID(' ','TEMP',0,IARG,1,TEMP,N3)
      CALL GETVID(' ','PRES',0,IARG,1,PRESS,N4)
      CALL GETVR8(' ','INST',0,IARG,1,TIME,N6)
      CALL GETVIS(' ','MODE_FOURIER',0,IARG,1,NH,N7)
      IF (N3.NE.0) THEN
        CHTEMP = TEMP
        CALL CHPVER('F',CHTEMP,'NOEU','TEMP_R',IERD)
      ENDIF
      IF (N4.NE.0) THEN
        CHPRES = PRESS
        CALL CHPVER('F',CHPRES,'NOEU','PRES_C',IERD)
      ENDIF
      IF (N6.NE.0) EXITIM = .TRUE.
      IF (N7.EQ.0) NH = 0

      CALL MECHAM(OPTION,MODELE,NCHAR,ZK8(JCHA),CARA,NH,CHGEOM,CHCARA,
     &            CHHARM,IRET)
      IF (IRET.NE.0) GO TO 10
      NOMA = CHGEOM(1:8)
      IF (EXITIM) CALL MECHTI(NOMA,TIME,RUNDF,RUNDF,CHTIME)

C        -------------------------
C        -- OPTIONS DE THERMIQUE :
C        -------------------------
      IF (OPTION(1:7).EQ.'FLUX_EL') THEN
        CHFLUG='&&OP0038.FLUXGAUSS'
        LCHIN(1)=CHGEOM
        LPAIN(1)='PGEOMER'
        LCHIN(2)=MATE
        LPAIN(2)='PMATERC'
        LCHIN(3)=CHCARA(7)
        LPAIN(3)='PCACOQU'
        LCHIN(4)=CHCARA(12)
        LPAIN(4)='PCAMASS'
        LCHIN(5)=CHTEMP
        LPAIN(5)='PTEMPER'
        LCHIN(6)=CHTIME
        LPAIN(6)='PTEMPSR'
        LCHIN(7)=CHHARM
        LPAIN(7)='PHARMON'
        LCHIN(8)=K24B
        LPAIN(8)='PVARCPR'
        LCHOUT(1)=CHFLUG
        LPAOUT(1)='PFLUXPG'
C
        CALL CALCUL('S','FLUX_ELGA',LIGREL,8,LCHIN,LPAIN,1,LCHOUT,
     &              LPAOUT,'V','OUI')
C
        IF (OPTION.EQ.'FLUX_ELNO') THEN
          LCHIN(1)=CHFLUG
          LPAIN(1)='PFLUXPG'
          LCHOUT(1)=CHELEM
          LPAOUT(1)='PFLUXNO'
C
          CALL CALCUL('S',OPTION,LIGREL,1,LCHIN,LPAIN,1,LCHOUT,
     &                LPAOUT,BASE,'OUI')
C
        ELSE IF (OPTION.EQ.'FLUX_ELGA') THEN
          CALL COPISD('CHAMP','G',CHFLUG,CHELEM)
        ENDIF

C        ---------------------------
C        -- OPTION POINTS DE GAUSS :
C        ---------------------------
      ELSE IF (OPTION.EQ.'COOR_ELGA') THEN
        LCHIN(1)=CHGEOM
        LPAIN(1)='PGEOMER'
        LCHIN(2)=CHCARA(1)
        LPAIN(2)='PCAORIE'
        LCHIN(3)=CHCARA(17)
        LPAIN(3)='PFIBRES'
        LCHIN(4)=CHCARA(16)
        LPAIN(4)='PNBSP_I'
        LCHIN(5)=CHCARA(7)
        LPAIN(5)='PCACOQU'
        LCHIN(6)=CHCARA(5)
        LPAIN(6)='PCAGEPO'
        LCHOUT(1)=CHELEM
        LPAOUT(1)='PCOORPG'
        CALL CESVAR(CARA,' ',LIGREL,LCHOUT(1))

        CALL CALCUL('S',OPTION,LIGREL,6,LCHIN,LPAIN,1,LCHOUT,
     &              LPAOUT,BASE,'OUI')
C        ------------------------
C        -- OPTIONS ACOUSTIQUES :
C        ------------------------
      ELSE IF (OPTION.EQ.'PRAC_ELNO') THEN
        LPAIN(1)='PPRESSC'
        LCHIN(1)=CHPRES
        LCHOUT(1)=CHELEM
        LPAOUT(1)='PPRAC_R'

        CALL CALCUL('S',OPTION,LIGREL,1,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'G',
     &                 'OUI')

C        ----------------------
C        -- OPTIONS INCONNUES :
C        ----------------------
      ELSE
        CALL U2MESK('F','CALCULEL3_22',1,OPTION)
      END IF

   10 CONTINUE

C     -- SI CHELEM N'EST PAS MPI_COMPLET, ON LE COMPLETE :
      CALL DISMOI('F','MPI_COMPLET',CHELEM,'CHAM_ELEM',IBID,KMPIC,IBID)
      IF (KMPIC.EQ.'NON')  CALL SDMPIC('CHAM_ELEM',CHELEM)

      CALL JEDEMA()
      END
