      SUBROUTINE TE0164(OPTION,NOMTE)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*16 OPTION,NOMTE
C ......................................................................
C    - FONCTION REALISEE:  CALCUL DES FORCES NODALES DE MECABL2
C                          OPTION : 'FORC_NODA', 'REFE_FORC_NODA'

C    - ARGUMENTS:
C        DONNEES:      OPTION       -->  OPTION DE CALCUL
C                      NOMTE        -->  NOM DU TYPE ELEMENT
C ......................................................................

      REAL*8  BILINE,COEF,JACOBI,NX,YTYWPQ(9),W(9),FORREF
      INTEGER NNO,KP,I,IPOIDS,IVF,IGEOM,NC,NORDRE,IRET,K
      INTEGER IVECTU,INO,NDIM,NNOS,NPG
      INTEGER IDFDK,JGANO,IYTY,IDEPLA,IDEPLP,LSIGMA,JEFINT
C ----------------------------------------------------------------------

      IF(OPTION.EQ.'REFE_FORC_NODA')THEN
         NNO = 2
         NC  = 3
         CALL TEREFE('EFFORT_REFE','MECA_BARRE',FORREF)
         CALL JEVECH('PVECTUR','E',IVECTU)
         DO 101 INO=1,NNO
            DO 102  I=1,NC
               ZR(IVECTU+(INO-1)*NC+I-1)=FORREF
102        CONTINUE
101      CONTINUE

      ELSEIF(OPTION.EQ.'FORC_NODA')THEN
         CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG,IPOIDS,
     &               IVF,IDFDK,JGANO)
         CALL JEVETE('&INEL.CABPOU.YTY','L',IYTY)
         NORDRE = 3*NNO
C        PARAMETRES EN ENTREE
         CALL JEVECH('PGEOMER','L',IGEOM)

         CALL JEVECH('PDEPLMR','L',IDEPLA)
         CALL TECACH('ONN','PDEPLPR',1,IDEPLP,IRET)
         CALL JEVECH('PCONTMR','L',LSIGMA)
C        PARAMETRES EN SORTIE
         CALL JEVECH('PVECTUR','E',JEFINT)

         IF (IDEPLP.EQ.0) THEN
            DO 10 I = 1,3*NNO
               W(I) = ZR(IDEPLA-1+I)
10          CONTINUE
         ELSE
            DO 20 I = 1,3*NNO
               W(I) = ZR(IDEPLA-1+I) + ZR(IDEPLP-1+I)
20          CONTINUE
         END IF
         DO 40 KP = 1,NPG
            K = (KP-1)*NORDRE*NORDRE
            JACOBI=SQRT(BILINE(NORDRE,ZR(IGEOM),ZR(IYTY+K),ZR(IGEOM)))
            NX = ZR(LSIGMA-1+KP)
            CALL MATVEC(NORDRE,ZR(IYTY+K),2,ZR(IGEOM),W,YTYWPQ)
            COEF = NX*ZR(IPOIDS-1+KP)/JACOBI
            DO 30 I = 1,NORDRE
               ZR(JEFINT-1+I) = ZR(JEFINT-1+I) + COEF*YTYWPQ(I)
30          CONTINUE
40       CONTINUE
      ENDIF
      END
