      SUBROUTINE MMIMP4(IFM   ,NOMA  ,NUMMAE,IPTM  ,INDCOI,
     &                  INDCON,INDFRI,INDFRN,LFROT ,LVITES,
     &                  LGLISS,JEU   ,JEUVIT,LAMBDC)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF DEBUG  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'

      CHARACTER*32 JEXNUM
      INTEGER      IFM
      INTEGER      NUMMAE
      CHARACTER*8  NOMA
      INTEGER      IPTM
      INTEGER      INDCOI,INDCON
      INTEGER      INDFRI,INDFRN
      LOGICAL      LFROT,LVITES,LGLISS
      REAL*8       JEU,JEUVIT,LAMBDC
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - UTILITAIRE - IMPRESSIONS)
C
C AFFICHAGE ALGORITHME CONTRAINTES ACTIVES
C
C ----------------------------------------------------------------------
C
C
C IN  IFM    : UNITE D'IMPRESSION DU MESSAGE
C IN  NOMA   : NOM DU MAILLAGE
C IN  NUMMAE : NUMERO ABSOLU DE LA MAILLE ESCLAVE
C IN  IPTM   : NUMERO DU POINT DE CONTACT DANS LA MAILLE ESCLAVE
C IN  INDCOI : INDICATEUR DE CONTACT INITIAL
C              - INDCOI = 0: PAS DE CONTACT
C              - INDCOI = 1: CONTACT
C IN  INDCON : INDICATEUR DE CONTACT FINAL
C              - INDCON = 0: PAS DE CONTACT
C              - INDCON = 1: CONTACT
C IN  INDFRI : INDICATEUR DE FROTTEMENT INITIAL
C              - INDFRI = 0 SI ADHERENT
C              - INDFRI = 1 SI GLISSANT
C IN  INDFRN : INDICATEUR DE FROTTEMENT FINAL
C              - INDFRN = 0 SI ADHERENT
C              - INDFRN = 1 SI GLISSANT
C IN  LVITES : .TRUE. SI FORMULATION EN VITESSE
C IN  LGLISS : .TRUE. SI CONTACT GLISSIERE
C IN  LFROT  : .TRUE. SI FROTTEMENT
C IN  JEU    : JEU TOTAL (Y COMPRIS DIST_* ET USURE)
C IN  JEUVIT : GAP VITESSE
C IN  LAMBDC : LAGRANGE DE CONTACT (PRESSION DE CONTACT)
C
C ----------------------------------------------------------------------
C
      CHARACTER*8  NOMESC
      CHARACTER*16 STATUT
C
C ----------------------------------------------------------------------
C
C
C --- REPERAGE MAILLE ESCLAVE
C
      CALL JENUNO(JEXNUM(NOMA//'.NOMMAI',NUMMAE),NOMESC)
      WRITE(IFM,1000) NOMESC
      WRITE(IFM,2000) IPTM
 1000 FORMAT (' <CONTACT>     * LA MAILLE ESCLAVE ',A8)
 2000 FORMAT (' <CONTACT>     ** DONT LE POINT DE CONTACT ',I3)
C
C --- PROPRIETES (FORMULATION)
C
      IF (LVITES) THEN
        WRITE(IFM,1001)
      ELSE
        WRITE(IFM,1002)
      ENDIF
 1001 FORMAT (' <CONTACT>        (FORMULATION VITESSE)')
 1002 FORMAT (' <CONTACT>        (FORMULATION DEPLACEMENT)')
C
C --- PROPRIETES (GLISSIERE)
C
      IF (LGLISS) THEN
        WRITE(IFM,3001)
      ENDIF
 3001 FORMAT (' <CONTACT>        (GLISSIERE)')
C
C --- ETAT DE CONTACT INITIAL
C
      IF (INDCOI.EQ.0) THEN
        STATUT = ' PAS EN CONTACT '
      ELSE
        STATUT = ' EN CONTACT     '
      ENDIF
      WRITE(IFM,5000) STATUT
 5000 FORMAT (' <CONTACT>         -> ETAT DE CONTACT    INITIAL:',A16)
C
C --- ETAT DE FROTTEMENT INITIAL
C
      IF (LFROT) THEN
        IF (INDFRI.EQ.0) THEN
          STATUT = ' ADHERENT '
        ELSE
          STATUT = ' GLISSANT '
        ENDIF
        WRITE(IFM,5001) STATUT
      ENDIF
 5001 FORMAT (' <CONTACT>         -> ETAT DE FROTTEMENT INITIAL:',A16)
C
C --- PROPRIETES (JEUX)
C
      IF (LVITES) THEN
        WRITE(IFM,6001) JEU,JEUVIT,LAMBDC
      ELSE
        WRITE(IFM,6000) JEU,LAMBDC
      ENDIF
 6000 FORMAT (' <CONTACT>         <> JEU:',E10.3,
     &        ' - LAGS_C :',E10.3)

 6001 FORMAT (' <CONTACT>         <> JEU:',E10.3,
     &        ' - SAUT VITESSE:',E10.3,
     &        ' - LAGS_C :',E10.3)
C
C --- ETAT DE CONTACT FINAL
C
      IF (INDCON.EQ.0) THEN
        STATUT = ' PAS EN CONTACT '
      ELSE
        STATUT = ' EN CONTACT     '
      ENDIF
      WRITE(IFM,7000) STATUT
 7000 FORMAT (' <CONTACT>         -> ETAT DE CONTACT    FINAL  :',A16)
C
C --- ETAT DE FROTTEMENT FINAL
C
      IF (LFROT) THEN
        IF (INDFRN.EQ.0) THEN
          STATUT = ' ADHERENT '
        ELSE
          STATUT = ' GLISSANT '
        ENDIF
        WRITE(IFM,7001) STATUT
      ENDIF
 7001 FORMAT (' <CONTACT>         -> ETAT DE FROTTEMENT FINAL  :',A16)
C
      END
