      SUBROUTINE SURFC2(CHAR,NOMA,IFM)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF DEBUG  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*32 JEXNUM
      CHARACTER*8 CHAR
      CHARACTER*8 NOMA
      INTEGER     IFM
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - AFFICHAGE DONNEES)
C
C AFFICHAGE LES INFOS CONTENUES DANS LA SD CONTACT POUR LA FORMULATION
C CONTINUE
C
C ----------------------------------------------------------------------
C
C
C IN  CHAR   : NOM UTILISATEUR DU CONCEPT DE CHARGE
C IN  NOMA   : NOM DU MAILLAGE
C IN  IFM    : UNITE D'IMPRESSION
C
C
C
C
      INTEGER      CFDISI,MMINFI,NZOCO,NNOCO,NMACO
      REAL*8       MMINFR,TOLINT
      LOGICAL      MMINFL,LVERI
      INTEGER      IZONE
      CHARACTER*24 MAILMA,DEFICO
      INTEGER      JNOMNO,JNOMMA
      CHARACTER*8  NOMMAE
      INTEGER      NUMMAE,POSMAE,IMAE,JDECME
      INTEGER      NBMAE
      INTEGER      NDEXFR,NPTM
C
      CHARACTER*24 PARACR,PARACI
      INTEGER      JPARCR,JPARCI
      CHARACTER*24 CARACF
      INTEGER      JCMCF
      CHARACTER*24 CONTNO,CONTMA
      INTEGER      JNOCO,JMACO
      INTEGER      CFMMVD,ZCMCF
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ
C
C --- INITIALISATIONS
C
      DEFICO = CHAR(1:8)//'.CONTACT'
C
C --- ACCES SD DU MAILLAGE
C
      MAILMA = NOMA(1:8)//'.NOMMAI'
C
C --- COMMUNS TOUTES FORMULATIONS
C
      PARACR = DEFICO(1:16)//'.PARACR'
      PARACI = DEFICO(1:16)//'.PARACI'
      CALL JEVEUO(PARACR,'L',JPARCR)
      CALL JEVEUO(PARACI,'L',JPARCI)
C
C --- COMMUNS AVEC FORM. MAILLEES (DISCRET ET CONTINUE MAIS PAS XFEM)
C
      CONTNO = DEFICO(1:16)//'.NOEUCO'
      CONTMA = DEFICO(1:16)//'.MAILCO'
      CALL JEVEUO(CONTNO,'L',JNOCO )
      CALL JEVEUO(CONTMA,'L',JMACO )
C
C --- SPECIFIQUES FORMULATION CONTINUE
C
      CARACF = DEFICO(1:16)//'.CARACF'
C
      CALL JEVEUO(CARACF,'L',JCMCF)
C
      ZCMCF = CFMMVD('ZCMCF')
C
C --- INITIALISATIONS
C
      NZOCO  = CFDISI(DEFICO,'NZOCO')
      NMACO  = CFDISI(DEFICO,'NMACO')
      NNOCO  = CFDISI(DEFICO,'NNOCO')
C
C --- CREATION VECTEURS TEMPORAIRES
C
      CALL WKVECT('&&SURFC2.TRAVNO','V V K8',NZOCO*NNOCO,JNOMNO)
      CALL WKVECT('&&SURFC2.TRAVMA','V V K8',NZOCO*NMACO,JNOMMA)
C
C --- IMPRESSIONS POUR L'UTILISATEUR
C
      WRITE (IFM,*)
      WRITE (IFM,*) '<CONTACT> INFOS SPECIFIQUES SUR LA FORMULATION'//
     &              ' CONTINUE'
      WRITE (IFM,*)
C
C --- IMPRESSIONS POUR LES PARAMETRES CONSTANTS
C
      WRITE (IFM,*) '<CONTACT> ... PARAMETRES CONSTANTS SUR TOUTES '//
     &              ' LES ZONES'

      WRITE (IFM,1070) 'AXISYMETRIE     ',ZI(JPARCI+16-1)
C
 1070 FORMAT (' <CONTACT> ...... PARAM. : ',A16,' - VAL. : ',I5)
 1071 FORMAT (' <CONTACT> ...... PARAM. : ',A16,' - VAL. : ',E12.5)
C
C --- IMPRESSIONS POUR LES PARAMETRES VARIABLES
C
      WRITE (IFM,*) '<CONTACT> ... PARAMETRES VARIABLES SUIVANT '//
     &              ' LES ZONES'
      DO 320 IZONE = 1,NZOCO
        WRITE (IFM,*) '<CONTACT> ...... ZONE : ',IZONE
        LVERI  = MMINFL(DEFICO,'VERIF',IZONE )
        IF (LVERI) THEN
          WRITE (IFM,*) '<CONTACT> ...... ZONE DE VERIFICATION'
          TOLINT = MMINFR(DEFICO,'TOLE_INTERP',IZONE)
          WRITE (IFM,1071) 'TOLE_INTERP     ',TOLINT
        ELSE
          WRITE (IFM,*) '<CONTACT> ...... ZONE DE CALCUL'
          WRITE (IFM,1071) 'INTEGRATION     ',
     &                      ZR(JCMCF+ZCMCF*(IZONE-1)-1+1)
          WRITE (IFM,1071) 'COEF_CONT      ',
     &                      ZR(JCMCF+ZCMCF*(IZONE-1)-1+2)
          WRITE (IFM,1071) 'ALGO_CONT       ',
     &                      ZR(JCMCF+ZCMCF*(IZONE-1)-1+3)
          WRITE (IFM,1071) 'COEF_FROT       ',
     &                      ZR(JCMCF+ZCMCF*(IZONE-1)-1+4)
          WRITE (IFM,1071) 'ALGO_FROT       ',
     &                      ZR(JCMCF+ZCMCF*(IZONE-1)-1+5)
          WRITE (IFM,1071) 'COULOMB         ',
     &                      ZR(JCMCF+ZCMCF*(IZONE-1)-1+6)
          WRITE (IFM,1071) 'SEUIL_INIT      ',
     &                      ZR(JCMCF+ZCMCF*(IZONE-1)-1+7)
          WRITE (IFM,1071) 'CONTACT_INIT    ',
     &                      ZR(JCMCF+ZCMCF*(IZONE-1)-1+8)
          WRITE (IFM,1071) 'GLISSIERE       ',
     &                      ZR(JCMCF+ZCMCF*(IZONE-1)-1+9)
          WRITE (IFM,1071) 'SANS_NOEUD      ',
     &                      ZR(JCMCF+ZCMCF*(IZONE-1)-1+10)
          WRITE (IFM,1071) 'SANS_NOEUD_FR   ',
     &                      ZR(JCMCF+ZCMCF*(IZONE-1)-1+11)
          WRITE (IFM,1071) 'EXCL_FROT_X     ',
     &                      ZR(JCMCF+ZCMCF*(IZONE-1)-1+12)
          WRITE (IFM,1071) 'USURE           ',
     &                      ZR(JCMCF+ZCMCF*(IZONE-1)-1+13)
          WRITE (IFM,1071) 'K               ',
     &                      ZR(JCMCF+ZCMCF*(IZONE-1)-1+14)
          WRITE (IFM,1071) 'H               ',
     &                      ZR(JCMCF+ZCMCF*(IZONE-1)-1+15)
          WRITE (IFM,1071) 'EXCLUSION_PIV_NUL',
     &                      ZR(JCMCF+ZCMCF*(IZONE-1)-1+16)
        ENDIF

 320  CONTINUE
C
C ---  MAILLES ESCLAVES
C
      WRITE (IFM,*) '<CONTACT> ... INFORMATIONS SUR MAILLES ESCLAVES'
C
      DO 900 IZONE = 1,NZOCO
        WRITE (IFM,*) '<CONTACT> ...... ZONE : ',IZONE
        JDECME = MMINFI(DEFICO,'JDECME',IZONE )
        NBMAE  = MMINFI(DEFICO,'NBMAE' ,IZONE )
        DO 901 IMAE = 1,NBMAE
          POSMAE = JDECME + IMAE

          CALL MMINFM(POSMAE,DEFICO,'NPTM',NPTM  )
          CALL CFNUMM(DEFICO,1     ,POSMAE,NUMMAE)
          CALL JENUNO(JEXNUM(MAILMA,NUMMAE),NOMMAE)
          WRITE (IFM,1080) NOMMAE

          WRITE (IFM,1070) 'ZONE            ',IZONE
          WRITE (IFM,1070) 'NB. PTS. INT.   ',NPTM

          CALL MMINFM(POSMAE,DEFICO,'NDEXFR',NDEXFR)

          WRITE (IFM,1070) 'NDEXFR          ',NDEXFR


 901    CONTINUE
 900  CONTINUE
 1080 FORMAT (' <CONTACT> ... MAILLE : ',A8)
C
C --- MENAGE
C
      CALL JEDETR('&&SURFC2.TRAVNO')
      CALL JEDETR('&&SURFC2.TRAVMA')
C
      CALL JEDEMA
      END
