      SUBROUTINE FONNO8 (RESU,NOMA,TABLEV,VNOR,VECT)
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*32 JEXNUM,JEXNOM
      CHARACTER*8         NOMA, RESU
      INTEGER             TABLEV(2)
      REAL*8              VECT(3),VNOR(2,3)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C       ----------------------------------------------------------------
C      DETERMINATION D'UN VECTEUR SE DIRIGEANT VERS LA LEVRE SUPERIEURE
C       ----------------------------------------------------------------
C    ENTREES
C       RESU   : NOM DU CONCEPT RESULTAT DE L'OPERATEUR
C       NOMA   : NOM DU MAILLAGE
C       TABLEV : VECTEUR CONTENANT LES NUMEROS DES DEUX MAILLES
C                CONNECTEES AU NOEUD SOMMET COURANT DU PREMIER SEGMENT
C                ET AUX LEVRES
C       VNOR   : VECTEUR NORMAL AU NOEUD SOMMET COURANT
C    SORTIE
C       VECT   : VECTEUR SE DIRIGEANT VERS LA LEVRE SUPERIEURE
C                IL SERT A REORIENTER LE VECTEUR NORMAL POUR QU'IL AILLE
C                DE LA LEVRE INF VERS LA LEVRE SUP
C
C
      INTEGER       COMP
      INTEGER       IAMASE,IATYMA,IFON,ILEV,INN,INN2,INP,IRET,ITYP,
     &              ITYPMA
      INTEGER       JCOOR,JCONX,JFON,JMALE
      INTEGER       NBLEV,NN,NN2,NBNOTT(3)
      REAL*8        XG,YG,ZG
      CHARACTER*8   K8B,TYPE

C     -----------------------------------------------------------------
C
      CALL JEMARQ()
C
C     RECUPERATION DES DONNES SUR LE MAILLAGE
      CALL JEVEUO (NOMA//'.TYPMAIL','L',IATYMA)
      CALL JEVEUO (NOMA//'.COORDO    .VALE', 'L', JCOOR)

      CALL JEVEUO (RESU//'.LEVRESUP.MAIL', 'L', JMALE )
      CALL JELIRA (RESU//'.LEVRESUP.MAIL', 'LONUTI', NBLEV, K8B)
C

C     DETERMINATION D'UN VECTEUR ALLANT DU PREMIER NOEUD DU FOND
C     FISSURE A UN NOEUD DE LA LEVRE_SUP

      DO 200 INP=1,2

        CALL JEVEUO(JEXNUM(NOMA//'.CONNEX',TABLEV(INP)),'L',JCONX)
        ITYPMA = IATYMA-1+TABLEV(INP)

        CALL JENUNO(JEXNUM('&CATA.TM.NOMTM',ZI(ITYPMA)),TYPE)
        CALL DISMOI('F','NBNO_TYPMAIL',TYPE,'TYPE_MAILLE',
     &                 NN2,K8B,IRET)

        DO 210 ILEV=1,NBLEV
          COMP = 0
          CALL JENONU(JEXNOM(NOMA//'.NOMMAI',ZK8(JMALE-1+ILEV)),IRET)
          CALL JEVEUO(JEXNUM(NOMA//'.CONNEX',IRET),'L',IAMASE)
          ITYP = IATYMA-1+IRET

          CALL JENUNO(JEXNUM('&CATA.TM.NOMTM',ZI(ITYP)),TYPE)
          CALL DISMOI('F','NBNO_TYPMAIL',TYPE,'TYPE_MAILLE',
     &                   NN,K8B,IRET)

          DO 220 INN=1,NN
            DO 230 INN2=1,NN2
              IF (ZI(JCONX-1+INN2).EQ.ZI(IAMASE-1 + INN)) THEN
                COMP=COMP+1
                IF (COMP .EQ. NN) GOTO 300
              ENDIF
  230       CONTINUE
  220     CONTINUE
  210   CONTINUE
  200 CONTINUE

  300 CONTINUE

C     CALCUL DES COORDONNEES DU CENTRE DE GRAVITE
      CALL PANBNO(ZI(ITYPMA),NBNOTT)

      XG=0
      YG=0
      ZG=0
      DO 240 INN2=1,NBNOTT(1)
        XG=XG+ZR(JCOOR-1 + (ZI(JCONX-1+INN2)-1)*3 + 1)
        YG=YG+ZR(JCOOR-1 + (ZI(JCONX-1+INN2)-1)*3 + 2)
        ZG=ZG+ZR(JCOOR-1 + (ZI(JCONX-1+INN2)-1)*3 + 3)
  240 CONTINUE

      CALL JEEXIN(RESU//'.FOND.NOEU',IFON)
      IF (IFON.NE.0) THEN
        CALL JEVEUO (RESU//'.FOND.NOEU', 'L', JFON )
      ELSE
        CALL JEVEUO (RESU//'.FOND_INF.NOEU', 'L', JFON )
      ENDIF
      CALL JENONU(JEXNOM(NOMA//'.NOMNOE',ZK8(JFON)),IRET)

      VECT(1) = XG/NBNOTT(1) - ZR(JCOOR-1 + (IRET-1)*3 + 1)
      VECT(2) = YG/NBNOTT(1) - ZR(JCOOR-1 + (IRET-1)*3 + 2)
      VECT(3) = ZG/NBNOTT(1) - ZR(JCOOR-1 + (IRET-1)*3 + 3)

      CALL JEDEMA()
      END
