      SUBROUTINE MBRIGI(FAMI,KPG,IMATE,RIG)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 04/09/2012   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================

C ----------------------------------------------------------------------
C      CALCUL DE LA MATRICE DE RIGIDITE POUR UN COMPORTEMENT
C                   DE MEMBRANE ANISOTROPE
C ----------------------------------------------------------------------
C IN  FAMI         FAMILLE D'ELEMENT
C IN  KPG          NUMERO DU POINT DE GAUSS
C IN  IMATE        IDENTIFIANT DU MATERIAU
C OUT RIG          MATRICE DE RIGIDITE MEMBRANAIRE
C ----------------------------------------------------------------------

      IMPLICIT NONE
      INTEGER  CODRES(7)
      CHARACTER*4  FAMI
      CHARACTER*8  NOMRES(7)
      CHARACTER*13 PHENOM
      INTEGER  KPG,IMATE,CODRET
      REAL*8   VALRES(7), RIG(3,3)

C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------

C - VERIFICATION DU COMPORTEMENT

      CALL RCCOMA(ZI(IMATE),'ELAS',PHENOM,CODRET)
      IF (PHENOM.NE.'ELAS_MEMBRANE') CALL ASSERT(.FALSE.)

C - RECUPERATION DES COMPOSANTES

      NOMRES(1) = 'M_LLLL'
      NOMRES(2) = 'M_LLTT'
      NOMRES(3) = 'M_LLLT'
      NOMRES(4) = 'M_TTTT'
      NOMRES(5) = 'M_TTLT'
      NOMRES(6) = 'M_LTLT'

      CALL RCVALB(FAMI,KPG,1,'+',ZI(IMATE),' ',PHENOM,
     &            0,' ',0.D0,6,
     &            NOMRES,VALRES,CODRES, 1)

C -  EN CAS DE PROBLEME AVEC LES VARIABLES DE COMMANDES

C      CALL RCVALA(ZI(IMATE),' ',PHENOM,
C     &            0,' ',0.D0,6,
C     &            NOMRES,VALRES,CODRES, 1)

C - CONSTRUCTION DE LA MATRICE DE RIGIDITE

      CALL R8INIR(3*3, 0.D0, RIG , 1)
      RIG(1,1) = VALRES(1)
      RIG(2,1) = VALRES(2)
      RIG(3,1) = VALRES(3)
      RIG(1,2) = VALRES(2)
      RIG(2,2) = VALRES(4)
      RIG(3,2) = VALRES(5)
      RIG(1,3) = VALRES(3)
      RIG(2,3) = VALRES(5)
      RIG(3,3) = VALRES(6)

      END
