      SUBROUTINE MMMLAV(LUSURE,LDYNA ,LFOVIT,PRFUSU,CWEAR ,
     &                  JEUSUP,NDEXFR,COEFAC,COEFAF)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      LOGICAL LUSURE,LFOVIT,LDYNA
      REAL*8  JEUSUP
      REAL*8  PRFUSU,CWEAR
      INTEGER NDEXFR
      REAL*8  COEFAC,COEFAF
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - CALCUL)
C
C PREPARATION DES CALCULS - LECTURE FONCTIONNALITES AVANCEES
C
C ----------------------------------------------------------------------
C
C
C OUT LUSURE : .TRUE. SI USURE ACTIVEE
C OUT LDYNA  : .TRUE. SI DYNAMIQUE
C OUT LFOVIT : .TRUE. SI FORMULATION EN VITESSE
C OUT PRFUSU : JEU SUPPLEMENTAIRE PAR PROFONDEUR D'USURE
C OUT CWEAR  : COEFFICIENT D'USURE
C OUT JEUSUP : JEU SUPPLEMENTAIRE PAR DIST_ESCL/DIST_MAIT
C OUT NDEXFR : ENTIER CODE POUR EXCLUSION DIRECTION DE FROTTEMENT
C I/O COEFAC : COEF_AUGM_CONT
C I/O COEFAF : COEF_AUGM_FROT
C
C
C
C
      INTEGER      JPCF,JUSUP
      INTEGER      IUSURE,IFORM
      REAL*8       KW,HW,THETA,DELTAT
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- RECUPERATION DES DONNEES DU CHAM_ELEM DU CONTACT
C
      CALL JEVECH('PCONFR','L',JPCF )
      JEUSUP   =      ZR(JPCF-1+14)
      IUSURE   = NINT(ZR(JPCF-1+21))
      KW       =      ZR(JPCF-1+22)
      HW       =      ZR(JPCF-1+23)
      NDEXFR   = NINT(ZR(JPCF-1+24))
      IFORM    = NINT(ZR(JPCF-1+25))
      DELTAT   =      ZR(JPCF-1+26)
      THETA    =      ZR(JPCF-1+27)
C
C --- FONCTIONNALITES ACTIVEES
C
      LUSURE   = IUSURE.EQ.1
      LFOVIT   = IFORM.EQ.2
      LDYNA    = IFORM.NE.0
C
C --- RECUPERATION JEU USURE
C
      IF (LUSURE) THEN
        CALL JEVECH('PUSULAR','L',JUSUP )
        PRFUSU = ZR(JUSUP-1+1)
      ELSE
        PRFUSU = 0.D0
      END IF
C
      IF (HW.NE.0.D0) THEN
        CWEAR = KW/HW
      ELSE
        CWEAR = 0.D0
      ENDIF
C
C --- COEFFICIENTS MODIFIES POUR FORMULATION EN THETA-VITESSE
C
      IF (LFOVIT) THEN
        COEFAF = COEFAF/DELTAT/THETA
        COEFAC = COEFAC/DELTAT/THETA
      ENDIF
C
      CALL JEDEMA()
      END
