      SUBROUTINE MMMSTA(NDIM  ,LELTF ,LPENAF,LOPTF ,DJEUT ,
     &                  DLAGRF,COEFAF,COEFFF,TAU1  ,TAU2  ,
     &                  LCONT ,LADHE ,LAMBDA,RESE  ,NRESE )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      INTEGER      NDIM
      REAL*8       DLAGRF(2),DJEUT(3)      
      LOGICAL      LOPTF,LPENAF,LELTF
      REAL*8       TAU1(3),TAU2(3) 
      LOGICAL      LCONT,LADHE
      REAL*8       RESE(3),NRESE,LAMBDA
      REAL*8       COEFAF,COEFFF
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - CALCUL)
C
C PREPARATION DES CALCULS - LECTURE DES STATUTS
C
C ----------------------------------------------------------------------
C
C
C IN  NDIM   : DIMENSION DE L'ESPACE
C IN  LPENAF : .TRUE. SI FROTTEMENT PENALISE
C IN  LELTF  : .TRUE. SI ELEMENT DE FROTTEMENT
C IN  LOPTF  : .TRUE. SI OPTION DE FROTTEMENT
C IN  DLAGRF : INCREMENT DEPDEL DES LAGRANGIENS DE FROTTEMENT
C IN  DJEUT  : INCREMENT DEPDEL DU JEU TANGENT
C IN  COEFAF : COEF_AUGM_FROT
C IN  COEFFF : COEFFICIENT DE FROTTEMENT DE COULOMB
C IN  TAU1   : PREMIER VECTEUR TANGENT
C IN  TAU2   : SECOND VECTEUR TANGENT
C OUT LCONT  : .TRUE. SI CONTACT (SU=1)
C OUT LADHE  : .TRUE. SI ADHERENCE
C OUT LAMBDA : VALEUR DU MULT. DE CONTACT (SEUIL FIXE)
C OUT RESE   : SEMI-MULTIPLICATEUR GTK DE FROTTEMENT 
C               GTK = LAMBDAF + COEFAF*VITESSE
C OUT NRESE  : NORME DU SEMI-MULTIPLICATEUR GTK DE FROTTEMENT
C 
C
C
C
      INTEGER      JPCF
      INTEGER      INDCO
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      LCONT   = .FALSE.
      LADHE   = .FALSE.
      NRESE   = 0.D0
      RESE(1) = 0.D0
      RESE(2) = 0.D0
      RESE(3) = 0.D0      
C
C --- RECUPERATION DES STATUTS
C
      CALL JEVECH('PCONFR','L',JPCF )
      INDCO    = NINT(ZR(JPCF-1+12))
C
C --- STATUT DU CONTACT
C
      LCONT    = INDCO.EQ.1
C
C --- PAS DE FROTTEMENT SI CALCUL OPTION CONTACT
C
      IF (.NOT.LOPTF) THEN
        LELTF = .FALSE.
      ENDIF
C
C --- STATUT DU CONTACT - CAS DU FROTTEMENT
C
      IF (LOPTF) THEN
        IF (COEFFF.EQ.0.D0) LCONT = .FALSE.
        IF (LAMBDA.EQ.0.D0) LCONT = .FALSE.
        IF (.NOT.LELTF)     LCONT = .FALSE.
      ENDIF  
C
C --- ETAT D'ADHERENCE DU POINT DE CONTACT
C  
      IF (LOPTF.AND.LCONT) THEN
        CALL MMTRPR(NDIM  ,LPENAF,DJEUT ,DLAGRF,COEFAF,
     &              TAU1  ,TAU2  ,LADHE ,RESE  ,NRESE )
      ENDIF
C
      CALL JEDEMA()
C
      END
