      SUBROUTINE MMTAPE(PHASEP,LELTF ,NDIM  ,NNL   ,NNE   ,
     &                  NNM   ,NBCPS ,WPG   ,JACOBI,FFL   ,
     &                  FFE   ,FFM   ,NORM  ,TAU1  ,TAU2  ,
     &                  MPROJT,RESE  ,NRESE ,LAMBDA,COEFFF,
     &                  COEFAF,COEFAC,MATRCC,MATRFF,MATRCE,
     &                  MATRCM,MATRFE,MATRFM)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 23/04/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C TOLE CRP_21
C
      IMPLICIT NONE
      CHARACTER*9  PHASEP
      LOGICAL      LELTF
      INTEGER      NDIM,NNE,NNL,NNM,NBCPS
      REAL*8       FFE(9),FFL(9),FFM(9)
      REAL*8       WPG,JACOBI
      REAL*8       TAU1(3),TAU2(3),NORM(3)
      REAL*8       RESE(3),NRESE
      REAL*8       MPROJT(3,3)
      REAL*8       LAMBDA
      REAL*8       COEFAF,COEFFF
      REAL*8       COEFAC
      REAL*8       MATRCC(9,9),MATRFF(18,18)
      REAL*8       MATRCE(9,27),MATRCM(9,27)
      REAL*8       MATRFE(18,27),MATRFM(18,27)
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - CALCUL)
C
C CALCUL DES MATRICES - LOIS DE CONTACT/FROTTEMENT - CAS POIN_ELEM
C
C ----------------------------------------------------------------------
C
C
C IN  PHASEP : 'SANS' - PAS DE CONTACT
C              'CONT' - CONTACT
C              'ADHE' - CONTACT ADHERENT
C              'GLIS' - CONTACT GLISSANT
C              'SANS_PENA' - PENALISATION - PAS DE CONTACT
C              'CONT_PENA' - PENALISATION - CONTACT
C              'ADHE_PENA' - PENALISATION - CONTACT ADHERENT
C              'GLIS_PENA' - PENALISATION - CONTACT GLISSANT
C IN  LELTF  : .TRUE. SI ELEMENT COMPORTANT DES DDL DE FROTTEMENT
C IN  NDIM   : DIMENSION DU PROBLEME
C IN  NNE    : NOMBRE DE NOEUDS DE LA MAILLE ESCLAVE
C IN  NNM    : NOMBRE DE NOEUDS DE LA MAILLE MAITRE
C IN  NNL    : NOMBRE DE NOEUDS DE LAGRANGE
C IN  NBCPS  : NB DE DDL DE LAGRANGE
C IN  WPG    : POIDS DU POINT INTEGRATION DU POINT DE CONTACT
C IN  FFE    : FONCTIONS DE FORMES DEPL. ESCL.
C IN  FFL    : FONCTIONS DE FORMES LAGR.
C IN  FFM    : FONCTIONS DE FORMES DEPL. MAIT.
C IN  NORM   : VECTEUR NORMAL
C IN  TAU1   : PREMIER VECTEUR TANGENT
C IN  TAU2   : SECOND VECTEUR TANGENT
C IN  MPROJT : MATRICE DE PROJECTION TANGENTE [Pt]
C IN  JACOBI : JACOBIEN DE LA MAILLE AU POINT DE CONTACT
C IN  RESE   : SEMI-MULTIPLICATEUR GTK DE FROTTEMENT
C               GTK = LAMBDAF + COEFAF*VITESSE
C IN  NRESE  : RACINE DE LA NORME DE RESE
C IN  LAMBDA : LAGRANGIEN DE CONTACT
C IN  COEFFF : COEFFICIENT DE FROTTEMENT DE COULOMB
C IN  COEFAC : COEF_AUGM_CONT
C IN  COEFAF : COEF_AUGM_FROT
C OUT MATRCC : MATRICE ELEMENTAIRE LAGR_C/LAGR_C
C OUT MATRFF : MATRICE ELEMENTAIRE LAGR_F/LAGR_F
C OUT MATRCE : MATRICE ELEMENTAIRE LAGR_C/DEPL_E
C OUT MATRCM : MATRICE ELEMENTAIRE LAGR_C/DEPL_M
C OUT MATRFE : MATRICE ELEMENTAIRE LAGR_F/DEPL_E
C OUT MATRFM : MATRICE ELEMENTAIRE LAGR_F/DEPL_M
C
C ----------------------------------------------------------------------
C
      IF (PHASEP(1:4).EQ.'SANS') THEN
        IF (LELTF) THEN
          CALL MMMTFF(PHASEP,NDIM  ,NBCPS ,NNL   ,WPG   ,
     &                FFL   ,JACOBI,TAU1  ,TAU2  ,RESE  ,
     &                NRESE ,LAMBDA,COEFAF,COEFFF,MATRFF)
        ELSE
          CALL MMMTCC(PHASEP,NNL   ,WPG   ,FFL   ,JACOBI,
     &                COEFAC,MATRCC)
        ENDIF
      ELSEIF (PHASEP(1:4).EQ.'CONT') THEN
        CALL MMMTCU(PHASEP,NDIM  ,NNL   ,NNE   ,NNM   ,
     &              NORM  ,WPG   ,FFL   ,FFE   ,FFM   ,
     &              JACOBI,MATRCE,MATRCM)
        IF (PHASEP(6:9).EQ.'PENA') THEN
          CALL MMMTCC(PHASEP,NNL   ,WPG   ,FFL   ,JACOBI,
     &                COEFAC,MATRCC)
        ENDIF
      ELSEIF (PHASEP(1:4).EQ.'ADHE') THEN
        CALL MMMTFU(PHASEP,NDIM  ,NNL   ,NNE   ,NNM   ,
     &              NBCPS ,WPG   ,JACOBI,FFL   ,FFE   ,
     &              FFM   ,TAU1  ,TAU2  ,MPROJT,RESE  ,
     &              NRESE ,LAMBDA,COEFFF,MATRFE,MATRFM)
        IF (PHASEP(6:9).EQ.'PENA') THEN
          CALL MMMTFF(PHASEP,NDIM  ,NBCPS ,NNL   ,WPG   ,
     &                FFL   ,JACOBI,TAU1  ,TAU2  ,RESE  ,
     &                NRESE ,LAMBDA,COEFAF,COEFFF,MATRFF)
        ENDIF
      ELSEIF (PHASEP(1:4).EQ.'GLIS') THEN
        CALL MMMTFF(PHASEP,NDIM  ,NBCPS ,NNL   ,WPG   ,
     &              FFL   ,JACOBI,TAU1  ,TAU2  ,RESE  ,
     &              NRESE ,LAMBDA,COEFAF,COEFFF,MATRFF)
        CALL MMMTFU(PHASEP,NDIM  ,NNL   ,NNE   ,NNM   ,
     &              NBCPS ,WPG   ,JACOBI,FFL   ,FFE   ,
     &              FFM   ,TAU1  ,TAU2  ,MPROJT,RESE  ,
     &              NRESE ,LAMBDA,COEFFF,MATRFE,MATRFM)
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF

C
      END
