      SUBROUTINE MMTFPE(PHASEP,IRESOF,NDIM  ,NNE   ,NNM   ,
     &                  NNL   ,NBCPS ,WPG   ,JACOBI,FFL   ,
     &                  FFE   ,FFM   ,DFFM  ,NORM  ,TAU1  ,
     &                  TAU2  ,MPROJN,MPROJT,RESE  ,NRESE ,
     &                  LAMBDA,JEU   ,COEFFF,COEFAF,COEFAC,
     &                  DLAGRC,DLAGRF,DJEUT ,MATREE,MATRMM,
     &                  MATREM,MATRME,MATREC,MATRMC,MATREF,
     &                  MATRMF)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 25/06/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C TOLE CRP_21
C
      IMPLICIT     NONE
      CHARACTER*9  PHASEP
      INTEGER      NDIM,NNE,NNM,NNL,NBCPS
      INTEGER      IRESOF
      REAL*8       NORM(3),TAU1(3),TAU2(3)
      REAL*8       MPROJN(3,3),MPROJT(3,3)
      REAL*8       FFE(9),FFM(9),FFL(9)
      REAL*8       WPG,JACOBI,DFFM(2,9)
      REAL*8       RESE(3),NRESE
      REAL*8       COEFAC,COEFAF
      REAL*8       LAMBDA,COEFFF,JEU
      REAL*8       DLAGRF(2),DLAGRC
      REAL*8       DJEUT(3)
      REAL*8       MATREM(27,27),MATRME(27,27)
      REAL*8       MATREE(27,27),MATRMM(27,27)
      REAL*8       MATREC(27,9) ,MATRMC(27,9)
      REAL*8       MATRMF(27,18),MATREF(27,18)
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - CALCUL)
C
C CALCUL DES MATRICES - EQUATION EQUILIBRE - CAS POIN_ELEM
C
C ----------------------------------------------------------------------
C
C
C IN  PHASEP : 'SANS' - PAS DE CONTACT
C              'CONT' - CONTACT
C              'ADHE' - CONTACT ADHERENT
C              'GLIS' - CONTACT GLISSANT
C              'SANS_PENA' - PENALISATION - PAS DE CONTACT
C              'CONT_PENA' - PENALISATION - CONTACT
C              'ADHE_PENA' - PENALISATION - CONTACT ADHERENT
C              'GLIS_PENA' - PENALISATION - CONTACT GLISSANT
C IN  NDIM   : DIMENSION DU PROBLEME
C IN  NBCPS  : NB DE DDL DE LAGRANGE
C IN  NNE    : NOMBRE DE NOEUDS DE LA MAILLE ESCLAVE
C IN  NNM    : NOMBRE DE NOEUDS DE LA MAILLE MAITRE
C IN  NNL    : NOMBRE DE NOEUDS DE LAGRANGE
C IN  NORM   : NORMALE AU POINT DE CONTACT
C IN  TAU1   : PREMIER VECTEUR TANGENT
C IN  TAU2   : SECOND VECTEUR TANGENT
C IN  MPROJN : MATRICE DE PROJECTION NORMALE [Pn]
C IN  MPROJT : MATRICE DE PROJECTION TANGENTE [Pt]
C IN  WPG    : POIDS DU POINT INTEGRATION DU POINT DE CONTACT
C IN  FFE    : FONCTIONS DE FORMES DEPL. ESCL.
C IN  FFL    : FONCTIONS DE FORMES LAGR.
C IN  FFM    : FONCTIONS DE FORMES DEPL. MAIT.
C IN  JACOBI : JACOBIEN DE LA MAILLE AU POINT DE CONTACT
C IN  COEFFF : COEFFICIENT DE FROTTEMENT DE COULOMB
C IN  COEFAC : COEF_AUGM_CONT
C IN  COEFAF : COEF_AUGM_FROT
C IN  DLAGRF : INCREMENT DEPDEL DES LAGRANGIENS DE FROTTEMENT
C IN  DJEUT  : INCREMENT DEPDEL DU JEU TANGENT
C IN  LAMBDA : LAGRANGIEN DE CONTACT
C IN  IRESOF : ALGO. DE RESOLUTION POUR LE FROTTEMENT
C              0 - POINT FIXE
C              1 - NEWTON PARTIEL
C              2 - NEWTON COMPLET
C IN  RESE   : SEMI-MULTIPLICATEUR GTK DE FROTTEMENT
C               GTK = LAMBDAF + COEFAF*VITESSE
C IN  NRESE  : NORME DU SEMI-MULTIPLICATEUR GTK DE FROTTEMENT
C OUT MATREC : MATRICE ELEMENTAIRE DEPL_E/LAGR_C
C OUT MATRMC : MATRICE ELEMENTAIRE DEPL_M/LAGR_C
C OUT MATREF : MATRICE ELEMENTAIRE DEPL_E/LAGR_F
C OUT MATRMF : MATRICE ELEMENTAIRE DEPL_M/LAGR_F
C OUT MATREE : MATRICE ELEMENTAIRE DEPL_E/DEPL_E
C OUT MATRMM : MATRICE ELEMENTAIRE DEPL_M/DEPL_M
C OUT MATRME : MATRICE ELEMENTAIRE DEPL_M/DEPL_E
C OUT MATREM : MATRICE ELEMENTAIRE DEPL_E/DEPL_M
C
C ----------------------------------------------------------------------
C
      LOGICAL   LNEWTG
      REAL*8    H11T1N(3,3),H12T2N(3,3)
      REAL*8    H21T1N(3,3),H22T2N(3,3)
C
C ----------------------------------------------------------------------
C
      LNEWTG = .FALSE.
C
      CALL MATINI(3,3,0.D0,H11T1N)
      CALL MATINI(3,3,0.D0,H12T2N)
      CALL MATINI(3,3,0.D0,H21T1N)
      CALL MATINI(3,3,0.D0,H22T2N)

      IF (PHASEP(1:4).EQ.'CONT') THEN
        CALL MMMTUC(PHASEP,NDIM  ,NNL   ,NNE   ,NNM   ,
     &              NORM  ,TAU1  ,TAU2  ,MPROJT,WPG   ,
     &              FFL   ,FFE   ,FFM   ,JACOBI,COEFFF,
     &              COEFAF,DLAGRF,DJEUT ,RESE  ,NRESE ,
     &              MATREC,MATRMC)
        CALL MMMTUU(PHASEP,LNEWTG,NDIM  ,NNE   ,NNM   ,
     &              MPROJN,MPROJT,WPG   ,FFE   ,FFM   ,
     &              DFFM  ,JACOBI,COEFAC,COEFAF,COEFFF,
     &              RESE  ,NRESE ,LAMBDA,JEU   ,DLAGRC,
     &              H11T1N,H12T2N,H21T1N,H22T2N,MATREE,
     &              MATRMM,MATREM,MATRME)
      ELSEIF (PHASEP(1:4).EQ.'ADHE') THEN
        CALL MMMTUF(PHASEP,NDIM  ,NNL   ,NNE   ,NNM   ,
     &              NBCPS ,WPG   ,JACOBI,FFL   ,FFE   ,
     &              FFM   ,TAU1  ,TAU2  ,MPROJT,RESE  ,
     &              NRESE ,LAMBDA,COEFFF,MATREF,MATRMF)
        CALL MMMTUU(PHASEP,LNEWTG,NDIM  ,NNE   ,NNM   ,
     &              MPROJN,MPROJT,WPG   ,FFE   ,FFM   ,
     &              DFFM  ,JACOBI,COEFAC,COEFAF,COEFFF,
     &              RESE  ,NRESE ,LAMBDA,JEU   ,DLAGRC,
     &              H11T1N,H12T2N,H21T1N,H22T2N,MATREE,
     &              MATRMM,MATREM,MATRME)
        IF (IRESOF.GE.1) THEN
          CALL MMMTUC(PHASEP,NDIM  ,NNL   ,NNE   ,NNM   ,
     &                NORM  ,TAU1  ,TAU2  ,MPROJT,WPG   ,
     &                FFL   ,FFE   ,FFM   ,JACOBI,COEFFF,
     &                COEFAF,DLAGRF,DJEUT ,RESE  ,NRESE ,
     &                MATREC,MATRMC)
        ENDIF
      ELSEIF (PHASEP(1:4).EQ.'GLIS') THEN
        CALL MMMTUU(PHASEP,LNEWTG,NDIM  ,NNE   ,NNM   ,
     &              MPROJN,MPROJT,WPG   ,FFE   ,FFM   ,
     &              DFFM  ,JACOBI,COEFAC,COEFAF,COEFFF,
     &              RESE  ,NRESE ,LAMBDA,JEU   ,DLAGRC,
     &              H11T1N,H12T2N,H21T1N,H22T2N,MATREE,
     &              MATRMM,MATREM,MATRME)
        CALL MMMTUF(PHASEP,NDIM  ,NNL   ,NNE   ,NNM   ,
     &              NBCPS ,WPG   ,JACOBI,FFL   ,FFE   ,
     &              FFM   ,TAU1  ,TAU2  ,MPROJT,RESE  ,
     &              NRESE ,LAMBDA,COEFFF,MATREF,MATRMF)
        IF (IRESOF.GE.1) THEN
          CALL MMMTUC(PHASEP,NDIM  ,NNL   ,NNE   ,NNM   ,
     &                NORM  ,TAU1  ,TAU2  ,MPROJT,WPG   ,
     &                FFL   ,FFE   ,FFM   ,JACOBI,COEFFF,
     &                COEFAF,DLAGRF,DJEUT ,RESE  ,NRESE ,
     &                MATREC,MATRMC)
        ENDIF
      ENDIF
C
      END
