      SUBROUTINE MMTGEO(PHASEP,NDIM  ,NNE   ,NNM   ,MPROJN,
     &                  MPROJT,WPG   ,FFE   ,FFM   ,DFFM  ,
     &                  JACOBI,COEFAC,COEFAF,COEFFF,RESE  ,
     &                  NRESE ,LAMBDA,JEU   ,DLAGRC,MPRT1N,
     &                  MPRT2N,GENE11,GENE21,MATREE,MATRMM,
     &                  MATREM,MATRME)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 25/06/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C TOLE CRP_21
C
      IMPLICIT     NONE
      CHARACTER*9  PHASEP
      INTEGER      NDIM,NNE,NNM
      REAL*8       MPROJN(3,3),MPROJT(3,3)
      REAL*8       FFE(9),FFM(9),DFFM(2,9)
      REAL*8       WPG,JACOBI
      REAL*8       RESE(3),NRESE
      REAL*8       COEFAC,COEFAF
      REAL*8       LAMBDA,COEFFF,JEU
      REAL*8       DLAGRC
      REAL*8       MPRT1N(3,3),MPRT2N(3,3)
      REAL*8       GENE11(3,3),GENE21(3,3)
      REAL*8       MATREM(27,27),MATRME(27,27)
      REAL*8       MATREE(27,27),MATRMM(27,27)
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE CONTINUE - CALCUL)
C
C CALCUL DES MATRICES - EQUATION EQUILIBRE - CAS POIN_ELEM
C
C ----------------------------------------------------------------------
C
C
C IN  PHASEP : PHASE DE CALCUL
C              'CONT'      - CONTACT
C              'CONT_PENA' - CONTACT PENALISE
C              'ADHE'      - ADHERENCE
C              'ADHE_PENA' - ADHERENCE PENALISE
C              'GLIS'      - GLISSEMENT
C              'GLIS_PENA' - GLISSEMENT PENALISE
C IN  NDIM   : DIMENSION DU PROBLEME
C IN  NNE    : NOMBRE DE NOEUDS DE LA MAILLE ESCLAVE
C IN  NNM    : NOMBRE DE NOEUDS DE LA MAILLE MAITRE
C IN  MPROJN : MATRICE DE PROJECTION NORMALE [Pn]
C IN  MPROJT : MATRICE DE PROJECTION TANGENTE [Pt]
C IN  WPG    : POIDS DU POINT INTEGRATION DU POINT DE CONTACT
C IN  FFE    : FONCTIONS DE FORMES DEPL. ESCL.
C IN  FFM    : FONCTIONS DE FORMES DEPL. MAIT.
C IN  DFFM   : DERIVEES PREMIERES DES FONCTIONS DE FORME MAITRES
C IN  JACOBI : JACOBIEN DE LA MAILLE AU POINT DE CONTACT
C IN  COEFAC : COEF_AUGM_CONT
C IN  COEFAF : COEF_AUGM_FROT
C IN  LAMBDA : LAGRANGIEN DE CONTACT
C IN  DLAGRC : INCREMENT DEPDEL DU LAGRANGIEN DE CONTACT
C IN  DJEU   : INCREMENT DEPDEL DU JEU
C IN  RESE   : SEMI-MULTIPLICATEUR GTK DE FROTTEMENT
C               GTK = LAMBDAF + COEFAF*VITESSE
C IN  NRESE  : NORME DU SEMI-MULTIPLICATEUR GTK DE FROTTEMENT
C IN  COEFFF : COEFFICIENT DE FROTTEMENT DE COULOMB
C IN  MPRT1N : MATRICE DE PROJECTION TANGENTE1/NORMALE
C IN  MPRT2N : MATRICE DE PROJECTION TANGENTE2/NORMALE
C IN  GENE11 : MATRICE
C IN  GENE12 : MATRICE
C IN  GENE21 : MATRICE
C IN  GENE22 : MATRICE
C OUT MATREE : MATRICE ELEMENTAIRE DEPL_E/DEPL_E
C OUT MATRMM : MATRICE ELEMENTAIRE DEPL_M/DEPL_M
C OUT MATRME : MATRICE ELEMENTAIRE DEPL_M/DEPL_E
C OUT MATREM : MATRICE ELEMENTAIRE DEPL_E/DEPL_M
C
C ----------------------------------------------------------------------
C
      INTEGER   I,K,L
      LOGICAL   LNEWTG
      REAL*8    H11T1N(3,3),H12T2N(3,3)
      REAL*8    H21T1N(3,3),H22T2N(3,3)
C
C ----------------------------------------------------------------------
C
      LNEWTG = .TRUE.
C
      CALL MATINI(3,3,0.D0,H11T1N)
      CALL MATINI(3,3,0.D0,H12T2N)
      CALL MATINI(3,3,0.D0,H21T1N)
      CALL MATINI(3,3,0.D0,H22T2N)
C
      DO 51 L = 1,NDIM
        DO 52 K = 1,NDIM
          DO 53 I = 1,NDIM
            H11T1N(L,K) = GENE11(L,I)*MPRT1N(I,K) + H11T1N(L,K)
            H11T1N(L,K) = GENE11(L,I)*MPRT2N(I,K) + H11T1N(L,K)
C            H12T1N(L,K) = GENE12(L,I)*MPRT1N(I,K) + H12T1N(L,K)
C            H12T1N(L,K) = GENE12(L,I)*MPRT2N(I,K) + H12T1N(L,K)
            H21T1N(L,K) = GENE21(L,I)*MPRT1N(I,K) + H21T1N(L,K)
            H21T1N(L,K) = GENE21(L,I)*MPRT2N(I,K) + H21T1N(L,K)
C            H22T1N(L,K) = GENE22(L,I)*MPRT1N(I,K) + H22T1N(L,K)
C            H22T1N(L,K) = GENE22(L,I)*MPRT2N(I,K) + H22T1N(L,K)
53        CONTINUE
52      CONTINUE
51    CONTINUE
C
C --- CONTRIBUTIONS MATRICE GEOMETRIQUE
C
      IF (PHASEP(1:4).NE.'SANS') THEN
        CALL MMMTUU(PHASEP,LNEWTG,NDIM  ,NNE   ,NNM   ,
     &              MPROJN,MPROJT,WPG   ,FFE   ,FFM   ,
     &              DFFM  ,JACOBI,COEFAC,COEFAF,COEFFF,
     &              RESE  ,NRESE ,LAMBDA,JEU   ,DLAGRC,
     &              H11T1N,H12T2N,H21T1N,H22T2N,MATREE,
     &              MATRMM,MATREM,MATRME)
      ENDIF
C
      END
