      SUBROUTINE MPPFFN(ZIMAT,NMNBN,NMPLAS,NMZEF,NMZEG,NMIEF,NORMM)
        IMPLICIT NONE
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 22/05/2012   AUTEUR SFAYOLLE S.FAYOLLE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C     CALCUL LES VALEURS DES MOMENTS LIMITES DE PLASTICITE
C     ET CALCUL LES ZEROS ADIMENSIONNELS POUR LES CRITERES
C
C IN  ZIMAT : ADRESSE DE LA LISTE DE MATERIAU CODE
C IN  NMNBN : EFFORT - EFFORT DE RAPPEL
C IN  NORMM : NORME SUR LA FONCTION MP = F(N)
C
C OUT NMZEF : ZERO ADIMENSIONNEL POUR LE CRITERE F
C OUT NMZEG : ZERO ADIMENSIONNEL POUR LE CRITERE G
C OUT NMIEF : NMIEF > 0 : NBN HORS DE LA ZONE DE DEFINITION DE MP
C OUT NMPLAS : MOMENTS LIMITES DE PLASTICITE

      INTEGER I, IER, NMIEF, ZIMAT, ICODRE(4)

      REAL*8 NMNBN(6), NMPLAS(2,3)
      REAL*8 NMZEF, NMZEG, ZERO, NORMM
      REAL*8 VALRES(4)

      CHARACTER*8 NOMRES(4)

      ZERO = 1.0D-6
      NMIEF = 0

      NOMRES(1)='MPCST'

      CALL RCVALB('FPG1',1,1,'+',ZIMAT,' ','GLRC_DAMAGE',0,' ',0.D0,
     &            1,NOMRES,VALRES,ICODRE,1)

      IF (VALRES(1) .EQ. 0.D0) THEN
        NOMRES(1)='MAXMP1'
        NOMRES(2)='MAXMP2'
        NOMRES(3)='MINMP1'
        NOMRES(4)='MINMP2'

        CALL RCVALB('FPG1',1,1,'+',ZIMAT,' ','GLRC_DAMAGE',0,' ',0.D0,
     &            4,NOMRES,VALRES,ICODRE,1)

        NMPLAS(1,1)=VALRES(1)
        NMPLAS(1,2)=VALRES(2)
        NMPLAS(1,3)=0.D0
        NMPLAS(2,1)=VALRES(3)
        NMPLAS(2,2)=VALRES(4)
        NMPLAS(2,3)=0.D0
      ELSE
        NOMRES(1) = 'FMEX1'
        NOMRES(2) = 'FMEX2'
        NOMRES(3) = 'FMEY1'
        NOMRES(4) = 'FMEY2'
        DO 20, I = 1,2
          CALL CDNFON(ZIMAT,NOMRES(2*(I-1)+1),NMNBN(I),0,
     &                NMPLAS(1,I),IER)
          NMIEF = NMIEF + IER

          CALL CDNFON(ZIMAT,NOMRES(2*I),NMNBN(I),0,
     &                NMPLAS(2,I),IER)
          NMIEF = NMIEF + IER
 20     CONTINUE
      ENDIF

      NMZEF = ZERO * (NORMM**2)
      NMZEG = ZERO * NORMM

      END
