      SUBROUTINE NMCB2(EPS,BETA1,EB,D1,SIGF1,BETA2,D2,SIGMA)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 23/07/2012   AUTEUR FLEJOU J-L.FLEJOU 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
C --- ------------------------------------------------------------------
C     LABORDERIE 1D : CALCUL DE SIGMA DANS LE CAS 2
C
C     EPS   : IN     : DEFORMATION
C     EB    : IN     : MODULE BETON
C     BETA1 : IN     : COEFFICIENT BETA1 DE LA LOI
C     BETA2 : IN     : COEFFICIENT BETA2 DE LA LOI
C     D1    : IN     : ENDOMMAGEMENT
C     D2    : IN     : ENDOMMAGEMENT
C     SIGF1 : IN     : CONTRAINTE DE REFERMETURE DES FISSURES
C     SIGMA : OUT    : CONTRAINTE
C
C --- ------------------------------------------------------------------
      REAL*8      EPS,BETA1,EB,D1,SIGF1,BETA2,D2,SIGMA
      REAL*8      FPRIM,TITI,TOTO,UN,ESEC
      PARAMETER  (UN=1.0D0)

C     MODULE SECANT DE COMPRESSION
      ESEC = EB*(UN-D2)
C
      TITI  = SIGF1 + BETA1*D1*(UN-D2)/(UN-D1)
      TOTO  = BETA1*D1*(UN-D2)/(UN-D1)
      FPRIM = (ESEC*EPS-BETA2*D2+SIGF1)/TITI
C --- CONTRAINTE
      SIGMA = ESEC*EPS - BETA2*D2 - TOTO*FPRIM
      END
