      SUBROUTINE PMFRIG(NOMTE,ICDMAT,KLV)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*(*) NOMTE
      INTEGER ICDMAT
      REAL*8 KLV(*)
C     ------------------------------------------------------------------
C     CALCULE LA MATRICE DE RIGIDITE DES ELEMENTS DE POUTRE MULTIFIBRES

C IN  NOMTE : NOM DU TYPE ELEMENT
C             'MECA_POU_D_EM'
C     ------------------------------------------------------------------

      CHARACTER*8  NOMAIL
      CHARACTER*16 CH16
      INTEGER LX,LSECT,IADZI,IAZK24
      REAL*8 G,XJX,GXJX,XL,ZERO,CASECT(6)
      PARAMETER(ZERO=0.0D0)
C     ------------------------------------------------------------------

C        --- POUTRE DROITE D'EULER A 6 DDL ---
      IF (NOMTE.NE.'MECA_POU_D_EM') THEN
        CH16 = NOMTE
        CALL U2MESK('F','ELEMENTS2_42',1,CH16)
      END IF

C    --- APPEL INTEGRATION SUR SECTION ET CALCUL G TORSION
      CALL PMFITX(ICDMAT,1,CASECT,G)

C     --- RECUPERATION DE LA CONSTANTE DE TORSION
C     --- (A PARTIR DES CARACTERISTIQUES GENERALES DES SECTIONS
C          POUR L'INSTANT)
      CALL JEVECH('PCAGNPO','L',LSECT)
      XJX = ZR(LSECT+7)
      GXJX = G*XJX

C     --- RECUPERATION DES COORDONNEES DES NOEUDS ---
      CALL JEVECH('PGEOMER','L',LX)
      LX = LX - 1
      XL = SQRT((ZR(LX+4)-ZR(LX+1))**2+ (ZR(LX+5)-ZR(LX+2))**2+
     &     (ZR(LX+6)-ZR(LX+3))**2)
      IF (XL.EQ.ZERO) THEN
        CALL TECAEL(IADZI,IAZK24)
        NOMAIL = ZK24(IAZK24-1+3)(1:8)
        CALL U2MESK('F','ELEMENTS2_43',1,NOMAIL)
      END IF

C     --- CALCUL DE LA MATRICE DE RIGIDITE LOCALE
C        --- POUTRE DROITE A SECTION CONSTANTE ---
      CALL PMFK01(CASECT,GXJX,XL,KLV)


      END
