      FUNCTION RESTZO(ZIMAT,NMNBN,BEND,NORMM,NORMN)
      IMPLICIT NONE
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 22/05/2012   AUTEUR SFAYOLLE S.FAYOLLE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C     CALCUL LA FONCTION INDIQUANT SI ON EST PROCHE DU SOMMET DU CONE
C
C IN  ZIMAT : ADRESSE DE LA LISTE DE MATERIAU CODE
C IN  NMNBN : FORCE - BACKFORCE
C IN  BEND : FLEXION POSITIVE (1) OU NEGATIVE (-1)
C IN  NORMM : NORME SUR LA FONCTION MP = F(N)
C IN  NORMN : NORME SUR LA FONCTION MP = F(N)
C
C OUT RESTZO : FONCTION INDIQUANT SI ON EST PROCHE DU SOMMET DU CONE

      INTEGER I, ZIMAT, RESTZO, BEND, ICODRE(4)

      REAL*8 NMNBN(6), DX, DY, DISTFO, NORMN, NORMM, MPCSTE(2)
      REAL*8 VALRES(4)

      CHARACTER*8 NOMRES(4),KPFONC(2)

      RESTZO = 0

      NOMRES(1)='MPCST'

      CALL RCVALB('FPG1',1,1,'+',ZIMAT,' ','GLRC_DAMAGE',0,' ',0.D0,
     &            1,NOMRES,VALRES,ICODRE,1)

      IF (VALRES(1) .EQ. 0.D0) THEN
        NOMRES(1)='MAXMP1'
        NOMRES(2)='MAXMP2'
        NOMRES(3)='MINMP1'
        NOMRES(4)='MINMP2'

        CALL RCVALB('FPG1',1,1,'+',ZIMAT,' ','GLRC_DAMAGE',0,' ',0.D0,
     &            4,NOMRES,VALRES,ICODRE,1)

        IF(BEND .EQ. 1) THEN
          MPCSTE(1)=VALRES(1)
          MPCSTE(2)=VALRES(2)
        ELSE
          MPCSTE(1)=VALRES(3)
          MPCSTE(2)=VALRES(4)
        ENDIF

        DX = ABS(NMNBN(4)-MPCSTE(1))/NORMM
        DY = ABS(NMNBN(5)-MPCSTE(2))/NORMM
      ELSE
        NOMRES(1) = 'FMEX1'
        NOMRES(2) = 'FMEX2'
        NOMRES(3) = 'FMEY1'
        NOMRES(4) = 'FMEY2'

        IF(BEND .EQ. 1) THEN
          DO 10, I = 1,2
            KPFONC(I) = NOMRES(2*(I-1)+1)
 10       CONTINUE
        ELSE
          DO 30, I = 1,2
            KPFONC(I) = NOMRES(2*I)
 30       CONTINUE
        ENDIF

        DX = DISTFO(ZIMAT,KPFONC(1),NMNBN(1),NMNBN(4),NORMN,NORMM)
        DY = DISTFO(ZIMAT,KPFONC(2),NMNBN(2),NMNBN(5),NORMN,NORMM)
      ENDIF

      IF(SQRT(DX**2+DY**2) .LT. 5.0D-2) THEN
        RESTZO = 1
      ENDIF

      END
