      SUBROUTINE TE0066(OPTION,NOMTE)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*16 OPTION,NOMTE
C.......................................................................

C     BUT: CALCUL DE L'ENERGIE THERMIQUE A L'EQUILIOBRE
C          ELEMENTS ISOPARAMETRIQUES 3D

C          OPTION : 'EPOT_ELEM_TEMP'

C     ENTREES  ---> OPTION : OPTION DE CALCUL
C          ---> NOMTE  : NOM DU TYPE ELEMENT
C.......................................................................


      CHARACTER*8 NOMPAR,FAMI,POUM
      INTEGER ICODRE
      REAL*8   VALPAR,LAMBDA,POIDS,EPOT
      REAL*8   DFDX(27),DFDY(27),DFDZ(27),FLUX,FLUY,FLUZ
      INTEGER  I,IPOIDS,IVF,IDFDE,IGEOM,IMATE,KPG,SPT
      INTEGER  NDIM,JGANO,NNO,KP,NPG1,IENER,ITEMP,ITEMPE

C-----------------------------------------------------------------------
      INTEGER IRET ,NBPAR ,NNOS
C-----------------------------------------------------------------------
      CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG1,IPOIDS,IVF,IDFDE,JGANO)

      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PMATERC','L',IMATE)
      CALL JEVECH('PTEMPER','L',ITEMPE)
      CALL JEVECH('PENERDR','E',IENER)

      FAMI='FPG1'
      KPG=1
      SPT=1
      POUM='+'
      CALL TECACH('ONN','PTEMPSR',1,ITEMP,IRET)
      IF (ITEMP.EQ.0) THEN
        NBPAR = 0
        NOMPAR = ' '
        VALPAR = 0.D0
      ELSE
        NBPAR = 1
        NOMPAR = 'INST'
        VALPAR = ZR(ITEMP)
      END IF

      CALL RCVALB(FAMI,KPG,SPT,POUM,ZI(IMATE),' ','THER',NBPAR,NOMPAR,
     &            VALPAR,1,'LAMBDA',LAMBDA,ICODRE,1)

      EPOT = 0.D0
      DO 30 KP = 1,NPG1
        CALL DFDM3D ( NNO, KP, IPOIDS, IDFDE,
     &                ZR(IGEOM), DFDX, DFDY, DFDZ, POIDS )
        FLUX = 0.D0
        FLUY = 0.D0
        FLUZ = 0.D0
        DO 20 I = 1,NNO
          FLUX = FLUX + ZR(ITEMPE-1+I)*DFDX(I)
          FLUY = FLUY + ZR(ITEMPE-1+I)*DFDY(I)
          FLUZ = FLUZ + ZR(ITEMPE-1+I)*DFDZ(I)
   20   CONTINUE

        EPOT = EPOT - (FLUX**2+FLUY**2+FLUZ**2)*POIDS

   30 CONTINUE
      ZR(IENER) = EPOT*LAMBDA/2.D0
      END
