      SUBROUTINE TE0120(OPTION,NOMTE)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE SFAYOLLE S.FAYOLLE
      IMPLICIT NONE

      INCLUDE 'jeveux.h'
      CHARACTER*16 OPTION,NOMTE


C ......................................................................
C    - FONCTION REALISEE:  CALCUL DES OPTIONS NON-LINEAIRES MECANIQUES
C                          EN 2D (CPLAN ET DPLAN) ET 3D
C                          POUR ELEMENTS MIXTES A DEUX CHAMPS
C    - ARGUMENTS:
C        DONNEES:      OPTION       -->  OPTION DE CALCUL
C                      NOMTE        -->  NOM DU TYPE ELEMENT
C ......................................................................

      INTEGER DLNS
      INTEGER NNO,NNOS,NPG,IMATUU
      INTEGER IPOIDS,IVF,IDFDE,IGEOM,IMATE
      INTEGER JGANO
      INTEGER NDIM

      INTEGER ICODR1
      CHARACTER*4 FAMI
      CHARACTER*16 PHENOM



      FAMI = 'MASS'
      CALL ELREF4(' ',FAMI,NDIM,NNO,NNOS,NPG,IPOIDS,IVF,IDFDE,JGANO)

C - PARAMETRES EN ENTREE

      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PMATERC','L',IMATE)

      IF (OPTION(1:9).EQ.'MASS_MECA') THEN
C---------------- CALCUL MATRICE DE MASSE ------------------------

        CALL JEVECH('PMATUUR','E',IMATUU)

        IF (NDIM.EQ.2) THEN
C - 2 DEPLACEMENTS + 1 PRES
          IF (NOMTE(1:6).EQ.'MIAXUP' .OR.
     &        NOMTE(1:6).EQ.'MIPLUP') THEN
            DLNS = 3
          ELSEIF (NOMTE(1:4).EQ.'MIAX' .OR.
     &            NOMTE(1:4).EQ.'MIPL') THEN
C - 2 DEPLACEMENTS + 1 PRES + 1 GONF
            DLNS = 4
          ELSE
            CALL ASSERT(.FALSE.)
          ENDIF
        ELSEIF (NDIM.EQ.3) THEN
C - 3 DEPLACEMENTS + 1 PRES
          IF (NOMTE(1:6).EQ.'MINCUP') THEN
            DLNS = 4
          ELSEIF (NOMTE(1:5).EQ.'MINC_') THEN
C - 3 DEPLACEMENTS + 1 PRES + 1 GONF
            DLNS = 5
          ELSE
            CALL ASSERT(.FALSE.)
          ENDIF
        ELSE
          CALL ASSERT(.FALSE.)
        ENDIF

        CALL MASSUP(OPTION,NDIM,DLNS,NNO,NNOS,ZI(IMATE),PHENOM,
     &              NPG,IPOIDS,IDFDE,ZR(IGEOM),
     &              ZR(IVF),IMATUU,ICODR1,IGEOM,IVF)

C--------------- FIN CALCUL MATRICE DE MASSE -----------------------
      END IF
      END
