      SUBROUTINE TE0178(OPTION,NOMTE)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C ......................................................................
C    - FONCTION REALISEE:  CALCUL DES MATRICES ELEMENTAIRES
      IMPLICIT NONE
C                          D'AMORTISSEMENT ACOUSTIQUE SUR DES ARETES
C                          D'ELEMENTS 2D
C                          OPTION : 'AMOR_ACOU'
C    - ARGUMENTS:
C        DONNEES:      OPTION       -->  OPTION DE CALCUL
C                      NOMTE        -->  NOM DU TYPE ELEMENT
C ......................................................................

      INCLUDE 'jeveux.h'

      COMPLEX*16 RHOSZ
      CHARACTER*8 FAMI,POUM
      CHARACTER*16 OPTION,NOMTE
      INTEGER ICODRE
      REAL*8 POIDS,R,NX,NY,RHO
      INTEGER NNO,KP,NPG,IPOIDS,IVF,IDFDE,IGEOM
      INTEGER IMATTT,I,J,IJ,L,LI,LJ
      INTEGER IMATE,IIMPE,KPG,SPT
      LOGICAL LTEATT, LAXI


C-----------------------------------------------------------------------
      INTEGER JGANO ,MATER ,NDIM ,NNOS
      REAL*8 R8B
C-----------------------------------------------------------------------
      CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG,IPOIDS,IVF,IDFDE,JGANO)

      LAXI = .FALSE.
      IF (LTEATT(' ','AXIS','OUI')) LAXI = .TRUE.

      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PIMPEDC','L',IIMPE)
      CALL JEVECH('PMATERC','L',IMATE)
      CALL JEVECH('PMATTTC','E',IMATTT)

      FAMI='FPG1'
      KPG=1
      SPT=1
      POUM='+'
      MATER = ZI(IMATE)
      CALL RCVALB(FAMI,KPG,SPT,POUM,MATER,' ','FLUIDE',0,' ',
     &            R8B,1,'RHO',RHO,ICODRE,1)

      IF (ZC(IIMPE).NE. (0.D0,0.D0)) THEN
        RHOSZ = RHO/ZC(IIMPE)
      ELSE
        GO TO 50
      END IF

      DO 40 KP = 1,NPG
        CALL VFF2DN(NDIM,NNO,KP,IPOIDS,IDFDE,ZR(IGEOM),NX,NY,POIDS)
        IF (LAXI) THEN
          R = 0.D0
          DO 10 I = 1,NNO
            L = (KP-1)*NNO + I
            R = R + ZR(IGEOM+2*I-2)*ZR(IVF+L-1)
   10     CONTINUE
          POIDS = POIDS*R
        END IF
        IJ = IMATTT - 1
        DO 30 I = 1,NNO
          LI = IVF + (KP-1)*NNO + I - 1
          DO 20 J = 1,I
            LJ = IVF + (KP-1)*NNO + J - 1
            IJ = IJ + 1
            ZC(IJ) = ZC(IJ) + POIDS*RHOSZ*ZR(LI)*ZR(LJ)
   20     CONTINUE
   30   CONTINUE
   40 CONTINUE
   50 CONTINUE
      END
