      SUBROUTINE TE0179(OPTION,NOMTE)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C ......................................................................
C    - FONCTION REALISEE:  CALCUL DES VECTEURS ELEMENTAIRES
      IMPLICIT NONE
C                          EN ACOUSTIQUE CORRESPONDANT AUX VITESSES
C                          NORMALES IMPOSEES SUR DES ARETES D'ELEMENTS
C                          ISOPARAMETRIQUES 2D
C                          OPTION : 'CHAR_ACOU_VNOR_C'
C    - ARGUMENTS:
C        DONNEES:      OPTION       -->  OPTION DE CALCUL
C                      NOMTE        -->  NOM DU TYPE ELEMENT
C ......................................................................
      INCLUDE 'jeveux.h'

      CHARACTER*8 FAMI,POUM
      CHARACTER*16 OPTION,NOMTE
      INTEGER ICODRE,KPG,SPT
      REAL*8 POIDS,R,NX,NY,RHO
      INTEGER NNO,KP,NPG,IPOIDS,IVF,IDFDE,IGEOM
      INTEGER I,L,LI
      INTEGER IMATE,IVITN
      LOGICAL LTEATT,LAXI


C-----------------------------------------------------------------------
      INTEGER IVECTT ,JGANO ,MATER ,NDIM ,NNOS
      REAL*8 R8B
C-----------------------------------------------------------------------
      CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG,IPOIDS,IVF,IDFDE,JGANO)

      FAMI='FPG1'
      KPG=1
      SPT=1
      POUM='+'
      LAXI = .FALSE.
      IF (LTEATT(' ','AXIS','OUI')) LAXI = .TRUE.

      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PVITENC','L',IVITN)
      CALL JEVECH('PMATERC','L',IMATE)
      CALL JEVECH('PVECTTC','E',IVECTT)

      MATER = ZI(IMATE)
      CALL RCVALB(FAMI,KPG,SPT,POUM,MATER,' ','FLUIDE',0,' ',
     &            R8B,1,'RHO',RHO,ICODRE,1)

      DO 30 KP = 1,NPG
        CALL VFF2DN(NDIM,NNO,KP,IPOIDS,IDFDE,ZR(IGEOM),NX,NY,POIDS)
        IF (LAXI) THEN
          R = 0.D0
          DO 10 I = 1,NNO
            L = (KP-1)*NNO + I
            R = R + ZR(IGEOM+2*I-2)*ZR(IVF+L-1)
   10     CONTINUE
          POIDS = POIDS*R
        END IF

        DO 20 I = 1,NNO
          LI = IVF + (KP-1)*NNO + I - 1
          ZC(IVECTT+I-1) = ZC(IVECTT+I-1) +
     &                     POIDS*ZR(LI)*ZC(IVITN+KP-1)*RHO
   20   CONTINUE
   30 CONTINUE
      END
