      SUBROUTINE TE0180(OPTION,NOMTE)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C.......................................................................

C     BUT: CALCUL DES MATRICES DE RIGIDITE ELEMENTAIRES EN ACOUSTIQUE
C          ELEMENTS ISOPARAMETRIQUES 3D

C          OPTION : 'RIGI_ACOU '

C     ENTREES  ---> OPTION : OPTION DE CALCUL
C          ---> NOMTE  : NOM DU TYPE ELEMENT
C.......................................................................

      IMPLICIT NONE

      INCLUDE 'jeveux.h'

      CHARACTER*16 NOMTE,OPTION
      REAL*8 DFDX(27),DFDY(27),DFDZ(27),POIDS
      INTEGER IPOIDS,IVF,IDFDE,IGEOM
      INTEGER JGANO,NNO,KP,NPG1,I,J,IMATTT,NDI




C-----------------------------------------------------------------------
      INTEGER IJ ,NDIM ,NNOS
C-----------------------------------------------------------------------
      CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG1,IPOIDS,IVF,IDFDE,JGANO)
      NDI = NNO* (NNO+1)/2

      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PMATTTC','E',IMATTT)

      DO 20 I = 1,NDI
        ZC(IMATTT+I-1) = (0.0D0,0.0D0)
   20 CONTINUE

C    BOUCLE SUR LES POINTS DE GAUSS

      DO 50 KP = 1,NPG1

        CALL DFDM3D ( NNO, KP, IPOIDS, IDFDE,
     &                ZR(IGEOM), DFDX, DFDY, DFDZ, POIDS )

        DO 40 I = 1,NNO
          DO 30 J = 1,I
            IJ = (I-1)*I/2 + J
            ZC(IMATTT+IJ-1) = ZC(IMATTT+IJ-1) +
     &                        POIDS* (DFDX(I)*DFDX(J)+DFDY(I)*DFDY(J)+
     &                        DFDZ(I)*DFDZ(J))
   30     CONTINUE
   40   CONTINUE

   50 CONTINUE

      END
