      SUBROUTINE TE0185(OPTION,NOMTE)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE PELLET J.PELLET
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*16 OPTION,NOMTE
C     ----------------------------------------------------------------
C     CALCUL DE L'OPTION EFGE_ELNO
C     CETTE ROUTINE NE SERT QUE D'INDIRECTION VERS LE BON TE00IJ
C     EN FONCTION DE LA MODELISATION ET DE LA NATURE DU CALCUL :
C     LINEAIRE OU NON-LINEAIRE
      INTEGER J1,INLIN,IBID
      LOGICAL LINE
      CHARACTER*3  CMOD
      CHARACTER*8  ALIAS8
C-----------------------------------------------------------------------

C     -- CALCUL DE LINE :
      CALL JEVECH('PNONLIN','L',J1)
      INLIN=ZI(J1-1+1)
      LINE=(INLIN.EQ.0)

C     -- CALCUL DE CMOD (CODE DE LA MODELISATION) :
      CALL TEATTR(' ','S','ALIAS8',ALIAS8,IBID)
      CMOD=ALIAS8(3:5)

      IF (LINE) THEN
C       -- QUAND LE CALCUL EST LINEAIRE :
        IF     (CMOD.EQ.'2DB') THEN
C         -- 2D_BARRE
          CALL EF0154(NOMTE)
        ELSEIF (CMOD.EQ.'2DT'.OR.CMOD.EQ.'2TR') THEN
C         -- 2D_DIS_T , 2D_DIS_TR
          CALL EF0042(NOMTE)
        ELSEIF (CMOD.EQ.'BAR') THEN
C         -- BARRE
          CALL EF0154(NOMTE)
        ELSEIF (CMOD.EQ.'CAB'.OR.CMOD.EQ.'CAP') THEN
C         -- CABLE, CABLE_POULIE
          CALL ASSERT(.FALSE.)
        ELSEIF (CMOD.EQ.'CQ3') THEN
C         -- COQUE_3D
          CALL EF0410(NOMTE)
        ELSEIF (CMOD.EQ.'CQA'.OR.CMOD.EQ.'CQC'.OR.CMOD.EQ.'CQD') THEN
C         -- COQUE_AXIS, COQUE_C_PLAN, COQUE_D_PLAN
          CALL EF0231(NOMTE)
        ELSEIF (CMOD.EQ.'DIT') THEN
C         -- DIS_T
          CALL EF0042(NOMTE)
        ELSEIF (CMOD.EQ.'DTG'.OR.CMOD.EQ.'Q4S') THEN
C         -- DKTG, Q4GG
          CALL EF0033(NOMTE)
        ELSEIF (CMOD.EQ.'DKT'.OR.CMOD.EQ.'DST'.OR.CMOD.EQ.'Q4G') THEN
C         -- DKT, DST, Q4G
          CALL EF0033(NOMTE)
        ELSEIF (CMOD.EQ.'DTR') THEN
C         -- DIS_TR
          CALL EF0042(NOMTE)
        ELSEIF (CMOD.EQ.'PCT') THEN
C         -- POU_C_T
          CALL EF0142(NOMTE)
        ELSEIF (CMOD.EQ.'PDE') THEN
C         -- POU_D_E
          CALL EF0142(NOMTE)
        ELSEIF (CMOD.EQ.'PDG') THEN
C         -- POU_D_TG
          CALL EF0344(NOMTE)
        ELSEIF (CMOD.EQ.'PDT') THEN
C         -- POU_D_T
          CALL EF0142(NOMTE)
        ELSEIF (CMOD.EQ.'PGD') THEN
C         -- POU_D_T_GD
          CALL ASSERT(.FALSE.)
        ELSEIF (CMOD.EQ.'PFM') THEN
C         -- POU_D_EM
          CALL EF0142(NOMTE)
        ELSEIF (CMOD.EQ.'PGM') THEN
C         -- POU_D_TGM
          CALL ASSERT(.FALSE.)
        ELSEIF (CMOD.EQ.'TU3'.OR.CMOD.EQ.'TU6') THEN
C         -- TUYAU_3M, TUYAU_6M
          CALL EF0585(NOMTE)
        ELSE
          CALL ASSERT(.FALSE.)
        ENDIF



      ELSE
C     -- QUAND LE CALCUL EST NON-LINEAIRE :
        IF     (CMOD.EQ.'2DB') THEN
C         -- 2D_BARRE
          CALL EF0156(NOMTE)
        ELSEIF (CMOD.EQ.'2DT'.OR.CMOD.EQ.'2TR') THEN
C         -- 2D_DIS_T , 2D_DIS_TR
          CALL EF0039(NOMTE)
        ELSEIF (CMOD.EQ.'BAR') THEN
C         -- BARRE
          CALL EF0156(NOMTE)
        ELSEIF (CMOD.EQ.'CAB'.OR.CMOD.EQ.'CAP') THEN
C         -- CABLE, CABLE_POULIE
          CALL ASSERT(.FALSE.)
        ELSEIF (CMOD.EQ.'CQ3') THEN
C         -- COQUE_3D
          CALL EF0415(NOMTE)
        ELSEIF (CMOD.EQ.'CQA'.OR.CMOD.EQ.'CQC'.OR.CMOD.EQ.'CQD') THEN
C         -- COQUE_AXIS, COQUE_C_PLAN, COQUE_D_PLAN
          CALL ASSERT(.FALSE.)
        ELSEIF (CMOD.EQ.'DIT') THEN
C         -- DIS_T
          CALL EF0039(NOMTE)
        ELSEIF (CMOD.EQ.'DTG'.OR.CMOD.EQ.'Q4S') THEN
C         -- DKTG, Q4GG
          CALL EF0409(NOMTE)
        ELSEIF (CMOD.EQ.'DKT'.OR.CMOD.EQ.'DST'.OR.CMOD.EQ.'Q4G') THEN
C         -- DKT, DST, Q4G
          IF (CMOD.EQ.'DST'.OR.CMOD.EQ.'Q4G') CALL ASSERT(.FALSE.)
          CALL EF0031(NOMTE)
        ELSEIF (CMOD.EQ.'DTR') THEN
C         -- DIS_TR
          CALL EF0039(NOMTE)
        ELSEIF (CMOD.EQ.'PCT') THEN
C         -- POU_C_T
          CALL EF0039(NOMTE)
        ELSEIF (CMOD.EQ.'PDE') THEN
C         -- POU_D_E
          CALL EF0347(NOMTE)
        ELSEIF (CMOD.EQ.'PDG') THEN
C         -- POU_D_TG
          CALL EF0347(NOMTE)
        ELSEIF (CMOD.EQ.'PDT') THEN
C         -- POU_D_T
          CALL EF0347(NOMTE)
        ELSEIF (CMOD.EQ.'PGD') THEN
C         -- POU_D_T_GD
          CALL ASSERT(.FALSE.)
        ELSEIF (CMOD.EQ.'PFM') THEN
C         -- POU_D_EM
          CALL EF0517(NOMTE)
        ELSEIF (CMOD.EQ.'PGM') THEN
C         -- POU_D_TGM
          CALL EF0517(NOMTE)
        ELSEIF (CMOD.EQ.'TU3'.OR.CMOD.EQ.'TU6') THEN
C         -- TUYAU_3M, TUYAU_6M
          CALL EF0587(NOMTE)
        ELSE
          CALL ASSERT(.FALSE.)
        ENDIF
      ENDIF

      END
