      SUBROUTINE TE0197 ( OPTION , NOMTE )
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*16        OPTION , NOMTE
C ......................................................................
C    - FONCTION REALISEE:  CALCUL DES VECTEURS ELEMENTAIRES
C                          OPTION : 'CHAR_ME_ROTAR   '
C                          CAS AXISYMETRIQUE FOURIER
C
C    - ARGUMENTS:
C        DONNEES:      OPTION       -->  OPTION DE CALCUL
C                      NOMTE        -->  NOM DU TYPE ELEMENT
C ......................................................................
C
      INTEGER ICODRE
      CHARACTER*8 FAMI,POUM
      REAL*8             DFDX(9),DFDY(9),POIDS,R
      INTEGER            NNO,KP,NPG1,I,IVECTU,IROTA,NDIM,JGANO,NNOS
      INTEGER            IPOIDS,IVF,IDFDE,IGEOM,IMATE,KPG,SPT
C
C
C-----------------------------------------------------------------------
      INTEGER K
      REAL*8 R8B ,R8MIEM ,RHO
C-----------------------------------------------------------------------
      CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG1,IPOIDS,IVF,IDFDE,JGANO)
C
      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PMATERC','L',IMATE)
      CALL JEVECH('PROTATR','L',IROTA)
C
C VERIFICATIONS SUR LE CHARGEMENT ROTATION (AXE=Oy et CENTRE=ORIGINE)
C
      IF(ZR(IROTA+1).GT.R8MIEM().OR.ZR(IROTA+3).GT.R8MIEM()) THEN
         CALL U2MESS('F','MODELISA10_1')
      END IF
      IF(ZR(IROTA+4).GT.R8MIEM().OR.ZR(IROTA+5).GT.R8MIEM()
     &  .OR.ZR(IROTA+6).GT.R8MIEM()) THEN
         CALL U2MESS('F','MODELISA10_2')
      END IF
      CALL JEVECH('PVECTUR','E',IVECTU)
C
      FAMI='FPG1'
      KPG=1
      SPT=1
      POUM='+'
      CALL RCVALB(FAMI,KPG,SPT,POUM,ZI(IMATE),' ','ELAS',0,' ',R8B,1,
     &            'RHO',RHO,ICODRE,1)
C
      DO 101 KP=1,NPG1
        K=(KP-1)*NNO
        CALL DFDM2D(NNO,KP,IPOIDS,IDFDE,ZR(IGEOM),DFDX,DFDY,POIDS)
        R = 0.D0
        DO 102 I=1,NNO
          R = R + ZR(IGEOM+2*(I-1))*ZR(IVF+K+I-1)
102     CONTINUE
        POIDS = POIDS*RHO*R
        R = R - ZR(IROTA+4)
        DO 103 I=1,NNO
           K=(KP-1)*NNO
           ZR(IVECTU+3*I-3) = ZR(IVECTU+3*I-3) +
     &        POIDS * (ZR(IROTA)*ZR(IROTA+2))**2 * R * ZR(IVF+K+I-1)
103     CONTINUE
101   CONTINUE
      END
