      SUBROUTINE TE0220 ( OPTION , NOMTE )
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*16        OPTION , NOMTE
C ......................................................................
C    - FONCTION REALISEE:
C                         CALCUL DE L'ENERGIE THERMIQUE A L'EQUILIBRE
C                         OPTION : 'EPOT_ELEM_TEMP'
C
C    - ARGUMENTS:
C        DONNEES:      OPTION       -->  OPTION DE CALCUL
C                      NOMTE        -->  NOM DU TYPE ELEMENT
C ......................................................................
C
C
      INTEGER            ICODRE,KPG,SPT
      CHARACTER*8        NOMPAR,FAMI,POUM
      REAL*8             VALRES, VALPAR
      REAL*8             DFDX(9),DFDY(9),POIDS,FLUX,FLUY,EPOT
      INTEGER            NDIM,NNO,NNOS,NPG,KP,J,ITEMPE,ITEMP,IENER
      INTEGER            IPOIDS,IVF,IDFDE,JGANO,IGEOM,IMATE,IRET,NBPAR
C     ------------------------------------------------------------------
C
      CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG,IPOIDS,IVF,IDFDE,JGANO)
C
      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PMATERC','L',IMATE)
      CALL JEVECH('PTEMPER','L',ITEMPE)
      CALL JEVECH('PENERDR','E',IENER)
C
      CALL TECACH('ONN','PTEMPSR',1,ITEMP,IRET)
      IF ( ITEMP .EQ. 0 ) THEN
         NBPAR  = 0
         NOMPAR = ' '
         VALPAR = 0.D0
      ELSE
         NBPAR  = 1
         NOMPAR = 'INST'
         VALPAR = ZR(ITEMP)
      ENDIF
C
      FAMI='FPG1'
      KPG=1
      SPT=1
      POUM='+'
      CALL RCVALB(FAMI,KPG,SPT,POUM,ZI(IMATE),' ','THER',NBPAR,NOMPAR,
     &            VALPAR,1,'LAMBDA',  VALRES,ICODRE,1)
C
      EPOT = 0.D0
      DO 101 KP=1,NPG
         CALL DFDM2D ( NNO,KP,IPOIDS,IDFDE,ZR(IGEOM),DFDX,DFDY,POIDS )
         FLUX = 0.D0
         FLUY = 0.D0
         DO 110 J=1,NNO
             FLUX = FLUX + ZR(ITEMPE+J-1)*DFDX(J)
             FLUY = FLUY + ZR(ITEMPE+J-1)*DFDY(J)
 110     CONTINUE
C
         EPOT = EPOT - ( FLUX**2 + FLUY**2 )*POIDS
101   CONTINUE
      ZR(IENER) = EPOT * VALRES / 2.D0
C
      END
