      SUBROUTINE TE0262(OPTION,NOMTE)
      IMPLICIT NONE
C     ------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C TOLE CRS_512
C ======================================================================
      INCLUDE 'jeveux.h'

      CHARACTER*16 OPTION,NOMTE
C     ------------------------------------------------------------------
C     ------------------------------------------------------------------
C IN  OPTION : K16 : NOM DE L'OPTION A CALCULER
C       'MECA_GYRO': CALCUL DE LA MATRICE DE RAIDEUR GYROSCOPIQUE
C IN  NOMTE  : K16 : NOM DU TYPE ELEMENT
C       'MECA_POU_D_E'  : POUTRE DROITE D'EULER       (SECTION VARIABLE)
C       'MECA_POU_D_T'  : POUTRE DROITE DE TIMOSHENKO (SECTION VARIABLE)
C       'MECA_POU_D_EM' : POUTRE DROITE MULTIFIBRE D EULER (SECT. CONST)
C       'MECA_POU_D_TG' : POUTRE DROITE DE TIMOSHENKO (GAUCHISSEMENT)
C       'MECA_POU_D_TGM': POUTRE DROITE DE TIMOSHENKO (GAUCHISSEMENT)
C                         MULTI-FIBRES (SECTION CONSTANTE)


      INTEGER NBRES,NL
      PARAMETER (NBRES=3,NL=144)
      REAL*8 VALRES(NBRES)
      INTEGER CODRES(NBRES)
      CHARACTER*8 NOMPAR,NOMRES(NBRES),FAMI,POUM
      REAL*8 PGL(3,3),KLV(NL)
      REAL*8 E, RHO
      REAL*8     VALPAR, XNU, ZERO
      INTEGER IMATE, LMAT, LORIEN, LSECT
      INTEGER NBPAR, NNO,KPG,SPT
C     ------------------------------------------------------------------
      DATA NOMRES/'E','RHO','NU'/
C     ------------------------------------------------------------------
      ZERO = 0.D0
C     ------------------------------------------------------------------
C
C     --- CARACTERISTIQUES DES ELEMENTS
C
      IF (NOMTE.EQ.'MECA_POU_D_E'  .OR.
     &    NOMTE.EQ.'MECA_POU_D_T'  .OR.
     &    NOMTE.EQ.'MECA_POU_D_EM'     ) THEN
        NNO = 2
      ELSE
        CALL U2MESK('F','ELEMENTS2_42',1,NOMTE)
      ENDIF
C
C     --- RECUPERATION DES CARACTERISTIQUES MATERIAUX ---
C
      CALL JEVECH('PMATERC','L',IMATE)

      NBPAR  = 0
      NOMPAR = ' '
      VALPAR = ZERO
      FAMI='FPG1'
      KPG=1
      SPT=1
      POUM='+'
      CALL RCVALB(FAMI,KPG,SPT,POUM,ZI(IMATE),' ','ELAS',NBPAR,NOMPAR,
     &            VALPAR,NBRES,NOMRES,VALRES,CODRES,1)
      E   = VALRES(1)
      RHO = VALRES(2)
      XNU = VALRES(3)

      CALL JEVECH('PCAGNPO','L',LSECT)

      CALL JEVECH('PMATUNS','E',LMAT)

C     --- RECUPERATION DES ORIENTATIONS ---

      CALL JEVECH('PCAORIE','L',LORIEN)

C     --- CALCUL DE LA MATRICE GYROSCOPIQUE LOCALE ---
      CALL PORIGY(NOMTE,E,RHO,XNU,ZI(IMATE),KLV,NL)

      CALL MATROT(ZR(LORIEN),PGL)
C  CHANGEMENT DE BASE : LOCAL -> GLOBAL
      CALL UTPPLG (NNO,6,PGL,KLV,ZR(LMAT))
C
      END
