      SUBROUTINE TE0289(OPTION,NOMTE)
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*16 OPTION,NOMTE
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
C    - FONCTIONS REALISEES :  ROUTINE X-FEM
C
C          PASSAGE DES CONTRAINTES
C          DES POINTS DE GAUSS DES SOUS-ELEMENTS :
C            * AUX NOEUDS DES ELEMENTS PARENTS
C              (OPTION 'SIEF_ELNO' ET 'SIGM_ELNO') ;
C            * AUX SOMMETS (NOEUDS) DES SOUS-ELEMENTS
C              (OPTION 'SISE_ELNO') ;
C
C    - ARGUMENTS:
C        DONNEES:      OPTION       -->  OPTION DE CALCUL
C                      NOMTE        -->  NOM DU TYPE ELEMENT
C ......................................................................
C
C
C
C
      INTEGER MXVAL
      PARAMETER (MXVAL=6*3*4)
C     EN 2D :
C     MXVAL =  6 (NBSE MAX) * 3 (NBNOSE MAX) * 4 (NBCMP MAX)
C     EN 3D :
C     MXVAL = 32 (NBSE MAX) * 4 (NBNOSE MAX) * 6 (NBCMP MAX)

      INTEGER IBID,NDIM,NNOP,NNO,NPG,IVF,JGANO
      INTEGER NFH,NFE,SINGU,DDLC,NBSIGM,NBSIG
      INTEGER JCNSET,JLONCH,JSIGPG
      INTEGER JOUT1,JOUT2
      INTEGER NSE


      REAL*8 SISENO(MXVAL)

      CHARACTER*8  ELREFP,ELRESE(3),FAMI(3)

      DATA    ELRESE /'SE2','TR3','TE4'/
      DATA    FAMI   /'BID','XINT','XINT'/
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C-----------------------------------------------------------------------
C     INITIALISATIONS
C-----------------------------------------------------------------------

C     ELEMENT DE REFERENCE PARENT : RECUP DE NDIM ET NNOP
      CALL ELREF1(ELREFP)
      CALL ELREF4(' ','RIGI',NDIM,NNOP,IBID,IBID,IBID,IBID,IBID,IBID)
      CALL ASSERT(NNOP.LE.27)

C
C     SOUS-ELEMENT DE REFERENCE : RECUP DE NNO, NPG, IVF ET JGANO
      CALL ELREF4(ELRESE(NDIM),FAMI(NDIM),IBID,NNO,IBID,NPG,
     &                                          IBID,IVF,IBID,JGANO)

      CALL ASSERT(NPG.LE.15)

C     INITIALISATION DES DIMENSIONS DES DDLS X-FEM
      CALL XTEINI(NOMTE,NFH,NFE,SINGU,DDLC,IBID,IBID,IBID,
     &            IBID,IBID,IBID)
C
C     NOMBRE DE CONTRAINTES ASSOCIE A L'ELEMENT
      NBSIG = NBSIGM()
      CALL ASSERT(NBSIG.LE.6)

C-----------------------------------------------------------------------
C     RECUPERATION DES ENTREES / SORTIE
C-----------------------------------------------------------------------

      CALL JEVECH('PLONCHA','L',JLONCH)
      CALL JEVECH('PCONTRR','L',JSIGPG)

C     RCUPRATION DE LA SUBDIVISION DE L'LMENT EN NSE SOUS ELEMENT
      NSE=ZI(JLONCH-1+1)

C-----------------------------------------------------------------------
C     OPTION SISE_ELNO
C-----------------------------------------------------------------------
C
      IF (OPTION.EQ.'SISE_ELNO') THEN
C
C       RECUPERATION DES ENTREES / SORTIE
        CALL JEVECH('PCONTSER','E',JOUT1)
C
C       CALCUL DES CONTRAINTES PAR SOUS-ELEMENTS AUX NOEUDS (SENO)
        CALL XSSENO(NNO,NBSIG,NSE,NPG,JGANO,JSIGPG,ZR(JOUT1))

C-----------------------------------------------------------------------
C     OPTION SIEF_ELNO ET SIGM_ELNO
C-----------------------------------------------------------------------
C
      ELSE IF ((OPTION.EQ.'SIEF_ELNO').OR.
     &         (OPTION.EQ.'SIGM_ELNO')) THEN
C
C       RECUPERATION DES ENTREES / SORTIE
        CALL JEVECH('PCNSETO','L',JCNSET)
        CALL JEVECH('PSIEFNOR','E',JOUT2)
C
C       CALCUL DES CONTRAINTES PAR ELEMENTS AUX NOEUDS (ELNO)
        CALL XSSENO(NNO,NBSIG,NSE,NPG,JGANO,JSIGPG,SISENO)
        CALL XSELNO(NNO,NNOP,NBSIG,NSE,NDIM,JCNSET,SISENO,JOUT2)
C
C-----------------------------------------------------------------------
C     OPTION NON PREVUE
C-----------------------------------------------------------------------
C
      ELSE
C
        CALL ASSERT(.FALSE.)
C
      ENDIF
C
      CALL JEDEMA()
C
      END
