      SUBROUTINE TE0364(OPTION,NOMTE )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 25/06/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT      NONE
      INCLUDE       'jeveux.h'
      CHARACTER*16  OPTION,NOMTE
C
C ----------------------------------------------------------------------
C
C
C  CALCUL CALCUL DES MATRICES DE CONTACT ET DE FROTTEMENT
C  DE COULOMB STANDARD  VEC LA METHODE CONTINUE
C
C  OPTION : 'RIGI_CONT' (CALCUL DES MATRICES DE CONTACT )
C           'RIGI_FROT' (CALCUL DES MATRICES DE FROTTEMENT STANDARD)
C
C  ENTREES  ---> OPTION : OPTION DE CALCUL
C           ---> NOMTE  : NOM DU TYPE ELEMENT
C
C ----------------------------------------------------------------------
C
      INTEGER      I,J,IJ
      INTEGER      NNE,NNM,NNL
      INTEGER      NDDL,NDIM,NBCPS,NBDM
      INTEGER      IRESOF,IRESOG
      INTEGER      NDEXFR
      REAL*8       COEFFF,LAMBDA,LAMBDS
      REAL*8       COEFAC,COEFAF
      REAL*8       WPG,JACOBI
      REAL*8       MMAT(81,81)
      REAL*8       NORM(3),TAU1(3),TAU2(3)
      REAL*8       MPROJN(3,3),MPROJT(3,3)
      REAL*8       RESE(3),NRESE
      REAL*8       JEUSUP
      REAL*8       DLAGRC,DLAGRF(2)
      REAL*8       JEU,DJEUT(3)
      CHARACTER*8  TYPMAE,TYPMAM
      CHARACTER*9  PHASEP
      LOGICAL      LAXIS,LELTF
      LOGICAL      LPENAC,LPENAF
      LOGICAL      LOPTF,LUSURE,LDYNA,LFOVIT,LCONT
      LOGICAL      LADHE
      LOGICAL      DEBUG
      INTEGER      JMATT
      REAL*8       PRFUSU,CWEAR
      REAL*8       FFE(9),FFM(9),FFL(9),DFFM(2,9)
      REAL*8       MPRT1N(3,3),MPRT2N(3,3)
      REAL*8       GENE11(3,3),GENE21(3,3)
C
      REAL*8       MATRCC(9,9)
      REAL*8       MATREE(27,27),MATRMM(27,27)
      REAL*8       MATREM(27,27),MATRME(27,27)
      REAL*8       MATRCE(9,27) ,MATRCM(9,27)
      REAL*8       MATRMC(27,9) ,MATREC(27,9)
      REAL*8       MATRFF(18,18)
      REAL*8       MATRFE(18,27),MATRFM(18,27)
      REAL*8       MATRMF(27,18),MATREF(27,18)
      REAL*8       MATRFC(18,9)
C
      CHARACTER*24 TYPELT
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      CALL MATINI(81,81,0.D0,MMAT  )
      CALL MATINI( 9, 9,0.D0,MATRCC)
      CALL MATINI(27,27,0.D0,MATREE)
      CALL MATINI(27,27,0.D0,MATRMM)
      CALL MATINI(27,27,0.D0,MATREM)
      CALL MATINI(27,27,0.D0,MATRME)
      CALL MATINI( 9,27,0.D0,MATRCE)
      CALL MATINI( 9,27,0.D0,MATRCM)
      CALL MATINI(27, 9,0.D0,MATREC)
      CALL MATINI(27, 9,0.D0,MATRMC)
      CALL MATINI(18,18,0.D0,MATRFF)
      CALL MATINI(18,27,0.D0,MATRFE)
      CALL MATINI(18,27,0.D0,MATRFM)
      CALL MATINI(27,18,0.D0,MATREF)
      CALL MATINI(27,18,0.D0,MATRMF)
      CALL MATINI(18,9 ,0.D0,MATRFC)

      DEBUG  = .FALSE.
C
C --- TYPE DE MAILLE DE CONTACT
C
      TYPELT = 'POIN_ELEM'
      LOPTF  = OPTION.EQ.'RIGI_FROT'
C
C --- PREPARATION DES CALCULS - INFOS SUR LA MAILLE DE CONTACT
C
      CALL MMELEM(NOMTE ,NDIM  ,NDDL  ,TYPMAE,NNE   ,
     &            TYPMAM,NNM   ,NNL   ,NBCPS ,NBDM  ,
     &            LAXIS ,LELTF )
C
C --- PREPARATION DES CALCULS - LECTURE DES COEFFICIENTS
C
      CALL MMMLCF(COEFFF,COEFAC,COEFAF,LPENAC,LPENAF,
     &            IRESOF,IRESOG,LAMBDS)
C
C --- PREPARATION DES CALCULS - LECTURE FONCTIONNALITES AVANCEES
C
      CALL MMMLAV(LUSURE,LDYNA ,LFOVIT,PRFUSU,CWEAR ,
     &            JEUSUP,NDEXFR,COEFAC,COEFAF)
C
C --- PREPARATION DES DONNEES
C
      IF (TYPELT.EQ.'POIN_ELEM') THEN
C
C ----- CALCUL DES QUANTITES
C
        CALL MMTPPE(TYPMAE,TYPMAM,NDIM  ,NNE   ,NNM   ,
     &              NNL   ,NBDM  ,IRESOG,LAXIS ,LDYNA ,
     &              JEUSUP,PRFUSU,FFE   ,FFM   ,DFFM  ,
     &              FFL   ,JACOBI,WPG   ,JEU   ,DJEUT ,
     &              DLAGRC,DLAGRF,NORM  ,TAU1  ,TAU2  ,
     &              MPROJN,MPROJT,MPRT1N,MPRT2N,GENE11,
     &              GENE21)
C
C ----- CHOIX DU LAGRANGIEN DE CONTACT
C
        CALL MMLAGC(LAMBDS,DLAGRC,IRESOF,LAMBDA)
C
C ----- STATUTS
C
        CALL MMMSTA(NDIM  ,LELTF ,LPENAF,LOPTF ,DJEUT ,
     &              DLAGRF,COEFAF,COEFFF,TAU1  ,TAU2  ,
     &              LCONT ,LADHE ,LAMBDA,RESE  ,NRESE )
C
C ----- PHASE DE CALCUL
C
        CALL MMMPHA(LOPTF ,LCONT ,LADHE ,NDEXFR,LPENAC,
     &              LPENAF,PHASEP)

C
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF
C
C --- CALCUL FORME FAIBLE FORCE DE CONTACT/FROTTEMENT
C
      IF (TYPELT.EQ.'POIN_ELEM') THEN
        CALL MMTFPE(PHASEP,IRESOF,NDIM  ,NNE   ,NNM   ,
     &              NNL   ,NBCPS ,WPG   ,JACOBI,FFL   ,
     &              FFE   ,FFM   ,DFFM  ,NORM  ,TAU1  ,
     &              TAU2  ,MPROJN,MPROJT,RESE  ,NRESE ,
     &              LAMBDA,JEU   ,COEFFF,COEFAF,COEFAC,
     &              DLAGRC,DLAGRF,DJEUT ,MATREE,MATRMM,
     &              MATREM,MATRME,MATREC,MATRMC,MATREF,
     &              MATRMF)
C
C ----- CONTRIBUTIONS NON-LINEARITES GEOMETRIQUES
C
        IF (IRESOG.EQ.1) THEN
          CALL MMTGEO(PHASEP,NDIM  ,NNE   ,NNM   ,MPROJN,
     &                MPROJT,WPG   ,FFE   ,FFM   ,DFFM  ,
     &                JACOBI,COEFAC,COEFAF,COEFFF,RESE  ,
     &                NRESE ,LAMBDA,JEU   ,DLAGRC,MPRT1N,
     &                MPRT2N,GENE11,GENE21,MATREE,MATRMM,
     &                MATREM,MATRME)
        ENDIF

      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF
C
C --- CALCUL FORME FAIBLE LOI DE CONTACT/FROTTEMENT
C
      IF (TYPELT.EQ.'POIN_ELEM') THEN
        CALL MMTAPE(PHASEP,LELTF ,NDIM  ,NNL   ,NNE   ,
     &              NNM   ,NBCPS ,WPG   ,JACOBI,FFL   ,
     &              FFE   ,FFM   ,NORM  ,TAU1  ,TAU2  ,
     &              MPROJT,RESE  ,NRESE ,LAMBDA,COEFFF,
     &              COEFAF,COEFAC,MATRCC,MATRFF,MATRCE,
     &              MATRCM,MATRFE,MATRFM)
      ELSE
        CALL ASSERT(.FALSE.)
      ENDIF
C
C --- CALCULS - FONCTIONNALITES AVANCEES
C
      CALL MMMTAV(PHASEP,LUSURE,NDIM  ,NNE   ,NNM   ,
     &            NNL   ,NBDM  ,FFE   ,FFM   ,FFL   ,
     &            WPG   ,JACOBI,COEFAC,NORM  ,MPROJT,
     &            CWEAR ,PRFUSU,MATRCC,MATRCE,MATRCM,
     &            MATREC,MATRMC,MATREE,MATRMM,MATREM,
     &            MATRME)
C
C --- MODIFICATIONS EXCLUSION
C
      CALL MMMTEX(NDEXFR,NDIM  ,NNL   ,NNE   ,NNM   ,
     &            NBCPS ,MATRFF,MATRFE,MATRFM,MATREF,
     &            MATRMF)
C
C --- ASSEMBLAGE FINAL
C
      CALL MMMTAS(NBDM  ,NDIM  ,NNL   ,NNE   ,NNM   ,
     &            NBCPS ,MATRCC,MATREE,MATRMM,MATREM,
     &            MATRME,MATRCE,MATRCM,MATRMC,MATREC,
     &            MATRFF,MATRFE,MATRFM,MATRMF,MATREF,
     &            MMAT  )

      IF((LPENAC.AND.(OPTION.EQ.'RIGI_CONT'))
     &    .OR.((OPTION.EQ.'RIGI_FROT').AND.(IRESOF.NE.0))
     &    .OR.(LPENAF.AND.(OPTION.EQ.'RIGI_FROT')))THEN
C
C --- RECUPERATION DE LA MATRICE 'OUT' NON SYMETRIQUE
C
        CALL JEVECH('PMATUNS','E',JMATT )
C
C --- FIN DE CHANGEMENT ET COPIE
C
        DO 760 J = 1,NDDL
           DO 750 I = 1,NDDL
             IJ = J+NDDL*(I-1)
             ZR(JMATT+IJ-1) = MMAT(I,J)
             IF (DEBUG) THEN
               CALL MMMTDB(MMAT(I,J),'IJ',I,J)
             ENDIF
 750       CONTINUE
 760    CONTINUE
      ELSE
C
C --- RECUPERATION DE LA MATRICE 'OUT' SYMETRIQUE
C
        CALL JEVECH('PMATUUR','E',JMATT )
C
C --- FIN DE CHANGEMENT ET COPIE
C
        DO 761 J = 1,NDDL
           DO 751 I = 1,J
             IJ = (J-1)*J/2 + I
             ZR(JMATT+IJ-1) = MMAT(I,J)
             IF (DEBUG) THEN
               CALL MMMTDB(MMAT(I,J),'IJ',I,J)
             ENDIF
 751       CONTINUE
 761    CONTINUE
C
      ENDIF

      CALL JEDEMA()
      END
