      SUBROUTINE TE0371(OPTION,NOMTE)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C.......................................................................
      IMPLICIT NONE
C
C     BUT: CALCUL DES MATRICES DE RIGIDITE  ELEMENTAIRES EN MECANIQUE
C          ELEMENTS 2D DE COUPLAGE PESANTEUR-SURFACE LIBRE D'UN FLUIDE
C
C          OPTION : 'MASS_MECA'
C
C     ENTREES  ---> OPTION : OPTION DE CALCUL
C          ---> NOMTE  : NOM DU TYPE ELEMENT
C.......................................................................
      INCLUDE 'jeveux.h'

      INTEGER ICODRE
      CHARACTER*8        FAMI,POUM
      CHARACTER*16       NOMTE,OPTION
      INTEGER            IGEOM,IMATE,KPG,SPT
      INTEGER            I,J,K,L,IK,IJKL,LDEC,KDEC,INO,JNO
      INTEGER            NDIM,NNO,NPG2,IPG,NNOS,JGANO
      INTEGER            IPOIDS,IVF,IDFRDE,IMATUU
      REAL*8             A(2,2,27,27),RHO
      REAL*8             POIDS,JAC
      REAL*8             DXDE,DXDK,DYDE,DYDK
C
C
C-----------------------------------------------------------------------
      REAL*8 R8B
C-----------------------------------------------------------------------
      CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG2,IPOIDS,IVF,IDFRDE,JGANO)
C
      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PMATERC','L',IMATE)
      CALL JEVECH('PMATUUR','E',IMATUU)
      FAMI='FPG1'
      KPG=1
      SPT=1
      POUM='+'
C
      CALL RCVALB(FAMI,KPG,SPT,POUM,ZI(IMATE),' ','FLUIDE',0,' ',
     &            R8B,1,'RHO',RHO,ICODRE,1)
C
C     INITIALISATION DE LA MATRICE
C
      DO 112 K=1,2
         DO 112 L=1,2
            DO 112 I=1,NNO
            DO 112 J=1,I
                A(K,L,I,J) = 0.D0
112   CONTINUE
C
C    BOUCLE SUR LES POINTS DE GAUSS
C
      DO 113 IPG=1,NPG2
C
       KDEC = (IPG-1)*NNO*NDIM
       LDEC = (IPG-1)*NNO
C
       DXDE=0.D0
       DXDK=0.D0
       DYDE=0.D0
       DYDK=0.D0
       DO 100 I=1,NNO
        DXDE=DXDE+ZR(IGEOM+3*(I-1))*ZR(IDFRDE+KDEC+(I-1)*NDIM)
        DXDK=DXDK+ZR(IGEOM+3*(I-1))*ZR(IDFRDE+KDEC+(I-1)*NDIM+1)
        DYDE=DYDE+ZR(IGEOM+3*(I-1)+1)*ZR(IDFRDE+KDEC+(I-1)*NDIM)
        DYDK=DYDK+ZR(IGEOM+3*(I-1)+1)*ZR(IDFRDE+KDEC+(I-1)*NDIM+1)
100    CONTINUE
       JAC   = DXDE*DYDK-DXDK*DYDE
       POIDS = ABS(JAC)*ZR(IPOIDS+IPG-1)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C       CALCUL DU TERME RHO * PHI * Z      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
        DO 130 INO=1,NNO
           DO 140 JNO=1,INO
              A(1,2,INO,JNO) = A(1,2,INO,JNO) +
     &                         POIDS * RHO *
     &                         ZR(IVF+LDEC+INO-1) * ZR(IVF+LDEC+JNO-1)
140        CONTINUE
130      CONTINUE
113     CONTINUE
C
      DO 151 INO=1,NNO
        DO 152 JNO=1 ,INO
           A(2,1,INO,JNO) = A(1,2,INO,JNO)
152     CONTINUE
151   CONTINUE
C
C PASSAGE DU STOCKAGE RECTANGULAIRE AU STOCKAGE TRIANGULAIRE
C
      IJKL = 0
      IK = 0
      DO 160 K=1,2
         DO 160 L=1,2
            DO 160 I=1,NNO
                IK = ((2*I+K-3) * (2*I+K-2)) / 2
            DO 160 J=1,I
                IJKL = IK + 2 * (J-1) + L
                ZR(IMATUU+IJKL-1) = A(K,L,I,J)
160   CONTINUE
C
      END
