      SUBROUTINE TE0400(OPTION,NOMTE)
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*16 OPTION,NOMTE
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
C     BUT:
C         CREATION DE LA SD VOISIN POUR LES SOUS ELEMENTS D'UN ELEMENT
C         PARENT XFEM (2D):
C         ON ETABLIT LA TABLE DE CONNECTIVITE INVERSE DES SOUS-ELEMENTS
C         PUIS ON EN DEDUIT LES VOISINS DES SOUS ELEMENTS
C         OPTION : 'CHVOIS_XFEM'
C
C
C     ARGUMENTS:
C     ----------
C
C      ENTREE :
C-------------
C IN   OPTION : OPTION DE CALCUL
C IN   NOMTE  : NOM DU TYPE ELEMENT
C
C ......................................................................
C
C
C
C
      INTEGER       NINTER,NNONSX
      PARAMETER    ( NINTER = 3 ,NNONSX=540 )

      INTEGER      NDIM,NNOP,NNO,NSE,IBID,NNOTOT
      INTEGER      JCNSET,JLONCH,IVOISX
      INTEGER      IRESE,I
      CHARACTER*8  ELRESE(6),FAMI(6),ELREFP
      LOGICAL      ISMALI
      INTEGER      VCNINX(990)

      DATA    ELRESE /'SE2','TR3','TE4','SE3','TR6','TE4'/
      DATA    FAMI   /'BID','RIGI','XINT','BID','RIGI','XINT'/
C
C ----------------------------------------------------------------------
C

      CALL JEMARQ()

C     ELEMENT DE REFERENCE PARENT
      CALL ELREF1(ELREFP)
      CALL ELREF4(' ','RIGI',NDIM,NNOP,IBID,IBID,IBID,IBID,IBID,IBID)

C     SOUS-ELEMENT DE REFERENCE : RECUP DE NNO
      IF (.NOT.ISMALI(ELREFP).AND. NDIM.LE.2) THEN
        IRESE=3
      ELSE
        IRESE=0
      ENDIF

      CALL ELREF4(ELRESE(NDIM+IRESE),FAMI(NDIM+IRESE),IBID,NNO,IBID,
     &     IBID,IBID,IBID,IBID,IBID)
C
C --- RECUPERATION DES CHAMPS IN ET OUT
C
      CALL JEVECH('PCNSETO','L',JCNSET)
      CALL JEVECH('PLONCHA','L',JLONCH)
      CALL JEVECH('PCVOISX','E',IVOISX)
C
C --- PREALABLES
C
      NSE = ZI(JLONCH-1+1)
      NNOTOT = NNOP+NINTER
C
C --- CALCUL DE LA CONNECTIVITE INVERSE

      CALL ASSERT((NSE+1)*NNOTOT.LE.NNONSX)
      DO 10 I=1,NNONSX
          VCNINX(I)=0
 10   CONTINUE
      CALL XCNINV(NNOTOT,NSE,NNOP,NNO,JCNSET,VCNINX)
C
C --- CALCUL DE LA SD VOISIN PAR SOUS ELEMENTS
C
      CALL XVOISE(NNOTOT,NSE,NNOP,NNO,JCNSET,VCNINX,ZI(IVOISX))
C
      CALL JEDEMA()
C
      END
