      SUBROUTINE TE0508(OPTION,NOMTE)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================

      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*16 OPTION,NOMTE
C ......................................................................
C    - FONCTION REALISEE:  OPTIONS FORC_NODA ET REFE_FORC_NODA
C                          POUR LA MODELISATION GRAD_VARI
C    - ARGUMENTS:
C        DONNEES:      OPTION       -->  OPTION DE CALCUL
C                      NOMTE        -->  NOM DU TYPE ELEMENT
C ......................................................................
      INTEGER    NNOMAX,NPGMAX,EPSMAX,DDLMAX
      PARAMETER (NNOMAX=27,NPGMAX=27,EPSMAX=20,DDLMAX=15*NNOMAX)
C ......................................................................
      CHARACTER*8 TYPMOD(2)
      LOGICAL AXI
      INTEGER NNO,NNOB,NPG,NDIM,NDDL,NEPS
      INTEGER IRET,NNOS,JGANO,IPOIDS,IVF,IDFDE,IVFB,IDFDEB,JGANOB
      INTEGER IGEOM,ICONTM,IVECTU
      REAL*8  SIGREF,VARREF,LAGREF,SREF(11)
      REAL*8  B(EPSMAX,NPGMAX,DDLMAX),W(NPGMAX),NI2LDC(EPSMAX)
      CHARACTER*16 NOMELT
      COMMON /FFAUTO/ NOMELT



C - INITIALISATION

      NOMELT = NOMTE
      CALL TEATTR(' ','S','TYPMOD',TYPMOD(1),IRET)
      TYPMOD(2) = 'GRADVARI'
      AXI = TYPMOD(1).EQ.'AXIS'

      CALL ELREFV(NOMTE,'RIGI',NDIM,NNO,NNOB,NNOS,NPG,IPOIDS,IVF,
     &              IVFB,IDFDE,IDFDEB,JGANO,JGANOB)



C - CALCUL DES ELEMENTS CINEMATIQUES

      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL NMGVMB(NDIM,NNO,NNOB,NPG,AXI,ZR(IGEOM),ZR(IVF),ZR(IVFB),
     &            IDFDE,IDFDEB,IPOIDS,NDDL,NEPS,B,W,NI2LDC)

C - OPTION FORC_NODA

      IF (OPTION.EQ.'FORC_NODA') THEN
        CALL JEVECH('PCONTMR','L',ICONTM)
        CALL JEVECH('PVECTUR','E',IVECTU)
        CALL NGFORC(NDDL,NEPS,NPG,W,B,NI2LDC,ZR(ICONTM),ZR(IVECTU))
      ENDIF



C - OPTION REFE_FORC_NODA

      IF (OPTION.EQ.'REFE_FORC_NODA') THEN
        CALL JEVECH('PVECTUR','E',IVECTU)

C      LECTURE DES COMPOSANTES DE REFERENCE
        CALL TEREFE('SIGM_REFE','MECA_GRADVARI',SIGREF)
        CALL TEREFE('VARI_REFE','MECA_GRADVARI',VARREF)
        CALL TEREFE('LAGR_REFE','MECA_GRADVARI',LAGREF)

C      AFFECTATION DES CONTRAINTES GENERALISEES DE REFERENCE
        IF (NDIM.EQ.2) THEN
          SREF(1) = SIGREF
          SREF(2) = SIGREF
          SREF(3) = SIGREF
          SREF(4) = SIGREF
          SREF(5) = LAGREF
          SREF(6) = VARREF
          SREF(7) = 0
          SREF(8) = 0
        ELSE IF (NDIM.EQ.3) THEN
          SREF(1) = SIGREF
          SREF(2) = SIGREF
          SREF(3) = SIGREF
          SREF(4) = SIGREF
          SREF(5) = SIGREF
          SREF(6) = SIGREF
          SREF(7) = LAGREF
          SREF(8) = VARREF
          SREF(9) = 0
          SREF(10) = 0
          SREF(11) = 0
        END IF

        CALL NGFORE(NDDL,NEPS,NPG,W,B,NI2LDC,SREF,ZR(IVECTU))
      END IF

      END
