      SUBROUTINE TE0518(OPTION,NOMTE)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================

      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*16 OPTION,NOMTE
C ......................................................................
C   CALCUL DES COEFFICIENTS A0 ET A1 POUR LE PILOTAGE PAR CRITERE
C   ELASTIQUE OU PAR DEFORMATION POUR LES ELEMENTS GRAD_VARI
C ......................................................................
      INTEGER    NNOMAX,NPGMAX,EPSMAX,DDLMAX
      PARAMETER (NNOMAX=27,NPGMAX=27,EPSMAX=20,DDLMAX=15*NNOMAX)
C ......................................................................
      CHARACTER*8 TYPMOD(2)
      CHARACTER*16 TYPILO
      LOGICAL AXI
      INTEGER NNO,NNOB,NPG,NDIM,NDDL,NEPS,LGPG,JTAB(7)
      INTEGER IRET,NNOS,JGANO,IPOIDS,IVF,IDFDE,IVFB,IDFDEB,JGANOB
      INTEGER IGEOM,IMATE,ITYPE,ICONTM,IVARIM,ICOPIL,IBORNE,ICTAU
      INTEGER IDDLM,IDDLD,IDDL0,IDDL1,ICOMPO
      REAL*8  B(EPSMAX,NPGMAX,DDLMAX),W(NPGMAX),NI2LDC(EPSMAX)
      REAL*8  ETAMIN,ETAMAX
      CHARACTER*16 NOMELT
      COMMON /FFAUTO/ NOMELT


C - INITIALISATION

      NOMELT = NOMTE
      CALL TEATTR(' ','S','TYPMOD',TYPMOD(1),IRET)
      TYPMOD(2) = 'GRADVARI'
      AXI = TYPMOD(1).EQ.'AXIS'

      CALL ELREFV(NOMTE,'RIGI',NDIM,NNO,NNOB,NNOS,NPG,IPOIDS,IVF,
     &              IVFB,IDFDE,IDFDEB,JGANO,JGANOB)


C - CALCUL DES ELEMENTS CINEMATIQUES

      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL NMGVMB(NDIM,NNO,NNOB,NPG,AXI,ZR(IGEOM),ZR(IVF),ZR(IVFB),
     &            IDFDE,IDFDEB,IPOIDS,NDDL,NEPS,B,W,NI2LDC)
C - TYPE DE PILOTAGE (IDENTIQUE A UNE SELECTION VIA LE NOM DE L'OPTION

      CALL JEVECH('PTYPEPI','L',ITYPE)
      TYPILO = ZK16(ITYPE)


C - PARAMETRES COMMUNS AUX MODELES DE PILOTAGE

      CALL JEVECH('PDEPLMR','L',IDDLM)
      CALL JEVECH('PDDEPLR','L',IDDLD)
      CALL JEVECH('PDEPL0R','L',IDDL0)
      CALL JEVECH('PDEPL1R','L',IDDL1)
      CALL JEVECH('PCDTAU', 'L',ICTAU)
      CALL JEVECH('PCOPILO','E',ICOPIL)


C - PARAMETRES SPECIFIQUES AU PILOTAGE PAR LA LOI DE COMPORTEMENT

      IF (TYPILO .EQ. 'PRED_ELAS') THEN
        CALL JEVECH('PMATERC','L',IMATE)
        CALL JEVECH('PCOMPOR','L',ICOMPO)
        CALL JEVECH('PCONTMR','L',ICONTM)
        CALL JEVECH('PVARIMR','L',IVARIM)
        CALL JEVECH('PBORNPI','L',IBORNE)

C      BORNES POUR LE PILOTAGE (SELON LOIS DE COMPORTEMENT)
        ETAMIN=ZR(IBORNE+1)
        ETAMAX=ZR(IBORNE)

C      NOMBRE DE VARIABLES INTERNES
        CALL TECACH('OON','PVARIMR',7,JTAB,IRET)
        LGPG = MAX(JTAB(6),1)*JTAB(7)
      ELSE
        IMATE=1
        ICOMPO=1
        ICONTM=1
        IVARIM=1
        IBORNE=1
        LGPG=0
        ETAMIN=0.D0
        ETAMAX=0.D0
      END IF

      CALL NGPIPE(TYPILO,NPG,NEPS,NDDL,B,NI2LDC,TYPMOD,ZI(IMATE),
     &  ZK16(ICOMPO),LGPG,ZR(IDDLM),ZR(ICONTM),ZR(IVARIM),ZR(IDDLD),
     &  ZR(IDDL0),ZR(IDDL1),ZR(ICTAU),ETAMIN,ETAMAX,ZR(ICOPIL))

      END
