      SUBROUTINE TE0550(OPTION,NOMTE)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C.......................................................................
      IMPLICIT NONE

C     BUT: CALCUL DES MATRICES ELEMENTAIRES EN MECANIQUE
C          CORRESPONDANT A UNE IMPEDANCE IMPOSEE
C          SUR DES FACES D'ELEMENTS ISOPARAMETRIQUES 2D

C          OPTION : 'IMPE_ABSO'

C     ENTREES  ---> OPTION : OPTION DE CALCUL
C          ---> NOMTE  : NOM DU TYPE ELEMENT
C.......................................................................

      INCLUDE 'jeveux.h'

      INTEGER ICODRE
      CHARACTER*8 FAMI,POUM
      CHARACTER*16 NOMTE,OPTION
      REAL*8 NX,NY,POIDS,A(6,6)
      REAL*8 VITES(6)
      INTEGER IPOIDS,IVF,IDFDE,IGEOM,IMATE
      INTEGER NDI,NNO,KP,NPG
      INTEGER LDEC,KPG,SPT
      LOGICAL LTEATT,LAXI


C-----------------------------------------------------------------------
      INTEGER I ,II ,IVECTU ,IVIEN ,IVITE ,J ,JGANO
      INTEGER JJ ,NDIM ,NNOS
      REAL*8 CELER ,R ,R8B
C-----------------------------------------------------------------------
      CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG,IPOIDS,IVF,IDFDE,JGANO)
      NDI = 2*NNO
      LAXI = .FALSE.
      IF (LTEATT(' ','AXIS','OUI')) LAXI = .TRUE.

      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PMATERC','L',IMATE)
      CALL JEVECH('PVITPLU','L',IVITE)
      CALL JEVECH('PVITENT','L',IVIEN)
      FAMI='FPG1'
      KPG=1
      SPT=1
      POUM='+'
      CALL RCVALB(FAMI,KPG,SPT,POUM,ZI(IMATE),' ','FLUIDE',0,' ',R8B,1,
     &            'CELE_R',CELER,ICODRE,1)
      IF (CELER.LT.1.D-1) GO TO 110

      CALL JEVECH('PVECTUR','E',IVECTU)

C --- INITIALISATION DU VECTEUR DE CORRECTION
      DO 10 I = 1,NDI
        ZR(IVECTU+I-1) = 0.D0
   10 CONTINUE

C --- INITIALISATION DE LA MATRICE D'IMPEDANCE
      CALL MATINI(6,6,0.D0,A)

C     BOUCLE SUR LES POINTS DE GAUSS

      DO 100 KP = 1,NPG
        LDEC = (KP-1)*NNO
        NX = 0.0D0
        NY = 0.0D0
        CALL VFF2DN(NDIM,NNO,KP,IPOIDS,IDFDE,ZR(IGEOM),NX,NY,POIDS)
C%
        IF (LAXI) THEN
          R = 0.D0
          DO 40 I = 1,NNO
            R = R + ZR(IGEOM+2* (I-1))*ZR(IVF+LDEC+I-1)
   40     CONTINUE
          POIDS = POIDS*R
        END IF
C%
        DO 60 I = 1,NNO

          DO 50 J = 1,NNO
            II = 2*I
            JJ = 2*J - 1

            A(II,JJ) = A(II,JJ) - POIDS/CELER*ZR(IVF+LDEC+I-1)*
     &                 ZR(IVF+LDEC+J-1)

   50     CONTINUE
   60   CONTINUE

C     CALCUL DE LA VITESSE ABSOLUE
        DO 70 I = 1,NDI
          VITES(I) = ZR(IVITE+I-1) + ZR(IVIEN+I-1)
   70   CONTINUE

        DO 90 I = 1,NDI
          DO 80 J = 1,NDI
            ZR(IVECTU+I-1) = ZR(IVECTU+I-1) - A(I,J)*VITES(J)
   80     CONTINUE
   90   CONTINUE

  100 CONTINUE
  110 CONTINUE

      END
