      SUBROUTINE TE0555(OPTION,NOMTE)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C.......................................................................
      IMPLICIT NONE
C
C     BUT: CALCUL DES MATRICES ELEMENTAIRES EN MECANIQUE
C          CORRESPONDANT A UNE IMPEDANCE IMPOSEE
C          SUR DES FACES D'ELEMENTS ISOPARAMETRIQUES 3D
C
C          OPTION : 'IMPE_ABSO'
C
C     ENTREES  ---> OPTION : OPTION DE CALCUL
C          ---> NOMTE  : NOM DU TYPE ELEMENT
C.......................................................................
C
      INCLUDE 'jeveux.h'

      INTEGER ICODRE(1)
      CHARACTER*8        NOMRES(1),FAMI,POUM
      CHARACTER*16       NOMTE,OPTION
      REAL*8             NX,NY,NZ,SX(9,9),SY(9,9),SZ(9,9),JAC
      REAL*8             VALRES(1),CELER,A(18,18),VITES(18)
      INTEGER            IPOIDS,IVF,IDFDX,IDFDY,IGEOM,IMATE
      INTEGER            NDIM,NNO,NDI,IPG,NPG2
      INTEGER            IDEC,JDEC,KDEC,LDEC
      INTEGER            IVITE,NNOS,JGANO,KPG,SPT
C
C
C-----------------------------------------------------------------------
      INTEGER I ,II ,INO ,IVECTU ,IVIEN ,J ,JJ
      INTEGER JNO ,MATER
      REAL*8 R8B
C-----------------------------------------------------------------------
      CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG2,IPOIDS,IVF,IDFDX,JGANO)
      IDFDY  = IDFDX  + 1
      NDI = 2*NNO
C
      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PMATERC','L',IMATE)
      CALL JEVECH('PVITPLU','L',IVITE)
      CALL JEVECH('PVITENT','L',IVIEN)

      MATER=ZI(IMATE)
      NOMRES(1)='CELE_R'
      FAMI='FPG1'
      KPG=1
      SPT=1
      POUM='+'
      CALL RCVALB(FAMI,KPG,SPT,POUM,MATER,' ','FLUIDE',0,' ',R8B,1,
     &            NOMRES,VALRES,ICODRE,1)
      CELER = VALRES(1)
      IF (CELER.LT.1.D-1) GOTO 999
C
      CALL JEVECH('PVECTUR','E',IVECTU)
C
C --- INITIALISATION DU VECTEUR DE CORRECTION
      DO 10 I = 1,NDI
         ZR(IVECTU+I-1) = 0.D0
10    CONTINUE

C
C --- RECUPERATION DES COORDONNEES DES POINTS DE GAUSS (SI NECESSAIRE)
C
C --- INITIALISATION DE LA MATRICE D'IMPEDANCE

      CALL MATINI(18,18,0.D0,A)
C
C        CALCUL DES PRODUITS VECTORIELS OMI X OMJ
C
         DO 1 INO = 1,NNO
            I = IGEOM + 3*(INO-1) -1
            DO 2 JNO = 1,NNO
               J = IGEOM + 3*(JNO-1) -1
               SX(INO,JNO) = ZR(I+2) * ZR(J+3) - ZR(I+3) * ZR(J+2)
               SY(INO,JNO) = ZR(I+3) * ZR(J+1) - ZR(I+1) * ZR(J+3)
               SZ(INO,JNO) = ZR(I+1) * ZR(J+2) - ZR(I+2) * ZR(J+1)
2           CONTINUE
1        CONTINUE
C
C        BOUCLE SUR LES POINTS DE GAUSS
C
         DO 101 IPG=1,NPG2
            KDEC = (IPG-1)*NNO*NDIM
            LDEC = (IPG-1)*NNO

            NX = 0.0D0
            NY = 0.0D0
            NZ = 0.0D0
C
C           CALCUL DE LA NORMALE AU POINT DE GAUSS IPG
C
            DO 102 I=1,NNO
               IDEC = (I-1)*NDIM
            DO 102 J=1,NNO
               JDEC = (J-1)*NDIM
C
           NX = NX + ZR(IDFDX+KDEC+IDEC) * ZR(IDFDY+KDEC+JDEC) * SX(I,J)
           NY = NY + ZR(IDFDX+KDEC+IDEC) * ZR(IDFDY+KDEC+JDEC) * SY(I,J)
           NZ = NZ + ZR(IDFDX+KDEC+IDEC) * ZR(IDFDY+KDEC+JDEC) * SZ(I,J)
C
102         CONTINUE
C
C           CALCUL DU JACOBIEN AU POINT DE GAUSS IPG
C
            JAC = SQRT(NX*NX + NY*NY + NZ*NZ)
C
C           CALCUL DE LA MATRICE D'IMPEDANCE POUR L'ORDRE 0
C
               DO 103 I=1,NNO
C
                  DO 104 J=1,NNO
C
                        II = 2*I
                        JJ = 2*J-1
                        A(II,JJ)=A(II,JJ) - JAC / CELER *
     &      ZR(IPOIDS+IPG-1) * ZR(IVF+LDEC+I-1) * ZR(IVF+LDEC+J-1)
C
104               CONTINUE
103            CONTINUE
101      CONTINUE

C     CALCUL DE LA VITESSE ABSOLUE
      DO 109 I = 1,NDI
         IF (IVIEN.NE.0) THEN
            VITES(I) = ZR(IVITE+I-1) + ZR(IVIEN+I-1)
         ELSE
            VITES(I) = ZR(IVITE+I-1)
         ENDIF
109   CONTINUE

      DO 110 I = 1,NDI
         DO 112 J = 1,NDI
            ZR(IVECTU+I-1)=ZR(IVECTU+I-1)
     &               -A(I,J)*VITES(J)
112      CONTINUE
110   CONTINUE

999   CONTINUE
      END
