      SUBROUTINE TE0562(OPTION,NOMTE)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================

      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*16 OPTION,NOMTE
C ......................................................................
C    - FONCTION REALISEE:  OPTION MASS_MECA_* POUR GRAD_VARI
C    - ARGUMENTS:
C        DONNEES:      OPTION       -->  OPTION DE CALCUL
C                      NOMTE        -->  NOM DU TYPE ELEMENT
C ......................................................................

      INTEGER DLNS
      INTEGER NNO,NPG1,IMATUU,NDIM,NNOS,JGANO,IRET,ICODR1
      INTEGER IPOIDS,IVF,IDFDE,IGEOM,IMATE
      INTEGER NNOB,IVFB,IDFDEB,JGANOB

      CHARACTER*8 TYPMOD(2)
      CHARACTER*16 PHENOM


      CALL ELREFV(NOMTE,'MASS',NDIM,NNO,NNOB,NNOS,NPG1,IPOIDS,IVF,
     &  IVFB,IDFDE,IDFDEB,JGANO,JGANOB)

C    TYPE DE MODELISATION
      CALL TEATTR(' ','S','TYPMOD',TYPMOD(1),IRET)
      TYPMOD(2) = 'GRADVARI'

C     PARAMETRES EN ENTREE

      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PMATERC','L',IMATE)
      CALL JEVECH('PMATUUR','E',IMATUU)

C    DEPLACEMENT + LAMBDA + VAR_REG
      CALL ASSERT(NDIM.EQ.2 .OR. NDIM.EQ.3)
      DLNS = NDIM + 2

      CALL MASSUP(OPTION,NDIM,DLNS,NNO,NNOB,ZI(IMATE),PHENOM,
     &  NPG1,IPOIDS,IDFDE,ZR(IGEOM),ZR(IVF),
     &  IMATUU,ICODR1,IGEOM,IVF)

      END
