      SUBROUTINE VFF2DN( NDIM,NNO,IPG,IPOIDS,IDFDE,COOR,NX,NY,JAC )
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      INTEGER            NDIM,NNO,IPOIDS,IDFDE,IPG,I,K
      REAL *8            DX,COOR(1),NX,NY,JAC,DXDS,DYDS
C ......................................................................
C    - BUT:  CALCULER LA VALEUR DU POIDS D'INTEGRATION EN 1 POINT DE
C            GAUSS POUR UN SEGMENT PLAN  A 2 OU 3 NOEUDS.
C      CALCULE AUSSI LA NORMALE AU SEGMENT AU POINT DE GAUSS.
C
C    - ARGUMENTS:
C        DONNEES:
C        IPG      -->  NUMERO DU POINT DE GAUSS
C        NDIM     -->  1 (SEGMENT)
C        IPOIDS   -->  ADRESSE DES POIDS DE GAUSS
C        NNO      -->  NOMBRE DE NOEUDS
C        DFDE     -->  ADRESSES DES DERIVEES DES FONCTIONS DE FORME
C        COOR     -->  COORDONNEES DES NOEUDS
C
C        RESULTATS:    NX,NY    <--  COMPOSANTES DE LA NORMALE
C                      JAC      <--  PRODUIT DU JACOBIEN ET DU POIDS
C
C  REMARQUE :
C    - LES SEGMENTS DOIVENT ETRE "PLANS" (DANS OXY)
C ......................................................................
C
C
      CALL ASSERT(NDIM.EQ.1)
      DXDS = 0.D0
      DYDS = 0.D0
      DO 1 I = 1,NNO
         K = NNO*(IPG-1)
         DX = ZR(IDFDE-1+K+I)
         DXDS = DXDS + DX * COOR(2*I-1)
         DYDS = DYDS + DX * COOR(2*I)
 1    CONTINUE
      JAC = SQRT(DXDS**2 + DYDS**2)
      NX  =  DYDS/JAC
      NY  = -DXDS/JAC
      JAC = ZR(IPOIDS + IPG-1) * JAC
      END
