      SUBROUTINE XSELNO(NNO,NNOP,NBSIG,NSE,NDIM,JCNSET,SISENO,JOUT2)
      IMPLICIT NONE
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
C    - FONCTIONS REALISEES :  ROUTINE X-FEM
C
C          PASSAGE DES CONTRAINTES
C          DES POINTS DE GAUSS DES SOUS-ELEMENTS :
C            * AUX NOEUDS DES ELEMENTS PARENTS
C              (OPTION 'SIGM_ELNO') ;
C            * AUX SOMMETS (NOEUDS) DES SOUS-ELEMENTS
C              (OPTION 'SISE_ELNO') ;
C
C    - ARGUMENTS:
C        DONNEES:      OPTION       -->  OPTION DE CALCUL
C                      NOMTE        -->  NOM DU TYPE ELEMENT
C ......................................................................
C
C
C
C
      INCLUDE 'jeveux.h'
      INTEGER MXVAL
      PARAMETER (MXVAL=6*3*4)
C     EN 2D :
C     MXVAL =  6 (NBSE MAX) * 3 (NBNOSE MAX) * 4 (NBCMP MAX)
C     EN 3D :
C     MXVAL = 32 (NBSE MAX) * 4 (NBNOSE MAX) * 6 (NBCMP MAX)

      INTEGER NDIM,NNOP,NNO
      INTEGER NBSIG,NBSECO(27)
      INTEGER JCNSET
      INTEGER JOUT2
      INTEGER I,J,NSE,ISE,IN,INO,IC

      REAL*8 TMP,SOMSIG(27,6)

      REAL*8 SISENO(MXVAL)

C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()

C     TABLEAUX DE LA SOMME DES CONTRAINTES
      DO 444 I=1,NNOP
        DO 445 J=1,NBSIG
          SOMSIG(I,J)=0
 445    CONTINUE
 444  CONTINUE

C     TABLEAUX DU NOMBRE DE SOUS-ELEMENTS CONNECTES AUX NOEUDS
      DO 446 I=1,NNOP
        NBSECO(I)=0
 446  CONTINUE

C       BOUCLE SUR LES NSE SOUS-LMENTS
      DO 210 ISE=1,NSE

C       BOUCLE SUR LES 4/3 SOMMETS DU SOUS-TETRA/TRIA
        DO 211 IN=1,NNO
          INO=ZI(JCNSET-1+(NDIM+1)*(ISE-1)+IN)
          IF (INO.LT.1000) THEN
            NBSECO(INO)=NBSECO(INO)+1
            DO 212 IC = 1,NBSIG
              TMP =  SISENO(NBSIG*NNO*(ISE-1)+NBSIG*(IN-1)+IC)
              SOMSIG(INO,IC)=SOMSIG(INO,IC)+TMP
 212        CONTINUE
          ENDIF
 211    CONTINUE

 210  CONTINUE

C     MOYENNES DES CONTRAINTES AUX NOEUDS DE L'ELEMENT PARENT
      DO 300 INO = 1,NNOP
        CALL ASSERT(NBSECO(INO).GT.0)
        DO 310 IC = 1,NBSIG
          ZR(JOUT2-1+NBSIG*(INO-1)+IC) = SOMSIG(INO,IC) / NBSECO(INO)
 310    CONTINUE
 300  CONTINUE

      CALL JEDEMA()

      END
