      SUBROUTINE XTLAGC(TYPMAI,NDIM  ,NNC   ,JNN    ,
     &                  NDDLS ,NFACE ,CFACE ,JDEPDE,JPCAI  ,
     &                  FFC   ,NCONTA,
     &                  NFHE,LMULTI,HEAVNO,DLAGRC)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      INTEGER      NDIM,NNC,JNN(3),NFHE
      INTEGER      JDEPDE,JPCAI,HEAVNO(8)
      REAL*8       FFC(9)
      CHARACTER*8  TYPMAI
      REAL*8       DLAGRC
      INTEGER      CFACE(5,3),NFACE,NCONTA
      LOGICAL      LMULTI
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODE XFEMGG - CALCUL ELEM.)
C
C CALCUL DES INCREMENTS - LAGRANGE DE CONTACT
C
C ----------------------------------------------------------------------
C ROUTINE SPECIFIQUE A L'APPROCHE <<GRANDS GLISSEMENTS AVEC XFEM>>,
C TRAVAIL EFFECTUE EN COLLABORATION AVEC I.F.P.
C ----------------------------------------------------------------------
C
C
C DEPDEL - INCREMENT DE DEPLACEMENT DEPUIS DEBUT DU PAS DE TEMPS
C
C IN  NDIM   : DIMENSION DU MODELE
C IN  NNC    : NOMBRE DE NOEUDS DE CONTACT
C IN  NN     : NOMBRE DE NOEUDS
C IN  NDDLS  : NOMBRE DE DDL SUR UN NOEUD SOMMET
C IN  NNS    : NOMBRE DE NOEUDS SOMMETS
C IN  JDEPDE : ADRESSE JEVEUX POUR DEPDEL
C IN  FFC    : FONCTIONS DE FORMES LAGR.
C IN  CFACE  : CONNECTIVIT DES NOEUDS DES FACETTES
C IN  NFACE  : NUMRO DE LA FACETTE
C IN  JAINT  : ADRESSE DES INFORMATIONS CONCERNANT LES ARETES COUPES
C IN  TYPMAI : TYPE DE LA MAILLE
C OUT DLAGRC : INCREMENT DEPDEL DU LAGRANGIEN DE CONTACT
C
C
C
C
      INTEGER INO
      INTEGER IN,XOULA,PL,NN,NNS,NDDLS
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      NN = JNN(1)
      NNS= JNN(2)
C
      DLAGRC    = 0.D0
C
C --- LAGRANGE DE CONTACT
C
      DO 230 INO = 1,NNC
C --- XOULA NE SERT PLUS A RIEN AVEC LA FORMULATION NOEUDS SOMMETS !!!
        IN     = XOULA(CFACE ,NFACE ,INO   ,JPCAI ,TYPMAI,NCONTA)
        CALL XPLMA2(NDIM  ,NN    ,NNS   ,NDDLS ,IN    ,NFHE  ,PL    )
        IF (LMULTI) PL = PL + (HEAVNO(INO)-1)*NDIM
        DLAGRC = DLAGRC+FFC(INO)*ZR(JDEPDE-1+PL+1-1)
 230  CONTINUE
C
      CALL JEDEMA()
C
      END
