      SUBROUTINE JXLOCS ( ITAB, GEN1, LTY1, LON1, JADM , LDEPS, JITAB)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF JEVEUX  DATE 13/11/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE LEFEBVRE J-P.LEFEBVRE
C TOLE CRP_6
      IMPLICIT NONE
      INCLUDE 'jeveux_private.h'
      INTEGER             ITAB(*) ,   LTY1,  LON1, JADM,  JITAB
      LOGICAL                                            LDEPS
      CHARACTER *(*)            GEN1
C ----------------------------------------------------------------------
C RENVOIE L'ADRESSE DU SEGMENT DE VALEUR PAR RAPPORT A ITAB
C ROUTINE AVEC APPEL SYSTEME : LOC
C
C IN  ITAB   : TABLEAU PAR RAPPORT AUQUEL L'ADRESSE EST RENVOYEE
C IN  GEN1   : GENRE DE L'OBJET ASSOCIE
C IN  LTY1   : LONGUEUR DU TYPE DE L'OBJET ASSOCIE
C IN  LON1   : LONGUEUR DU SEGMENT DE VALEUR EN OCTET
C IN  JADM   : ADRESSE MEMOIRE DU SEGMENT DE VALEUR EN OCTET
C IN  LDEPS  : .TRUE. SI ON AUTUORISE LE DEPLACEMENT EN MEMOIRE
C OUT JITAB  : ADRESSE DANS ITAB DU SEGMENT DE VALEUR
C ----------------------------------------------------------------------
      INTEGER          LK1ZON , JK1ZON , LISZON , JISZON 
      COMMON /IZONJE/  LK1ZON , JK1ZON , LISZON , JISZON
      INTEGER          LBIS , LOIS , LOLS , LOR8 , LOC8
      COMMON /IENVJE/  LBIS , LOIS , LOLS , LOR8 , LOC8
      INTEGER          ILOC
      COMMON /ILOCJE/  ILOC
C
      INTEGER          IDEC
      INTEGER*8        VALLOC,IA,LTYP2
C DEB-------------------------------------------------------------------
C-----------------------------------------------------------------------
      INTEGER IR ,KADM ,LADM 
C-----------------------------------------------------------------------
      KADM = JADM
      LADM = ISZON(JISZON + KADM - 3)
      JITAB = 0
      VALLOC = LOC(ITAB)
      IA = (ILOC-VALLOC) + KADM*LOIS
      IR = 0
      LTYP2 = LTY1
      IDEC = MOD(IA,LTYP2)
      IF ( IDEC .NE. 0 .AND. GEN1(1:1) .NE. 'N' ) THEN
        IF ( IDEC .GT. 0 ) THEN
          IR = LTY1 - IDEC
        ELSE
          IR = -IDEC
        ENDIF
      ENDIF
      IF ( LTY1 .NE. LOIS .AND. GEN1(1:1) .NE. 'N' ) THEN
        IF ( IR .NE. LADM ) THEN
          IF ( LDEPS ) THEN
            CALL JXDEPS ( (KADM-1)*LOIS + LADM + 1 ,
     &                    (KADM-1)*LOIS + IR   + 1 , LON1 )
          ELSE
            CALL U2MESS('F','JEVEUX1_60')
          ENDIF
        ENDIF
      ENDIF
      JITAB = 1 + (IA+IR)/LTY1
      ISZON(JISZON + KADM - 3 ) = IR
C FIN ------------------------------------------------------------------
      END
