      SUBROUTINE  CALCSP ( CASINT, NOMU, TABLE, FREQ, MASG, NBM,
     &                     NBMR, IMOD1, NUOR, IVITE )
      IMPLICIT NONE
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C-----------------------------------------------------------------------
C     CALCUL POUR CHAQUE VITESSES DES INTERSPECTRES DE REPONSES
C-----------------------------------------------------------------------
C IN  : CASINT: BOOLEEN CARACTERISANT L'OPTION DE CALCUL
C       CASINT= TRUE   => ON CALCULE TOUS LES INTERSPECTRES
C       CASINT= FALSE  => ON CALCULE LES AUTOSPECTRES UNIQUEMENT
C IN  : NOMU  : NOM UTILISATEUR DU CONCEPT TABL_INTSP CORRESPONDANT
C               AUX INTERSPECTRES DE REPONSES : A PRODUIRE
C IN  : TABLE : NOM UTILISATEUR DU CONCEPT TABL_INTSP CORRESPONDANT
C               AUX INTERSPECTRES D'EXCITATIONS : DONNEE DU CALCUL
C IN  : FREQ  : TABLEAU DES FREQUENCES ET AMORTISSEMENTS
C IN  : MASG  : TABLEAU DES MASSES GENERALISEES
C IN  : NBM   : NOMBRE DE MODES DE LA BASE DE CONCEPT MELASFLU
C IN  : NBMR  : NOMBRE DE MODES PRIS EN COMPTE
C IN  : IMOD1 : INDICE DU PREMIER MODE PRIS EN COMPTE DANS LA BASE DE
C               CONCEPT MELASFLU
C IN  : NUOR  : LISTE DES NUMEROS D'ORDRE DES MODES PRIS EN COMPTE
C IN  : IVITE : NUMERO VITESSE DU FLUIDE
C     ----------------------------------------------------------------
C
      INCLUDE 'jeveux.h'

      CHARACTER*32 JEXNUM
      LOGICAL       CASINT
      CHARACTER*8   NOMU, TABLE
      INTEGER       NBM, NBMR, IMOD1, NUOR(*),IVITE
      REAL*8        FREQ(*), MASG(*)
C
C-----------------------------------------------------------------------
      INTEGER IDEB ,IFONC ,IHI ,IHI1 ,IHR
      INTEGER IHR1 ,IL ,IM ,IM1 ,IM2 ,IMB ,IMODF
      INTEGER IP ,IV ,LVALE ,NBPF

      REAL*8 FR ,FRI ,HHI ,HHR ,HII1 ,HII2 ,HIR1
      REAL*8 HIR2 ,PI ,R8PI
C-----------------------------------------------------------------------
      INTEGER       IVAL(3), VALI(2)
      INTEGER       LNUMI,LNUMJ,LFREQ,I1,NBABS
      INTEGER       LRNUMI,LRNUMJ,LRFREQ,MXVAL,MRXVAL,IPF
      REAL*8        MGI, KSI, HDENOM
      CHARACTER*8   K8B
      CHARACTER*24  CHNUMI,CHNUMJ,CHFREQ,CHVALE
      CHARACTER*24  CRNUMI,CRNUMJ,CRFREQ,CRVALE
C
C-----------------------------------------------------------------------
      CALL JEMARQ()
C
      PI = R8PI()
      IMODF = IMOD1 + NBMR - 1
C
      CHNUMI = TABLE//'.NUMI'
      CHNUMJ = TABLE//'.NUMJ'
      CHFREQ = TABLE//'.FREQ'
      CHVALE = TABLE//'.VALE'
      CALL JEVEUO(CHNUMI,'L',LNUMI)
      CALL JEVEUO(CHNUMJ,'L',LNUMJ)
      CALL JEVEUO(CHFREQ,'L',LFREQ)
      CALL JELIRA(CHNUMI,'LONMAX',MXVAL,K8B)
      CALL JELIRA(CHFREQ,'LONMAX',NBPF,K8B)
C
      CRNUMI = NOMU//'.NUMI'
      CRNUMJ = NOMU//'.NUMJ'
      CRFREQ = NOMU//'.FREQ'
      CRVALE = NOMU//'.VALE'
      CALL WKVECT(CRFREQ,'G V R',NBPF,LRFREQ)
      DO 240 IP = 1,NBPF
        ZR(LRFREQ+IP-1) = ZR(LFREQ+IP-1)
240   CONTINUE

      MRXVAL = 0
      DO 250 IM2 = 1,NBMR
        IDEB = IM2
        IF ( CASINT ) IDEB = 1
        DO 260 IM1 = IDEB,IM2
          MRXVAL = MRXVAL+1
260     CONTINUE
250   CONTINUE
C
      CALL WKVECT(CRNUMI,'G V I',MRXVAL,LRNUMI)
      CALL WKVECT(CRNUMJ,'G V I',MRXVAL,LRNUMJ)
C
      CALL JECREC(CRVALE,'G V R','NU','DISPERSE','VARIABLE',MRXVAL)

C --- CREATION DE VECTEURS DE TRAVAIL ---
C
      CALL WKVECT('&&CALCSP.TEMP.HR  ','V V R8',NBMR*NBPF,IHR  )
      CALL WKVECT('&&CALCSP.TEMP.HI  ','V V R8',NBMR*NBPF,IHI  )
C
      IV = IVITE
        DO 25 IM = IMOD1,IMODF
          FRI = FREQ(2*NBM*(IV-1)+2*(IM-1)+1)
          IF ( FRI.LT.0.D0 ) THEN
             VALI(1) = IV
             VALI(2) = NUOR(IM)
             CALL U2MESI('A','MODELISA2_90', 2 ,VALI)
             GO TO 20
          ENDIF
 25     CONTINUE
C
        DO 30 IM = IMOD1,IMODF
C
          MGI = MASG(IM)*4.D0*PI*PI
          FRI = FREQ(2*NBM*(IV-1)+2*(IM-1)+1)
          KSI = FREQ(2*NBM*(IV-1)+2*(IM-1)+2)
          IF ( KSI .LE. 0.D0 ) KSI = 1.D-06
C
          IMB = IM - IMOD1 + 1
C
          DO 40 IP = 1,NBPF
            FR = ZR(LFREQ+IP-1)
            IHR1 = IHR+NBPF*(IMB-1)+IP-1
            IHI1 = IHI+NBPF*(IMB-1)+IP-1
            ZR(IHR1) = (MGI*(FRI*FRI - FR*FR))
            ZR(IHI1) = (MGI*KSI*FR*FRI*2.D0)

 40       CONTINUE
 30     CONTINUE
C
        IPF = 1
        DO 50 IM2 = 1,NBMR
C
          IVAL(3) = NUOR(IM2)
C
          IDEB = IM2
          IF ( CASINT ) IDEB = 1
C
          DO 60 IM1 = IDEB,IM2
C
            IVAL(2) = NUOR(IM1)
C
            DO 200 I1 = 1,MXVAL
              IF ((ZI(LNUMI-1+I1) .EQ. IVAL(3)) .AND.
     &            (ZI(LNUMJ-1+I1) .EQ. IVAL(2))) THEN
                CALL JEVEUO(JEXNUM(CHVALE,I1),'L',IFONC)
              ENDIF
200         CONTINUE

        CALL JECROC(JEXNUM(CRVALE,IPF))
          ZI(LRNUMI-1+IPF) = IVAL(3)
          ZI(LRNUMJ-1+IPF) = IVAL(2)
        IF (IVAL(2) .EQ. IVAL(3)) THEN
          NBABS = NBPF
        ELSE
          NBABS = 2*NBPF
        ENDIF
        CALL JEECRA(JEXNUM(CRVALE,IPF),'LONMAX',NBABS,' ')
        CALL JEECRA(JEXNUM(CRVALE,IPF),'LONUTI',NBABS,' ')
        CALL JEVEUO(JEXNUM(CRVALE,IPF),'E',LVALE)
            IPF = IPF + 1
C
            DO 80 IL = 1,NBPF
              HIR1 = ZR(IHR+NBPF*(IM1-1)+IL-1)
              HII1 = ZR(IHI+NBPF*(IM1-1)+IL-1)
              HIR2 = ZR(IHR+NBPF*(IM2-1)+IL-1)
              HII2 = ZR(IHI+NBPF*(IM2-1)+IL-1)
              HDENOM = (HIR1*HIR1+HII1*HII1)*(HIR2*HIR2+HII2*HII2)
              HHR = (HIR1*HIR2 + HII1*HII2)/HDENOM
              HHI = (HIR2*HII1 - HIR1*HII2)/HDENOM

              IF (IVAL(2) .EQ. IVAL(3)) THEN
                ZR(LVALE+IL-1)   = HHR*ZR(IFONC+IL-1)
              ELSE
                ZR(LVALE+2*(IL-1))  = HHR*ZR(IFONC+2*(IL-1))-
     &                                HHI*ZR(IFONC+2*(IL-1)+1)
                ZR(LVALE+2*(IL-1)+1)= HHR*ZR(IFONC+2*(IL-1)+1)+
     &                                HHI*ZR(IFONC+2*(IL-1))
              ENDIF
 80         CONTINUE
C
 60       CONTINUE
 50     CONTINUE
 20   CONTINUE
C
C
C --- MENAGE
C
      CALL JEDETR('&&CALCSP.TEMP.HR  ')
      CALL JEDETR('&&CALCSP.TEMP.HI  ')
C
      CALL JEDEMA()
      END
