      SUBROUTINE CARACM(CHAR  ,NZOCO ,IFORM )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*8  CHAR
      INTEGER      NZOCO
      INTEGER      IFORM
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES MAILLEES - LECTURE DONNEES)
C
C CREATION DES SDS DE DEFINITION DU CONTACT
C SDS DEDIEES AUX METHODES MAILLEES
C
C ----------------------------------------------------------------------
C
C
C IN  CHAR   : NOM UTILISATEUR DU CONCEPT DE CHARGE
C IN  IFORM  : TYPE DE FORMULATION (DISCRET/CONTINU/XFEM)
C IN  NZOCO  : NOMBRE DE ZONES DE CONTACT
C
C
C
C
      LOGICAL      LMAIL
      CHARACTER*24 DEFICO
      INTEGER      CFMMVD,ZTOLE ,ZDIRN ,ZMETH
      CHARACTER*24 METHCO,DIRAPP,TOLECO,DIRNOR
      INTEGER      JMETH ,JDIRAP,JTOLE,JDIRNO
      CHARACTER*24 JEUFO1,JEUFO2
      INTEGER      JJFO1 ,JJFO2
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      DEFICO = CHAR(1:8)//'.CONTACT'
      LMAIL  = (IFORM.EQ.1).OR.(IFORM.EQ.2)
C
C --- CREATION DES SD DE BASE
C
      METHCO = DEFICO(1:16)//'.METHCO'
      DIRAPP = DEFICO(1:16)//'.DIRAPP'
      DIRNOR = DEFICO(1:16)//'.DIRNOR'
      JEUFO1 = DEFICO(1:16)//'.JFO1CO'
      JEUFO2 = DEFICO(1:16)//'.JFO2CO'
      TOLECO = DEFICO(1:16)//'.TOLECO'
C
      ZMETH  = CFMMVD('ZMETH')
      ZDIRN  = CFMMVD('ZDIRN')
      ZTOLE  = CFMMVD('ZTOLE')
C
      IF (LMAIL) THEN
        CALL WKVECT(METHCO,'G V I' ,ZMETH*NZOCO  ,JMETH )
        CALL WKVECT(DIRAPP,'G V R' ,3*NZOCO      ,JDIRAP)
        CALL WKVECT(DIRNOR,'G V R' ,ZDIRN*NZOCO  ,JDIRNO)
        CALL WKVECT(JEUFO1,'G V K8',NZOCO        ,JJFO1 )
        CALL WKVECT(JEUFO2,'G V K8',NZOCO        ,JJFO2 )
        CALL WKVECT(TOLECO,'G V R' ,ZTOLE*NZOCO  ,JTOLE )
      ENDIF
C
      CALL JEDEMA()
C
      END
