      SUBROUTINE CGNOIV(IOCC,NOMAZ,LISNOZ,NBNO)
      IMPLICIT   NONE
      INCLUDE 'jeveux.h'

      INTEGER IOCC,NBNO
      CHARACTER*(*) NOMAZ,LISNOZ
C RESPONSABLE PELLET J.PELLET
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
C       CGNOIV -- TRAITEMENT DE L'OPTION INTERVALLE_VALE
C                 DU MOT FACTEUR CREA_GROUP_NO DE
C                 LA COMMANDE DEFI_GROUP
C
C -------------------------------------------------------
C  IOCC          - IN    - I    - : NUMERO D'OCCURENCE DU MOT-FACTEUR
C  NOMAZ         - IN    - K8   - : NOM DU MAILLAGE
C  LISNOZ        - JXVAR - K24  - : NOM DE LA LISTE DE NOEUDS RETENUS
C  NBNO          - OUT   -  I   - : LONGUEUR DE CETTE LISTE
C -------------------------------------------------------
C
      INTEGER N1,IBID,K,NBNOT,IARG,INO,JTRAV,NCMP
      INTEGER JLISNO,JCN2V,JCN2L,JCN2K
      CHARACTER*3 TSCA
      CHARACTER*8 NOCMP,NOMA,MA1,KBID,NOMGD
      CHARACTER*16 MOTFAC
      CHARACTER*19 CHAM19,CNS1,CNS2
      CHARACTER*24 LISNOI,VALK(5)
      REAL*8 VALR(2),VMIN,VMAX,V1
C     -----------------------------------------------------------------
C
      CALL JEMARQ()

      MOTFAC='CREA_GROUP_NO'
      LISNOI=LISNOZ
      NOMA=NOMAZ
      NBNO=0

      CALL GETVID(MOTFAC,'CHAM_GD',IOCC,IARG,1,CHAM19,N1)
      CALL GETVTX(MOTFAC,'NOM_CMP',IOCC,IARG,1,NOCMP,N1)
      CALL GETVR8(MOTFAC,'VALE',IOCC,IARG,2,VALR(1),N1)
      CALL ASSERT(N1.EQ.2)
      VMIN=VALR(1)
      VMAX=VALR(2)
      IF (VMIN.GT.VMAX)GOTO 30

      CALL DISMOI('F','NOM_MAILLA',CHAM19,'CHAMP',IBID,MA1,IBID)
      IF (NOMA.NE.MA1) THEN
        VALK(1)=CHAM19
        VALK(2)=NOMA
        CALL U2MESK('F','CALCULEL2_50',2,VALK)
      ENDIF
      CALL DISMOI('F','NB_NO_MAILLA',NOMA,'MAILLAGE',NBNOT,KBID,IBID)

      CNS1='&&CGNOIV.CNS1'
      CNS2='&&CGNOIV.CNS2'
      CALL CNOCNS(CHAM19,'V',CNS1)
      NCMP=1
      CALL CNSRED(CNS1,0,0,NCMP,NOCMP,'V',CNS2)

      CALL JEVEUO(CNS2//'.CNSK','L',JCN2K)
      CALL JEVEUO(CNS2//'.CNSV','L',JCN2V)
      CALL JEVEUO(CNS2//'.CNSL','L',JCN2L)
      NOMGD=ZK8(JCN2K-1+2)
      CALL DISMOI('F','TYPE_SCA',NOMGD,'GRANDEUR',IBID,TSCA,IBID)
      CALL ASSERT(TSCA.EQ.'R'.OR.TSCA.EQ.'I')

      CALL WKVECT('&&CGNOIV.LISNO','V V I',NBNOT,JTRAV)
      DO 10,INO=1,NBNOT
        IF (.NOT.ZL(JCN2L-1+(INO-1)*NCMP+1))GOTO 10
        IF (TSCA.EQ.'R') THEN
          V1=ZR(JCN2V-1+(INO-1)*NCMP+1)
        ELSEIF (TSCA.EQ.'I') THEN
          V1=ZI(JCN2V-1+(INO-1)*NCMP+1)
        ENDIF
        IF (V1.GE.VMIN .AND. V1.LE.VMAX) THEN
          NBNO=NBNO+1
          ZI(JTRAV-1+NBNO)=INO
        ENDIF
   10 CONTINUE


C
C --- ALLOCATION DU VECTEUR DES NUMEROS DES MAILLES RETENUES
C     --------------------------------------------------------
      CALL WKVECT(LISNOI,'V V I',MAX(NBNO,1),JLISNO)
      DO 20 K=1,NBNO
        ZI(JLISNO-1+K)=ZI(JTRAV-1+K)
   20 CONTINUE


C --- MENAGE :
      CALL JEDETR('&&CGNOIV.LISNO')
      CALL DETRSD('CHAM_NO_S',CNS1)
      CALL DETRSD('CHAM_NO_S',CNS2)

   30 CONTINUE
      CALL JEDEMA()

      END
