      SUBROUTINE DIMECZ(CHAR  ,NOMA  ,NZOCO ,IFORM )     
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C 
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*8  CHAR,NOMA
      INTEGER      NZOCO,IFORM
C      
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES MAILLEES - LECTURE DONNEES)
C
C CONSTRUCTION DU VECTEUR D'INFORMATION SUR LES LONGUEURS PAR ZONE
C      
C ----------------------------------------------------------------------
C
C
C IN  CHAR   : NOM UTILISATEUR DU CONCEPT DE CHARGE
C IN  NOMA   : NOM DU MAILLAGE
C IN  NZOCO  : NOMBRE DE ZONES DE CONTACT
C IN  IFORM  : FORMULATION DISCRETE(1) OU CONTINUE(2)
C
C
C
C
      CHARACTER*24 METHCO
      INTEGER      JMETH
      INTEGER      CFMMVD,ZMETH     
      INTEGER      IZONE,IMAE
      INTEGER      JDECME,JDECMM,JDECNE,JDECNM
      INTEGER      ISUMAE,ISUMAM
      INTEGER      POSMAE,NUMMAE
      INTEGER      NBNOM,NBNOE,NBMAM,NBMAE
      INTEGER      NBNOMC,NBNOEC,NBMAMC,NBMAEC     
      INTEGER      NBPT,NNINT
      CHARACTER*24 DEFICO
      INTEGER      MMINFI,TYPINT
      LOGICAL      MMINFL,LVERI
      INTEGER      NBPC
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      DEFICO = CHAR(1:8)//'.CONTACT'
      NBMAE  = 0
      NBNOE  = 0
      NBMAM  = 0
      NBMAE  = 0
      NBPT   = 0
      NBPC   = 0         
C 
C --- ACCES AUX STRUCTURES DE DONNEES DE CONTACT
C 
      METHCO = DEFICO(1:16)//'.METHCO'
      CALL JEVEUO(METHCO,'E',JMETH)
      ZMETH  = CFMMVD('ZMETH')
C
C --- NOMBRE DE NOEUDS ET DE MAILLES (TOTAL) PAR ZONE
C --- DECALAGES PAR ZONE
C
      DO 30 IZONE = 1,NZOCO
        CALL CFZONE(DEFICO,IZONE ,'ESCL',ISUMAE)
        CALL CFNBSF(DEFICO,ISUMAE,'MAIL',NBMAE ,JDECME)
        CALL CFNBSF(DEFICO,ISUMAE,'NOEU',NBNOE ,JDECNE)   
        CALL CFZONE(DEFICO,IZONE ,'MAIT',ISUMAM)
        CALL CFNBSF(DEFICO,ISUMAM,'MAIL',NBMAM ,JDECMM)
        CALL CFNBSF(DEFICO,ISUMAM,'NOEU',NBNOM ,JDECNM) 
        
        LVERI  = MMINFL(DEFICO,'VERIF',IZONE )
        IF (LVERI) THEN
          NBMAEC = 0
          NBMAMC = 0
          NBNOEC = 0
          NBNOMC = 0   
        ELSE
          NBMAEC = NBMAE
          NBMAMC = NBMAM
          NBNOEC = NBNOE
          NBNOMC = NBNOM                             
        ENDIF
        
        ZI(JMETH+ZMETH*(IZONE-1)+8 -1) = NBMAE
        ZI(JMETH+ZMETH*(IZONE-1)+9 -1) = NBNOE
        ZI(JMETH+ZMETH*(IZONE-1)+10-1) = NBMAM
        ZI(JMETH+ZMETH*(IZONE-1)+11-1) = NBNOM
        ZI(JMETH+ZMETH*(IZONE-1)+12-1) = NBMAEC
        ZI(JMETH+ZMETH*(IZONE-1)+13-1) = NBNOEC
        ZI(JMETH+ZMETH*(IZONE-1)+14-1) = NBMAMC
        ZI(JMETH+ZMETH*(IZONE-1)+15-1) = NBNOMC        
 30   CONTINUE 
C
C --- DECALAGES PAR ZONE
C
      DO 31 IZONE = 1,NZOCO
        CALL CFZONE(DEFICO,IZONE ,'ESCL',ISUMAE)
        CALL CFNBSF(DEFICO,ISUMAE,'MAIL',NBMAE ,JDECME)
        CALL CFNBSF(DEFICO,ISUMAE,'NOEU',NBNOE ,JDECNE)   
        CALL CFZONE(DEFICO,IZONE ,'MAIT',ISUMAM)
        CALL CFNBSF(DEFICO,ISUMAM,'MAIL',NBMAM ,JDECMM)
        CALL CFNBSF(DEFICO,ISUMAM,'NOEU',NBNOM ,JDECNM) 
        ZI(JMETH+ZMETH*(IZONE-1)+16-1) = JDECME
        ZI(JMETH+ZMETH*(IZONE-1)+17-1) = JDECMM
        ZI(JMETH+ZMETH*(IZONE-1)+18-1) = JDECNE
        ZI(JMETH+ZMETH*(IZONE-1)+19-1) = JDECNM
 31   CONTINUE    
C
C --- NOMBRE DE POINTS DE CONTACT PAR ZONE
C 
      DO 40 IZONE = 1,NZOCO
        IF (IFORM.EQ.1) THEN
          NBPT   = MMINFI(DEFICO,'NBNOE'      ,IZONE )
        ELSEIF (IFORM.EQ.2) THEN
          NBMAE  = MMINFI(DEFICO,'NBMAE'      ,IZONE )
          JDECME = MMINFI(DEFICO,'JDECME'     ,IZONE )
          TYPINT = MMINFI(DEFICO,'INTEGRATION',IZONE )
          NBPT   = 0
          DO 45 IMAE = 1,NBMAE
            POSMAE = IMAE + JDECME
            CALL CFNUMM(DEFICO,1     ,POSMAE,NUMMAE)
            CALL MMELIN(NOMA  ,NUMMAE,TYPINT,NNINT ) 
            NBPT = NBPT + NNINT
 45       CONTINUE
        ELSE
          CALL ASSERT(.FALSE.)
        ENDIF
C        
        ZI(JMETH+ZMETH*(IZONE-1)+20-1) = NBPT
C 
C --- CONTACT EFFECTIF
C       
        LVERI  = MMINFL(DEFICO,'VERIF',IZONE )
        IF (LVERI) THEN
          NBPC  = 0
        ELSE
          NBPC  = NBPT
        ENDIF  
C        
        ZI(JMETH+ZMETH*(IZONE-1)+21-1) = NBPC        
C           
 40   CONTINUE
C
      CALL JEDEMA()
      END
