      SUBROUTINE ELIMCO(CHAR  ,NOMA  ,NOMO  ,INDQUA,NZOCO ,
     &                  NSUCO ,NMACO ,NNOCO )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*8  CHAR
      CHARACTER*8  NOMA,NOMO
      INTEGER      INDQUA
      INTEGER      NZOCO,NSUCO,NMACO,NNOCO
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES MAILLEES - LECTURE DONNEES)
C
C ELIMINATION AU SEIN DE CHAQUE SURFACE DE CONTACT POTENTIELLE DES
C NOEUDS ET MAILLES REDONDANTS. MODIFICATION DES POINTEURS ASSOCIES.
C
C ----------------------------------------------------------------------
C
C
C IN  CHAR   : NOM UTILISATEUR DU CONCEPT DE CHARGE
C IN  NOMA   : NOM DU MAILLAGE
C IN  NOMO   : NOM DU MODELE
C IN  INDQUA : VAUT 0 LORSQUE L'ON DOIT TRAITER LES NOEUDS MILIEUX
C                     A PART
C              VAUT 1 LORSQUE L'ON DOIT TRAITER LES NOEUDS MILIEUX
C                     NORMALEMENT
C IN  NZOCO  : NOMBRE TOTAL DE ZONES DE CONTACT
C IN  NSUCO  : NOMBRE TOTAL DE SURFACES DE CONTACT
C I/O NMACO  : NOMBRE TOTAL DE MAILLES DES SURFACES
C I/O NNOCO  : NOMBRE TOTAL DE NOEUDS DES SURFACES
C
C
C
C
      INTEGER      NNOCO0,NMACO0
      CHARACTER*24 DEFICO
      CHARACTER*24 POINSM,LISTMA
      CHARACTER*24 POINSN,LISTNO
      INTEGER      CFDISI,IFORM
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- LECTURE DES STRUCTURES DE DONNEES DE CONTACT
C
      DEFICO = CHAR(1:8)//'.CONTACT'
C
C --- TYPE DE FORMULATION (DISCRETE/CONTINUE/XFEM)
C
      IFORM  = CFDISI(DEFICO,'FORMULATION')
C
C --- NOMBRE INITIAL
C
      NMACO0 = NMACO
      NNOCO0 = NNOCO
C
C --- REPERAGE DES MAILLES REDONDANTES
C
      LISTMA = '&&ELIMCO.TRAVMA'
      POINSM = '&&ELIMCO.ELIMMA'
      CALL CFLEMA(DEFICO,NSUCO  ,NMACO0,LISTMA,POINSM,
     &            NMACO )
C
C --- MISE A JOUR DE LA LISTE DES MAILLES APRES ELIMINATION
C
      IF (NMACO0.NE.NMACO) THEN
        CALL CFMEMA(DEFICO,NSUCO  ,NMACO0,LISTMA,POINSM,
     &              NMACO )
      ENDIF
      CALL JEDETR(LISTMA)
      CALL JEDETR(POINSM)
C
C --- REPERAGE DES NOEUDS REDONDANTS
C
      LISTNO = '&&ELIMCO.TRAVNO'
      POINSN = '&&ELIMCO.ELIMNO'
      CALL CFLENO(DEFICO,NSUCO  ,NNOCO0,LISTNO,POINSN,
     &            NNOCO )
C
C --- MISE A JOUR DE LA LISTE DES NOEUDS APRES ELIMINATION
C
      IF (NNOCO0.NE.NNOCO) THEN
        CALL CFMENO(DEFICO,NSUCO  ,NNOCO0,LISTNO,POINSN,
     &              NNOCO )
      ENDIF
      CALL JEDETR(LISTNO)
      CALL JEDETR(POINSN)
C
C --- CAS DES COQUES 3D (ON REPERE LE NOEUD MILIEU DES TRIA7/QUAD9)
C
      NNOCO0 = NNOCO
      CALL CFLECQ(IFORM ,NOMA  ,NOMO  ,DEFICO,NSUCO  ,
     &            NNOCO0,LISTNO,POINSN,NNOCO )
C
C --- MISE A JOUR DE LA LISTE DES NOEUDS APRES ELIMINATION
C
      IF (NNOCO0.NE.NNOCO) THEN
        CALL CFMENO(DEFICO,NSUCO  ,NNOCO0,LISTNO,POINSN,
     &              NNOCO )
      ENDIF
      CALL JEDETR(LISTNO)
      CALL JEDETR(POINSN)
C
C --- TRAITEMENT MOT-CLEFS SPECIFIQUES FORMULATION DISCRETE
C
      IF (IFORM.EQ.1) THEN
        CALL ELIMCQ(CHAR  ,NOMA  ,INDQUA,NZOCO ,NSUCO ,
     &              NNOCO )
      ENDIF
C
      CALL JEDEMA()
      END
