      SUBROUTINE EVALI2(ISZ,PG,NMA,PHI,VALPAR,IMA,POSMAI,IPG,PDGI,
     &                  ICMP,NOCMPI,SPHI)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================

      IMPLICIT NONE
C-----------------------------------------------------------------------
C     OPERATEUR PROJ_SPEC_BASE
C     CREATION DE LA MATRICE DES MODES PROPRES DEFINIS SUR LES POINTS DE
C     GAUSS ET DE LA LISTE DES POINTS DE GAUSS ASSOCIES AVEC LEURS
C     COORDONNEES
C-----------------------------------------------------------------------
C IN      : ISZ    : INTER-SPECTRE CONTENANT LES FONCTIONS ANALYTIQUES
C                    A PROJETER SUR LES MODES
C IN      : COL    : INDICE DE LA COLONNE COURANTE DE CALCUL
C IN      : PG     : CHAM_ELEM_S CONTENANT LES COORDONNEES DES POINTS
C                    DE GAUSS ET LEURS POIDS RESPECTIFS
C IN      : NMA    : NOMBRE DE MAILLES DU LIGREL
C IN      : PHI    : VECTEUR CONTENANT LES NOMS DES MODES PROPRES
C                    DEFINIS AUX POINTS DE GAUSS (CHAM_ELEM_S)
C IN      : VALPAR : COORDONNEES DU POINT DE GAUSS COURANT I (VALEURS 1
C                    A 3) ET FREQUENCE COURANTE (VAL 7). lES VALEURS
C                    4 A 6 STOCKENT LES COORDONNEES DU PDG J
C IN      : POSMAI : POSITION DE LA MAILLE DE CALCUL COURANT I
C IN      : IPG    : POINT DE GAUSS DE LA MAILLE DU CALCUL COURANT I
C IN/OUT  : SPHI   : VECTEUR CONTENANT LES NOMS DE CHAM_ELEM_S POUR
C                    Y RANGER LE RESULTAT DE S.PHI
C-----------------------------------------------------------------------


      INCLUDE 'jeveux.h'

      INTEGER      ICMPI,ICMPJ,IER,IFO,ITBLP,ITBNP
      INTEGER      ILI,NBPARA,IPARA,NBL,IPG,JPG,NBPG,IDPG,JMA
      INTEGER      MODJ,NBCMP,NBM,NBSP,NMA,IPHI,POSMA,IVFI,IDFI,ILFI
      INTEGER      IKFI,ICFI,ICMP,IRET,IVPG,ISPHI,POSMAI,POSMAJ,IVSFI
      INTEGER      JCMP,IMA
      REAL*8       VALPAR(7),PDGJ,PDGI,VALPHI,ZEROD
      REAL*8       RESUR,RESUI
      COMPLEX*16   RESU,VALSPH
      CHARACTER*19 PHI,SPHI,PHII,SPHII,PG,IS
      CHARACTER*24 K24,CMPIS,CMPJS,NOFOS
      CHARACTER*8   NOMPAR(7),FONC,CMPI,CMPJ,NOCMPI,NOCMPJ
      CHARACTER*8  KBID,ISZ
C-----------------------------------------------------------------------
C                         _       _    _   _
C   CALCUL DE LA MATRICE | SXX SXY |  | PHI |
C                        |_SYX SYY_|  |_   _|
C   LES FONCTIONS SZZ SONT DEFINIES ANALYTIQUEMENT DANS UNE TABLE INTER
C   SPECTRALE. DANS LE CAS CI-DESSUS, ON SUPPOSE QUE LES EXCITATIONS
C   SONT DANS LES DIRECTIONS X ET Y ET QU'ELLES SONT CORRELEES ENTRE
C   ELLES (TERME CROISE SXY ET SYX). NORMALEMENT, IL FAUT QUE SXY ET
C   SYX SOIENT CONJGUEES L'UNE DE L'AUTRE, MAIS ON NE LE VERIFIE PAS
C   TODO !!!! AJOUTER CETTE VERIFICATION ?
C
C   STRUCTURE DE LA ROUTINE : LE ROUTINE EVALIS FAIT UNE BOUCLE SUR
C   LE POINT DE GAUSS I. ICI, ON BOUCLE SUR LES PDG J :
C   1 - LECTURE DE L'INTER-SPECTRE
C   2 - BOUCLE SUR LES LIGNES DE L'INTER-SPECTRE (COMPOSANTES I ET J)
C         BOUCLE SUR LES MAILLES
C           BOUCLE SUR LES POINTS DE GAUSS
C             EVALUATION DE LA FONCTION ANALYTIQUE CORRESPONDANT AUX
C             COMPOSANTES DONNEES A LA LIGENDE L'INTER-SPECTRE
C             BOUCLE SUR LES MODES
C               BOUCLE SUR LES COMPOSANTES
C                 SI LA COMPOSANTE COURANTE EST CELLE DE LA COLONNE
C                 DE L'INTER-SPECTRE
C                  CALCUL DE PHI(IMA,IPG,IMOD,ICMP).WI.WJ.SZZ(I,J,IFREQ)

      CALL JEMARQ()

      ZEROD=0.0D0

C
C NOMS DES PARAMETRES DES FONCTIONS ANALYTIQUES
      NOMPAR(1)='X1'
      NOMPAR(2)='Y1'
      NOMPAR(3)='Z1'
      NOMPAR(4)='X2'
      NOMPAR(5)='Y2'
      NOMPAR(6)='Z2'
      NOMPAR(7)='FREQ'

C EXPLORATION DE LA TABLE INTER-SPECTRE CONTENANT LES FONCTIONS DE FORME
      IS='                   '
      IS(1:8)=ISZ
      CALL JEVEUO(IS//'.TBNP','L',ITBNP)
      CALL JEVEUO(IS//'.TBLP','L',ITBLP)
      NBPARA=ZI(ITBNP)
      NBL=ZI(ITBNP+1)
      DO 1 IPARA=1,NBPARA
        K24=ZK24(ITBLP-4+IPARA*4)
        IF (K24(1:10).EQ.'FONCTION_C') THEN
          NOFOS=ZK24(ITBLP-4+IPARA*4+2)
        ELSEIF (K24(1:12).EQ.'NUME_ORDRE_I') THEN
          CMPIS=ZK24(ITBLP-4+IPARA*4+2)
        ELSEIF (K24(1:12).EQ.'NUME_ORDRE_J') THEN
          CMPJS=ZK24(ITBLP-4+IPARA*4+2)
        ENDIF
1     CONTINUE

C CHAMP CONTENANT LES COORDONNEES DES POINTS DE GAUSS DU MAILLAGE
      CALL JEVEUO(PG//'.CESV','L',IVPG)
      CALL JEVEUO(PG//'.CESD','L',IDPG)

C RECUPERATION DES NOMS DES CHAMPS PHI ET SPHI
      CALL JEVEUO(PHI,'L',IPHI)
      CALL JEVEUO(SPHI,'L',ISPHI)

C NOMBRE DE MODES
      CALL JELIRA(PHI,'LONMAX',NBM,KBID)

C BOUCLES SUR LES LIGNES DE LA TABLE INTER-SPECTRE ANALYTIQUE
      DO 3 ILI=1,NBL
        CALL JEVEUO(CMPIS,'L',ICMPI)
        CMPI=ZK8(ICMPI-1+ILI)
        CALL JEVEUO(CMPJS,'L',ICMPJ)
        CMPJ=ZK8(ICMPJ-1+ILI)
        CALL JEVEUO(NOFOS,'L',IFO)
        FONC=ZK8(IFO-1+ILI)
C BOUCLE SUR LES MAILLES ET POINTS DE GAUSS & EVALUATION DE LA FONCTION
C DE L'IS CORRESPONDANT AUX COMP CMPI ET CMPJ
        DO 4 JMA=1,NMA
C  NOMBRE DE PDG ET DE SOUS PDG DE LA MAILLE JMA
          NBPG=ZI(IDPG-1+5+4*(JMA-1)+1)
          NBSP=ZI(IDPG-1+5+4*(JMA-1)+2)
          POSMA=ZI(IDPG-1+5+4*(JMA-1)+4)
          CALL ASSERT(NBSP.EQ.1)
          DO 5 JPG=1,NBPG
C  COORDONNEES DU POINT DE GAUSS JPG X2,Y2,Z2
            VALPAR(4)=ZR(IVPG+POSMA+4*(JPG-1))
            VALPAR(5)=ZR(IVPG+POSMA+4*(JPG-1)+1)
            VALPAR(6)=ZR(IVPG+POSMA+4*(JPG-1)+2)
            PDGJ=ZR(IVPG+POSMA+4*(JPG-1)+3)
            CALL FOINTC('F',FONC,7,NOMPAR,VALPAR,RESUR,RESUI,IER)
            RESU=DCMPLX(RESUR,RESUI)

C BOUCLE SUR LES MODES
            DO 6 MODJ=1,NBM
C ALLER CHERCHER LA VALEUR DE PHI(MODJ) AU POINT DE GAUSS DONNE
C POUR LA COMPOSANTE DONNEE
              PHII=ZK24(IPHI-1+MODJ)(1:19)
              SPHII=ZK24(ISPHI-1+MODJ)(1:19)
              CALL JEVEUO(PHII//'.CESV','L',IVFI)
              CALL JEVEUO(PHII//'.CESD','L',IDFI)
              CALL JEVEUO(PHII//'.CESL','L',ILFI)
              CALL JEVEUO(PHII//'.CESK','L',IKFI)
              CALL JEVEUO(PHII//'.CESC','L',ICFI)
              CALL JEVEUO(SPHII//'.CESV','E',IVSFI)
              NBCMP=ZI(IDFI-1+5+4*(JMA-1)+3)
              POSMAJ=ZI(IDFI-1+5+4*(JMA-1)+4)
              DO 7 JCMP=1,NBCMP
                NOCMPJ=ZK8(ICFI-1+JCMP)
                IF ((NOCMPJ.EQ.CMPJ).AND.(NOCMPI.EQ.CMPI)) THEN
                  CALL CESEXI('S',IDFI,ILFI,JMA,JPG,1,JCMP,IRET)
                  IF (IRET.LT.0) GOTO 8
                  VALPHI=ZR(IVFI+POSMAJ+NBCMP*(JPG-1)+JCMP-1)
C CALCUL DE WI.WJ.SFF(XI,XJ,FREQ).PHI(XJ,MODJ)
                  VALSPH = ZC(IVSFI+POSMAI+NBCMP*(IPG-1)+ICMP-1)
                  VALSPH = VALSPH + DCMPLX(VALPHI,ZEROD)*RESU
     &                       *DCMPLX(PDGI,ZEROD)*DCMPLX(PDGJ,ZEROD)
                  ZC(IVSFI+POSMAI+NBCMP*(IPG-1)+ICMP-1) = VALSPH
                ENDIF
8               CONTINUE
7             CONTINUE
6           CONTINUE
5         CONTINUE
4       CONTINUE
3     CONTINUE

      CALL JEDEMA()
      END
