      SUBROUTINE EXLIM3(MOTFAZ,BASE,MODELZ,LIGREL)
      IMPLICIT   NONE
      INCLUDE 'jeveux.h'
      CHARACTER*(*) MOTFAZ,BASE,MODELZ,LIGREL
C     -----------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 29/10/2012   AUTEUR SELLENET N.SELLENET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE PELLET J.PELLET
C ======================================================================
C BUT  :  SCRUTER LES MOTS CLE TOUT/GROUP_MA/MAILLE POUR CREER
C         UN LIGREL "REDUIT" A PARTIR DU LIGREL DU MODELE MODELZ

C LA DIFFERENCE AVEC EXLIMA.F EST QUE CETTE ROUTINE SCRUTE TOUTES LES
C OCCURENCES DE MOTFAZ ET DETERMINE L'EVELOPPE DE LA LISTE DES MAILLES
C
C IN  : MODELZ : NOM DU MODELE
C
C OUT/JXOUT   : LIGREL  : LIGREL REDUIT
C     ATTENTION :
C          - LE NOM DE LIGREL EST TOUJOURS "OUT"
C          - PARFOIS ON REND LIGREL=LIGREL(MODELE) :
C             - ALORS ON NE TIENT DONC PAS COMPTE DE 'BASE'
C             - IL NE FAUT PAS LE DETRUIRE !
C          - PARFOIS ON EN CREE UN NOUVEAU SUR LA BASE 'BASE'
C             - LE NOM DU LIGREL EST OBTENU PAR GNOMSD
C     -----------------------------------------------------------------
C
      INTEGER IB,N1,NBMA,NOCC,NBMAT,IOCC,JNUMA,JLIMA1
      INTEGER K,NUMA,JLIMA
      CHARACTER*8 MODELE,NOMA,K8BID
      CHARACTER*16 MOTFAC,MOTCLE(2),TYPMCL(2)
      CHARACTER*19 LIGRMO
      CHARACTER*24 NOOJB
      INTEGER GETEXM
      INTEGER      IARG
C     -----------------------------------------------------------------
C
      MOTFAC=MOTFAZ
      CALL ASSERT(MOTFAC.NE.' ')
      CALL GETFAC(MOTFAC,NOCC)
      CALL ASSERT(NOCC.GT.0)


      MODELE=MODELZ
      CALL ASSERT(MODELE.NE.' ')

      CALL DISMOI('F','NOM_LIGREL',MODELE,'MODELE',IB,LIGRMO,IB)
      CALL DISMOI('F','NOM_MAILLA',MODELE,'MODELE',IB,NOMA,IB)
      CALL DISMOI('F','NB_MA_MAILLA',NOMA,'MAILLAGE',NBMAT,K8BID,IB)
      CALL ASSERT(NBMAT.GT.0)




C     --  SI ON DOIT TOUT PRENDRE , LIGREL = LIGRMO
C     ------------------------------------------------------
      IF (GETEXM(MOTFAC,'TOUT').EQ.1) THEN
        DO 10,IOCC=1,NOCC
          CALL GETVTX(MOTFAC,'TOUT',IOCC,IARG,1,K8BID,N1)
          IF (N1.EQ.1)GOTO 60
   10   CONTINUE
      ENDIF



C     -- ON STOCKE DANS .NUMA, LES NUMEROS DES MAILLES DES DIFFERENTES
C        OCCURRENCES :
C     ----------------------------------------------------------------
      CALL WKVECT('&&EXLIM3.NUMA','V V I',NBMAT,JNUMA)

      MOTCLE(1)='GROUP_MA'
      MOTCLE(2)='MAILLE'
      TYPMCL(1)='GROUP_MA'
      TYPMCL(2)='MAILLE'

      DO 30,IOCC=1,NOCC
        CALL RELIEM(MODELE,NOMA,'NU_MAILLE',MOTFAC,IOCC,2,MOTCLE(1),
     &              TYPMCL(1),'&&EXLIM3.LIMA1',NBMA)
        CALL ASSERT(NBMA.GT.0)
        CALL JEVEUO('&&EXLIM3.LIMA1','L',JLIMA1)
        DO 20,K=1,NBMA
          NUMA=ZI(JLIMA1-1+K)
          ZI(JNUMA-1+NUMA)=1
   20   CONTINUE
        CALL JEDETR('&&EXLIM3.LIMA1')
   30 CONTINUE


C     -- ON FABRIQUE LA LISTE DES NUMEROS DE MAILLES POUR EXLIM1 :
C     ------------------------------------------------------------
      NBMA=0
      DO 40,K=1,NBMAT
        IF (ZI(JNUMA-1+K).EQ.1)NBMA=NBMA+1
   40 CONTINUE
      CALL WKVECT('&&EXLIM3.LIMA','V V I',NBMA,JLIMA)
      NBMA=0
      DO 50,K=1,NBMAT
        IF (ZI(JNUMA-1+K).EQ.1) THEN
          NBMA=NBMA+1
          ZI(JLIMA-1+NBMA)=K
        ENDIF
   50 CONTINUE
      CALL JEDETR('&&EXLIM3.NUMA')




C --- CREATION DU LIGREL
C     ---------------------------------
      NOOJB='12345678.LIGR000000.LIEL'
      CALL GNOMSD(' ',NOOJB,14,19)
      LIGREL=NOOJB(1:19)
      CALL EXLIM1(ZI(JLIMA),NBMA,MODELE,BASE,LIGREL)
      CALL JEDETR('&&EXLIM3.LIMA')
      GOTO 70


   60 CONTINUE
      LIGREL=LIGRMO

   70 CONTINUE

C
      END
