      SUBROUTINE GROMAB(MAILLA,NMABET,NBMABE,MAIL2D,CAELEM,GROMAI)
      IMPLICIT NONE
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C-----------------------------------------------------------------------
C  DESCRIPTION : RECHERCHE DES PLUS GRANDS DIAMETRES DES MAILLES DE LA
C  -----------   LISTE NMABET SELON LES DIRECTIONS X, Y ET Z
C  IN     : MAILLA : CHARACTER*8 , SCALAIRE
C                    NOM DU CONCEPT MAILLAGE ASSOCIE A L'ETUDE
C  IN     : NMABET : CHARACTER*19 , SCALAIRE
C                    NOM D'UN VECTEUR D'ENTIERS POUR STOCKAGE DES
C                    NUMEROS DE MAILLES APPARTENANT A LA STRUCTURE BETON
C  IN     : NBMABE : INTEGER , SCALAIRE
C                    NOMBRE DE MAILLES APPARTENANT A LA STRUCTURE BETON
C  IN     : MAIL2D : LOGICAL , SCALAIRE
C                    .TRUE. SI LES MAILLES SONT DES MAILLES 2D
C  IN     : CAELEM : CHARACTER*8 , SCALAIRE
C                    NOM DU CONCEPT CARA_ELEM ASSOCIE A L'ETUDE
C  OUT    : NUNOBI : CHARACTER*19 , SCALAIRE
C                    NOM D'UN VECTEUR DE REELS POUR STOCKAGE DES
C                    3 PLUS GRANDS DIAMETRES RESP SELON X, Y ET Z
C-------------------   DECLARATION DES VARIABLES   ---------------------
C
C
C ARGUMENTS
C ---------
      INCLUDE 'jeveux.h'

      CHARACTER*32 JEXNOM,JEXATR
      CHARACTER*8   MAILLA,CAELEM
      CHARACTER*24  NMABET,GROMAI
      INTEGER       NBMABE
      LOGICAL       MAIL2D
C
C VARIABLES LOCALES
C -----------------
      INTEGER         INO, IRET,
     &              JCOOR,
     &                  NBNO,IMA,IAD
      REAL*8        XMAX,XK,YMAX,YK,ZMAX,ZK,X,Y,Z,EPMAX
      REAL*8        EP,SQRT
      CHARACTER*1   K1B
      CHARACTER*19  CARTE
      CHARACTER*24  COORNO,CONNEX,CAVALE
C
      INTEGER       I,J,K,IAD2,INOK
      INTEGER       JMABET,JCONN,JTABCO,JNUNOE,JGMAI,IVAL,NCACO
      INTEGER       NCAVA,NEP

C
C-------------------   DEBUT DU CODE EXECUTABLE    ---------------------
C
      CALL JEMARQ()


      CONNEX = MAILLA//'.CONNEX'
      COORNO = MAILLA//'.COORDO    .VALE'
      CALL JEVEUO(COORNO,'L',JCOOR)

      CALL JEVEUO(CONNEX,'L',JCONN)
      CALL JEVEUO(JEXATR(CONNEX,'LONCUM'),'L',JTABCO)
      CALL JEVEUO(NMABET,'L',JMABET)
      CALL WKVECT('&&GROMAB.NUNOE','V V I',27,JNUNOE)
      XMAX=0.D0
      YMAX=0.D0
      ZMAX=0.D0
      DO 10 I=1,NBMABE
        IMA = ZI(JMABET-1+I)
        IAD = ZI(JTABCO-1+IMA)
        IAD2 = ZI(JTABCO-1+IMA+1)
        NBNO = IAD2-IAD
        DO 20 J =1,NBNO
          INO = ZI(JCONN-1+IAD-1+J)
          ZI(JNUNOE-1+J)=INO
 20     CONTINUE

        DO 30 J=1,NBNO-1
          INO = ZI(JNUNOE-1+J)
          X = ZR(JCOOR+3*(INO-1)  )
          Y = ZR(JCOOR+3*(INO-1)+1)
          Z = ZR(JCOOR+3*(INO-1)+2)
          DO 40 K=J+1,NBNO
            INOK = ZI(JNUNOE-1+K)
            XK = ZR(JCOOR+3*(INOK-1)  )
            YK = ZR(JCOOR+3*(INOK-1)+1)
            ZK = ZR(JCOOR+3*(INOK-1)+2)

            IF (ABS(X-XK).GT.XMAX) XMAX = ABS(X-XK)
            IF (ABS(Y-YK).GT.YMAX) YMAX = ABS(Y-YK)
            IF (ABS(Z-ZK).GT.ZMAX) ZMAX = ABS(Z-ZK)

 40       CONTINUE
 30     CONTINUE
 10   CONTINUE
      CALL JEVEUO(GROMAI,'E',JGMAI)
      ZR(JGMAI)=XMAX
      ZR(JGMAI+1)=YMAX
      ZR(JGMAI+2)=ZMAX

      J=0
      IF(MAIL2D)THEN
C       DETERMINATION DE LA PLUS GRANDE EPAISSEUR
        CARTE=CAELEM//'.CARCOQUE  '
        CAVALE = CARTE//'.VALE'
        CALL JEEXIN(CAVALE,IRET)
        CALL ASSERT(IRET.NE.0)

        CALL JELIRA(JEXNOM('&CATA.GD.NOMCMP','CACOQU'),'LONMAX',NCACO,
     &                                                           K1B)

        CALL JELIRA(CAVALE,'LONMAX',NCAVA,K1B)
        CALL JEVEUO(CAVALE,'L',IVAL)

        NEP = NCAVA/NCACO
        EPMAX = 0.D0
        DO 50 I=1,NEP
          EP = ZR(IVAL+(I-1)*NCACO)
          IF (EP.GT.EPMAX) EPMAX = EP
 50     CONTINUE
        EPMAX = EPMAX*SQRT(2.D0)
        DO 60 I=1,3
          IF (ZR(JGMAI-1+I).LT.EPMAX) ZR(JGMAI-1+I) = EPMAX
 60     CONTINUE

      ENDIF

      CALL JEDEMA()
      END
