      SUBROUTINE OP0147()
      IMPLICIT NONE
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 24/07/2012   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C-----------------------------------------------------------------------
C   CALCUL DES INTERSPECTRES DE REPONSE MODALE (DYNA_SPEC_MODAL)
C      LE CONCEPT PRODUIT EST UN INTERSPECTRE
C-----------------------------------------------------------------------
C
      INCLUDE 'jeveux.h'
C-----------------------------------------------------------------------
      INTEGER I ,IBID ,IFREQ ,IM ,IMASG ,IMOD1 ,INUMO 
      INTEGER INUOR ,IVITE ,JNUOR ,NBM ,NBMR
      INTEGER NNN ,NPV ,I1,I3,IVITEF
C-----------------------------------------------------------------------
      LOGICAL       CASINT
      CHARACTER*8   K8B, TABLE, NOMU, OPTION
      CHARACTER*16  CONCEP, CMD
      CHARACTER*19  BASE
      CHARACTER*24  FREQ, MASG, VITE, NUMO, NOMOBJ,CHNUMI
      INTEGER      IARG,LNUMI,LREFE,LREFES
      REAL*8 EPSI,VAL,VITEF
C
C-----------------------------------------------------------------------
      CALL JEMARQ()
      CALL INFMAJ()
C
      CALL GETRES(NOMU,CONCEP,CMD)
C
C --- 1.RECUPERATION DES OBJETS DE LA BASE MODALE PERTURBEE ---
C
      CALL GETVID(' ','BASE_ELAS_FLUI',0,IARG,1,BASE,ZI)
C
      MASG = BASE//'.MASG'
      VITE = BASE//'.VITE'
      FREQ = BASE//'.FREQ'
      NUMO = BASE//'.NUMO'
C
      CALL JEVEUO(MASG,'L',IMASG)
C
      CALL JEVEUO(VITE,'L',IVITE)
      CALL JELIRA(VITE,'LONUTI',NPV,K8B)
      CALL GETVR8(' ','VITE_FLUI',0,IARG,1,VITEF,ZI)
      CALL GETVR8(' ','PRECISION',0,IARG,1,EPSI,ZI)
C
      IVITEF = 1
      DO 300 I3 = 1,NPV
        VAL = ZR(IVITE-1+I3)-VITEF
        IF (ABS(VAL) .LT. EPSI) THEN
          IVITEF = I3
        ENDIF
300   CONTINUE

      CALL JEVEUO(FREQ,'L',IFREQ)
      CALL JELIRA(FREQ,'LONUTI',NBM,K8B)
      NBM = NBM / ( 2 * NPV )
C
      CALL JEVEUO(NUMO,'L',INUMO)
C
C --- 2.RECUPERATION DU NOM DE LA TABLE ---
C
      CALL GETVID('EXCIT ','INTE_SPEC_GENE',1,IARG,1,TABLE,ZI)
C
C     VERIFICATION DES PARAMETRES DE LA TABLE
C
      CHNUMI = TABLE//'.NUMI'
      CALL JEVEUO(CHNUMI,'L',LNUMI)
      CALL JELIRA(CHNUMI,'LONMAX',NBMR,K8B)

      NOMOBJ = '&&OP0147.TEMP.NUOR'
      CALL WKVECT ( NOMOBJ, 'V V I', NBMR, JNUOR )
      DO 150 I1 = 1,NBMR
        ZI(JNUOR-1+I1) = ZI(LNUMI-1+I1)
150   CONTINUE
      CALL ORDIS  ( ZI(JNUOR) , NBMR )
      CALL WKVECT ( '&&OP0147.MODE', 'V V I', NBMR, INUOR )
      NNN = 1
      ZI(INUOR) = ZI(JNUOR)
      DO 20 I = 2 , NBMR
         IF ( ZI(JNUOR+I-1) .EQ. ZI(INUOR+NNN-1) ) GOTO 20
         NNN = NNN + 1
         ZI(INUOR+NNN-1) = ZI(JNUOR+I-1)
 20   CONTINUE
      NBMR = NNN
      DO 30 IM = 1,NBM
         IF (ZI(INUMO+IM-1).EQ.ZI(INUOR)) THEN
            IMOD1 = IM
            GOTO 31
         ENDIF
 30   CONTINUE
      CALL U2MESS('F','MODELISA5_78')
 31   CONTINUE
C
C --- 3.RECUPERATION DE L'OPTION DE CALCUL ---
C
      CASINT = .TRUE.
      CALL GETVTX ( ' ', 'OPTION', 0,IARG,1, OPTION, IBID )
      IF ( OPTION(1:4) .EQ. 'DIAG' ) CASINT = .FALSE.
C
      CALL JEVEUO(TABLE//'.REFE','L',LREFE)
      IF ( ZK16(LREFE+1)(1:4) .EQ. 'DIAG' .AND. CASINT ) THEN
        CALL U2MESS('F','MODELISA5_79')
      ENDIF
C
C --- 4.CREATION DE LA STRUCTURE RESULTAT ET CALCUL DE LA REPONSE ---
C ---   PAR CALCSP                                                ---
C
      CALL WKVECT(NOMU//'.REFE','G V K16',2,LREFES)
      ZK16(LREFES) = 'DEPL_GENE'
      ZK16(LREFES+1) = OPTION
C
      CALL CALCSP ( CASINT, NOMU, TABLE, ZR(IFREQ), ZR(IMASG), NBM,
     &              NBMR, IMOD1, ZI(INUOR), IVITEF )
C
      CALL TITRE
C
C
      CALL JEDEMA()
      END
