      SUBROUTINE POINCO(CHAR  ,MOTFAC,NOMA  ,NZOCO ,NSUCO )
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 13/06/2012   AUTEUR COURTOIS M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT     NONE
      INCLUDE 'jeveux.h'
      CHARACTER*8  CHAR
      CHARACTER*16 MOTFAC
      CHARACTER*8  NOMA
      INTEGER      NZOCO
      INTEGER      NSUCO
C
C ----------------------------------------------------------------------
C
C ROUTINE CONTACT (METHODES MAILLEES - LECTURE DONNEES)
C
C DETERMINATION DU NOMBRE DE ZONES DE CONTACT ET DU NOMBRE TOTAL DE
C MAILLES ET DE NOEUDS DE CONTACT.
C REMPLISSAGE DES POINTEURS ASSOCIES: PZONE,PSURMA,PSURNO,PNOQUA
C
C ----------------------------------------------------------------------
C
C
C IN  CHAR   : NOM UTILISATEUR DU CONCEPT DE CHARGE
C IN  MOTFAC : MOT-CLE FACTEUR
C IN  NOMA   : NOM DU MAILLAGE
C IN  NZOCO  : NOMBRE DE ZONES DE CONTACT
C OUT NSUCO  : NOMBRE TOTAL DE SURFACES DE CONTACT
C
C
C
C
      INTEGER      IZONE
      CHARACTER*24 PZONE,PSURMA,PSURNO
      INTEGER      JZONE,JSUMA,JSUNO
      CHARACTER*24 DEFICO
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      DEFICO = CHAR(1:8)//'.CONTACT'         
C
C --- ACCES AUX STRUCTURES DE DONNEES DE CONTACT
C
      PZONE  = DEFICO(1:16)//'.PZONECO'
      PSURMA = DEFICO(1:16)//'.PSUMACO'
      PSURNO = DEFICO(1:16)//'.PSUNOCO'
C
C --- INITIALISATIONS
C
      NSUCO  = 0
C
C --- DETERMINATION DU NOMBRE DE SURFACES
C
      CALL WKVECT(PZONE,'G V I',NZOCO+1,JZONE)
      DO 2 IZONE = 1,NZOCO
        CALL NBZOCO(MOTFAC,NOMA  ,IZONE ,JZONE ,NSUCO )
  2   CONTINUE
C
C --- TABLEAUX DU NOMBRE DE MAILLES ET DE NOEUDS DE CONTACT 
C
      CALL WKVECT(PSURMA,'G V I',NSUCO+1,JSUMA )
      CALL WKVECT(PSURNO,'G V I',NSUCO+1,JSUNO )
C
      CALL JEDEMA()
      END
