      SUBROUTINE RCVALC( JMAT,PHENOM,NBPAR,NOMPAR,VALPAR,
     &                   NBRES,NOMRES,VALRES,ICODRE, IARRET )
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      INTEGER            IMAT,NBPAR,NBRES,JMAT,NBMAT
      CHARACTER*(*)      PHENOM, NOMPAR(NBPAR), NOMRES(NBRES)
      INTEGER  IARRET
      INTEGER        ICODRE(NBRES)
      REAL*8             VALPAR(NBPAR)
      COMPLEX*16         VALRES(NBRES)
C ----------------------------------------------------------------------
C     OBTENTION DE LA VALEUR VALRES C D'UN "ELEMENT" D'UNE RELATION DE
C     COMPORTEMENT D'UN MATERIAU DONNE (NOUVELLE FORMULE RAPIDE)
C
C     ARGUMENTS D'ENTREE:
C        IMAT   : ADRESSE DU MATERIAU CODE
C        PHENOM : NOM DU PHENOMENE
C        NBPAR  : NOMBRE DE PARAMETRES DANS NOMPAR ET VALPAR
C        NOMPAR : NOMS DES PARAMETRES(EX: TEMPERATURE )
C        VALPAR : VALEURS DES PARAMETRES
C        NBRES  : NOMBRE DE RESULTATS
C        NOMRES : NOM DES RESULTATS (EX: E,NU,... )
C                 TELS QU'IL FIGURENT DANS LA COMMANDE MATERIAU
C     ARGUMENTS DE SORTIE:
C     VALRES : VALEURS DES RESULTATS APRES RECUPERATION ET INTERPOLATION
C     ICODRE : POUR CHAQUE RESULTAT, 0 SI ON A TROUVE, 1 SINON
C
C


C
C
      CHARACTER*10       NOMPHE
C ----------------------------------------------------------------------
C PARAMETER ASSOCIE AU MATERIAU CODE
C DEB ------------------------------------------------------------------

C-----------------------------------------------------------------------
      INTEGER ICOMP ,IDF ,IK ,IPI ,IR ,IRES ,IVALC
      INTEGER IVALK ,NBC ,NBF ,NBOBJ ,NBR ,NBT
C-----------------------------------------------------------------------
      NBMAT=ZI(JMAT)
      CALL ASSERT(NBMAT.EQ.1)
      IMAT = JMAT+ZI(JMAT+NBMAT+1)


      DO 130 IRES = 1, NBRES
        ICODRE(IRES) = 1
  130 CONTINUE
      NOMPHE = PHENOM
      DO 10 ICOMP=1,ZI(IMAT+1)
        IF ( NOMPHE .EQ. ZK16(ZI(IMAT)+ICOMP-1)(1:10) ) THEN
          IPI = ZI(IMAT+2+ICOMP-1)
          GOTO 11
        ENDIF
 10   CONTINUE
      CALL U2MESS('A','ELEMENTS2_63')
      GOTO 9999
 11   CONTINUE
C
      NBOBJ = 0
      NBR   = ZI(IPI  )
      NBC   = ZI(IPI+1)
      IVALK = ZI(IPI+3)
      IVALC = ZI(IPI+5)
      NBT = NBR + NBC
      DO 150 IR = 1, NBT
        DO 140 IRES = 1, NBRES
          IF (NOMRES(IRES) .EQ. ZK8(IVALK+IR-1)) THEN
            VALRES(IRES) = ZC(IVALC-1+IR)
            ICODRE(IRES) = 0
            NBOBJ = NBOBJ + 1
          ENDIF
  140   CONTINUE
  150 CONTINUE
      IF (NBOBJ .NE. NBRES) THEN
        IDF = ZI(IPI)+ZI(IPI+1)
        NBF = ZI(IPI+2)
        DO 170 IRES = 1,NBRES
          DO 160 IK = 1,NBF
            IF (NOMRES(IRES) .EQ. ZK8(IVALK+IDF+IK-1)) THEN
              CALL U2MESS('F','MODELISA6_93')
C              CALL FOINTA (IFON,NBPAR,NOMPAR,VALPAR,VALRES(IRES))
              ICODRE(IRES) = 0
            ENDIF
  160     CONTINUE
  170   CONTINUE
      ENDIF
 9999 CONTINUE
C
      CALL RCVALS( IARRET, ICODRE, NBRES, NOMRES )
C
      END
