      SUBROUTINE SCALFF(NBFONC,NBP,DISC,VALE,A)
      IMPLICIT NONE
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 03/07/2012   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C-----------------------------------------------------------------------
C     CALCUL DES PRODUITS SCALAIRES ENTRE LES FONCTIONS DE FORME
C     APPELANT : SPECFF
C-----------------------------------------------------------------------
C IN  : NBFONC : NOMBRE DE FONCTIONS
C IN  : NBP    : NOMBRE DE POINTS DE DISCRETISATION DES FONCTIONS
C IN  : DISC   : DISCRETISATION SUR LAQUELLE SONT CALCULEES LES
C                INTEGRALES DONNANT LES PRODUITS SCALAIRES  - DIM : NBP
C IN  : VALE   : TABLEAU DES VALEURS DES FONCTIONS  - DIM : (NBP,NBFONC)
C OUT : A      : MATRICE DES PRODUITS SCALAIRES  - DIM : (NBFONC,NBFONC)
C
C
      INCLUDE 'jeveux.h'
      INTEGER      NBFONC,NBP
      REAL*8       DISC(NBP),VALE(NBP,NBFONC),A(NBFONC,NBFONC)
      INTEGER IFO1 ,IFO2 ,IP
      REAL*8 DX ,Y1 ,Y2 ,YY
C-----------------------------------------------------------------------
C
C-----------------------------------------------------------------------
C
C-----1.CALCUL DES TERMES DU TRIANGLE INFERIEUR
C
      DO 10 IFO2 = 1,NBFONC
C
        DO 11 IFO1 = IFO2,NBFONC
C
          A(IFO1,IFO2) = 0.D0
          DO 12 IP = 1,NBP-1
            DX = DISC(IP+1) - DISC(IP)
            Y1 = VALE(IP,IFO1)*VALE(IP,IFO2)
            Y2 = VALE(IP+1,IFO1)*VALE(IP+1,IFO2)
            YY = Y1 + Y2
            A(IFO1,IFO2) = A(IFO1,IFO2) + YY * DX
  12      CONTINUE
          A(IFO1,IFO2) = A(IFO1,IFO2)/2.D0
C
  11    CONTINUE
C
  10  CONTINUE
C
C-----2.DEDUCTION DES TERMES DU TRIANGLE SUPERIEUR PAR SYMETRIE
C
      IF (NBFONC.GT.1) THEN
C
        DO 20 IFO2 = 2,NBFONC
          DO 21 IFO1 = 1,IFO2-1
            A(IFO1,IFO2) = A(IFO2,IFO1)
  21      CONTINUE
  20    CONTINUE
C
      ENDIF
C
      END
