      SUBROUTINE XLMAIL(FISS  ,NMAEN1,NMAEN2,NMAEN3,NMAFON,
     &                  JMAEN1,JMAEN2,JMAEN3,JMAFON,
     &                  NFON,JFON,NBFOND,JBAS,JFONMU,NDIM)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*8  FISS
      INTEGER      NMAEN1,NMAEN2,NMAEN3,NMAFON
      INTEGER      JMAEN1,JMAEN2,JMAEN3,JMAFON
      INTEGER      NFON
      INTEGER      JFON
      INTEGER      NBFOND
      INTEGER      JBAS
      INTEGER      JFONMU,NDIM
C
C ----------------------------------------------------------------------
C
C ROUTINE XFEM (CREATION DES SD)
C
C CREATION SD SUR MAILLAGE XFEM
C
C ----------------------------------------------------------------------
C
C
C IN  FISS   : NOM DE LA FISSURE
C IN  NOMA   : NOM DU MAILLAGE
C IN  NMAEN1 : NOMBRE DE MAILLES 'HEAVISIDE'
C IN  NMAEN2 : NOMBRE DE MAILLES 'CRACKTIP'
C IN  NMAEN3 : NOMBRE DE MAILLES 'HEAVISIDE-CRACKTIP'
C IN  NMAFON : NOMBRE DE MAILLES CONTENANT LE FOND DE FISSURE
C IN  JMAEN1 : POINTEUR SUR MAILLES 'HEAVISIDE'
C IN  JMAEN2 : POINTEUR SUR MAILLES 'CRACKTIP'
C IN  JMAEN3 : POINTEUR SUR MAILLES 'HEAVISIDE-CRACKTIP'
C IN  JMAFON : POINTEUR SUR MAILLES CONTENANT LE FOND DE FISSURE
C IN  NFON   : NOMBRE DE POINTS DE FOND DE FISSURE
C IN  JFON   : POINTEUR SUR POINTS DE FOND DE FISSURE
C IN  JBAS   : POINTEUR SUR DIRECTION DE PROPAGATION
C IN  NBFOND : NOMBRE DE FONDS DE FISSURES DETECTES
C IN  JFONMU : POINTEUR SUR DEBUT ET ARRIVEE DU FOND DE FISSURE
C
      CHARACTER*24 XHEAV,XCTIP,XHECT,XMAFON,XFONFI,XFONMU,XBASFO
      INTEGER      JMA1,JMA2,JMA3,JMA4,JFO,JFOMU,JBA
      INTEGER      I,K
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- ACCES AUX OBJETS
C
      XHEAV  = FISS(1:8)//'.MAILFISS.HEAV'
      XCTIP  = FISS(1:8)//'.MAILFISS.CTIP'
      XHECT  = FISS(1:8)//'.MAILFISS.HECT'
      XMAFON = FISS(1:8)//'.MAILFISS.MAFOND'
      XFONFI = FISS(1:8)//'.FONDFISS'
      XBASFO = FISS(1:8)//'.BASEFOND'
      XFONMU = FISS(1:8)//'.FONDMULT'
C
C --- ENREGISTREMENT DES GROUP_MA 'HEAVISIDE'
C
      IF (NMAEN1.NE.0) THEN
        CALL WKVECT(XHEAV,'G V I',NMAEN1,JMA1)
        DO 810 I=1,NMAEN1
           ZI(JMA1-1+I) = ZI(JMAEN1-1+I)
 810    CONTINUE
      ENDIF
C
C --- ENREGISTREMENT DES GROUP_MA 'CRACKTIP'
C
      IF (NMAEN2.NE.0) THEN
        CALL WKVECT(XCTIP,'G V I',NMAEN2,JMA2)
        DO 820 I=1,NMAEN2
           ZI(JMA2-1+I) = ZI(JMAEN2-1+I)
 820    CONTINUE
      ENDIF
C
C --- ENREGISTREMENT DES GROUP_MA ''HEAVISIDE-CRACKTIP'
C
      IF (NMAEN3.NE.0) THEN
        CALL WKVECT(XHECT,'G V I',NMAEN3,JMA3)
        DO 830 I=1,NMAEN3
           ZI(JMA3-1+I) = ZI(JMAEN3-1+I)
 830    CONTINUE
      ENDIF
C
C --- ENREGISTREMENT DES MAILLES CONTENANT LE FOND DE FISSURE
C
      IF (NMAFON.NE.0) THEN
        CALL WKVECT(XMAFON,'G V I',NMAFON,JMA4)
        DO 840 I=1,NMAFON
           ZI(JMA4-1+I) = ZI(JMAFON-1+I)
 840    CONTINUE
      ENDIF
C
C --- ENREGISTREMENT DES COORD ET DES ABS CURV
C
      IF (NFON.NE.0) THEN
        CALL WKVECT(XFONFI,'G V R',4*NFON,JFO)
        DO 860 I=1,NFON
          DO 850 K=1,4
            ZR(JFO-1+4*(I-1)+K) = ZR(JFON-1+4*(I-1)+K)
 850      CONTINUE
 860    CONTINUE

        CALL WKVECT(XBASFO,'G V R',2*NDIM*NFON,JBA)
        DO 940 I=1,NFON
          DO 950 K=1,NDIM
            ZR(JBA-1+2*NDIM*(I-1)+K) = ZR(JBAS-1+2*NDIM*(I-1)+K)
            ZR(JBA-1+2*NDIM*(I-1)+K+NDIM) =
     &                           ZR(JBAS-1+2*NDIM*(I-1)+K+NDIM)
 950      CONTINUE
 940    CONTINUE

      ENDIF
C
C --- ENREGISTREMENT DES FONDS MULTIPLES
C
      IF (NBFOND.NE.0) THEN
        CALL WKVECT(XFONMU,'G V I',2*NBFOND,JFOMU)
        DO 870 I=1,NBFOND
          ZI(JFOMU-1+2*(I-1)+1) = ZI(JFONMU-1+2*(I-1)+1)
          ZI(JFOMU-1+2*(I-1)+2) = ZI(JFONMU-1+2*(I-1)+2)
 870    CONTINUE
      ENDIF
C
      CALL JEDEMA()
      END
