      SUBROUTINE RVPAR0 ( NOMTAB, MCF, NBPOST )
C     ------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF POSTRELE  DATE 25/06/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C IN  NOMTAB  : NOM DE LA TABLE PRINCIPALE PRODUITE PAR LA COMMANDE
C IN  MCF     : MOT-CLE FACTEUR
C IN  NBPOST  : NOMBRE DE POST-TRAITEMENT A CONSIDERER
C     ------------------------------------------------------------------
C
C     INITIALISE LES TABLES DE POST_RELEVE_T
C
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
C 0.1. ==> ARGUMENTS
C
      INCLUDE 'jeveux.h'
      CHARACTER*6 MCF
      CHARACTER*8 NOMTAB
      INTEGER NBPOST
C
C
C 0.3. ==> VARIABLES LOCALES
C
      CHARACTER*6 NOMPRO
      PARAMETER ( NOMPRO = 'RVPAR0' )
C
      INTEGER IFM, NIV
      INTEGER IOCC,IAUX
      INTEGER NBTBMX, ADMEMO, NBTABL
      INTEGER NBRESU
C
      CHARACTER*8 K8B
      CHARACTER*18 NOMSTR
      INTEGER      IARG
C     ------------------------------------------------------------------
C
C====
C 1. PREALABLES
C====
C
      CALL JEMARQ ( )
C
      CALL INFMAJ
      CALL INFNIV(IFM,NIV)
C
      IF ( NIV.GE.2 ) CALL U2MESK('I','POSTRELE_8',1,NOMTAB)
C
      NOMSTR = '&&'//NOMPRO//'.NOMPARAMS'
C
C====
C 2. ON REPERE LE NOMBRE DE TABLES QU'IL FAUDRA INITIALISER :
C====
C
C 2.1. ==> ON ALLOUE LE TABLEAU DE MEMORISATION POUR 20 TABLES.
C          S'IL S'AVERE QU'IL Y EN A BESOIN DE DAVANTAGE, ON ALLONGERA.
C
      NBTBMX = 20
      CALL WKVECT ( NOMSTR, 'G V K8', 2*NBTBMX, ADMEMO )
C
C 2.2. ==> ON PARCOURT TOUTES LES ACTIONS DEMANDEES
C
      NBTABL = 0
C
      DO 22 , IOCC = 1, NBPOST
C
C 2.2.1. ==> EST-CE UN RESULTAT ?
C
        CALL GETVID ( MCF, 'RESULTAT', IOCC,IARG, 0, K8B, NBRESU )

C
C 2.2.2.1. ==> ON CHERCHE SI CETTE CONFIGURATION EST DEJA ENREGISTREE ;
C              SI OUI, ON PASSE AU PARAMETRE SUIVANT (GOTO 220)
C
        DO 222 , IAUX = 1 , NBTABL
          IF ( ZK8(ADMEMO+2*IAUX-2).EQ.NOMTAB) GOTO 220
  222   CONTINUE
C
C 2.2.2.2. ==> LA CONFIGURATION EST NOUVELLE
C              ON L'ENREGISTRE, EN ALLONGEANT EVENTUELLEMENT SI LA PLACE
C              RESERVEE EST TROP PETITE
C
        IF ( NBTABL.GE.NBTBMX ) THEN
          NBTBMX = NBTBMX + 50
          IAUX = 2*NBTBMX
          CALL JUVECA ( NOMSTR,IAUX )
          CALL JEVEUO ( NOMSTR, 'E', ADMEMO )
        ENDIF
        CALL JELIRA ( NOMSTR, 'LONUTI', IAUX, K8B )
        IAUX = IAUX + 2
        CALL JEECRA ( NOMSTR,'LONUTI',IAUX,K8B )
C
        NBTABL = NBTABL + 1
        ZK8(ADMEMO+2*NBTABL-2) = NOMTAB
C
   22 CONTINUE

 220  CONTINUE
C
C====
C 3. ON INITIALISE LES TABLES DEMANDEES
C====
C
      DO 30 , IAUX = 1 , NBTABL

        NOMTAB = ZK8(ADMEMO+2*IAUX-2)
        CALL RVPARA (NOMTAB,MCF, NBPOST )
C
   30 CONTINUE
C
C====
C 4. MENAGE
C====
C
      CALL JEDETR ( NOMSTR )
C
      CALL JEDEMA ( )
C
      END
