      SUBROUTINE AVCIPR( NBVEC, VECTN, VECTU, VECTV, NBORDR, KWORK,
     &                   SOMMW, VWORK, TDISP, TSPAQ, IPGN, NOMCRI,
     &                   NOMFOR, FORDEF,FATSOC,PROAXE, PSEUIL, METHOD,
     &                   NCYCL, VMIN, VMAX, OMIN, OMAX)
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      INTEGER       NBVEC, NBORDR, KWORK
      INTEGER       SOMMW, TDISP, TSPAQ, IPGN
      REAL*8        VECTN(3*NBVEC), VECTU(3*NBVEC), VECTV(3*NBVEC)
      REAL*8        VWORK(TDISP), FATSOC, PSEUIL
      CHARACTER*16  NOMCRI,NOMFOR,PROAXE
      CHARACTER*8   METHOD
      INTEGER       NCYCL(NBVEC)
      INTEGER       OMIN(NBVEC*(NBORDR+2)), OMAX(NBVEC*(NBORDR+2))
      REAL*8        VMIN(NBVEC*(NBORDR+2)), VMAX(NBVEC*(NBORDR+2))
      LOGICAL       FORDEF

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C TOLE CRP_21 CRS_1404
C---------------------------------------------------------------------
C BUT:  POUR LA FATIGUE A AMPLITUDE VARIABLE
C       A PARTIR DE l'HISTOIRE DE CISSAILLEMENT, PROJETER SUR UN OU
C       2 AXES ET DETERMINER DES PICS PAR LE COMPTAGE DE RAINFLOW
C REMARQUE: CETTE SUBROUTINE EST APPLICABLE POUR UN NOEUD OU UN POINT
C           GAUSSE
C
C ----------------------------------------------------------------------
C ARGUMENTS :
C  NBVEC    IN  I  : NOMBRE DE VECTEURS NORMAUX.
C  VECTN    IN  R  : VECTEUR CONTENANT LES COMPOSANTES DES
C                    VECTEURS NORMAUX.
C  VECTU    IN  R  : VECTEUR CONTENANT LES COMPOSANTES DES
C                    VECTEURS u DU PLAN DE CISAILLEMENT.
C  VECTV    IN  R  : VECTEUR CONTENANT LES COMPOSANTES DES
C                    VECTEURS v DU PLAN DE CISAILLEMENT.
C  NBORDR   IN  I  : NOMBRE DE NUMEROS D'ORDRE.
C  KWORK    IN  I  : KWORK = 0 ON TRAITE LA 1ERE MAILLE DU PAQUET
C                              MAILLES OU LE 1ER NOEUD DU PAQUET DE
C                              NOEUDS;
C                    KWORK = 1 ON TRAITE LA IEME (I>1) MAILLE DU PAQUET
C                              MAILLES OU LE IEME NOEUD DU PAQUET
C                              DE NOEUDS.
C  SOMMW    IN  I  : SOMME DES POINTS DE GAUSS OU DES NOEUDS DES N
C                    MAILLES PRECEDANT LA MAILLE COURANTE.
C  VWORK    IN  R  : VECTEUR DE TRAVAIL CONTENANT
C                    L'HISTORIQUE DES TENSEURS DES CONTRAINTES
C                    ATTACHES A CHAQUE POINT DE GAUSS OU NOEUD DES
C                    MAILLE OU NOEUD DU <<PAQUET>> DE MAILLES OU
C                    DE NOEUDS.
C  TDISP    IN  I  : DIMENSION DU VECTEUR VWORK
C  TSPAQ    IN  I  : TAILLE DU SOUS-PAQUET DU <<PAQUET>> DE MAILLES
C                    OU DE NOEUDS COURANT.
C  I        IN  I  : IEME POINT DE GAUSS OU IEME NOEUD.
C  NOMCRI   IN  K16: NOM DU CRITERE D'ENDOMMAGEMENT PAR FATIGUE.
C  FATSOC   IN  R  : COEFFICIENT PERMETTANT D'UTILISER LES MEMES
C                    ROUTINES POUR LE TRAITEMENT DES CONTRAINTES ET
C                    DES DEFORMATIONS.
C  PROAXE    IN   K16: TYPE DE PROJECTION (UN OU DEUX AXES).
C  PSEUIL    IN   R  : SEUIL DE DTECTION DES PICS
C
C  METHOD    IN   K  : METHODE D'EXTRACTION DES PICS, PAR EXEMPLE :
C                     RAINFLOW.
C NCYCL     OUT  I  : NOMBRE DE CYCLES ELEMENTAIRES POUR TOUS LES
C                     VECTEURS NORMAUX.
C VMIN      OUT  R  : VALEURS MIN DES CYCLES ELEMENTAIRES POUR TOUS LES
C                     VECTEURS NORMAUX.
C VMAX      OUT  R  : VALEURS MAX DES CYCLES ELEMENTAIRES POUR TOUS LES
C                     VECTEURS NORMAUX.
C OMIN      OUT  I  : NUMEROS D'ORDRE ASSOCIES AUX VALEURS MIN DES
C                     CYCLES ELEMENTAIRES POUR TOUS LES VECTEURS
C                     NORMAUX.
C OMAX      OUT  I  : NUMEROS D'ORDRE ASSOCIES AUX VALEURS MAX DES
C                     CYCLES ELEMENTAIRES POUR TOUS LES VECTEURS
C                     NORMAUX.
C REMARQUE : CETTE ROUTINE SERT POUR LE TRAITEMENT DES POINTS DE GAUSS
C            ET DES NOEUDS.
C ----------------------------------------------------------------------

C VECTRA  VECTEUR DE TRAVAIL CONTENANT
C         LES COMPOSANTES u ET v DU VECTEUR TAU
C         (CONTRAINTE DE CISAILLEMENT) OU
C         GAMMA (DEFORMATION DE CISAILLEMENT), POUR TOUS LES
C         NUMEROS D'ORDRE DE CHAQUE VECTEUR NORMAL.
C LSIG0   VARIABLE LOGIQUE QUI INDIQUE :
C         - LSIG0 = FALSE --> CAS GENERAL, LES CONTRAINTES
C                             SONT DIFFERENTES DE ZERO ;
C         - LSIG0 =  TRUE --> LES CONTRAINTES SONT NULLES
C                             A TOUS LES PAS DE TEMPS, QUEL
C                             QUE SOIT LE VECTEUR NORMAL.
C IFLAG  VECTEUR DE DRAPEAUX QUI INDIQUE :
C         - IFLAG(i) = 0 --> CAS GENERAL ;
C         - IFLAG(i) = 1 --> CAS OU LES POINTS DANS LE
C                            PLAN DE CISAILLEMENT SONT
C                            ALIGNES VERTICALEMENT ;
C         - IFLAG(i) = 2 --> CAS OU LES POINTS DANS LE
C                            PLAN DE CISAILLEMENT SONT
C                            ALIGNES HORIZONTALEMENT ;
C         - IFLAG(i) = 3 --> CAS OU LES POINTS DANS LE
C                            PLAN DE CISAILLEMENT SONT
C                            CONTENUS DANS UN CADRE DE
C                            COTES INFERIEURS A EPSILO.
C RMIMA  VECTEUR CONTENANT LES COORDONNEES DES POINTS
C        EXTREMES DU CADRE (CUMIN, CUMAX, CVMIN, CVMAX)
C        POUR TOUS LES VECTEURS NORMAUX.
C RAXE   VECTEUR CONTENANT L'AMPLITUDE DES POINTS
C        PROJETES.
C NPOIN  NOMBRE DE PICS DETECTES POUR TOUS LES VECTEURS
C        NORMAUX.
C VALPOI VALEUR DES PICS DETECTES POUR TOUS LES VECTEURS
C        NORMAUX.
C VALORD NUMEROS D'ORDRE ASSOCIES AUX PICS DETECTES POUR
C        TOUS LES VECTEURS NORMAUX.
C NPIC   NOMBRE DE PICS DETECTES POUR TOUS LES VECTEURS
C        NORMAUX APRES REARANGEMENT DES PICS.
C PIC    VALEUR DES PICS DETECTES POUR TOUS LES VECTEURS
C        NORMAUX APRES REARANGEMENT DES PICS.
C ORDPIC NUMEROS D'ORDRE ASSOCIES AUX PICS DETECTES POUR
C        TOUS LES VECTEURS NORMAUX APRES REARANGEMENT
C        DES PICS.
C RTRV   VECTEUR DE TRAVAIL REEL (POUR LES POINTS)
C ITRV   VECTEUR DE TRAVAIL ENTIER (POUR LES NUME_ORDRE)

      REAL*8        VECTRA(2*NBVEC*NBORDR), RMIMA(4*NBVEC)
      INTEGER       IFLAG(NBVEC), ITRV(2*(NBORDR+2))
      LOGICAL       LSIG0
      REAL*8        RAXE(NBVEC*NBORDR), VALPOI(NBVEC*NBORDR)
      INTEGER       NPOIN(NBVEC), VALORD(NBVEC*NBORDR)
      INTEGER       NPIC(NBVEC), ORDPIC(NBVEC*(NBORDR+2))
      REAL*8        PIC(NBVEC*(NBORDR+2)), RTRV(NBORDR+2)
C      REAL*8        CUDOMX, NXM, NYM, NZM
C     ------------------------------------------------------------------
C
C  PROJECTION DE L'HISTORIQUE DU CISAILLEMENT DANS UN PLAN
      CALL JEMARQ()

      CALL PROPLA( NBVEC, VECTN, VECTU, VECTV, NBORDR, KWORK,
     &            SOMMW, VWORK, TDISP, TSPAQ, IPGN,NOMCRI,NOMFOR,
     &                   FORDEF, FATSOC,VECTRA )

C CALCUL DU DOMMAGE MAX ET DU VECTEUR NORMAL ASSOCIE POUR
C LE NOEUD/POINT GAUSS COURANT DE LA MAILLE COURANTE.

C 1. REMISE A ZERO DU VECTEUR DE TRAVAIL CONTENANT LES VALEURS DE
C    DELTA_TAU POUR UN NOEUD ET DU VECTEUR DE TRAVAIL
C    PERMETTANT DE POINTER SUR LE VECTEUR NORMAL ASSOCIE.

C 2. ENCADREMENT DES POINTS DANS LE PLAN

      LSIG0 = .FALSE.

      CALL AVENCA(VECTRA, NBVEC, NBORDR, LSIG0, IFLAG,
     &               RMIMA)

C       IF (LSIG0) THEN
C          CUDOMX = 0.0D0
C          NXM = 0.0D0
C          NYM = 0.0D0
C          NZM = 1.0D0
C          GOTO 555
C       ENDIF

C 3. PROJECTION DE L'HISTORIQUE DE CHARGEMENT SUR UN OU DEUX AXES

         CALL PROJAX(VECTRA, NBVEC, NBORDR, PROAXE, IFLAG,
     &                RMIMA, RAXE)

C 4. COMPTAGE RAINFLOW (NORME AFNOR + POSTDAM)

C 4.1 PREMIER FILTRAGE DES PICS DE LA FONCTION

         CALL AVPEAK(RAXE, NBVEC, NBORDR, PSEUIL, IFLAG,
     &               NPOIN, VALPOI, VALORD)

C 4.2 REARANGEMENT ET EXTRACTION DES PICS


         CALL AVPIC2(METHOD, NBVEC, NBORDR, RTRV, ITRV,
     &               NPOIN, VALPOI, VALORD, NPIC,
     &               PIC, ORDPIC)

C 4.3 COMPTAGE RAINFLOW
C

         CALL AVRAIN(NBVEC, NBORDR, ITRV, NPIC, PIC, ORDPIC, FATSOC,
     &                  NCYCL, VMIN, VMAX, OMIN, OMAX)


      CALL JEDEMA()

      END
