      SUBROUTINE FGDOBA(NOMMAT,NBCYCL,SIGMIN,SIGMAX,LKE,RKE,
     &                  LHAIGH,RCORR,DOM)
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*8       NOMMAT
      REAL*8                          SIGMIN(*),SIGMAX(*)
      REAL*8                   RCORR(*),DOM(*),         RKE(*)
      INTEGER                  NBCYCL
      LOGICAL           LHAIGH,                     LKE
C     ------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 03/07/2012   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C     -----------------------------------------------------------------
C     CALCUL DU DOMMAGE ELEMENTAIRE PAR INTERPOLATION SUR
C     UNE COURBE DE WOHLER DONNEE PAR 1/N = A (DSIGMA)**BETA
C     FORMULE DE BASKIN
C     ------------------------------------------------------------------
C IN  NOMMAT : K8  : NOM DU MATERIAU
C IN  NBCYCL : I   : NOMBRE DE CYCLES
C IN  SIGMIN : R   : CONTRAINTES MINIMALES DES CYCLES
C IN  SIGMAX : R   : CONTRAINTES MAXIMALES DES CYCLES
C IN  LKE    : L   : PRISE EN COMPTE DU COEFFICIENT KE
C IN  RKE    : R   : VALEURS DU COEFFICIENT KE
C IN  LHAIGH : L   : PRISE EN COMPTE CORRECTION DE HAIGH
C IN  RCORR  : R   : VALEURS DE LA CORRECTION DE HAIGH
C OUT DOM    : R   : VALEURS DES DOMMAGES ELEMENTAIRES
C     ------------------------------------------------------------------
C
      REAL*8         DELTA,VAL(2),RBID
      INTEGER ICODRE(2)
      CHARACTER*8    NOMRES(2),NOMPAR
C
C-----------------------------------------------------------------------
      INTEGER I ,NBPAR 
C-----------------------------------------------------------------------
      NOMPAR = ' '
      NBPAR  = 0
      NOMRES(1) = 'A_BASQUI'
      NOMRES(2) = 'BETA_BAS'
      CALL RCVALE(NOMMAT,'FATIGUE',NBPAR,NOMPAR,RBID,2,NOMRES,VAL,
     &            ICODRE,2)
      DO 10 I=1,NBCYCL
        DELTA = (1.D0/2.D0)*ABS(SIGMAX(I)-SIGMIN(I))
        IF (LKE) DELTA = DELTA * RKE(I)
        IF (LHAIGH) DELTA = DELTA / RCORR(I)
        DOM(I) = VAL(1)* DELTA**VAL(2)
 10   CONTINUE
C
      END
