      SUBROUTINE FGTAHE(KDOMM,NBCYCL,EPSMIN,EPSMAX,DOM)
      IMPLICIT NONE
      INCLUDE 'jeveux.h'
      CHARACTER*(*)     KDOMM
      REAL*8                   EPSMIN(*),EPSMAX(*)
      REAL*8                   DOM(*)
      INTEGER                  NBCYCL
C     ------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 03/07/2012   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C     -----------------------------------------------------------------
C     ROUTINE CHAPEAU POUR LE CALCUL DU DOMMAGE PAR LOIS DE TAHERI
C     ------------------------------------------------------------------
C IN  KDOMM  : K   : LOI DE DOMMAGE TAHERI_MANSON/TAHERI_MIXTE
C IN  NBCYCL : I   : NOMBRE DE CYCLES
C IN  EPSMIN : R   : DEFORMATIONS MINIMALES DES CYCLES
C IN  EPSMAX : R   : DEFORMATIONS MAXIMALES DES CYCLES
C OUT DOM    : R   : VALEURS DES DOMMAGES ELEMENTAIRES
C     ------------------------------------------------------------------
C
C
      INTEGER   ICODWO,ICODMA,ICODBA,ICODHS,ICODRE(3)
      CHARACTER*8   NOMMAT,NOMFO1,NOMNAP,CARA
      CHARACTER*16  PHENO,PHENOM
      INTEGER      IARG
C
C-----------------------------------------------------------------------
      INTEGER NBVAL 
C-----------------------------------------------------------------------
      CALL JEMARQ()
C
C --- CALCUL DU DOMMAGE ELEMENTAIRE DE TAHERI_MANSON_COFFIN
C
      IF(KDOMM(1:13).EQ.'TAHERI_MANSON') THEN
        CALL GETVID(' ','MATER',1,IARG,0,NOMMAT,NBVAL)
        IF(NBVAL.EQ.0) CALL U2MESS('F','FATIGUE1_8')
        CALL GETVID(' ','TAHERI_FONC',1,IARG,0,NOMFO1,NBVAL)
        IF(NBVAL.EQ.0) CALL U2MESS('F','FATIGUE1_9')
        CALL GETVID(' ','TAHERI_NAPPE',1,IARG,0,NOMNAP,NBVAL)
        IF(NBVAL.EQ.0) CALL U2MESS('F','FATIGUE1_10')
        CALL GETVID(' ','MATER',1,IARG,1,NOMMAT,NBVAL)
        PHENO = 'FATIGUE'
        CALL RCCOME (NOMMAT,PHENO,PHENOM,ICODRE(1))
        IF(ICODRE(1).EQ.1) CALL U2MESS('F','FATIGUE1_24')
        CARA = 'MANSON_C'
        CALL RCPARE(NOMMAT,PHENO,CARA,ICODMA)
        IF(ICODMA.NE.0) THEN
          CALL U2MESS('F','FATIGUE1_11')
        ENDIF
        CALL GETVID(' ','TAHERI_FONC',1,IARG,1,NOMFO1,NBVAL)
        CALL GETVID(' ','TAHERI_NAPPE',1,IARG,1,NOMNAP,NBVAL)
        CALL FGTAEP(NOMMAT,NOMFO1,NOMNAP,NBCYCL,EPSMIN,EPSMAX,
     &      DOM)
      ENDIF
C
C --- CALCUL DU DOMMAGE ELEMENTAIRE DE TAHERI_MIXTE
C
      IF(KDOMM(1:14).EQ.'TAHERI_MIXTE') THEN
        CALL GETVID(' ','MATER',1,IARG,0,NOMMAT,NBVAL)
        IF(NBVAL.EQ.0) CALL U2MESS('F','FATIGUE1_12')
        CALL GETVID(' ','TAHERI_NAPPE',1,IARG,0,NOMNAP,NBVAL)
        IF(NBVAL.EQ.0) CALL U2MESS('F','FATIGUE1_10')
        CALL GETVID(' ','MATER',1,IARG,1,NOMMAT,NBVAL)
        PHENO = 'FATIGUE'
        CALL RCCOME (NOMMAT,PHENO,PHENOM,ICODRE(1))
        IF(ICODRE(1).EQ.1) CALL U2MESS('F','FATIGUE1_24')
        CARA = 'MANSON_C'
        CALL RCPARE(NOMMAT,PHENO,CARA,ICODMA)
        CARA = 'WOHLER'
        CALL RCPARE(NOMMAT,PHENO,CARA,ICODWO)
        CARA = 'A_BASQUI'
        CALL RCPARE(NOMMAT,PHENO,CARA,ICODBA)
        CARA = 'A0'
        CALL RCPARE(NOMMAT,PHENO,CARA,ICODHS)
        IF(ICODMA.NE.0) THEN
          CALL U2MESS('F','FATIGUE1_13')
        ENDIF
        IF(ICODWO.NE.0.AND.ICODBA.NE.0.AND.ICODHS.NE.0) THEN
          CALL U2MESS('F','FATIGUE1_14')
        ENDIF
        CALL GETVID(' ','TAHERI_NAPPE',1,IARG,1,NOMNAP,NBVAL)
        CALL FGTAES(NOMMAT,NOMNAP,NBCYCL,EPSMIN,EPSMAX,DOM)
      ENDIF
C
      CALL JEDEMA()
      END
