      SUBROUTINE  GMLNEU(IGMSH, NBNODE)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 03/07/2012   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C.======================================================================
      IMPLICIT NONE
C
C      GMLNEU --   LECTURE DES NUMEROS DE NOEUDS ET DE LEURS
C                  COORDONNEES SUR LE FICHIER DE SORTIE DE GMSH
C
C   ARGUMENT        E/S  TYPE         ROLE
C    NBNODE         OUT   I         NOMBRE DE NOEUDS DU MAILLAGE
C
C.========================= DEBUT DES DECLARATIONS ====================
C -----  ARGUMENTS
      INCLUDE 'jeveux.h'
      INTEGER  IGMSH, NBNODE
C -----  VARIABLES LOCALES
C
C
C.========================= DEBUT DU CODE EXECUTABLE ==================
C-----------------------------------------------------------------------
      INTEGER IMES ,INODE ,IUNIFI ,JCOOR ,JDETR ,JINFO ,NDMAX 
      INTEGER NODE 
      REAL*8 X ,Y ,Z 
C-----------------------------------------------------------------------
      CALL JEMARQ()
C
C --- INITIALISATION :
C     --------------
      NBNODE   = 0
C
C --- RECUPERATION DES NUMEROS D'UNITE LOGIQUE :
C     ----------------------------------------
      IMES  = IUNIFI('MESSAGE')
C
C --- LECTURE DU NOMBRE DE NOEUDS :
C     ---------------------------
      READ(IGMSH,'(I10)') NBNODE
C
C --- CREATION DE VECTEURS DE TRAVAIL :
C     -------------------------------
      CALL JEDETR('&&PREGMS.INFO.NOEUDS')
      CALL JEDETR('&&PREGMS.DETR.NOEUDS')
      CALL JEDETR('&&PREGMS.COOR.NOEUDS')
C
      CALL WKVECT('&&PREGMS.INFO.NOEUDS','V V I',NBNODE,JINFO)
      CALL WKVECT('&&PREGMS.COOR.NOEUDS','V V R',3*NBNODE,JCOOR)
C
C --- LECTURE DES NUMEROS DE NOEUDS ET DE LEURS COORDONNEES :
C     -----------------------------------------------------
      NDMAX = 0
      DO 10 INODE = 1, NBNODE
C        READ(IGMSH,'(I10,3(E25.16))') NODE,X,Y,Z
        READ(IGMSH,*) NODE,X,Y,Z
        NDMAX = MAX(NODE,NDMAX)
C
        ZI(JINFO+INODE-1) = NODE
        ZR(JCOOR-1+3*(INODE-1)+1) = X
        ZR(JCOOR-1+3*(INODE-1)+2) = Y
        ZR(JCOOR-1+3*(INODE-1)+3) = Z
C
  10  CONTINUE
C

C    LISTE DES NOEUDS A DETRUIRE (0: A DETRUIRE, 1: A CONSERVER)
      CALL WKVECT('&&PREGMS.DETR.NOEUDS','V V I',NDMAX+1,JDETR)
      DO 12 NODE = 0,NDMAX
        ZI(JDETR+NODE) = 0
 12   CONTINUE


      WRITE(IMES,*) 'NOMBRE DE NOEUDS : ',NBNODE
C
      CALL JEDEMA()
C
C.============================ FIN DE LA ROUTINE ======================
      END
