      SUBROUTINE IRMAD0 ( IFC, VERSIO, NSTAT, CHAMNO, NOMSYM )
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*32 JEXNUM,JEXNOM
      INTEGER                  VERSIO, NSTAT
      CHARACTER*(*)                       CHAMNO(*) , NOMSYM
C--------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C     IMPRESSION D'UNE LISTE DE CHAMNO A COMPOSANTES REELLES OU
C     COMPLEXES AU FORMAT IDEAS  ( COMMANDE MACRO_MADMACS )
C     ON IMPRIME LE CHAMNO A L'AIDE D'UN DATASET 252
CC
C     ------------------------------------------------------------------
C
      CHARACTER*1   K1B, TYPE, TYPI
      INTEGER       GD, NUM, GDI, NUMI
      CHARACTER*8   K8B, NOMMA, NOMGD
      CHARACTER*16  NOMCMD
      CHARACTER*19  CHAMN
      CHARACTER*24  NOMNU
C     ------------------------------------------------------------------
C
C-----------------------------------------------------------------------
      INTEGER I ,IAD ,IADESC ,IAEC ,IANUEQ ,IAPRNO ,IAREFE
      INTEGER IBID ,IER ,IFC ,INO ,IRET ,ITYPE ,JNO
      INTEGER JNU ,NBEC ,NBNO ,NCMPMX ,NEC
C-----------------------------------------------------------------------
      CALL JEMARQ()
      CHAMN = CHAMNO(1)
C
      CALL JEVEUO(CHAMN//'.REFE','L',IAREFE)
C
C     --- NOM DU MAILLAGE
      NOMMA = ZK24(IAREFE-1+1) (1:8)
C
C     --- NOM DU PROFIL AUX NOEUDS ASSOCIE S'IL EXISTE
      NOMNU = ZK24(IAREFE-1+2)
C
      CALL JELIRA(CHAMN//'.VALE','TYPE',IBID,TYPE)
      IF ( TYPE .EQ. 'R' ) THEN
          ITYPE = 1
      ELSEIF ( TYPE .EQ. 'C' ) THEN
          ITYPE = 2
      ELSE
          CALL GETRES(K8B,K8B,NOMCMD)
          CALL U2MESK('A','PREPOST_97',1,TYPE(1:1))
          GOTO 9999
      ENDIF
C
      CALL JEVEUO(CHAMN//'.DESC','L',IADESC)
      GD  = ZI(IADESC-1+1)
      NUM = ZI(IADESC-1+2)
      CALL JENUNO(JEXNUM('&CATA.GD.NOMGD',GD),NOMGD)
C
C     --- ON VERIFIE QUE TOUS LES CHAMPS SONT IDENTIQUES
C
      DO 10 I = 1 , NSTAT
        CHAMN = CHAMNO(I)
        CALL JEVEUO(CHAMN//'.DESC','L',IADESC)
        GDI  = ZI(IADESC-1+1)
        NUMI = ZI(IADESC-1+2)
        IF ( GDI .NE. GD )  CALL U2MESS('F','PREPOST2_67')
        IF ( NUMI .NE. NUM )  CALL U2MESS('F','PREPOST2_68')
        CALL JELIRA(CHAMN//'.VALE','TYPE',IBID,TYPI)
        IF ( TYPI .NE. TYPE )   CALL U2MESS('F','PREPOST2_69')
 10   CONTINUE
C
C     --- NOMBRE D'ENTIERS CODES POUR LA GRANDEUR NOMGD
      NEC = NBEC(GD)
      CALL JEEXIN('&&IRMAD0.ENT_COD',IRET)
      IF (IRET.NE.0) CALL JEDETR('&&IRMAD0.ENT_COD')
      CALL WKVECT('&&IRMAD0.ENT_COD','V V I',NEC,IAEC)
      CALL JELIRA(JEXNUM('&CATA.GD.NOMCMP',GD),'LONMAX',NCMPMX,K1B)
      CALL JEVEUO(JEXNUM('&CATA.GD.NOMCMP',GD),'L',IAD)
C
C     --- SI LE CHAMP EST A REPRESENTATION CONSTANTE: RIEN DE SPECIAL
C
C     --- SI LE CHAMP EST DECRIT PAR UN "PRNO":
      IF(NUM.GE.0) THEN
        CALL JEVEUO(NOMNU(1:19)//'.NUEQ','L',IANUEQ)
        CALL JENONU(JEXNOM(NOMNU(1:19)//'.LILI','&MAILLA'),IBID)
        CALL JEVEUO(JEXNUM(NOMNU(1:19)//'.PRNO',IBID),'L',IAPRNO)
      ENDIF
C
C     --- NOMBRE DE NOEUDS DU MAILLAGE: NBNO
      CALL DISMOI('F','NB_NO_MAILLA',NOMMA,'MAILLAGE',NBNO,K8B,IER)
C
C     --- CREATION LISTES DES NOMS ET DES NUMEROS DES NOEUDS A IMPRIMER
      CALL WKVECT('&&IRMAD0.NOMNOE','V V K8',NBNO,JNO)
      CALL WKVECT('&&IRMAD0.NUMNOE','V V I' ,NBNO,JNU)
      DO 20 INO = 1,NBNO
         CALL JENUNO(JEXNUM(NOMMA//'.NOMNOE',INO),ZK8(JNO-1+INO))
         ZI(JNU-1+INO) = INO
 20   CONTINUE
C
      IF ( NUM .GE. 0 ) THEN
         NCMPMX = 6
         CALL IRMAD1 ( IFC,VERSIO,NBNO,ZI(IAPRNO),ZI(IANUEQ),NEC,
     &                 ZI(IAEC),NCMPMX,ITYPE,NSTAT,CHAMNO,
     &                 ZK8(IAD),NOMSYM,ZI(JNU) )
      ELSE
         CALL GETRES(K8B,K8B,NOMCMD)
         CALL U2MESS('E','PREPOST2_70')
      ENDIF
C
C --- MENAGE
      CALL JEDETR('&&IRMAD0.ENT_COD')
      CALL JEDETR('&&IRMAD0.NOMNOE')
      CALL JEDETR('&&IRMAD0.NUMNOE')
C
 9999 CONTINUE
      CALL JEDEMA()
      END
