      SUBROUTINE OP0176()
      IMPLICIT   NONE
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 24/07/2012   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
C     BUT:
C       OPERATEUR D'EXTRACTION
C
C
C     ARGUMENTS:
C     ----------
C
C      ENTREE :
C-------------
C
C      SORTIE :
C-------------
C
C ......................................................................
C
C
C
C
      INCLUDE 'jeveux.h'
      CHARACTER*6 NOMPRO
      PARAMETER ( NOMPRO = 'OP0176' )
C
      INTEGER IBID,NBORDR,JORDR,NBEXCL,JEXCL,NBARCH,JARCH
      INTEGER NBAC,NBPA,JPA,IRET,NBNOSY,NBPARA,NBREST
      INTEGER IZERO,NIVE,VERSIO,IUL,IUNIFI

      REAL*8 R8B

      CHARACTER*1 CECR
      CHARACTER*8 K8B,FORM,FORMAR,TABID(1)
      CHARACTER*8 NOMA,NOMO
      CHARACTER*16 TYPCON,NOMCMD
      CHARACTER*19 RESUOU,RESUIN
      CHARACTER*24 LISARC,LICHEX,NOMPAR

      LOGICAL FALS,TRUE,LBID,LREST

      COMPLEX*16 C16B
      INTEGER      IARG,NMAIL,NMODE
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ( )
      CALL INFMAJ()
      TRUE = .TRUE.
      FALS = .FALSE.
C
      LISARC = '&&'//NOMPRO//'.LISTE.ARCH'
      LICHEX = '&&'//NOMPRO//'.LISTE.CHAM'
      NOMPAR = '&&'//NOMPRO//'.NOMS_PARA '
      FORMAR = '1PE12.5'
      NIVE   = 3
      VERSIO = 0
C
      CALL GETRES ( RESUOU, TYPCON, NOMCMD )
C
      CALL GETVID ( ' ', 'RESULTAT', 1,IARG,1, RESUIN, IBID )
C
C     --- CHAMPS ---
C
      CALL JELIRA ( RESUIN//'.DESC', 'NOMMAX', NBNOSY, K8B )
      IF ( NBNOSY .EQ. 0 ) GOTO 9997
C
C     --- NOMBRE DE NUMERO D'ORDRE ---
C
      CALL RSORAC ( RESUIN, 'LONUTI', IBID, R8B, K8B, C16B, R8B, K8B,
     &                                               NBORDR, 1, IBID )
      CALL WKVECT ( '&&'//NOMPRO//'.NUME_ORDRE', 'V V I', NBORDR, JORDR)
      CALL RSORAC ( RESUIN, 'TOUT_ORDRE', IBID, R8B, K8B, C16B, R8B,K8B,
     &                                         ZI(JORDR), NBORDR, IBID )
C
C     --- ACCES ET PARAMETRES ---
C
      CALL RSNOPA ( RESUIN, 2, NOMPAR, NBAC, NBPA )
      NBPARA = NBAC + NBPA
      CALL JEVEUO ( NOMPAR, 'L', JPA )
C
C     --- CHAMPS EXCLUS ET PAS D'ARCHIVAGE ---
C
      CALL DYARC0 ( RESUIN, NBNOSY, NBARCH, LISARC, NBEXCL, LICHEX )
C
C     --- MOT-CLE RESTREINT
      CALL GETFAC('RESTREINT',NBREST)
      LREST = .FALSE.
      IF ( NBREST.GT.0 ) THEN
        LREST = .TRUE.
        CALL GETVID('RESTREINT','MAILLAGE',1,IARG,1,NOMA,NMAIL)
        CALL GETVID('RESTREINT','MODELE',1,IARG,1,NOMO,NMODE)
      ENDIF
      IF ( (NBARCH.EQ.0).AND.(NBREST.EQ.0) ) THEN
        GOTO 9997
      ELSEIF ( (NBARCH.EQ.0) ) THEN
        JARCH = JORDR
        NBARCH = NBORDR
      ELSE
        CALL JEVEUO ( LISARC, 'L', JARCH )
      ENDIF
      CALL JEVEUO ( LICHEX, 'L', JEXCL )
C
C     --- ALLOCATION DE LA STRUCTURE SORTIE SI ELLE N'EXISTE PAS ---
C
      CALL JEEXIN (RESUOU//'.DESC',IRET)
      IF ( IRET.EQ.0 ) THEN
        CALL RSCRSD('G',RESUOU,TYPCON,NBARCH)
      ENDIF

C
        IF ( RESUIN .EQ. RESUOU ) THEN
          IF ( LREST ) CALL U2MESS('F','PREPOST2_5')
          CALL EXTRS1 ( RESUIN,
     &                  NBORDR, ZI(JORDR), NBPARA, ZK16(JPA),
     &                  NBARCH, ZI(JARCH), NBEXCL, ZK16(JEXCL), NBNOSY )
        ELSE
          CALL EXTRS2 ( RESUIN, RESUOU, TYPCON,
     &                  LREST, NOMA, NOMO,
     &                  NBORDR, ZI(JORDR), NBPARA, ZK16(JPA),
     &                  NBARCH, ZI(JARCH), NBEXCL, ZK16(JEXCL), NBNOSY )
        ENDIF
C
        CALL TITRE( )
C
C     --- IMPRESSION ---
C
        FORM = 'RESULTAT'
        IUL  = IUNIFI( 'MESSAGE' )
        CALL RSINFO ( RESUOU, IUL )
C
        CALL RSORAC ( RESUOU,'LONUTI',IBID,R8B,K8B,C16B,R8B,K8B,
     &                                                 NBORDR,1,IBID)
        CALL RSORAC ( RESUOU,'TOUT_ORDRE',IBID,R8B,K8B,C16B,R8B,K8B,
     &                                          ZI(JORDR),NBORDR,IBID)
        K8B  = '        '
        CECR = 'T'
        IZERO = 0
        TABID(1) = ' '
        CALL IRECRI ( RESUOU,FORM,IUL,K8B,LBID,
     &                IZERO,TABID,' ',NBPARA,ZK16(JPA),
     &                NBORDR,ZI(JORDR),TRUE,'RESU',1,CECR,K8B,FALS,
     &                IZERO,IBID,IZERO,IBID,IZERO,K8B,FALS,R8B,FALS,R8B,
     &                FALS,FALS,FORMAR,NIVE,VERSIO)

 9997 CONTINUE



C     -- CREATION DE L'OBJET .REFD SI NECESSAIRE:
C     -------------------------------------------
      CALL AJREFD(RESUIN,RESUOU,'COPIE')


      CALL JEDEMA( )
C
      END
