      SUBROUTINE SSAFMO(MO)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF SOUSTRUC  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
C
C     ARGUMENTS:
C     ----------
      INCLUDE 'jeveux.h'

      CHARACTER*32 JEXNOM
      CHARACTER*8 MO
C ----------------------------------------------------------------------
C     BUT: TRAITER LE MOT-CLEF AFFE_SOUS_STRUC DE LA COMMANDE
C          AFFE_MODELE.
C
C
C     IN: MO : NOM DU MODELE
C
C     OUT: MO EST (EVENTUELLEMENT) ENRICHI DE L'OBJET .SSSA
C        (CET OBJET PRECISE QUELS SONT LES (SUPER)MAILLES DU MAILLAGE
C         REELLEMENT AFFECTEES PAR DES SOUS_STRUCTURES DANS LE MODELE)
C
C ----------------------------------------------------------------------
C
C     FONCTIONS EXTERNES:
C     -------------------
C
C     VARIABLES LOCALES:
C     ------------------
      CHARACTER*8 MA ,KBID ,NOSMA
      CHARACTER*24 VALK(2)
      INTEGER      IARG
C
C
C
C-----------------------------------------------------------------------
      INTEGER I ,IALMAI ,IASSSA ,IBID ,IERD ,IMAS ,IOC
      INTEGER IRET ,N1 ,N2 ,NBOC ,NBSMA ,NBSS ,NL

C-----------------------------------------------------------------------
      CALL JEMARQ()
      CALL GETFAC('AFFE_SOUS_STRUC',NBOC)
      IF (NBOC.EQ.0) GO TO 9999
C
      CALL DISMOI('F','NOM_MAILLA',MO,'MODELE',IBID,MA,IERD)
      CALL DISMOI('F','NB_SM_MAILLA',MA,'MAILLAGE',NBSMA,KBID,IERD)
      CALL DISMOI('F','NB_NL_MAILLA',MA,'MAILLAGE',NL,KBID,IERD)
      IF (NBSMA.EQ.0) THEN
        CALL U2MESS('F','SOUSTRUC_30')
      END IF
C
      IOC=1
      CALL WKVECT(MO//'.MODELE    .SSSA','G V I',NBSMA+3,IASSSA)
C
C     -- CAS : TOUT: 'OUI' :
C     ----------------------
      CALL GETVTX('AFFE_SOUS_STRUC','TOUT',IOC,IARG,1,KBID,N1)
      IF (N1.EQ.1) THEN
        DO 1, I=1,NBSMA
          ZI(IASSSA-1+I)=1
 1      CONTINUE
        NBSS= NBSMA
        GO TO 9998
      END IF
C
C     -- CAS : MAILLE: L_MAIL
C     -----------------------
      CALL GETVTX('AFFE_SOUS_STRUC','SUPER_MAILLE',
     &                IOC,IARG,0,KBID,N1)
      CALL WKVECT('&&SSAFMO.LMAI','V V K8',-N1,IALMAI)
      CALL GETVTX('AFFE_SOUS_STRUC','SUPER_MAILLE',
     &                IOC,IARG,-N1,ZK8(IALMAI),N2)
      NBSS= -N1
      DO 2, I=1,-N1
        NOSMA=ZK8(IALMAI-1+I)
        CALL JENONU(JEXNOM(MA//'.SUPMAIL',NOSMA),IMAS)
        IF (IMAS.EQ.0) THEN
           VALK(1) = NOSMA
           VALK(2) = MA
           CALL U2MESK('F','SOUSTRUC_26', 2 ,VALK)
        ELSE
          ZI(IASSSA-1+IMAS)=1
        END IF
 2    CONTINUE
C
C     -- ON REMPLIT LES 3 DERNIERES VALEURS:
C     --------------------------------------
 9998 CONTINUE
      ZI(IASSSA-1+NBSMA+1)=NBSMA
      ZI(IASSSA-1+NBSMA+2)=NBSS
      ZI(IASSSA-1+NBSMA+3)=NL
C
      CALL JEEXIN('&&SSAFMO.LMAI',IRET)
      IF (IRET.GT.0) CALL JEDETR('&&SSAFMO.LMAI')
C
C
 9999 CONTINUE
      CALL JEDEMA()
      END
