      SUBROUTINE SSRIGE(NOMU)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF SOUSTRUC  DATE 03/07/2012   AUTEUR PELLET J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
      IMPLICIT NONE
C
C     ARGUMENTS:
C     ----------
      INCLUDE 'jeveux.h'
      CHARACTER*8 NOMU
C ----------------------------------------------------------------------
C     BUT: TRAITER LE MOT CLEF "RIGI_MECA" DE L'OPERATEUR MACR_ELEM_STAT
C          CALCULER LA MATRICE DE RIGIDITE CONDENSEE DU MACR_ELEM_STAT.
C
C     IN: NOMU   : NOM DU MACR_ELEM_STAT
C
C     OUT: LES OBJETS SUIVANTS DU MACR_ELEM_STAT SONT CALCULES:
C          .PHI_IE ET .KP_EE
C
C ----------------------------------------------------------------------
C
C
      INTEGER       NCHACI
      REAL*8         RTBLOC
      CHARACTER*1   BASE
      CHARACTER*8     NOMO, CARA, MATERI
      CHARACTER*14  NU
      CHARACTER*19  MATEL,MATAS
      CHARACTER*24  MATE
C
C-----------------------------------------------------------------------
      INTEGER IAREFM ,IBID ,JDESM ,JVARM 
      REAL*8 TIME 
C-----------------------------------------------------------------------
      CALL JEMARQ()
      NU   = NOMU
      BASE = 'V'
C
      MATEL = '&&MATEL'
      MATAS = NOMU//'.RIGIMECA'
C
      CALL JEVEUO(NOMU//'.DESM' ,'L',JDESM)
      NCHACI = ZI(JDESM-1+6)
C
      CALL JEVEUO(NOMU//'.REFM' ,'E',IAREFM)
      NOMO   = ZK8(IAREFM-1+1)
      CARA   = ZK8(IAREFM-1+4)
      MATERI = ZK8(IAREFM-1+3)
      IF ( MATERI .EQ. '        ' ) THEN
         MATE = ' '
      ELSE
         CALL RCMFMC ( MATERI , MATE )
      ENDIF
C
      CALL JEVEUO(NOMU//'.VARM' ,'L',JVARM)
      TIME = ZR(JVARM-1+2)
C
C        -- CALCULS MATRICES ELEMENTAIRES DE RIGIDITE:
      CALL MERIME(NOMO,NCHACI,ZK8(IAREFM-1+9+1),MATE,CARA,
     +            .TRUE.,TIME,' ',MATEL,IBID,BASE)
C
C        -- NUME_DDL:
      CALL NUMDDL(NU,'GG',1,MATEL,'RCMK')
      CALL CRNSLV(NU,'LDLT','RCMK','G')
C
C        -- ON MET LES DDLS INTERNES AVANT LES EXTERNES
C           AVANT DE CONSTRUIRE LE PROFIL :
      CALL SSRIU1(NOMU)
      CALL PROMOR(NU,'G')
      RTBLOC=ZR(JVARM-1+1)
      CALL SMOSLI(NU//'.SMOS',NU//'.SLCS','G',RTBLOC)
C
C        -- ASSEMBLAGE:
      CALL ASSMAM('G',MATAS,1,MATEL,1.0D0,NU,'ZERO',1)
C     -- IL FAUT COMPLETER LA MATRICE SI LES CALCULS SONT DISTRIBUES:
      CALL SDMPIC('MATR_ASSE',MATAS)


      CALL SSRIU2(NOMU)
C
C        -- MISE A JOUR DE .REFM(5) ET REFM(6)
      ZK8(IAREFM-1+5)=NU(1:8)
      ZK8(IAREFM-1+6)='OUI_RIGI'
C

      CALL JEDETR(NOMU//'      .NEWN')
      CALL JEDETR(NOMU//'      .OLDN')
      CALL JEDETR(NU//'     .ADNE')
      CALL JEDETR(NU//'     .ADLI')
      CALL JEDETR(MATAS(1:19)//'.LILI')
      CALL DETRSD('MATR_ELEM',MATEL)
C
      CALL JEDEMA()
      END
