      SUBROUTINE MODOPT ( RESUCO, MODELE, LESOPT, NBOPT )
      IMPLICIT   NONE
      INCLUDE 'jeveux.h'
      INTEGER             NBOPT
      CHARACTER*8         RESUCO, MODELE
      CHARACTER*24        LESOPT
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 02/10/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C
C    CETTE ROUTINE AJOUTE DES OPTIONS DE CALCUL SI CELLES-CI 
C    ONT ETE OMISES :
C
C    SI ERZ1_ELEM ALORS SIEF_ELGA PUIS SIZ1_NOEU
C    SI SIZ1_NOEU ALORS SIEF_ELGA
C    SI ERZ2_ELEM ALORS SIEF_ELGA PUIS SIZ2_NOEU
C    SI SIZ2_NOEU ALORS SIEF_ELGA
C    SI ERME_ELEM ALORS SIGM_ELNO ou SIEF_ELNO
C    SI ERTH_ELEM ALORS FLUX_ELNO
C    SI META_NOEU ALORS META_ELNO
C
C    SI XXXX_NOEU ALORS XXXX_ELNO
C    SI XXXX_ELNO ALORS XXXX_ELEM
C    
C ----------------------------------------------------------------------
      INTEGER       J, JOPT, JOPT2
      INTEGER       I, INDK16, IRET, IRXFEM, NBOPT2
      INTEGER       IERZ1, IERZ2, INOZ1, INOZ2, IERTH, IERTO, IERTNO
      INTEGER       IERME, IERMO, IERMNO, IQIREL, IQIREN, IMETA
      CHARACTER*16  TYSD
      CHARACTER*24  LESOP2
      LOGICAL       YATHM, PERMAN

C DEB ------------------------------------------------------------------
C
      CALL JEMARQ()
C
      CALL GETTCO ( RESUCO, TYSD )
      CALL JEVEUO(LESOPT,'L',JOPT)
C
      IERZ1 = INDK16( ZK16(JOPT), 'ERZ1_ELEM', 1, NBOPT )
C
      IERZ2 = INDK16( ZK16(JOPT), 'ERZ2_ELEM', 1, NBOPT )
C
      INOZ1 = INDK16( ZK16(JOPT), 'SIZ1_NOEU', 1, NBOPT )
C
      INOZ2 = INDK16( ZK16(JOPT), 'SIZ2_NOEU', 1, NBOPT )
C
      IERTH = INDK16( ZK16(JOPT), 'ERTH_ELEM', 1, NBOPT )
C
      IERTO = INDK16( ZK16(JOPT), 'ERTH_ELNO', 1, NBOPT )
C
      IERTNO = INDK16( ZK16(JOPT), 'ERTH_NOEU', 1, NBOPT )
C
      IERME = INDK16( ZK16(JOPT), 'ERME_ELEM', 1, NBOPT )
C
      IERMO = INDK16( ZK16(JOPT), 'ERME_ELNO', 1, NBOPT )
C
      IERMNO = INDK16( ZK16(JOPT), 'ERME_NOEU', 1, NBOPT )
C
      IQIREL = INDK16( ZK16(JOPT), 'QIRE_ELNO', 1, NBOPT )
C
      IQIREN = INDK16( ZK16(JOPT), 'QIRE_NOEU', 1, NBOPT )
C
      IMETA = INDK16( ZK16(JOPT), 'META_NOEU', 1, NBOPT )
C
      IF (IERZ1+IERZ2+INOZ1+INOZ2+IERTH+IERTO+IERTNO+IERME+IERMO+IERMNO
     &    +IQIREL+IQIREN+IMETA.EQ.0) THEN
        GOTO 9999
      ENDIF
C
      LESOP2 = '&&OP0058.NEW_OPTION'
      CALL JEDUPO ( LESOPT , 'V', LESOP2 , .FALSE. )
      CALL JEDETR ( LESOPT )
      CALL WKVECT ( LESOPT , 'V V K16' , NBOPT+20 , JOPT )
      CALL JEVEUO ( LESOP2 , 'L', JOPT2 )
C
      NBOPT2 = 1
C
C     EST-CE DU XFEM ?
      CALL EXIXFE(MODELE, IRXFEM)
      IF (IRXFEM.NE.0)THEN
         CALL RSCHEX ( RESUCO, 'SISE_ELNO', IRET )
         IF ( IRET .EQ. 0 ) THEN
            ZK16(JOPT+NBOPT2-1) = 'SISE_ELNO'
            NBOPT2 = NBOPT2 + 1
         ENDIF
      ENDIF
C
C
C     CHAMPS ERME_XXXX
C
      IF ((IERME.NE.0).OR.(IERMO.NE.0).OR.(IERMNO.NE.0)) THEN
C        EST-CE DE LA THM ?
         CALL EXITHM ( MODELE, YATHM, PERMAN)
         IF (YATHM) THEN
            CALL RSCHEX ( RESUCO, 'SIEF_ELNO', IRET )
            IF ( IRET .EQ. 0 ) THEN
               ZK16(JOPT+NBOPT2-1) = 'SIEF_ELNO'
               NBOPT2 = NBOPT2 + 1
            ENDIF
         ELSE
            CALL RSCHEX ( RESUCO, 'SIGM_ELNO', IRET )
            IF ( IRET .EQ. 0 ) THEN
               ZK16(JOPT+NBOPT2-1) = 'SIGM_ELNO'
               NBOPT2 = NBOPT2 + 1
            ENDIF
         ENDIF
      ENDIF
C
      IF ((IERMO.NE.0).OR.(IERMNO.NE.0)) THEN
         CALL RSCHEX ( RESUCO, 'ERME_ELEM', IRET )
         IF ( IRET .EQ. 0 ) THEN
            ZK16(JOPT+NBOPT2-1) = 'ERME_ELEM'
            NBOPT2 = NBOPT2 + 1
         ENDIF
      ENDIF
C
      IF (IERMNO.NE.0) THEN
         CALL RSCHEX ( RESUCO, 'ERME_ELNO', IRET )
         IF ( IRET .EQ. 0 ) THEN
            ZK16(JOPT+NBOPT2-1) = 'ERME_ELNO'
            NBOPT2 = NBOPT2 + 1
         ENDIF
      ENDIF
C
C
C     CHAMPS ERZX_ELEM ET SIZX_NOEU
C
      IF( ( IERZ1 .NE. 0 ).OR.
     &    ( IERZ2 .NE. 0 ).OR.
     &    ( INOZ1 .NE. 0 ).OR.
     &    ( INOZ2 .NE. 0 )) THEN
        IF ( TYSD .EQ. 'EVOL_ELAS' ) THEN
           CALL RSCHEX ( RESUCO, 'SIEF_ELGA', IRET )
           IF ( IRET .EQ. 0 ) THEN
              CALL U2MESS('A','UTILITAI2_52')
              ZK16(JOPT+NBOPT2-1) = 'SIEF_ELGA'
              NBOPT2 = NBOPT2 + 1
           ENDIF
        ENDIF
      ENDIF
C
      IF ( IERZ1 .NE. 0 ) THEN
         CALL RSCHEX ( RESUCO, 'SIZ1_NOEU', IRET )
         IF ( IRET .EQ. 0 ) THEN
            ZK16(JOPT+NBOPT2-1) = 'SIZ1_NOEU'
            NBOPT2 = NBOPT2 + 1
         ENDIF
      ENDIF
C
      IF ( IERZ2 .NE. 0 ) THEN
         CALL RSCHEX ( RESUCO, 'SIZ2_NOEU', IRET )
         IF ( IRET .EQ. 0 ) THEN
            ZK16(JOPT+NBOPT2-1) = 'SIZ2_NOEU'
            NBOPT2 = NBOPT2 + 1
         ENDIF
      ENDIF
C
C
C     CHAMPS ERTH_XXXX
C
      IF ((IERTH.NE.0).OR.(IERTO.NE.0).OR.(IERTNO.NE.0)) THEN
         CALL RSCHEX ( RESUCO, 'FLUX_ELNO', IRET )
         IF ( IRET .EQ. 0 ) THEN
            ZK16(JOPT+NBOPT2-1) = 'FLUX_ELNO'
            NBOPT2 = NBOPT2 + 1
         ENDIF
      ENDIF
C
      IF ((IERTO.NE.0).OR.(IERTNO.NE.0)) THEN
         CALL RSCHEX ( RESUCO, 'ERTH_ELEM', IRET )
         IF ( IRET .EQ. 0 ) THEN
            ZK16(JOPT+NBOPT2-1) = 'ERTH_ELEM'
            NBOPT2 = NBOPT2 + 1
         ENDIF
      ENDIF
C
      IF (IERTNO.NE.0) THEN
         CALL RSCHEX ( RESUCO, 'ERTH_ELNO', IRET )
         IF ( IRET .EQ. 0 ) THEN
            ZK16(JOPT+NBOPT2-1) = 'ERTH_ELNO'
            NBOPT2 = NBOPT2 + 1
         ENDIF
      ENDIF
C
C
C     CHAMPS QIRE_XXXX
C
      IF ((IQIREL.NE.0).OR.(IQIREN.NE.0)) THEN
         CALL RSCHEX ( RESUCO, 'QIRE_ELEM', IRET )
         IF ( IRET .EQ. 0 ) THEN
            ZK16(JOPT+NBOPT2-1) = 'QIRE_ELEM'
            NBOPT2 = NBOPT2 + 1
         ENDIF
      ENDIF
C
      IF ( IQIREN .NE. 0 ) THEN
         CALL RSCHEX ( RESUCO, 'QIRE_ELNO', IRET )
         IF ( IRET .EQ. 0 ) THEN
            ZK16(JOPT+NBOPT2-1) = 'QIRE_ELNO'
            NBOPT2 = NBOPT2 + 1
         ENDIF
      ENDIF
C
      IF ( IMETA .NE. 0 ) THEN
         CALL RSCHEX ( RESUCO, 'META_ELNO', IRET )
         IF ( IRET .EQ. 0 ) THEN
            ZK16(JOPT+NBOPT2-1) = 'META_ELNO'
            NBOPT2 = NBOPT2 + 1
         ENDIF
      ENDIF
C
      NBOPT2 = NBOPT2 - 1
C
      DO 10 I = 1 , NBOPT
         DO 12 J = 1 , NBOPT2
            IF ( ZK16(JOPT2+I-1) .EQ. ZK16(JOPT+J-1) ) GOTO 10
 12      CONTINUE
         NBOPT2 = NBOPT2 + 1
         ZK16(JOPT+NBOPT2-1) = ZK16(JOPT2+I-1)
 10   CONTINUE
C
      NBOPT = NBOPT2
      CALL JEDETR ( LESOP2 )
C
 9999 CONTINUE
      CALL JEDEMA()
      END
