      SUBROUTINE NMDIVR(SDDISC,SDERRO,ITERAT)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 02/04/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE GENIAUT S.GENIAUT
C
      IMPLICIT     NONE
      INTEGER      ITERAT
      CHARACTER*19 SDDISC
      CHARACTER*24 SDERRO
C
C ----------------------------------------------------------------------
C
C ROUTINE MECA_NON_LINE
C
C EVALUATION DE LA DIVERGENCE DU RESIDU
C
C ----------------------------------------------------------------------
C
C EVALUATION DE LA DIVERGENCE DU RESIDU :
C    ON DIT QU'IL Y A DIVERGENCE DU RESIDU SSI :
C       MIN[ R(I), R(I-1) ] > R(I-2), A PARTIR DE I=3 (COMME ABAQUS)
C
C    OU R(I)   EST LE RESIDU A L'ITERATION COURANTE
C       R(I-1) EST LE RESIDU A L'ITERATION MOINS 1
C       R(I-2) EST LE RESIDU A L'ITERATION MOINS 2
C
C ----------------------------------------------------------------------
C
C
C IN  SDDISC : SD DISCRETISATION TEMPORELLE
C IN  SDERRO : GESTION DES ERREURS
C IN  ITERAT : NUMERO ITERATION NEWTON
C
C ----------------------------------------------------------------------
C
      REAL*8       R,RM1,RM2
      LOGICAL      DIVRES
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      DIVRES = .FALSE.
C
C --- DIVRES N'EST EVALUE QU'A PARTIR DE L'ITERATION 3
C
      IF (ITERAT.LT.3) GOTO 999
C
C --- RESIDU GLOBAL (RESI_GLOB_MAXI) A L'ITERATION COURANTE
C
      CALL NMLERE(SDDISC,'L','VMAXI',ITERAT,R)
C
C --- RESIDU GLOBAL (RESI_GLOB_MAXI) A L'ITERATION "MOINS 1"
C
      CALL NMLERE(SDDISC,'L','VMAXI',ITERAT-1,RM1)
C
C --- RESIDU GLOBAL (RESI_GLOB_MAXI) A L'ITERATION "MOINS 2"
C
      CALL NMLERE(SDDISC,'L','VMAXI',ITERAT-2,RM2)
C
C --- SI LE RESIDU N'EST PAS DIMINUE SUR UNE DES 2 ITERATIONS : DIV
C
      IF ( MIN(R,RM1).GT.RM2 ) DIVRES = .TRUE.
C
  999 CONTINUE
C
C --- SAUVEGARDE DES EVENEMENTS
C
      CALL NMCREL(SDERRO,'DIVE_RESI',DIVRES)

      CALL JEDEMA()
      END
