      SUBROUTINE OBLGIP(SDLIST,IDNVAZ,INDICE)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 18/09/2012   AUTEUR ABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE ABBAS M.ABBAS
C
      IMPLICIT      NONE
      INCLUDE       'jeveux.h'
      CHARACTER*24  SDLIST
      CHARACTER*(*) IDNVAZ
      INTEGER       INDICE
C
C ----------------------------------------------------------------------
C
C ROUTINE UTILITAIRE (GESTION STRUCT - LISTE DE STRUCTS)
C
C INDICE D'UN STRUCT DANS LA LISTE - ACCES PAR PARAMETRE
C
C ----------------------------------------------------------------------
C
C
C IN  SDLIST : NOM DE LA LISTE
C IN  IDNVAL : VALEUR DU PARAMETRE IDENTIFIANT LE STRUCT
C OUT INDICE : INDICE DU STRUCT DANS LA LISTE
C
C ----------------------------------------------------------------------
C
      CHARACTER*24 IDNPAR
      INTEGER      ISTRU,NBSTRU
      CHARACTER*24 NOMSTR
      CHARACTER*15 VALPAR
      CHARACTER*24 TYPESD
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- INITIALISATIONS
C
      INDICE = 0
C
C --- PARAMETRE IDENTIFICATION
C
      CALL OBGETK(SDLIST,'PARA_IDEN_STRUCT',IDNPAR)
C
C --- VERIFICATION
C
      CALL OBGETT(SDLIST,TYPESD)
      IF (TYPESD.NE.'LISTE_STRUCTS') CALL ASSERT(.FALSE.)
C
C --- RECHERCHE DANS LA LISTE
C
      CALL OBGETI(SDLIST,'NBRE_STRUCTS',NBSTRU)
      DO 10 ISTRU = 1,NBSTRU
       CALL OBLGOI(SDLIST,ISTRU ,NOMSTR)
       IF (NOMSTR.EQ.' ') THEN
         WRITE(6,*) 'LISTE DES STRUCTS VIDE (NON INIT)'
         CALL ASSERT(.FALSE.)
       ENDIF
       CALL OBGETK(NOMSTR,IDNPAR,VALPAR)
       IF (IDNVAZ.EQ.VALPAR) THEN
         IF (INDICE.NE.0) THEN
           WRITE(6,*) 'PLUSIEURS STRUCTS DANS LA LISTE '
           CALL ASSERT(.FALSE.)
         ELSE
           INDICE = ISTRU
         ENDIF
       ENDIF
  10  CONTINUE
C
      IF (INDICE.EQ.0) THEN
        WRITE(6,*) 'STRUCT INTROUVABLE DANS LA LISTE '
        CALL ASSERT(.FALSE.)
      ENDIF
C
      CALL JEDEMA()
      END
