      SUBROUTINE RSRUSD(NOMSD,IORDR)
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*32 JEXNUM,JEXNOM
      INTEGER IORDR
      CHARACTER*(*) NOMSD
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE PELLET J.PELLET

C  BUT: "EFFACER" LA STRUCTURE DE DONNEES RESULTAT NOMSD
C        A PARTIR DU NUMERO D'ORDRE IORDR (Y COMPRIS IORDR)

C ----------------------------------------------------------------------
C IN  : NOMSD  : NOM DE LA STRUCTURE "RESULTAT"
C IN  : IORDR  : NUMERO D'ORDRE A PARTIR DUQUEL ON EFFACE TOUT
C       SI IORDR N'EST PAS UN NUMERO D'ORDRE DE NOMSD => ERREUR <F>
C ----------------------------------------------------------------------

C REMARQUES :
C------------
C ON NE REDIMENSIONNE PAS LES OBJETS JEVEUX MAIS :
C   - ON REMET LONUTI DE .ORDR A (IORDR-1)
C   - ON EFFACE LE CONTENU DE .ORDR AU DELA DE IORDR
C   - ON DETRUIT LES CHAMPS EXISTANTS AU DELA DE IORDR
C   - ON REMET LES NOMS DES CHAMPS A " "  AU DELA DE IORDR
C   - ON EFFACE LES VALEURS DES PARAMETRES AU DELA DE IORDR


      CHARACTER*16 NOMSY
      CHARACTER*19 NOMS2,CHEXTR
      CHARACTER*24 NOMOBJ
      CHARACTER*1 KBID
      INTEGER JORDR,KORDR,KRANG,IRANG,NBCHAM,NBORDR,K,IBID,JTACH
      INTEGER NBORMX,N1,N2,KK,IUNDEF,JPARA,IER1,ISNNEM
      REAL*8 RUNDEF,R8VIDE
C ----------------------------------------------------------------------
      CALL JEMARQ()

      RUNDEF = R8VIDE()
      IUNDEF = ISNNEM()

      NOMS2 = NOMSD
      CALL JELIRA(NOMS2//'.DESC','NOMMAX',NBCHAM,KBID)
      CALL JELIRA(NOMS2//'.ORDR','LONMAX',NBORMX,KBID)
      CALL JEVEUO(NOMS2//'.ORDR','E',JORDR)

      CALL RSUTRG(NOMS2,IORDR,IRANG,NBORDR)

C     -- SI IORDR N'EST PAS TROUVE DANS NOMSD, ON VERIFIE
C        QUE IORDR > DERNIER NUMERO D'ORDRE
C        ET ON RESSORT SANS RIEN FAIRE :
      IF (IRANG.EQ.0) THEN
        CALL ASSERT(IORDR.GT.ZI(JORDR-1+NBORDR))
        GOTO 40
      ENDIF


C     -- ON DETRUIT ET ON EFFACE LES CHAMPS :
C     ---------------------------------------
      DO 20 K = 1,NBCHAM
        CALL JENUNO(JEXNUM(NOMS2//'.DESC',K),NOMSY)
        CALL JENONU(JEXNOM(NOMS2//'.DESC',NOMSY),IBID)
        CALL JEVEUO(JEXNUM(NOMS2//'.TACH',IBID),'E',JTACH)
        DO 10 KRANG = IRANG,NBORDR
          KORDR=ZI(JORDR-1+KRANG)
          CALL RSUTCH(NOMSD,NOMSY,KORDR,CHEXTR,.TRUE.)
          CALL DETRSD('CHAMP_GD',CHEXTR)
          ZK24(JTACH-1+KRANG) = ' '
   10   CONTINUE
   20 CONTINUE


C     -- ON EFFACE LES PARAMETRES :
C     ------------------------------
      NOMOBJ=NOMS2//'.RSPR'
      CALL JEEXIN(NOMOBJ,IER1)
      IF (IER1.GT.0) THEN
        CALL JELIRA(NOMOBJ,'LONMAX',N1,KBID)
        N2=N1/NBORMX
        CALL ASSERT(N1.EQ.N2*NBORMX)
        CALL JEVEUO(NOMOBJ,'E',JPARA)
        DO 1, KK=N2*IRANG, N2*NBORMX
          ZR(JPARA-1+KK)=RUNDEF
 1      CONTINUE
      ENDIF


      NOMOBJ=NOMS2//'.RSPC'
      CALL JEEXIN(NOMOBJ,IER1)
      IF (IER1.GT.0) THEN
        CALL JELIRA(NOMOBJ,'LONMAX',N1,KBID)
        N2=N1/NBORMX
        CALL JEVEUO(NOMOBJ,'E',JPARA)
        DO 2, KK=N2*IRANG, N2*NBORMX
          ZC(JPARA-1+KK) = DCMPLX(RUNDEF,RUNDEF)
 2      CONTINUE
      ENDIF


      NOMOBJ=NOMS2//'.RSPI'
      CALL JEEXIN(NOMOBJ,IER1)
      IF (IER1.GT.0) THEN
        CALL JELIRA(NOMOBJ,'LONMAX',N1,KBID)
        N2=N1/NBORMX
        CALL JEVEUO(NOMOBJ,'E',JPARA)
        DO 3, KK=N2*IRANG, N2*NBORMX
          ZI(JPARA-1+KK)=IUNDEF
 3      CONTINUE
      ENDIF


      NOMOBJ=NOMS2//'.RSP8'
      CALL JEEXIN(NOMOBJ,IER1)
      IF (IER1.GT.0) THEN
        CALL JELIRA(NOMOBJ,'LONMAX',N1,KBID)
        N2=N1/NBORMX
        CALL JEVEUO(NOMOBJ,'E',JPARA)
        DO 4, KK=N2*IRANG, N2*NBORMX
          ZK8(JPARA-1+KK)=' '
 4      CONTINUE
      ENDIF


      NOMOBJ=NOMS2//'.RS16'
      CALL JEEXIN(NOMOBJ,IER1)
      IF (IER1.GT.0) THEN
        CALL JELIRA(NOMOBJ,'LONMAX',N1,KBID)
        N2=N1/NBORMX
        CALL JEVEUO(NOMOBJ,'E',JPARA)
        DO 5, KK=N2*IRANG, N2*NBORMX
          ZK16(JPARA-1+KK)=' '
 5      CONTINUE
      ENDIF


      NOMOBJ=NOMS2//'.RS24'
      CALL JEEXIN(NOMOBJ,IER1)
      IF (IER1.GT.0) THEN
        CALL JELIRA(NOMOBJ,'LONMAX',N1,KBID)
        N2=N1/NBORMX
        CALL JEVEUO(NOMOBJ,'E',JPARA)
        DO 6, KK=N2*IRANG, N2*NBORMX
          ZK24(JPARA-1+KK)=' '
 6      CONTINUE
      ENDIF


      NOMOBJ=NOMS2//'.RS32'
      CALL JEEXIN(NOMOBJ,IER1)
      IF (IER1.GT.0) THEN
        CALL JELIRA(NOMOBJ,'LONMAX',N1,KBID)
        N2=N1/NBORMX
        CALL JEVEUO(NOMOBJ,'E',JPARA)
        DO 7, KK=N2*IRANG, N2*NBORMX
          ZK32(JPARA-1+KK)=' '
 7      CONTINUE
      ENDIF


      NOMOBJ=NOMS2//'.RS80'
      CALL JEEXIN(NOMOBJ,IER1)
      IF (IER1.GT.0) THEN
        CALL JELIRA(NOMOBJ,'LONMAX',N1,KBID)
        N2=N1/NBORMX
        CALL JEVEUO(NOMOBJ,'E',JPARA)
        DO 8, KK=N2*IRANG, N2*NBORMX
          ZK80(JPARA-1+KK)=' '
 8      CONTINUE
      ENDIF

C     -- ON EFFACE .ORDR :
      CALL JEECRA(NOMS2//'.ORDR','LONUTI',IRANG-1,KBID)
      DO 30 KRANG = IRANG,NBORMX
        ZI(JORDR-1+KRANG)=0
   30 CONTINUE

   40 CONTINUE
      CALL JEDEMA()
      END
