      SUBROUTINE RSUTCH(NOMSD,NOMSY,IORDR,NOMCHA,LVERIF)
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      CHARACTER*32 JEXNUM,JEXNOM
      INTEGER IORDR
      CHARACTER*(*) NOMSD,NOMSY,NOMCHA
      LOGICAL LVERIF
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE PELLET J.PELLET

C DETERMINATION DU NOM DU CHAMP19 CORRESPONDANT A NOMSD(IORDR,NOMSY)
C ----------------------------------------------------------------------
C IN  : NOMSD  : NOM DE LA STRUCTURE "RESULTAT"
C IN  : NOMSY  : NOM SYMBOLIQUE DU CHAMP
C IN  : IORDR  : NUMERO D'ORDRE DU CHAMP
C OUT : NOMCHA : NOM DU CHAMP
C      LE NOM EST DE LA FORME : 'NOMSD(1:8).III.JJJJJJ'
C      OU : III    : NUMERO ASSOCIE AU NOM SYMBOLIQUE
C           JJJJJJ : NUMERO DE RANGEMENT - 1
C IN  : LVERIF : .TRUE. : SI .TACH EST REMPLI, ON VERIFIE QUE LA
C                REGLE DE NOMMAGE EST VERIFIEE.
C ----------------------------------------------------------------------


      CHARACTER*3 NUCH
      CHARACTER*6 CHFORD
      CHARACTER*19 RESU19,NOMCH3,NOMCH2
      INTEGER ISYMB,IRANG,JTACH,NBORDR
C ----------------------------------------------------------------------

      RESU19 = NOMSD

      CALL JENONU(JEXNOM(RESU19//'.DESC',NOMSY),ISYMB)
      CALL ASSERT(ISYMB.GT.0)
      CALL CODENT(ISYMB,'D0',NUCH)

      CALL RSUTRG(NOMSD,IORDR,IRANG,NBORDR)
      CALL ASSERT(IRANG.GE.0)
      CALL ASSERT(IRANG.LE.NBORDR)


C     -- NOMCH2 : NOM QUE LE CHAMP DOIT AVOIR :
      IF ( IRANG.EQ.0 ) THEN
        CALL CODENT(NBORDR,'D0',CHFORD)
      ELSE
        CALL CODENT(IRANG-1,'D0',CHFORD)
      ENDIF
      NOMCH2 = RESU19(1:8)//'.'//NUCH//'.'//CHFORD


C     -- ON VERIFIE LA COHERENCE DE NOMCH2 AVEC L'OBJET .TACH :
      IF (IRANG.GT.0 .AND. LVERIF) THEN
        CALL JEVEUO(JEXNUM(RESU19//'.TACH',ISYMB),'L',JTACH)
        NOMCH3 = ZK24(JTACH-1+IRANG)(1:19)
        IF (NOMCH3.NE.' ') CALL ASSERT(NOMCH3.EQ.NOMCH2)
      END IF

      NOMCHA = NOMCH2

      END
