      SUBROUTINE UTFLMD(MAILLA,LIMAIL,DIM,TYPMAI,NBTROU,LITROU)
      IMPLICIT NONE
      INCLUDE 'jeveux.h'

      INTEGER DIM,NBTROU
      CHARACTER*8 MAILLA
      CHARACTER*(*) LITROU,LIMAIL,TYPMAI
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 09/11/2012   AUTEUR DELMAS J.DELMAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE DELMAS J.DELMAS
C
C     BUT:
C       FILTRER UNE LISTE DE MAILLE D'APRES LEUR DIMENSION
C       *           *        *                   *
C       IDEM QUE UTFLM2 MAIS AVEC UN VECTEUR JEVEUX
C
C
C     ARGUMENTS:
C     ----------
C
C      ENTREE :
C-------------
C IN   MAILLA    : NOM DU MAILLAGE
C IN   LIMAIL    : LISTE DES MAILLES (OBJET JEVEUX)
C IN   NDIM      : DIMENSION DES MAILLES A TROUVER (-1,0,1,2,3)
C IN   TYPMAI    : SI DIM=-1, ON FILTRE SUR TYPMAI='QUAD4'/'TRIA3'/...
C                  SINON, ON NE SE SERT PAS DE TYPMAI
C
C      SORTIE :
C-------------
C OUT  NBTROU    : NOMBRE DE MAILLE TROUVEES
C OUT  LITROU    : LISTE DES MAILLES TROUVEES (OBJET JEVEUX)
C                  SI NBTROU = 0, L'OBJET JEVEUX N'EST PAS CREE
C
C.......................................................................
C
C

C
C
      INTEGER NBMAIL
      INTEGER ILIMAI,ITRMA

      CHARACTER*1 K1BID
C
C ----------------------------------------------------------------------
      CALL JEMARQ()

      CALL JEVEUO(LIMAIL,'L',ILIMAI)
      CALL JELIRA(LIMAIL,'LONMAX',NBMAIL,K1BID)
      CALL WKVECT(LITROU,'V V I',NBMAIL,ITRMA)

      CALL UTFLM2(MAILLA,ZI(ILIMAI),NBMAIL,DIM,TYPMAI,NBTROU,ZI(ITRMA))

      IF (NBTROU.GT.0) THEN
        CALL JUVECA(LITROU,NBTROU)
      ELSE
        CALL JEDETR(LITROU)
      ENDIF
      CALL JEDEMA()
      END
